unit ApplicationWorkUnit;
(*
  Program: ApplicationWorkUnit
  Version: 0.10
  Author:  engenic
  Date:    2004 - ongoing
  License: GPL

  Copyright(c) 2004 engenic
*)

// WARNING: Do not update or add to "WorkUnit" files
// - We will not accept contributions for these files
// It's a Library ... place in search path
// Library contains old code and abandoned code
// Use at own risk

interface

uses classes, SysUtils, Windows, Graphics, Messages, Dialogs, Controls, Forms, ComCtrls, StdCtrls,  ExtCtrls,
     CalcWorkUnit, TCPIPWorkUnit, FileWorkUnit, Registry, enGRangeBar, enGKnob, enGPanelGrad,
     Grids, DBGrids, DBCtrls;
     // ,,,; StdCtrls Controls  ShellAPI    FileCtrl  Messages

// Expose controls (crack open a component)
// eg:  TExpose(DBNavigator).Color := clGreen;
type
  TExpose = class(TControl)
    public
        property Color;
    end;

function GetVersionInfo(pExeName: String): String;
procedure WinLocationsCreate(pExeName: String; pOwner: TForm);
procedure WinLocationsClose(pExeName: String; pOwner: TForm);
function AutomaticProgramUpdater(pHost: String; pPort, pVMSPort: Integer; pExeName: String; pAskWhenNonMandatory: Boolean; pUpdateQuestion, pManUpdateMess, pOptUpdateMess: String): Boolean;function BuildFormCaption(pProgramName: String; pInteractive: Boolean): String;
function AppOneInstanceOnly(pFormNameToTestFor, pFormTitleToTestFor : String): Boolean;
procedure AppSleep(pSleepForMS: Integer);
function OneInstanceOnly(pFormNameToTestFor, pFormTitleToTestFor : String): Boolean;
procedure AdjustApplicationToStandards(pOwner: TForm); Overload;
procedure AdjustApplicationToStandards(pOwner: TForm; pColor: TColor); Overload;
function WinSettingRead(pExeName: String; pOwner: TForm; pSetting: String): String;
procedure WinSettingWrite(pExeName: String; pOwner: TForm; pSetting, pValue: String);
function WinSettingReadHKLM(pExeName: String; pOwner: TForm; pSetting: String): String;
procedure WinSettingWriteHKLM(pExeName: String; pOwner: TForm; pSetting, pValue: String);
function FindDocumentsAndSettingsPathForApp(pApp: String): String;
function AppMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Integer): Integer; Overload
function AppMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Integer; AColor: TColor): Integer; Overload
procedure DisableProcessWindowsGhosting;
function GetTeleFlowServerInstallLocation: String;

var
   GlobStandardPanelColor : TColor;

   // Defaults
   GlobAppColorInterface  : Integer;

   GlobSetPanelGradsYN    : Boolean;
   GlobAppColorBack       : Integer;
   GlobAppColorGradTop    : Integer;
   GlobAppColorGradBot    : Integer;
   GlobAppColorBorder     : Integer;
   GlobAppColorMemo       : Integer;

implementation

const
{$I ConstStandardInclude.pas}

// Update components to behave nicely
// -- In Create() add:  AdjustApplicationToStandards(Self);
// -- A good place to add global standards for viewability
procedure AdjustApplicationToStandards(pOwner: TForm; pColor: TColor); Overload;
begin
     // Use default colors
     if pColor > 0 then
     begin
          // Remember, as this is the future
          GlobStandardPanelColor := pColor;
     end;

     // Continue as normal
     AdjustApplicationToStandards(pOwner);
end;

procedure AdjustApplicationToStandards(pOwner: TForm); Overload;
var
   mColor  : TColor;
   mCpt    : Integer;
begin
     // Set up default colours
     if GlobAppColorBack      = 0 then GlobAppColorBack      := $00E8DDD9;
     if GlobAppColorGradTop   = 0 then GlobAppColorGradTop   := $00E8DDD9;
     if GlobAppColorGradBot   = 0 then GlobAppColorGradBot   := $00D9C9C2;
     if GlobAppColorBorder    = 0 then GlobAppColorBorder    := $00A57A7A;
     if GlobAppColorMemo      = 0 then GlobAppColorMemo      := $00E8DDD9;
     if GlobAppColorInterface = 0 then GlobAppColorInterface := $00DACCC6;

     // Don't let someone elses program mess up our formatting
     // - This is especially relative for date formats
     Application.UpdateFormatSettings   := False;
     // In theory, this is the only time we need this statement
     SetStandardDateTimeFormats;


     // Prevent MessageDlgs from popping under
     DisableProcessWindowsGhosting;

     // If a standard color was selected by the Creating Form....
     if GlobStandardPanelColor > 0 then
     begin
          try
             // Then, use that color...
             mColor := GlobStandardPanelColor;
          except
             mColor := GlobAppColorInterface;
          end;
     end
     else
     begin
          mColor := GlobAppColorInterface;
     end;


     // Form
     with (pOwner) do
     begin
          if Color = clBtnFace then
          begin
               Color := mColor;
          end;
     end;

     // All the components the Form holds
     for mCpt := 0 to pOwner.ComponentCount - 1 do
     begin
          // Panel
          if (pOwner.Components[mCpt] is TPanel) then
          begin
               with (pOwner.Components[mCpt] as TPanel) do
               begin
                    DoubleBuffered := True;
                    if Color = clBtnFace then
                    begin
                         Color := mColor;
                    end;
               end;
          end;

          // CheckBox
          if (pOwner.Components[mCpt] is TCheckBox) then
          begin
               with (pOwner.Components[mCpt] as TCheckBox) do
               begin
                    if Color = clBtnFace then
                    begin
                         Color := mColor;
                    end;
               end;
          end;

          // DBNavigator
          if (pOwner.Components[mCpt] is TDBNavigator) then
          begin
               with (pOwner.Components[mCpt] as TDBNavigator) do
               begin
                    if TExpose(pOwner.Components[mCpt]).Color = clBtnFace then
                    begin
                         TExpose(pOwner.Components[mCpt]).Color := mColor;
                    end;
               end;
          end;


          // TrackBar
          if (pOwner.Components[mCpt] is TTrackBar) then
          begin
               with (pOwner.Components[mCpt] as TTrackBar) do
               begin
                    if TExpose(pOwner.Components[mCpt]).Color = clBtnFace then
                    begin
                         TExpose(pOwner.Components[mCpt]).Color := mColor;
                    end;
               end;
          end;


          // enGKnob
          if (pOwner.Components[mCpt] is TenGKnob) then
          begin
               with (pOwner.Components[mCpt] as TenGKnob) do
               begin
                    DoubleBuffered := True;
                    if Color = clBtnFace then
                    begin
                         Color := GlobAppColorInterface;
                    end;
               end;
          end;


          // enGPanelGrad
          if (pOwner.Components[mCpt] is TenGPanelGrad) then
          begin
               with (pOwner.Components[mCpt] as TenGPanelGrad) do
               begin
                    DoubleBuffered := True;
                    
                    // Set this to True to take effect
                    if GlobSetPanelGradsYN then
                    begin
                         BeginColor     := GlobAppColorGradTop;
                         BorderColor    := GlobAppColorBorder;
                         EndColor       := GlobAppColorGradBot;
                    end;
               end;
          end;


          // enGRangeBar
          if (pOwner.Components[mCpt] is TenGRangeBar) then
          begin
               with (pOwner.Components[mCpt] as TenGRangeBar) do
               begin
                    DoubleBuffered := True;
                    if Color = clBtnFace then
                    begin
                         Color := GlobAppColorInterface;
                    end;
               end;
          end;

          // Splitter ][
          if (pOwner.Components[mCpt] is TSplitter) then
          begin
               with (pOwner.Components[mCpt] as TSplitter) do
               begin
                    Color := clSplitter;
               end;
          end;

          // Bottom Status bar
          if (pOwner.Components[mCpt] is TStatusBar) then
          begin
               with (pOwner.Components[mCpt] as TStatusBar) do
               begin
                    DoubleBuffered := True;
                    Color          := mColor;
               end;
          end;


          if (pOwner.Components[mCpt] is TEdit) then
          begin
             (pOwner.Components[mCpt] as TEdit).DoubleBuffered := True;
          end;

          if (pOwner.Components[mCpt] is TMemo) then
          begin
             (pOwner.Components[mCpt] as TMemo).DoubleBuffered := True;
          end;

          if (pOwner.Components[mCpt] is TPageControl) then
          begin
             (pOwner.Components[mCpt] as TPageControl).DoubleBuffered := True;
          end;

          if (pOwner.Components[mCpt] is TMonthCalendar) then
          begin
             (pOwner.Components[mCpt] as TMonthCalendar).DoubleBuffered := True;
          end;

       //   if (pOwner.Components[mCpt] is TKPanelMvGrad) then
       //   begin
       //      (pOwner.Components[mCpt] as TKPanelMvGrad).DoubleBuffered := True;
       //   end;
     end;
end; // AdjustApplicationToStandards



// Borland says use this to prevent the MessageDlg from popping Under the main form
procedure DisableProcessWindowsGhosting;
var
   DisableProcessWindowsGhostingImp : procedure;
begin
     @DisableProcessWindowsGhostingImp :=
     GetProcAddress(GetModuleHandle('user32.dll'),'DisableProcessWindowsGhosting');

     if @DisableProcessWindowsGhostingImp <> nil then
     DisableProcessWindowsGhostingImp;
end;


// Read program (none-database) setting
procedure WinLocationsCreate(pExeName: String; pOwner: TForm);
var
   mWinTop                : Integer;
   mWinLeft               : Integer;
   mWinHeight             : Integer;
   mWinWidth              : Integer;

   Registry               : TRegistry;

   mAppName               : String;
   mGridWidths            : String;
   mWidth                 : Integer;
   mLoop                  : Integer;
   mCpt                   : Integer;
   mTotal                 : Integer;

   mKeyRoot               : String;
   mKeyValueRoot          : String;
   mDB                    : Boolean;
begin
     // Locations
     mWinTop                  :=  (pOwner).Top;
     mWinLeft                 :=  (pOwner).Left;
     mWinHeight               :=  (pOwner).Height;
     mWinWidth                :=  (pOwner).Width;

     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_CURRENT_USER;  // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER;

        mAppName := ExtractFileName(ChangeFileExt(pExeName,''));


        // True to create it if it doesnt exist
        mKeyRoot := 'SOFTWARE\engenic\'+mAppName+'\'+pOwner.Name;
        if Registry.KeyExists(mKeyRoot) then
        begin
             if Registry.OpenKey(mKeyRoot, True) then
             begin
                  try
                     // Retrieve position info
                     mKeyValueRoot := mKeyRoot+'\'+'x';
                     if Registry.ValueExists('x') then
                     begin
                          mWinTop                  := Registry.ReadInteger('y'            );
                          mWinLeft                 := Registry.ReadInteger('x'            );
                          mWinHeight               := Registry.ReadInteger('Height'       );
                          mWinWidth                := Registry.ReadInteger('Width'        );

                          // All the components the Form holds
                          for mCpt := 0 to pOwner.ComponentCount - 1 do
                          begin
                               if pOwner.Components[mCpt].InheritsFrom(TCustomGrid) then
                               begin
                                    if Registry.ValueExists('Grid'+(pOwner.Components[mCpt] as TCustomGrid).Name ) then
                                    begin
                                         mGridWidths   := '';
                                         mGridWidths   := Registry.ReadString('Grid'+(pOwner.Components[mCpt] as TCustomGrid).Name);

                                         mDB    := False;
                                         mTotal := 30;

                                         if pOwner.Components[mCpt].InheritsFrom(TDrawGrid) then
                                         begin
                                              mTotal := (pOwner.Components[mCpt] as TDrawGrid).ColCount;
                                         end;
                                         if pOwner.Components[mCpt].InheritsFrom(TDBGrid) then
                                         begin
                                              mDB    := True;
                                              mTotal := (pOwner.Components[mCpt] as TDBGrid).Columns.Count;
                                         end;

                                         // Ensures that all components will get attention
                                         try
                                            for mLoop := 1 to mTotal do
                                            begin
                                                 mWidth := StrToIntDef(RecordParse(mGridWidths, mLoop),-1);
                                                 if mWidth > -1 then
                                                 begin
                                                      if not mDB then
                                                      begin
                                                           (pOwner.Components[mCpt] as TCustomDrawGrid).ColWidths[mLoop-1 ] := mWidth;
                                                      end
                                                      else
                                                      begin
                                                           (pOwner.Components[mCpt] as TDBGrid).Columns[mLoop-1 ].Width     := mWidth;
                                                      end;
                                                 end;
                                            end;
                                          except
                                          end;

                                    end;
                               end;
                          end;
                     end;
                  except

                  end;
             end;
        end;

        // Locations
        (pOwner).Position        := poDesigned;
        (pOwner).Top             := mWinTop       ;
        (pOwner).Left            := mWinLeft      ;
        (pOwner).Height          := mWinHeight    ;
        (pOwner).Width           := mWinWidth     ;

     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;

end;  // WinLocationsRead


// Write settings
procedure WinLocationsClose(pExeName: String; pOwner: TForm);
var
   mWinTop                : Integer;
   mWinLeft               : Integer;
   mWinHeight             : Integer;
   mWinWidth              : Integer;

   // Registry Information
   Registry               : TRegistry;

   mAppName               : String;
   mCpt                   : Integer;
   mIndex                 : Integer;
   mTotal                 : Integer;

   mGridWidths            : String;
   //mDB                    : Boolean;
begin
     mWinTop     := (pOwner).Top;
     mWinLeft    := (pOwner).Left;
     mWinHeight  := (pOwner).Height;
     mWinWidth   := (pOwner).Width;

     mAppName := ExtractFileName(ChangeFileExt(pExeName,''));


     Registry:=TRegistry.Create;
     Registry.RootKey := HKEY_CURRENT_USER;
     try
        // True because we want to create it if it doesnt exist}
        // -- Note, Next OpenKey goes up the tree
        Registry.OpenKey('SOFTWARE\enGenic\'+mAppName+'\'+pOwner.Name, True);
        try
           // Location
           Registry.WriteInteger('y'            ,mWinTop     );
           Registry.WriteInteger('x'            ,mWinLeft    );
           Registry.WriteInteger('Height'       ,mWinHeight  );
           Registry.WriteInteger('Width'        ,mWinWidth   );

           // All the components the Form holds
           for mCpt := 0 to pOwner.ComponentCount - 1 do
           begin
                // Panel
                if pOwner.Components[mCpt].InheritsFrom(TCustomGrid) then
                begin
                     mTotal := 0;
                     if pOwner.Components[mCpt].InheritsFrom(TDrawGrid) then
                     begin
                          mTotal := (pOwner.Components[mCpt] as TDrawGrid).ColCount;
                     end;
                     if pOwner.Components[mCpt].InheritsFrom(TDBGrid) then
                     begin
                          //mDB    := True;
                          mTotal := (pOwner.Components[mCpt] as TDBGrid).Columns.Count;
                     end;

                     mGridWidths := '';

                     // (pOwner.Components[mCpt] as TCustomGrid).ColCount
                     // - Is "protected"... so, we can't read it.
                     try
                        for mIndex := 0 to mTotal -1 do
                        begin
                             if pOwner.Components[mCpt].InheritsFrom(TDrawGrid) then
                             begin
                                  mGridWidths := mGridWidths + iff((mGridWidths = ''), '', ',') +
                                                 IntToStr((pOwner.Components[mCpt] as TDrawGrid).ColWidths[mIndex ]);
                             end;
                             if pOwner.Components[mCpt].InheritsFrom(TDBGrid) then
                             begin
                                  mGridWidths := mGridWidths + iff((mGridWidths = ''), '', ',') +
                                                 IntToStr((pOwner.Components[mCpt] as TDBGrid).Columns[mIndex ].Width);
                             end;
                        end;
                     except
                     end;

                     // If have something, write it
                     if mGridWidths <> '' then
                     begin
                          Registry.WriteString('Grid'+(pOwner.Components[mCpt] as TCustomGrid).Name,  mGridWidths);
                     end;
                end;
           end;

        except
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;
end;  // WinLocationsWrite


// Read program (none-database) setting
(* eg;
     EditWXSPathFile.Text := WinSettingRead(Application.ExeName, DripForm, 'EditWXSPathFile');
     EditRipBasePath.Text := WinSettingRead(Application.ExeName, DripForm, 'EditRipBasePath');
     EditFreqPrepend.Text := WinSettingRead(Application.ExeName, DripForm, 'EditFreqPrepend');
     UICheckBox.Checked   := (WinSettingRead(Application.ExeName, DripForm, 'UICheckBox') = 'Yes');
*)
function WinSettingRead(pExeName: String; pOwner: TForm; pSetting: String): String;
var
   Registry               : TRegistry;

   mAppName               : String;
   mKeyRoot               : String;
   mKeyValueRoot          : String;
begin
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_CURRENT_USER;  // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER;

        mAppName := ExtractFileName(ChangeFileExt(pExeName,''));

        result   := '';

        // True to create it if it doesnt exist
        mKeyRoot := 'SOFTWARE\engenic\'+mAppName+'\'+pOwner.Name;
        if Registry.KeyExists(mKeyRoot) then
        begin
             mKeyValueRoot := mKeyRoot+'\'+'Setting';
             if Registry.OpenKey(mKeyValueRoot, True) then
             begin
                  try
                     // Retrieve position info
                     if Registry.ValueExists(pSetting) then
                     begin
                          result   := Registry.ReadString(pSetting);
                     end;
                  except
                  end;
             end;
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;
end;
// And again for machine
function WinSettingReadHKLM(pExeName: String; pOwner: TForm; pSetting: String): String;
var
   Registry               : TRegistry;

   mAppName               : String;
   mKeyRoot               : String;
   mKeyValueRoot          : String;
begin
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_LOCAL_MACHINE;  // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER;

        mAppName := ExtractFileName(ChangeFileExt(pExeName,''));

        result   := '';

        // True to create it if it doesnt exist
        mKeyRoot := 'SOFTWARE\engenic\'+mAppName+'\'+pOwner.Name;
        if Registry.KeyExists(mKeyRoot) then
        begin
             mKeyValueRoot := mKeyRoot+'\'+'Setting';
             if Registry.OpenKey(mKeyValueRoot, True) then
             begin
                  try
                     // Retrieve position info
                     if Registry.ValueExists(pSetting) then
                     begin
                          result   := Registry.ReadString(pSetting);
                     end;
                  except
                  end;
             end;
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;
end;


// Write settings
(* eg;
     WinSettingWrite(Application.ExeName, DripForm, 'EditWXSPathFile', EditWXSPathFile.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'EditRipBasePath', EditRipBasePath.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'EditFreqPrepend', EditFreqPrepend.Text);
     WinSettingWrite(Application.ExeName, DripForm, 'UICheckBox', iff(UICheckBox.Checked,'Yes','No'));
*)
procedure WinSettingWrite(pExeName: String; pOwner: TForm; pSetting, pValue: String);
var
   Registry               : TRegistry;

   mAppName               : String;

   mKeyRoot               : String;
   mKeyValueRoot          : String;
begin
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_CURRENT_USER;  // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER;

        mAppName := ExtractFileName(ChangeFileExt(pExeName,''));

        // True because we want to create it if it doesnt exist}
        // -- Note, Next OpenKey goes up the tree
        mKeyRoot := 'SOFTWARE\engenic\'+mAppName+'\'+pOwner.Name;
        if Registry.KeyExists(mKeyRoot) then
        begin
             mKeyValueRoot := mKeyRoot+'\'+'Setting';
             if Registry.OpenKey(mKeyValueRoot, True) then
             begin
                  try
                     // Retrieve position info
                     (*
                     if Registry.ValueExists('Setting') then
                     begin
                          if Registry.ValueExists(pSetting) then
                          begin
                          end;
                     end;
                     *)
                     Registry.WriteString(pSetting,  pValue);
                  except
                  end;
             end;
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;
end;
// And again for LOCAL Machine
procedure WinSettingWriteHKLM(pExeName: String; pOwner: TForm; pSetting, pValue: String);
var
   Registry               : TRegistry;

   mAppName               : String;

   mKeyRoot               : String;
   mKeyValueRoot          : String;
begin
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_LOCAL_MACHINE;  // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER;

        mAppName := ExtractFileName(ChangeFileExt(pExeName,''));

        // True because we want to create it if it doesnt exist}
        // -- Note, Next OpenKey goes up the tree
        mKeyRoot := 'SOFTWARE\engenic\'+mAppName+'\'+pOwner.Name;
        //if Registry.KeyExists(mKeyRoot) then
        begin
             mKeyValueRoot := mKeyRoot+'\'+'Setting';
             if Registry.OpenKey(mKeyValueRoot, True) then
             begin
                  try
                     // Retrieve position info
                     (*
                     if Registry.ValueExists('Setting') then
                     begin
                          if Registry.ValueExists(pSetting) then
                          begin
                          end;
                     end;
                     *)
                     Registry.WriteString(pSetting,  pValue);
                  except
                  end;
             end;
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;
end;



// Get software version and build from compiler
function GetVersionInfo(pExeName: String): String;
const
  InfoNum = 10;
  InfoStr: array[1..InfoNum] of string = ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName', 'LegalCopyright', 'LegalTradeMarks', 'OriginalFileName', 'ProductName', 'ProductVersion', 'Comments');
var
   S: string;
   n, Len, i: DWORD;
   Buf: PChar;
   Value: PChar;
begin
     S := pExeName;
     n := GetFileVersionInfoSize(PChar(S), n);
     if n > 0 then
     begin
          Buf := AllocMem(n);
          //('VersionInfoSize = ' + IntToStr(n));
          GetFileVersionInfo(PChar(S), 0, n, Buf);
          for i := 1 to InfoNum do
          begin
               if VerQueryValue(Buf, PChar('StringFileInfo\040904E4\' + InfoStr[i]), Pointer(Value), Len) then
               begin
                    if InfoStr[i] = 'FileVersion' then
                    begin
                         Result := Value;
                    end;
               end;
          end;
          FreeMem(Buf, n);
     end
     else
     begin
          Result := '???';
     end;
end;



// Custom MessageDlg
function AppMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Integer): Integer; OverLoad;
begin
     with CreateMessageDialog(Msg, DlgType, Buttons) do
     try
        Color  := cBackColor;
        Result := ShowModal;
     finally
        Free;
     end;
end;

// Custom MessageDlg
function AppMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Integer; AColor: TColor): Integer; OverLoad;
begin
     with CreateMessageDialog(Msg, DlgType, Buttons) do
     try
        Color  := AColor;
        Result := ShowModal;
     finally
        Free;
     end;
end;

// Get the documents and settings path for the current user
(*
For example:
    GlobDocPath := FindDocumentsAndSettingsPathForApp('NoticeViewer');
Will return (and create if necessary) for example...
    'C:\Documents and Settings\Vern\Application Data\NoticeViewer\'

It get the location for files that we might create temporarily for the current user...
and appends the name of the app at the end.  This is useful for ensuring that
the current user has his or her own reports or downloaded files etc.
This is highly useful for environments
*)
function FindDocumentsAndSettingsPathForApp(pApp: String): String;
var
   // Registry Information
   Registry   : TRegistry;
   mKey       : String;
   mPath      : String;
begin
     mPath := '';
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_CURRENT_USER;
        mKey             := 'Volatile Environment';

        // False because we do not want to create it if it doesnt exist
        if Registry.OpenKey(mKey, False) then
        begin
             mPath  := Registry.ReadString ('APPDATA'  );
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;

     // Build a path
     if mPath <> '' then
     begin
          // We found something in the registry, so lets go
          mPath := IncludeTrailingPathDelimiter(mPath) +
                   IncludeTrailingPathDelimiter(pApp);
     end
     else
     begin
          // There was no Reg Setting apparently...
          // - So, build something, anything..
          mPath := 'c:\Temp\';
     end;

     // Make sure it exists...
     ForceDirectories(mPath);

     result := mPath;

end; // FindDocumentsAndSettingsPath


// Read the install location from the registry
function GetTeleFlowServerInstallLocation: String;
var
   // Registry Information
   Registry   : TRegistry;
   mKey       : String;
   mPath      : String;
begin
     mPath := '';
     Registry:=TRegistry.Create;
     try
        Registry.RootKey := HKEY_LOCAL_MACHINE;
        mKey             := 'SOFTWARE\enGenic\TeleFlow Server\';

        // False because we do not want to create it if it doesnt exist
        if Registry.OpenKey(mKey, False) then
        begin
             mPath  := Registry.ReadString ('INSTALLDIRECTORY'  );
        end;
     finally
        // Close the key
        Registry.CloseKey;
        // Close it
        Registry.Free;
     end;

     // Return what we found
     result := mPath;
end;


// Take care of automatic updates
// - Check program file versions, and update with options
// 1.2.3.55   = Major Version, Minor Version, Release, Build
// 1 or 2     = Mandetory upgrade
// 3          = Optional upgrade
function AutomaticProgramUpdater(pHost: String; pPort, pVMSPort: Integer; pExeName: String; pAskWhenNonMandatory: Boolean; pUpdateQuestion, pManUpdateMess, pOptUpdateMess: String): Boolean;
const
   cTFUpdater        = 'TFUpdater.exe';
   cQuoteSingle      = '''';
   cTFNewExt         = '.ex-';
var
   mUpdateReceived   : String;
   mText             : String;
   mExplain          : String;
   mMessage          : String;
   mError            : Boolean;
   mVCurrent,
   mVUpdate          : String;
   mVCur1,
   mVCur2,
   mVCur3,
   mVUpd1,
   mVUpd2,
   mVUpd3            : Integer;
   mUpdateMan        : Boolean;
   mUpdateAvail      : Boolean;
   mFileCurFile,
   mFileNewFile,
   mFileNewPath,
   mFileCmdName      : String;
   mFileCmd          : TStringList;

   mGetUpdater       : Boolean;
   mGetNewProgram    : Boolean;

   // Questions and messages
   mUpdateQuestion,
   mManUpdateMess,
   mOptUpdateMess    : String;


begin
     Result := False;

     // Files to and from
     mFileCurFile  := pExeName;
     mFileNewFile  := ChangeFileExt(pExeName, cTFNewExt);

     // The first time will pick up if we cannot find NetConnect
     mError := True;
     try
        // Log that we are here
        mMessage := mFileCurFile+'~'+
                    GetVersionInfo(mFileCurFile)+'~'+
                    CalcGetUserName+'~'+
                    CalcGetComputerName;

        // Communicate with NetHub
        if HTTPLog(pHost,
                   pPort,
                   'ProgramStart',
                   mMessage) then
        begin
             // We got an entry there.
             mError := False;
        end;
     except
        on E: Exception do
        begin
             mText := E.Message+'  '+IntToStr(E.HelpContext);
        end;
     end;


     // Did we get this far
     if mError then
     begin
          mExplain := 'Check that NetConnect is running.';
     end
     else
     begin
          // Set up the questions and messages
          mUpdateQuestion := iff(pUpdateQuestion <> '', pUpdateQuestion , 'There is an update available for this program.'+#10+#13+
                                                                          'Would you like to update it now?');
          mManUpdateMess  := iff(pManUpdateMess  <> '', pManUpdateMess  , 'A mandatory update will be installed after you click '+cQuoteSingle+'Ok'+cQuoteSingle+'.');
          mOptUpdateMess  := iff(pOptUpdateMess  <> '', pOptUpdateMess  , 'The update will be installed after you click '+cQuoteSingle+'Ok'+cQuoteSingle+'.');

          // See if there is an update available of the Current Program
          // -- http://localhost:5048/&~TFProgVersion~TFUpdater.exe
          // Note: This would read the file version of the software in the NetHub\Web directory
          mVCurrent := GetVersionInfo(mFileCurFile);
          mVUpdate  := HTTPSendCommandToNetHub(2000, pHost, pPort, 'TFProgVersion~'+ExtractFileName(mFileCurFile));

          // If we got something
          mVUpdate := RecordParseCustomDelimiter(mVUpdate, '~', 2);
          if (mVUpdate <> '') and
             (Pos('N/A',   UpperCase(mVUpdate)) = 0) and
             (Pos('ERROR', UpperCase(mVUpdate)) = 0) then
          begin
               mUpdateMan        := False;
               mUpdateAvail      := False;

               // Determine the version numbers of both files
               mVCur1 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 1) , 999);
               mVCur2 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 2) , 999);
               mVCur3 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 3) , 999);
               mVUpd1 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 1) , -1);
               mVUpd2 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 2) , -1);
               mVUpd3 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 3) , -1);
               // Determine if we have a newer version
               if (mVUpd1 > mVCur1) then
               begin
                    // Mandatory update
                    mUpdateMan := True;
               end
               else
               if (mVUpd1 = mVCur1) then
               begin
                    if (mVUpd2 > mVCur2) then
                    begin
                         // Mandatory update
                         mUpdateMan := True;
                    end
                    else
                    if (mVUpd2 = mVCur2) then
                    begin
                         if (mVUpd3 > mVCur3) then
                         begin
                              // Update available available
                              mUpdateAvail := True;
                         end;
                    end;
               end;


               // Are we in need of an update?
               if mUpdateAvail or mUpdateMan then
               begin
                    mGetUpdater := True;

                    // Does the TFUpdater already exist here?
                    // /////////////////////////////////////
                    if FileExists( cTFUpdater ) then
                    begin
                         // See if we need an update
                         mGetUpdater := False;

                         mVCurrent := GetVersionInfo(cTFUpdater);
                         mVUpdate  := HTTPSendCommandToNetHub(2000, pHost, pPort, 'TFProgVersion~'+ExtractFileName(cTFUpdater));

                         // If we got something
                         mVUpdate := RecordParseCustomDelimiter(mVUpdate, '~', 2);
                         if (mVUpdate <> '') and
                            (Pos('N/A',   UpperCase(mVUpdate)) = 0) and
                            (Pos('ERROR', UpperCase(mVUpdate)) = 0) then
                         begin
                              // Determine the version numbers of both files
                              mVCur1 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 1) , 999);
                              mVCur2 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 2) , 999);
                              mVCur3 :=  StrToIntDef( RecordParseCustomDelimiter(mVCurrent, '.', 3) , 999);
                              mVUpd1 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 1) , -1);
                              mVUpd2 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 2) , -1);
                              mVUpd3 :=  StrToIntDef( RecordParseCustomDelimiter(mVUpdate,  '.', 3) , -1);
                              // Determine if we have a newer version
                              if (mVUpd1 > mVCur1) then
                              begin
                                   // Mandatory update
                                   mGetUpdater := True;
                              end
                              else
                              if (mVUpd1 = mVCur1) then
                              begin
                                   if (mVUpd2 > mVCur2) then
                                   begin
                                        // Mandatory update
                                        mGetUpdater := True;
                                   end
                                   else
                                   if (mVUpd2 = mVCur2) then
                                   begin
                                        if (mVUpd3 > mVCur3) then
                                        begin
                                             mGetUpdater := True;
                                        end;
                                   end;
                              end;
                         end;
                    end;

                    // Do we need to get it?
                    if mGetUpdater then
                    begin
                         // Remove it ... just in case
                         if FileExists( cTFUpdater ) then
                         begin
                              DeleteFile(pChar(cTFUpdater));
                         end;

                         // Download Updater Program
                         HTTPGetFile(pHost,
                                     pPort,
                                     cTFUpdater,
                                     cTFUpdater,
                                     '');
                    end;

                    // If we have an updater, lets run it
                    if (FileExists(cTFUpdater)) then
                    begin
                         mGetNewProgram := False;

                         // Should we ask a
                         if mUpdateMan then
                         begin
                              mGetNewProgram := True;
                         end
                         else if pAskWhenNonMandatory then
                         begin
                              if (MessageDlg(mUpdateQuestion,
                                             mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
                              begin
                                   mGetNewProgram := True;
                              end;
                         end;


                         // Mandatory or Requst
                         if mGetNewProgram then
                         begin
                              if mUpdateMan then
                              begin
                                   // Mandatory update message
                                   MessageDlg(mManUpdateMess,
                                              mtInformation, [mbOk], 0);
                              end
                              else
                              begin
                                   // Optional update messsage
                                   MessageDlg(mOptUpdateMess,
                                              mtInformation, [mbOk], 0);
                              end;


                              // If we download an update file...
                              mUpdateReceived := HTTPGetProgramUpdate(pHost,
                                                                      pPort,
                                                                      mFileCurFile,
                                                                      GetVersionInfo(mFileCurFile),
                                                                      CalcGetUserName,
                                                                      CalcGetComputerName);
                              //DebugOut(GlobDebugMode,'fa-0005');
                              if FileExists(mUpdateReceived) then
                              begin

                                   // Include the filepath
                                   mFileNewPath := ExtractFilePath(mFileNewFile);
                                   // Set the directory to this location so that the batch runs here
                                   //chdir(mFileNewPath);  // done in the next call

                                   // Run an update system for new Notice Viewer updates
                                   // - Command file of same name will be run
                                   // - Should wait 5 seconds... then copy over file
                                   //   ntsleep 5
                                   //   copy %1 ..


                                   mFileCmd := TStringList.Create;
                                   try
                                      mFileCmd.Add('@echo off');
                                      mFileCmd.Add('set DMCur=%1%');
                                      mFileCmd.Add('set DMNew=%2%');
                                      mFileCmd.Add(cTFUpdater+' %DMNew% %DMCur%');

                                      // Clear and run
                                      mFileCmdName    := ChangeFileExt(cTFUpdater,'.Cmd');
                                      if FileExists(mFileCmdName) then
                                      begin
                                           DeleteFile(pChar(mFileCmdName));
                                      end;

                                      mFileCmd.SaveToFile(mFileCmdName);

                                      // Run the autoupdater
                                      if FileExists( mFileCmdName ) then
                                      begin
                                           ShellExternalNewConsole(mFileCurFile,
                                                                   mFileCmdName,
                                                                   '"'+mFileCurFile +'" "'+mFileNewFile+'"');

                                      end;

                                   finally
                                      mFileCmd.Free;

                                   end;

                                   // We need the program to shut down now
                                   result := True;

                                   // Kill the program now
                              end;
                         end;
                    end;
               end;
          end;
     end;
end; // AutomaticProgramUpdater


// @@@ Customize for caption - Later.
function BuildFormCaption(pProgramName: String; pInteractive: Boolean): String;
var
   mNameList         : TStringList;
   mUserName         : String;
   mUserNameFile     : String;
begin
     mUserName := 'enGenic';
     mNameList := TStringList.Create;
     try
         // Select your name.
         mUserNameFile := '*** Implement from NetHub ***';
         if FileExists(mUserNameFile) then
         begin
              mNameList.LoadFromFile(mUserNameFile);
              // First line
              mUserName :=  mNameList[0];
         end
         else
         begin
              if pInteractive then
              begin
                   (* This has to be updated
                   BOUserForm.ShowModal;
                   mNameList.Clear;
                   mNameList.Add(BOUserForm.UserName.Text);
                   gUserName :=  mNameList[0];
                   mNameList.SaveToFile(cUserNameFile);
                   *)
              end;
         end;
     finally
         mNameList.Free;
     end;

     // Caption
     mUserName := ReplaceAllSingleChar(mUserName,' ', '');
     // Result for name of program
     result    := pProgramName+' for '+RecordParseCustomDelimiter(mUserName,' ',1);
end; //  BuildFormCaption


// Sleep with process messages (allows screen updates with a gentle sleep)
procedure AppSleep(pSleepForMS: Integer);
var
   mLoop,
   mBlocks : integer;
begin
     mBlocks :=  Round(pSleepForMS / 100);
     for mLoop := 1 to mBlocks do
     begin
          Sleep(100);
          Application.ProcessMessages;
     end;
end;


// Ensures only one instance can show
// - Make sure the title caption is blank
// eg: This code would go in Create
(*
     Caption := 'Starting...';
     if OneInstanceOnly(Name, 'Title') then
     begin
          // The caption must not be what we are testing for at first
          Caption := 'Title';
     end
     else
     begin
          Halt;
     end;
*)
// AppOne... because OneInstanceOnly conflicts
function AppOneInstanceOnly(pFormNameToTestFor, pFormTitleToTestFor : String): Boolean;
begin
     result := OneInstanceOnly(pFormNameToTestFor, pFormTitleToTestFor);
end;

function OneInstanceOnly(pFormNameToTestFor, pFormTitleToTestFor : String): Boolean;
var
   //mAppTitle: String;
   mTitle:       array[0..79] of Char;
   mName:        array[0..79] of Char;
   Hwnd: THandle;  // declare THandleObject variable
begin
     // look for another instance via returned handle value (integer) }
     result := True;

     // look for another instance via returned handle value (integer) }
     StrPCopy(mName,  'T'+pFormNameToTestFor); //mAppTitle);
     StrPCopy(mTitle, pFormTitleToTestFor); //mAppTitle);

     Hwnd := FindWindow(mName, mTitle);
     // if handle ALREADY exists (does not equal zero) then move it to
     // foreground and terminate this instance
     if Hwnd <> 0 then
     begin
          result := False;  // Shut down now

          // move application (identified by handle) to foreground }
          SetForegroundWindow(Hwnd);
          // Show the current program by sending a message to the other window
          PostMessage(Hwnd, WM_ACTIVATE, 0, 0);
          // Show the current program by sending a message to the other window
          //PostMessage(Hwnd, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
          PostMessage(Hwnd, WM_SYSCOMMAND, SC_RESTORE, 0);
     end;
end;  // OneInstanceOnly





end.