unit BDEWorkUnit;

// In the Project .DPR file, the BDEWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  BDEWorkUnit in 'BDEWorkUnit.pas';
*)




// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! CalcWorkUnit must be in the USES section for each unit

interface

uses
  db, dbtables, classes, dialogs,sysutils, CalcWorkUnit;

  function BDEErrorMessage(pDialogMode: Boolean; pMsgText: String; E: Exception): String;

implementation


// Manage database errors on exceptions
// pDialogMode = Show MessageDlg to screen ?
// pMsgText    = General message you want to provide about error. eg: "Could not insert column into Company_Used_Names table."
// E           = Exception class (passed after error)
(*
   // Open the BDE database
   try
       // Open with a fresh table
       Database1.DatabaseName := GlobParm2ODBC;
       Database1.AliasName    := GlobParm2ODBC;
       Database1.Connected    := True;
   except
       on E: Exception do
       begin
            GlobMessage := 'Unable to open ODBC source: '+GlobParm2ODBC;
            BDEErrorMessage(True, GlobMessage, E);
       end;
   end;
*)
function BDEErrorMessage(pDialogMode: Boolean; pMsgText: String; E: Exception): String;
const
   CRLF = #13#10;
var
   mErrorList         : TStringList;
   mErrorCode         : String;
   mErrorDesc         : String;
   mLoop              : Integer;
   mErrorText         : String;
begin
  mErrorList := TStringList.Create;
  try
     // Create the error messages
     // -- This list comes from:  bde.int (formated list found off internet)
     with mErrorList do
     begin
          //   Code  Hex  Description
          add('00000 0000 Successful completion.');
          add('00033 0021 System Error');
          add('00034 0022 Object of Interest Not Found');
          add('00035 0023 Physical Data Corruption');
          add('00036 0024 I/O Related Error');
          add('00037 0025 Resource or Limit Error');
          add('00038 0026 Data Integrity Violation');
          add('00039 0027 Invalid Request');
          add('00040 0028 Lock Violation');
          add('00041 0029 Access/Security Violation');
          add('00042 002A Invalid Context');
          add('00043 002B OS Error');
          add('00044 002C Network Error');
          add('00045 002D Optional Parameter');
          add('00046 002E Query Processor');
          add('00047 002F Version Mismatch');
          add('00048 0030 Capability Not Supported');
          add('00049 0031 System Configuration Error');
          add('00050 0032 Warning');
          add('00051 0033 Miscellaneous');
          add('00052 0034 Compatibility Error');
          add('00062 003E Driver Specific Error');
          add('00063 003F Internal Symbol');
          add('00256 0100 KEYVIOL');
          add('00257 0101 PROBLEMS');
          add('00258 0102 CHANGED');
          add('00512 0200 Production Index file missing, corrupt or cannot interpret index key');
          add('00513 0201 Open Read Only');
          add('00514 0202 Open the table in read only mode');
          add('00515 0203 Open and Detach');
          add('00516 0204 Open the table and detach the Production Index file');
          add('00517 0205 Fail Open');
          add('00518 0206 Do not open the table');
          add('00519 0207 Convert Non-dBase Index');
          add('00520 0208 Convert production index to dBase format');
          add('00521 0209 BLOB file not found');
          add('00522 020A Open without blob file');
          add('00523 020B Open the table without the blob file');
          add('00524 020C Empty all blob fields');
          add('00525 020D Reinitialize BLOB file and LOSE all blobs');
          add('00526 020E Fail Open');
          add('00527 020F Do not open the table');
          add('00528 0210 Import Non-dBASE BLOB file');
          add('00529 0211 Import BLOB file to dBASE format');
          add('00530 0212 Open as Non-dBASE table');
          add('00531 0213 Open Table and BLOB file in its native format');
          add('00532 0214 Production Index Language driver mismatch');
          add('00533 0215 Production Index damaged');
          add('00534 0216 Rebuild Production Index');
          add('00535 0217 Rebuild all the Production Indexes');
          add('01024 0400 Lookup table not found or corrupt');
          add('01025 0401 Blob file not found or corrupt');
          add('01026 0402 Open Read Only');
          add('01027 0403 Open the table in read only mode');
          add('01028 0404 Fail Open');
          add('01029 0405 Do not open the table');
          add('01030 0406 Remove lookup');
          add('01031 0407 Remove link to lookup table');
          add('02048 0800 Reading records');
          add('02049 0801 Sorting records');
          add('02050 0802 Writing records');
          add('02051 0803 Merging');
          add('02052 0804 Steps Completed');
          add('02053 0805 Packing records');
          add('02309 0905 LIKE');
          add('02310 0906 NOT');
          add('02320 0910 INSERT');
          add('02321 0911 DELETE');
          add('02322 0912 CHANGETO');
          add('02323 0913 CHANGE');
          add('02324 0914 TO');
          add('02325 0915 FIND');
          add('02326 0916 CALC');
          add('02327 0917 COUNT');
          add('02328 0918 SUM');
          add('02329 0919 AVERAGE');
          add('02330 091A MAX');
          add('02331 091B MIN');
          add('02332 091C ALL');
          add('02333 091D UNIQUE');
          add('02334 091E BLANK');
          add('02335 091F TODAY');
          add('02336 0920 AS');
          add('02337 0921 DESCENDING');
          add('02338 0922 OR');
          add('02339 0923 ONLY');
          add('02340 0924 EVERY');
          add('02341 0925 NO');
          add('02342 0926 EXACTLY');
          add('02343 0927 SET');
          add('02347 092B %time');
          add('02348 092C %date');
          add('02353 0931 %lower');
          add('02354 0932 %upper');
          add('02355 0933 %trim');
          add('02356 0934 %substring');
          add('02364 093C __QB0000');
          add('02365 093D ANSWER');
          add('02366 093E DELETED');
          add('02367 093F INSERTED');
          add('02368 0940 CHANGED');
          add('02369 0941 ERRORDEL');
          add('02370 0942 ERRORINS');
          add('02371 0943 ERRORCHG');
          add('02372 0944 __XLTTMP');
          add('02373 0945 __QBEDIC');
          add('02405 0965 JAN');
          add('02406 0966 FEB');
          add('02407 0967 MAR');
          add('02408 0968 APR');
          add('02409 0969 MAY');
          add('02410 096A JUN');
          add('02411 096B JUL');
          add('02412 096C AUG');
          add('02413 096D SEP');
          add('02414 096E OCT');
          add('02415 096F NOV');
          add('02416 0970 DEC');
          add('02423 0977 INSERTED.DB');
          add('02424 0978 CHANGED.DB');
          add('02425 0979 DELETED.DB');
          add('02426 097A ANSWER.DB');
          add('02427 097B blank');
          add('02428 097C Sum of');
          add('02429 097D Average of');
          add('02430 097E Count of');
          add('02431 097F Max of');
          add('02432 0980 Min of');
          add('02433 0981 GROUPBY');
          add('02434 0982 FIELDORDER');
          add('02435 0983 SORT');
          add('02436 0984 ANSWER');
          add('02437 0985 TYPE');
          add('02438 0986 OPTIONS');
          add('02440 0988 GENERATE AUXILIARY TABLES');
          add('02441 0989 NO AUXILIARY TABLES');
          add('02442 098A SERVER');
          add('02443 098B LOCAL');
          add('02444 098C CANNED');
          add('02445 098D LIVE');
          add('02446 098E SPEED');
          add('02447 098F %extract');
          add('02448 0990 DATE');
          add('02449 0991 TIME');
          add('02450 0992 YEAR');
          add('02451 0993 MONTH');
          add('02452 0994 DAY');
          add('02453 0995 HOUR');
          add('02454 0996 MINUTE');
          add('02455 0997 SECOND');
          add('08449 2101 Cannot open a system file.');
          add('08450 2102 I/O error on a system file.');
          add('08451 2103 Data structure corruption.');
          add('08452 2104 Cannot find Engine configuration file.');
          add('08453 2105 Cannot write to Engine configuration file.');
          add('08454 2106 Cannot initialize with different configuration file.');
          add('08455 2107 System has been illegally re-entered.');
          add('08456 2108 Cannot locate IDAPI01.DLL');
          add('08457 2109 Cannot load IDAPI01.DLL');
          add('08458 210A Cannot load an IDAPI service library');
          add('08705 2201 At beginning of table.');
          add('08706 2202 At end of table.');
          add('08707 2203 Record moved because key value changed.');
          add('08708 2204 Record/Key deleted.');
          add('08709 2205 No current record.');
          add('08710 2206 Could not find record.');
          add('08711 2207 End of BLOB.');
          add('08712 2208 Could not find object.');
          add('08713 2209 Could not find family member.');
          add('08714 220A BLOB file is missing.');
          add('08715 220B Could not find language driver.');
          add('08961 2301 Corrupt table/index header.');
          add('08962 2302 Corrupt file - other than header.');
          add('08963 2303 Corrupt Memo/BLOB file.');
          add('08965 2305 Corrupt index.');
          add('08966 2306 Corrupt lock file.');
          add('08967 2307 Corrupt family file.');
          add('08968 2308 Corrupt or missing .VAL file.');
          add('08969 2309 Foreign index file format.');
          add('09217 2401 Read failure.');
          add('09218 2402 Write failure.');
          add('09219 2403 Cannot access directory.');
          add('09220 2404 File Delete operation failed.');
          add('09221 2405 Cannot access file.');
          add('09222 2406 Access to table disabled because of previous error.');
          add('09473 2501 Insufficient memory for this operation.');
          add('09474 2502 Not enough file handles.');
          add('09475 2503 Insufficient disk space.');
          add('09476 2504 Temporary table resource limit.');
          add('09477 2505 Record size is too big for table.');
          add('09478 2506 Too many open cursors.');
          add('09479 2507 Table is full.');
          add('09480 2508 Too many sessions from this workstation.');
          add('09481 2509 Serial number limit (Paradox).');
          add('09482 250A Some internal limit (see context).');
          add('09483 250B Too many open tables.');
          add('09484 250C Too many cursors per table.');
          add('09485 250D Too many record locks on table.');
          add('09486 250E Too many clients.');
          add('09487 250F Too many indexes on table.');
          add('09488 2510 Too many sessions.');
          add('09489 2511 Too many open databases.');
          add('09490 2512 Too many passwords.');
          add('09491 2513 Too many active drivers.');
          add('09492 2514 Too many fields in Table Create.');
          add('09493 2515 Too many table locks.');
          add('09494 2516 Too many open BLOBs.');
          add('09495 2517 Lock file has grown too large.');
          add('09496 2518 Too many open queries.');
          add('09498 251A Too many BLOBs.');
          add('09729 2601 Key violation.');
          add('09730 2602 Minimum validity check failed.');
          add('09731 2603 Maximum validity check failed.');
          add('09732 2604 Field value required.');
          add('09733 2605 Master record missing.');
          add('09734 2606 Master has detail records. Cannot delete or modify.');
          add('09735 2607 Master table level is incorrect.');
          add('09736 2608 Field value out of lookup table range.');
          add('09737 2609 Lookup Table Open operation failed.');
          add('09738 260A Detail Table Open operation failed.');
          add('09739 260B Master Table Open operation failed.');
          add('09740 260C Field is blank.');
          add('09741 260D Link to master table already defined.');
          add('09742 260E Master table is open.');
          add('09743 260F Detail table(s) exist.');
          add('09744 2610 Master has detail records. Cannot empty it.');
          add('09745 2611 Self referencing referential integrity must be entered one at a time with no other changes to table');
          add('09746 2612 Detail table is open.');
          add('09747 2613 Cannot make this master a detail of another table if its details are not empty.');
          add('09748 2614 Referential integrity fields must be indexed.');
          add('09749 2615 A table linked by referential integrity requires password to open.');
          add('09750 2616 Field(s) linked to more than one master.');
          add('09985 2701 Number is out of range.');
          add('09986 2702 Invalid parameter.');
          add('09987 2703 Invalid file name.');
          add('09988 2704 File does not exist.');
          add('09989 2705 Invalid option.');
          add('09990 2706 Invalid handle to the function.');
          add('09991 2707 Unknown table type.');
          add('09992 2708 Cannot open file.');
          add('09993 2709 Cannot redefine primary key.');
          add('09994 270A Cannot change this RINTDesc.');
          add('09995 270B Foreign and primary key do not match.');
          add('09996 270C Invalid modify request.');
          add('09997 270D Index does not exist.');
          add('09998 270E Invalid offset into the BLOB.');
          add('09999 270F Invalid descriptor number.');
          add('10000 2710 Invalid field type.');
          add('10001 2711 Invalid field descriptor.');
          add('10002 2712 Invalid field transformation.');
          add('10003 2713 Invalid record structure.');
          add('10004 2714 Invalid descriptor.');
          add('10005 2715 Invalid array of index descriptors.');
          add('10006 2716 Invalid array of validity check descriptors.');
          add('10007 2717 Invalid array of referential integrity descriptors.');
          add('10008 2718 Invalid ordering of tables during restructure.');
          add('10009 2719 Name not unique in this context.');
          add('10010 271A Index name required.');
          add('10011 271B Invalid session handle.');
          add('10012 271C invalid restructure operation.');
          add('10013 271D Driver not known to system.');
          add('10014 271E Unknown database.');
          add('10015 271F Invalid password given.');
          add('10016 2720 No callback function.');
          add('10017 2721 Invalid callback buffer length.');
          add('10018 2722 Invalid directory.');
          add('10019 2723 Translate Error. Value out of bounds.');
          add('10020 2724 Cannot set cursor of one table to another.');
          add('10021 2725 Bookmarks do not match table.');
          add('10022 2726 Invalid index/tag name.');
          add('10023 2727 Invalid index descriptor.');
          add('10024 2728 Table does not exist.');
          add('10025 2729 Table has too many users.');
          add('10026 272A Cannot evaluate Key or Key does not pass filter condition.');
          add('10027 272B Index already exists.');
          add('10028 272C Index is open.');
          add('10029 272D Invalid BLOB length.');
          add('10030 272E Invalid BLOB handle in record buffer.');
          add('10031 272F Table is open.');
          add('10032 2730 Need to do (hard) restructure.');
          add('10033 2731 Invalid mode.');
          add('10034 2732 Cannot close index.');
          add('10035 2733 Index is being used to order table.');
          add('10036 2734 Unknown user name or password.');
          add('10037 2735 Multi-level cascade is not supported.');
          add('10038 2736 Invalid field name.');
          add('10039 2737 Invalid table name.');
          add('10040 2738 Invalid linked cursor expression.');
          add('10041 2739 Name is reserved.');
          add('10042 273A Invalid file extension.');
          add('10043 273B Invalid language Driver.');
          add('10044 273C Alias is not currently opened.');
          add('10045 273D Incompatible record structures.');
          add('10046 273E Name is reserved by DOS.');
          add('10047 273F Destination must be indexed.');
          add('10048 2740 Invalid index type');
          add('10049 2741 Language Drivers of Table and Index do not match');
          add('10050 2742 Filter handle is invalid');
          add('10051 2743 Invalid Filter');
          add('10052 2744 Invalid table create request');
          add('10053 2745 Invalid table delete request');
          add('10054 2746 Invalid index create request');
          add('10055 2747 Invalid index delete request');
          add('10056 2748 Invalid table specified');
          add('10058 274A Invalid Time.');
          add('10059 274B Invalid Date.');
          add('10060 274C Invalid Datetime');
          add('10061 274D Tables in different directories');
          add('10062 274E Mismatch in the number of arguments');
          add('10063 274F Function not found in service library.');
          add('10064 2750 Must use baseorder for this operation.');
          add('10065 2751 Invalid procedure name');
          add('10241 2801 Record locked by another user.');
          add('10242 2802 Unlock failed.');
          add('10243 2803 Table is busy.');
          add('10244 2804 Directory is busy.');
          add('10245 2805 File is locked.');
          add('10246 2806 Directory is locked.');
          add('10247 2807 Record already locked by this session.');
          add('10248 2808 Object not locked.');
          add('10249 2809 Lock time out.');
          add('10250 280A Key group is locked.');
          add('10251 280B Table lock was lost.');
          add('10252 280C Exclusive access was lost.');
          add('10253 280D Table cannot be opened for exclusive use.');
          add('10254 280E Conflicting record lock in this session.');
          add('10255 280F A deadlock was detected.');
          add('10256 2810 A user transaction is already in progress.');
          add('10257 2811 No user transaction is currently in progress.');
          add('10258 2812 Record lock failed.');
          add('10259 2813 Couldnt perform the edit because another user changed the record.');
          add('10260 2814 Couldnt perform the edit because another user deleted or moved the record.');
          add('10497 2901 Insufficient field rights for operation.');
          add('10498 2902 Insufficient table rights for operation. Password required.');
          add('10499 2903 Insufficient family rights for operation.');
          add('10500 2904 This directory is read only.');
          add('10501 2905 Database is read only.');
          add('10502 2906 Trying to modify read-only field.');
          add('10503 2907 Encrypted dBASE tables not supported.');
          add('10504 2908 Insufficient SQL rights for operation.');
          add('10753 2A01 Field is not a BLOB.');
          add('10754 2A02 BLOB already opened.');
          add('10755 2A03 BLOB not opened.');
          add('10756 2A04 Operation not applicable.');
          add('10757 2A05 Table is not indexed.');
          add('10758 2A06 Engine not initialized.');
          add('10759 2A07 Attempt to re-initialize Engine.');
          add('10760 2A08 Attempt to mix objects from different sessions.');
          add('10761 2A09 Paradox driver not active.');
          add('10762 2A0A Driver not loaded.');
          add('10763 2A0B Table is read only.');
          add('10764 2A0C No associated index.');
          add('10765 2A0D Table(s) open. Cannot perform this operation.');
          add('10766 2A0E Table does not support this operation.');
          add('10767 2A0F Index is read only.');
          add('10768 2A10 Table does not support this operation because it is not uniquely indexed.');
          add('10769 2A11 Operation must be performed on the current session.');
          add('10770 2A12 Invalid use of keyword.');
          add('10771 2A13 Connection is in use by another statement.');
          add('10772 2A14 Passthrough SQL connection must be shared');
          add('11009 2B01 Invalid function number.');
          add('11010 2B02 File or directory does not exist.');
          add('11011 2B03 Path not found.');
          add('11012 2B04 Too many open files. You may need to increase MAXFILEHANDLE limit in IDAPI configuration.');
          add('11013 2B05 Permission denied.');
          add('11014 2B06 Bad file number.');
          add('11015 2B07 Memory blocks destroyed.');
          add('11016 2B08 Not enough memory.');
          add('11017 2B09 Invalid memory block address.');
          add('11018 2B0A Invalid environment.');
          add('11019 2B0B Invalid format.');
          add('11020 2B0C Invalid access code.');
          add('11021 2B0D Invalid data.');
          add('11023 2B0F Device does not exist.');
          add('11024 2B10 Attempt to remove current directory.');
          add('11025 2B11 Not same device.');
          add('11026 2B12 No more files.');
          add('11027 2B13 Invalid argument.');
          add('11028 2B14 Argument list is too long.');
          add('11029 2B15 Execution format error.');
          add('11030 2B16 Cross-device link.');
          add('11041 2B21 Math argument.');
          add('11042 2B22 Result is too large.');
          add('11043 2B23 File already exists.');
          add('11047 2B27 Unknown internal operating system error.');
          add('11058 2B32 Share violation.');
          add('11059 2B33 Lock violation.');
          add('11060 2B34 Critical DOS Error.');
          add('11061 2B35 Drive not ready.');
          add('11108 2B64 Not exact read/write.');
          add('11109 2B65 Operating system network error.');
          add('11110 2B66 Error from NOVELL file server.');
          add('11111 2B67 NOVELL server out of memory.');
          add('11112 2B68 Record already locked by this workstation.');
          add('11113 2B69 Record not locked.');
          add('11265 2C01 Network initialization failed.');
          add('11266 2C02 Network user limit exceeded.');
          add('11267 2C03 Wrong .NET file version.');
          add('11268 2C04 Cannot lock network file.');
          add('11269 2C05 Directory is not private.');
          add('11270 2C06 Multiple .NET files in use.');
          add('11271 2C07 Unknown network error.');
          add('11272 2C08 Not initialized for accessing network files.');
          add('11273 2C09 SHARE not loaded. It is required to share local files.');
          add('11274 2C0A Not on a network. Not logged in or wrong network driver.');
          add('11275 2C0B Lost communication with SQL server.');
          add('11521 2D01 Optional parameter is required.');
          add('11522 2D02 Invalid optional parameter.');
          add('11777 2E01 obsolete');
          add('11778 2E02 obsolete');
          add('11779 2E03 Ambiguous use of ! (inclusion operator).');
          add('11780 2E04 obsolete');
          add('11781 2E05 obsolete');
          add('11782 2E06 A SET operation cannot be included in its own grouping.');
          add('11783 2E07 Only numeric and date/time fields can be averaged.');
          add('11784 2E08 Invalid expression.');
          add('11785 2E09 Invalid OR expression.');
          add('11786 2E0A obsolete');
          add('11787 2E0B bitmap');
          add('11788 2E0C CALC expression cannot be used in INSERT, DELETE, CHANGETO and SET rows.');
          add('11789 2E0D Type error in CALC expression.');
          add('11790 2E0E CHANGETO can be used in only one query form at a time.');
          add('11791 2E0F Cannot modify CHANGED table.');
          add('11792 2E10 A field can contain only one CHANGETO expression.');
          add('11793 2E11 A field cannot contain more than one expression to be inserted.');
          add('11794 2E12 obsolete');
          add('11795 2E13 CHANGETO must be followed by the new value for the field.');
          add('11796 2E14 Checkmark or CALC expressions cannot be used in FIND queries.');
          add('11797 2E15 Cannot perform operation on CHANGED table together with a CHANGETO query.');
          add('11798 2E16 chunk');
          add('11799 2E17 More than 255 fields in ANSWER table.');
          add('11800 2E18 AS must be followed by the name for the field in the ANSWER table.');
          add('11801 2E19 DELETE can be used in only one query form at a time.');
          add('11802 2E1A Cannot perform operation on DELETED table together with a DELETE query.');
          add('11803 2E1B Cannot delete from the DELETED table.');
          add('11804 2E1C Example element is used in two fields with incompatible types or with a BLOB.');
          add('11805 2E1D Cannot use example elements in an OR expression.');
          add('11806 2E1E Expression in this field has the wrong type.');
          add('11807 2E1F Extra comma found.');
          add('11808 2E20 Extra OR found.');
          add('11809 2E21 One or more query rows do not contribute to the ANSWER.');
          add('11810 2E22 FIND can be used in only one query form at a time.');
          add('11811 2E23 FIND cannot be used with the ANSWER table.');
          add('11812 2E24 A row with GROUPBY must contain SET operations.');
          add('11813 2E25 GROUPBY can be used only in SET rows.');
          add('11814 2E26 Use only INSERT, DELETE, SET or FIND in leftmost column.');
          add('11815 2E27 Use only one INSERT, DELETE, SET or FIND per line.');
          add('11816 2E28 Syntax error in expression.');
          add('11817 2E29 INSERT can be used in only one query form at a time.');
          add('11818 2E2A Cannot perform operation on INSERTED table together with an INSERT query.');
          add('11819 2E2B INSERT, DELETE, CHANGETO and SET rows may not be checked.');
          add('11820 2E2C Field must contain an expression to insert (or be blank).');
          add('11821 2E2D Cannot insert into the INSERTED table.');
          add('11822 2E2E Variable is an array and cannot be accessed.');
          add('11823 2E2F Label');
          add('11824 2E30 Rows of example elements in CALC expression must be linked.');
          add('11825 2E31 Variable name is too long.');
          add('11826 2E32 Query may take a long time to process.');
          add('11827 2E33 Reserved word or one that cant be used as a variable name.');
          add('11828 2E34 Missing comma.');
          add('11829 2E35 Missing ).');
          add('11830 2E36 Missing right quote.');
          add('11831 2E37 Cannot specify duplicate column names.');
          add('11832 2E38 Query has no checked fields.');
          add('11833 2E39 Example element has no defining occurrence.');
          add('11834 2E3A No grouping is defined for SET operation.');
          add('11835 2E3B Query makes no sense.');
          add('11836 2E3C Cannot use patterns in this context.');
          add('11837 2E3D Date does not exist.');
          add('11838 2E3E Variable has not been assigned a value.');
          add('11839 2E3F Invalid use of example element in summary expression.');
          add('11840 2E40 Incomplete query statement. Query only contains a SET definition.');
          add('11841 2E41 Example element with ! makes no sense in expression.');
          add('11842 2E42 Example element cannot be used more than twice with a ! query.');
          add('11843 2E43 Row cannot contain expression.');
          add('11844 2E44 obsolete');
          add('11845 2E45 obsolete');
          add('11846 2E46 No permission to insert or delete records.');
          add('11847 2E47 No permission to modify field.');
          add('11848 2E48 Field not found in table.');
          add('11849 2E49 Expecting a column separator in table header.');
          add('11850 2E4A Expecting a column separator in table.');
          add('11851 2E4B Expecting column name in table.');
          add('11852 2E4C Expecting table name.');
          add('11853 2E4D Expecting consistent number of columns in all rows of table.');
          add('11854 2E4E Cannot open table.');
          add('11855 2E4F Field appears more than once in table.');
          add('11856 2E50 This DELETE, CHANGE or INSERT query has no ANSWER.');
          add('11857 2E51 Query is not prepared. Properties unknown.');
          add('11858 2E52 DELETE rows cannot contain quantifier expression.');
          add('11859 2E53 Invalid expression in INSERT row.');
          add('11860 2E54 Invalid expression in INSERT row.');
          add('11861 2E55 Invalid expression in SET definition.');
          add('11862 2E56 row use');
          add('11863 2E57 SET keyword expected.');
          add('11864 2E58 Ambiguous use of example element.');
          add('11865 2E59 obsolete');
          add('11866 2E5A obsolete');
          add('11867 2E5B Only numeric fields can be summed.');
          add('11868 2E5C Table is write protected.');
          add('11869 2E5D Token not found.');
          add('11870 2E5E Cannot use example element with ! more than once in a single row.');
          add('11871 2E5F Type mismatch in expression.');
          add('11872 2E60 Query appears to ask two unrelated questions.');
          add('11873 2E61 Unused SET row.');
          add('11874 2E62 INSERT, DELETE, FIND, and SET can be used only in the leftmost column.');
          add('11875 2E63 CHANGETO cannot be used with INSERT, DELETE, SET or FIND.');
          add('11876 2E64 Expression must be followed by an example element defined in a SET.');
          add('11877 2E65 Lock failure.');
          add('11878 2E66 Expression is too long.');
          add('11879 2E67 Refresh exception during query.');
          add('11880 2E68 Query canceled.');
          add('11881 2E69 Unexpected Database Engine error.');
          add('11882 2E6A Not enough memory to finish operation.');
          add('11883 2E6B Unexpected exception.');
          add('11884 2E6C Feature not implemented yet in query.');
          add('11885 2E6D Query format is not supported.');
          add('11886 2E6E Query string is empty.');
          add('11887 2E6F Attempted to prepare an empty query.');
          add('11888 2E70 Buffer too small to contain query string.');
          add('11889 2E71 Query was not previously parsed or prepared.');
          add('11890 2E72 Function called with bad query handle.');
          add('11891 2E73 QBE syntax error.');
          add('11892 2E74 Query extended syntax field count error.');
          add('11893 2E75 Field name in sort or field clause not found.');
          add('11894 2E76 Table name in sort or field clause not found.');
          add('11895 2E77 Operation is not supported on BLOB fields.');
          add('11896 2E78 General BLOB error.');
          add('11897 2E79 Query must be restarted.');
          add('11898 2E7A Unknown answer table type.');
          add('11926 2E96 Blob cannot be used as grouping field.');
          add('11927 2E97 Query properties have not been fetched.');
          add('11928 2E98 Answer table is of unsuitable type.');
          add('11929 2E99 Answer table is not yet supported under server alias.');
          add('11930 2E9A Non-null blob field required. Cant insert records');
          add('11931 2E9B Unique index required to perform changeto');
          add('11932 2E9C Unique index required to delete records');
          add('11933 2E9D Update of table on the server failed.');
          add('11934 2E9E Cant process this query remotely.');
          add('11935 2E9F Unexpected end of command.');
          add('11936 2EA0 Parameter not set in query string.');
          add('11937 2EA1 Query string is too long.');
          add('12033 2F01 Interface mismatch. Engine version different.');
          add('12034 2F02 Index is out of date.');
          add('12035 2F03 Older version (see context).');
          add('12036 2F04 .VAL file is out of date.');
          add('12037 2F05 BLOB file version is too old.');
          add('12038 2F06 Query and Engine DLLs are mismatched.');
          add('12289 3001 Capability not supported.');
          add('12290 3002 Not implemented yet.');
          add('12291 3003 SQL replicas not supported.');
          add('12292 3004 Non-blob column in table required to perform operation.');
          add('12293 3005 Multiple connections not supported.');
          add('12545 3101 Invalid database alias specification.');
          add('12546 3102 Unknown database type.');
          add('12547 3103 Corrupt system configuration file.');
          add('12548 3104 Network type unknown.');
          add('12549 3105 Not on the network.');
          add('12550 3106 Invalid configuration parameter.');
          add('12801 3201 Object implicitly dropped.');
          add('12802 3202 Object may be truncated.');
          add('12803 3203 Object implicitly modified.');
          add('12804 3204 Should field constraints be checked?');
          add('12805 3205 Validity check field modified.');
          add('12806 3206 Table level changed.');
          add('12807 3207 Copy linked tables?');
          add('12809 3209 Object implicitly truncated.');
          add('12810 320A Validity check will not be enforced.');
          add('12811 320B Multiple records found, but only one was expected.');
          add('12812 320C Field will be trimmed, cannot put master records into PROBLEM table.');
          add('13057 3301 File already exists.');
          add('13058 3302 BLOB has been modified.');
          add('13059 3303 General SQL error.');
          add('13060 3304 Table already exists.');
          add('13061 3305 Paradox 1.0 tables are not supported.');
          add('13313 3401 Different sort order.');
          add('13314 3402 Directory in use by earlier version of Paradox.');
          add('13315 3403 Needs Paradox 3.5-compatible language driver.');
          add('14849 3A01 SYSTEM');
          add('14850 3A02 DRIVERS');
          add('14851 3A03 DATABASES');
          add('14853 3A05 VERSION');
          add('14854 3A06 NET TYPE');
          add('14855 3A07 NET DIR');
          add('14856 3A08 LOCAL SHARE');
          add('14857 3A09 LANGDRIVER');
          add('14858 3A0A LANGDRVDIR');
          add('14859 3A0B MINBUFSIZE');
          add('14860 3A0C MAXBUFSIZE');
          add('14861 3A0D LOCKRETRY');
          add('14862 3A0E SYSFLAGS');
          add('14863 3A0F MAXFILEHANDLES');
          add('14864 3A10 SQLQRYMODE');
          add('14865 3A11 LOW MEMORY USAGE LIMIT');
          add('14866 3A12 AUTO ODBC');
          add('14867 3A13 DEFAULT DRIVER');
          add('14868 3A14 VERSION');
          add('14869 3A15 TYPE');
          add('14870 3A16 LANGDRIVER');
          add('14871 3A17 FILL FACTOR');
          add('14872 3A18 BLOCK SIZE');
          add('14873 3A19 LOCKPROTOCOL');
          add('14874 3A1A LEVEL');
          add('14875 3A1B DRIVER FLAGS');
          add('14878 3A1E MEMO FILE BLOCK SIZE');
          add('14879 3A1F MDX BLOCK SIZE');
          add('14888 3A28 INIT');
          add('14889 3A29 DB CREATE');
          add('14890 3A2A DB OPEN');
          add('14891 3A2B TABLE CREATE');
          add('14892 3A2C TABLE OPEN');
          add('14898 3A32 DB INFO');
          add('14908 3A3C TYPE');
          add('14909 3A3D PATH');
          add('14910 3A3E DEFAULT DRIVER');
          add('14918 3A46 INIT');
          add('14919 3A47 TYPE');
          add('14920 3A48 STANDARD');
          add('14921 3A49 TRUE');
          add('14922 3A4A FALSE');
          add('14923 3A4B OPEN MODE');
          add('14924 3A4C READ/WRITE');
          add('14925 3A4D READ ONLY');
          add('14926 3A4E SHARE MODE');
          add('14927 3A4F EXCLUSIVE');
          add('14928 3A50 SHARED');
          add('14929 3A51 USER NAME');
          add('14930 3A52 SERVER NAME');
          add('14931 3A53 DATABASE NAME');
          add('14932 3A54 SCHEMA CACHE SIZE');
          add('14933 3A55 STRICTINTEGRTY');
          add('14938 3A5A ORACLE');
          add('14939 3A5B 1.0');
          add('14940 3A5C SERVER');
          add('14941 3A5D NET PROTOCOL');
          add('14942 3A5E DECNET');
          add('14943 3A5F NETBIOS');
          add('14944 3A60 NAMED PIPES');
          add('14945 3A61 SPX/IPX');
          add('14946 3A62 TCP/IP');
          add('14947 3A63 3270');
          add('14948 3A64 VINES');
          add('14949 3A65 APPC');
          add('14950 3A66 ASYNC');
          add('14958 3A6E SYBASE');
          add('14959 3A6F 1.0');
          add('14960 3A70 SERVER');
          add('14961 3A71 BLOB EDIT LOGGING');
          add('14962 3A72 CONNECT TIMEOUT');
          add('14963 3A73 TIMEOUT');
          add('14964 3A74 DATE MODE');
          add('14965 3A75 DATE SEPARATOR');
          add('14966 3A76 DECIMAL SEPARATOR');
          add('14968 3A78 INTRBASE');
          add('14969 3A79 1.0');
          add('14970 3A7A SERVER');
          add('14978 3A82 FORMATS');
          add('14979 3A83 DATE');
          add('14980 3A84 TIME');
          add('14981 3A85 NUMBER');
          add('14988 3A8C SEPARATOR');
          add('14989 3A8D MODE');
          add('14990 3A8E FOURDIGITYEAR');
          add('14991 3A8F YEARBIASED');
          add('14992 3A90 LEADINGZEROM');
          add('14993 3A91 LEADINGZEROD');
          add('14994 3A92 TWELVEHOUR');
          add('14995 3A93 AMSTRING');
          add('14996 3A94 PMSTRING');
          add('14997 3A95 SECONDS');
          add('14998 3A96 MILSECONDS');
          add('15008 3AA0 DECIMALSEPARATOR');
          add('15009 3AA1 THOUSANDSEPARATOR');
          add('15010 3AA2 DECIMALDIGITS');
          add('15011 3AA3 LEADINGZERON');
          add('15013 3AA5 ascii');
          add('15014 3AA6 DB437US0');
          add('15018 3AAA /');
          add('15019 3AAB 0');
          add('15020 3AAC FALSE');
          add('15021 3AAD TRUE');
          add('15022 3AAE TRUE');
          add('15023 3AAF TRUE');
          add('15024 3AB0 TRUE');
          add('15025 3AB1 AM');
          add('15026 3AB2 PM');
          add('15027 3AB3 TRUE');
          add('15028 3AB4 FALSE');
          add('15029 3AB5 .');
          add('15030 3AB6 ,');
          add('15031 3AB7 TRUE');
          add('15873 3E01 Wrong driver name.');
          add('15874 3E02 Wrong system version.');
          add('15875 3E03 Wrong driver version.');
          add('15876 3E04 Wrong driver type.');
          add('15877 3E05 Cannot load driver.');
          add('15878 3E06 Cannot load language driver.');
          add('15879 3E07 Vendor initialization failed.');
          add('16129 3F01 Query By Example');
          add('16130 3F02 SQL Generator');
          add('16131 3F03 IDAPI');
          add('16132 3F04 Lock Manager');
          add('16133 3F05 SQL Driver');
          add('16134 3F06 IDAPI Services');
          add('16135 3F07 dBASE Driver');
          add('16138 3F0A Token');
          add('16140 3F0C Table');
          add('16141 3F0D Field');
          add('16142 3F0E Image');
          add('16143 3F0F User');
          add('16144 3F10 File');
          add('16145 3F11 Index');
          add('16146 3F12 Directory');
          add('16147 3F13 Key');
          add('16148 3F14 Alias');
          add('16149 3F15 Drive');
          add('16150 3F16 Server error');
          add('16151 3F17 Server message');
          add('16152 3F18 Line Number');
          add('16153 3F19 Capability');
          add('16154 3F1A Limit');
          add('16239 3F6F WORK');
          add('16240 3F70 PRIV');
          add('16241 3F71 Rec');
     end;

     // Log and Message Dialog
     if (E is EDatabaseError) then
     begin
       if (E is EDBEngineError) then
       begin
         with (E as EDBEngineError) do
         begin
              // Find the error code, and determine the description
              mErrorCode := RightCopy('00000'+IntToStr(Errors[0].ErrorCode),5);
              for mLoop := 0 to mErrorList.Count - 1 do
              begin
                   if mErrorCode = copy(mErrorList[mLoop],1,5) then
                   begin
                        mErrorDesc := mErrorList[mLoop];
                        break; // from loop
                   end;
              end;
              // Check the error
              if mErrorDesc = '' then
              begin
                   mErrorDesc := '*** Undefined error ***';
              end;
              // Put the header on it
              mErrorDesc := 'BDE Code: ' + mErrorDesc;


              // Show message to the screen
              if pDialogMode then
              MessageDlg(pMsgText + CRLF +
                         E.ClassName + CRLF +
                         E.Message + ' ('+IntToStr(E.HelpContext)+')' + CRLF +
                         mErrorDesc,
                         mtError,
                         [mbOk], 0);
              // Result
              mErrorText := Copy(FormatDateTime('yyyy"/"mm"/"dd-hh:nn:ss', Now),1,19)+
                            ': BDE DATABASE ENGINE ERROR: '+
                            E.ClassName+
                            ' - '+E.Message+' ('+IntToStr(E.HelpContext)+')'+
                            ' - '+mErrorDesc;
         end;
       end
       else
       begin
         if pDialogMode then
         MessageDlg(pMsgText + CRLF +
                    E.Message+' ('+IntToStr(E.HelpContext)+')',
                    mtError,
                    [mbOk], 0);
         // Result
         mErrorText := Copy(FormatDateTime('yyyy"/"mm"/"dd-hh:nn:ss', Now),1,19)+
                       ': DATABASE ERROR: '+
                       E.Message+' ('+IntToStr(E.HelpContext)+')';
       end;
     end
     else
     begin
       if pDialogMode then
       MessageDlg(pMsgText + CRLF +
                  E.ClassName + ': ' + E.Message+' ('+IntToStr(E.HelpContext)+')',
                  mtError,
                  [mbOk], 0);
       // Result
       mErrorText := Copy(FormatDateTime('yyyy"/"mm"/"dd-hh:nn:ss', Now),1,19)+
                     ': GENERAL ERROR: '+
                     E.ClassName+
                     ' - '+E.Message+' ('+IntToStr(E.HelpContext)+')';
     end; // if EDatabaseError

  finally
    mErrorList.Free;
  end;

end; // BDEErrorMessage


end.

