unit CalcWorkUnit;
(*
  Program: ApplicationWorkUnit
  Version: 1.12
  Author:  engenic
  Date:    1995 - ongoing
  License: GPL

  Copyright(c) 1995 engenic
*)

// WARNING: Do not update or add to "WorkUnit" files
// - We will not accept contributions for these files
// It's a Library ... place in search path
// Library contains old code and abandoned code
// Use at own risk

interface

uses
  ShellAPI,Messages,SysUtils,Classes,Windows, Math, DateUtils, Variants, Winsock;

    procedure SetStandardDateTimeFormats;
    function GetYYYYMMDDHHNNSSZZZ: String;
    procedure MoveStringToRecord(pString: string; pOffSet: Integer; var pRec; pRecSize : integer);
    procedure MoveRecordToString(var pRec; pRecSize : integer; var pString: string);
    function IsLeapYear( nYear: Integer ): Boolean;
    function MonthDays( nMonth, nYear: Integer ): Integer;
    function WeekOfYear( dDate: TDateTime ): Integer;
    function DayofWeekName( pDayNum: Integer): String;
    function PosOccurance(pSubStr, pString: String; pOccurance: Integer): integer;
    function WildCardMatch(AString, Pattern: string): boolean;
    function SlashToBackSlash( const str: string ) : string;
    function BackSlashToSlash( const str: string ) : string;
    function DateMathYYYYMMDDHHNNSSZZZ(pDateStamp: String; pDiffSeconds: Integer): String;
    function YYYYMMDDHHNNSStoDateTime(pDateStamp: String): TDateTime;
    function GetYYYYMMDDDate(pDate: TDateTime; pDaysDiff: Integer): String;
    function GetMMForMonthName(pMonthIn: String): String;
    function GetCurrentTimeZoneName(pTimeZoneCode: String; pDayLightSavings: Boolean): String;
    function GetHHMMSS: String;
    function ExtractFileNameNoPath(pPathFileName: String): String;
    function GetDateFromTFDate(pTFDate: String): TDateTime;
    function GetTimeFromTFTime(pTFTime: String): TDateTime;
    function GetDateTimeFromTFDateandTFTime(pTFDate, pTFTime: String): TDateTime;
    function GetTFTimeFromTime(pTime: TDateTime): String;
    function GetTFDateFromDate(pDate: TDateTime): String;
    function GetTFDateFromYYYYMMDD(pNumericDate: Integer): String;
    function IsValidTeleFlowDate(pTFDate: String): Boolean;
    function IsValidTeleFlowTime(pTFTime: String): Boolean;
    function IsValidTeleFlowVar(pTFVar: String): Boolean;
    function IsValidEmail(const Value: string): boolean;
    function IsValidHash(const Value: string): boolean;
    function Time24Add(pTime: String; pHours: Integer): String;
    function Time24AddMinutes(pTime: String; pMins: Integer): String;
    function TimeAmPmTo24hour(pTime: String): String;
    function Time24hourToAmPm(pTime: String): String;
    function DecimalTime(pTime: TDateTime; pRoundMinutes: Integer): Real;
    function TeleFlowTimeStamp: String;
    function TeleFlowTimeStampZZZ: String;
    function GetNowAsTeleFlowDate: String;
    function GetNowAsTeleFlowTime: String;
    function MakeTeleFlowDate(pDate: String): String;
    function CalcGetComputerName: String;
    function CalcGetUserName: String;
    function SentenceCase(s : string): string;
    function NameCase(s : string): string;
    function TitleCase(const sText: String; const bLowerCaseFirst: Boolean = True): String;
    function TrueOrYes(pWord: String): Boolean;
    function FalseOrNo(pWord: String): Boolean;
    function FormattedDateTimeToUniqueNumber(pDate, pTime: String): String;    // TeleFlow Types to YYYYMMDDhhmmss
    function GetLocalComputerName: String;
//    function GetLocalHostName: String;
    function IFF( condition: Boolean; ifvalue, elsevalue: variant):variant;
    function DoubleQuoteWrap(pText: String): String;
    function SingleQuoteWrap(pText: String): String;
    function QuoteWrapDouble(pText: String): String;
    function QuoteWrapSingle(pText: String): String;
    function ReplaceAllSingleChar(pString: String; pFrom: Char; pTo: String): String;
    function StringReplaceAll(pOriginalString, pFindString, pReplaceString: String): String;
    function ReplaceAllSubStringsWithAnother(pFindString, pReplaceString, pOriginalString: String): String;
    procedure FindAndReplaceString(var pChangeString: String; pFindString, pReplaceStr: String);
    function BuildStringListWithParameters(pStatement: TStrings; pParams: String; var pSuccess: Boolean): TStringList;
    function HexToInt(const HexStr: string): longint;
    function DiskInformation(pDriveList: String): String;
    function GetLocalHardDrives: string;
    function UpperCaseSpaceStrip(pField: String): String;
    function DateFormat(pDateIn, pDateFormatIn, pDateFormatOut: String): String;
    function TimeFormat(pTimeIn, pTimeFormatOut, pConvert: String): String;
    function TestExpression(pExpression, pString: String): Boolean;
    function RecordParse(pRecord: String; pFieldNum: Integer): String;
    function RecordParseRight(pRecord: String; pFieldNum: Integer): String;
    function RecordParseCustomDelimiter(pRecord, pDelim: String; pFieldNum: Integer): String;
    function RecordParseCustomDelimiterRight(pRecord, pDelim: String; pFieldNum: Integer): String;
    function RecordParseIsolateBetween(pRecord,pDelimiterStart,pDelimiterEnd: String): String;
    function StripRepeatingChars(pString, pChar: String): String;
    function StripOutSpaces(pString: String): String;
    function StripOutChar(pString, pChar: String): String;
    function StripOutDelimiterChars(pString: String): String;
    function StripOutDelimiterCharsComplete(pString: String): String;
    function StripOutNonDigits(pString: String): String;
    function SpaceOutNonDigits(pString: String): String;
    function StripOutNonDigitsOrAlpha(pString: String): String;
    function StripOutNonNamingChars(pString: String): String;
    function SpaceOutNonNamingChars(pString: String): String;
    function StripOutCRLF(pString: String): String;
    function StripOutCR(pString: String): String;
    function StripOutsideQuotes(pString: String): String;
    function StringListToString(pStringList: TStringList): String;
    function LeftCharUpperCaseCompare(pField1,pField2: String; pChars: Integer): Boolean;
    function AddDigitsTogether(pDigitsList: String): Integer;
    function UpperCaseCompare(pField1,pField2: String): Boolean;
    function TimeMath(pTime: TDateTime; pOpr: Char; pValue: Integer; pUnits: Char): TDateTime;
    function HoursDifference(pDateTime1,pDateTime2: TDateTime): Real;
    function DateStringAdd(pDate: String; pDays: Integer): String;
    function DateStringSubtract(pDate: String; pDays: Integer): String;
    function RightCopy(pString: String; pChars: Integer): String;
    function GetDegreeAngle(x1,y1,x2,y2: Integer): Extended;
    function PadStringToLength(pString: String; pLen: Integer): String;
    function CopyFromBetweenChars(pString,pCStart,pCEnd: String) :String;
    function DoubleBackSlashes(pFile: String): String;
    function VerboseDateOptionalTime(pDate, pTime: String): String; overload;
    function VerboseDateOptionalTime(pDate, pDateTimeSeperator, pTime: String): String; overload;
    function CommaIntToStr(pConvertInt: Integer): String;
    function FourByteReverse(pVal: Cardinal): Cardinal;
    function ExpressAge(pDateThen: TDateTime; pDaysTitle, pHoursTitle, pMinutesTitle: String): String;
    function GetStateProv(pCode: String; var pVarCountry: String): String;
    function GetPosOfLastCharInstance(pScanString, pSearchChar: String): Integer;
    // Telephone number stuff
    function TTLetterDigits(pStringToConv: String): String;
    function IsValidTelephoneNo10(pTelephone: String): Boolean;
    function IsNumber(pString: String): Boolean;
    function TelephoneNumberDisplay(pNumber: String): String;
    function TelephoneNumberClassic(pTelNo: String): String;
    function GetTelnoOverLay(pOverLayArea: Integer; var pInProvState: String): Integer;
    // Time marking and checking
    procedure FCTimeReportStart;
    function  FCTimeReportAdd(pShortDesc: String): String;
    procedure FCTimeCountGo;
    procedure FCTimeCountStop;  // You get the total in TTTimeCount (see notes below)
    function CompToStr(N: comp): string;
    // Encryption
    function StringEncrypt(const S: AnsiString; Key: Word): AnsiString;
    function StringDecrypt(const S: AnsiString; Key: Word): AnsiString;
    function Decode(const S: AnsiString): AnsiString;
    function PreProcess(const S: AnsiString): AnsiString;
    function InternalDecrypt(const S: AnsiString; Key: Word): AnsiString;
    function Encode(const S: AnsiString): AnsiString;
    function PostProcess(const S: AnsiString): AnsiString;
    function InternalEncrypt(const S: AnsiString; Key: Word): AnsiString;
    function GetCpuSpeed: String;
    function WhatOSisThis(var pNumber: Integer): String;
    function MoneyFormatDollars(pCents: Integer): String;
    // HTML functions
    function HTMLHardSpace(pText: String): String;
    function HTMLBr: String;
    // - Log
    function LogHTMLStart: String;
    function LogHTMLEnd: String;
    // -Table
    function HTMLTableStart(pOptionalColor: String): String;
    function HTMLTableEnd: String;
    function HTMLRowStart: String;
    function HTMLRowEnd: String;
    function HTMLCellAlternatingRowColor(pContents: String; pAlignRight: Boolean; pOptionalColor: String): String;
    function HTMLColorBGSetup(pBaseColor, pColor: String): String;
    function HTMLWrapErrorMessage(pError: String): String;
    // XML functions
    function XMLHeader: String;
    function XMLHeaderRemove(pData: String): String;
    function XMLRecordWrap(pField: String; pData: String): String;
    function XMLRecordWrapWithElements(pField: String; pElement, pData: String): String;
    function XMLTagWrapWithAttributes(pTag: String; pAttributes, pValue: String): String;
    function XMLTagWrap(pTag: String; pData: Variant): String;
    function XMLAttributeWrap(pAttribute: String; pData: Variant): String;
    function XMLGetTag(pTagName, pXMLString: String): String;
    function XMLReplaceProhibitedChars(pValue: String): String;
    function XMLInstallProhibitedChars(pValue: String): String;
    function XMLMagicQuoteSlash(pValue: String): String;
    function XMLPacketStart: String;
    function XMLPacketEnd: String;
    function XMLGetAttributeValue(pAttribute, pRecord: String): String;
    // VXML
    function VXMLHeader: String;

var
    // HTML rows
    GlobHTMLRow         : Integer;


    // Used for Debugging time testing
    TTTimeCount         : Comp;
    TTTimeAdd           : TTimeStamp;
    TTTimeStamp         : TTimeStamp;
    TTTimeReport        : String;
    TTTimeActive        : Boolean;

const
     // CrLf
     cCrLf = #13#10;

     // Encryption values
     TTC1  = 51835;
     TTC2  = 22314;

implementation

function GetYYYYMMDDHHNNSSZZZ: String;
begin
     result := FormatDateTime('yyyymmddhhnnsszzz',now);
end;

// String to record
procedure MoveStringToRecord(pString: string; pOffSet: Integer; var pRec; pRecSize : integer);
var
   mString: String;
begin
     mString := Copy(pString,pOffSet,pRecSize);
     Move(mString[1+pOffSet], pRec, pRecSize);
end;

// Record to string
procedure MoveRecordToString(var pRec; pRecSize : integer; var pString: string);
begin
     SetLength(pString, pRecSize);
     Move(pRec, pString[1], pRecSize);
end;


// Find the N'th occurrance of a Substring in a String
function PosOccurance(pSubStr, pString: String; pOccurance: Integer): integer;
const
   cScrubOut1 = '###############################################################';
   cScrubOut2 = '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^';
var
   mCopyString  : String;
   mReplace     : String;
   mReplaceLen  : Integer;
   mFind        : Integer;
   mLoop        : Integer;

begin
     // Set a not found result to start
     result      := 0;
     mReplaceLen := Length(pSubStr);

     // Build a wipe scrub out string
     mReplace := Copy(cScrubOut1+cScrubOut1+cScrubOut1+cScrubOut1,1,mReplaceLen);
     if mReplace = pSubStr then
     begin
          // Just in case its the same string...
          mReplace := Copy(cScrubOut2+cScrubOut2+cScrubOut2+cScrubOut2,1,mReplaceLen);
     end;

     // Find and Scrub
     mCopyString := pString;
     for mLoop := 1 to pOccurance do
     begin
          mFind := Pos(pSubStr, mCopyString);

          if mFind = 0 then
          begin
               // We have gone over the search
               result := -1;
               break;
          end;

          // Toast the occurance, and loop again
          if mFind > 0 then
          begin
               // This is what we found
               result := mFind;

               // Change the first Character to push along the next search
               mCopyString := Copy(mCopyString,0,mFind -1) + mReplace + Copy(mCopyString, mFind+mReplaceLen, 9999);
          end;
     end;
end; // PosOccurance


// To go along with UpperCase and LowerCase
function SentenceCase(s : string) : string;
begin
     result := NameCase(s);
end;

function NameCase(s : string) : string;
begin
     result := UpperCase(s[1]);
     result := result + LowerCase(copy(s, 2, length(s) - 1));
end;

// Change a string to Title Case
function TitleCase(const sText: String;
  const bLowerCaseFirst: Boolean = True): String;
const
  cDelimiters = [#9, #10, #13, ' ', ',', '.', ':', ';', '"',
                 '\', '/', '(', ')', '[', ']', '{', '}'];
var
  iLoop: Integer;
begin
  Result := sText;
  if (Result <> '') then
  begin
    if (bLowerCaseFirst) then
      Result := LowerCase(Result);

    Result[1] := UpCase(Result[1]);
    for iLoop := 2 to Length(Result) do
      if (Result[iLoop - 1] in cDelimiters) then
        Result[iLoop] := UpCase(Result[iLoop]);
  end;
end;


// Returns the position of the last instance of a particular character withing a string.
function GetPosOfLastCharInstance(pScanString, pSearchChar: String): Integer;
var
     mPos,
     mCurCharIndex: Integer;
     mChar: String;
begin
     mPos := -1;
     mCurCharIndex := Length(pScanString);

     while mCurCharIndex >= 0 do
     begin
          mChar := pScanString[mCurCharIndex];
          if mChar = pSearchChar then
          begin
               mPos := mCurCharIndex;
               mCurCharIndex := -1
          end
          else
          begin
               dec(mCurCharIndex);
          end;
     end;
     result := mPos;
end;


function IsLeapYear( nYear: Integer ): Boolean;
begin
     Result := (nYear mod 4 = 0) and ((nYear mod 100 <> 0) or (nYear mod 400 = 0)); 
end;


function MonthDays( nMonth, nYear: Integer ): Integer; 
const
     DaysPerMonth: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31); 
begin 
     Result := DaysPerMonth[nMonth]; 
     if (nMonth = 2) and IsLeapYear(nYear) then Inc(Result); 
end; 

function DayofWeekName( pDayNum: Integer): String;
begin
     case pDayNum of
     0: result := 'Sunday';
     1: result := 'Monday';
     2: result := 'Tueday';
     3: result := 'Wednesday';
     4: result := 'Thusday';
     5: result := 'Friday';
     6: result := 'Saturday';
     else
        result := '';
     end;
end; // Day of week name


function WeekOfYear( dDate: TDateTime ): Integer;
var 
   X, nDayCount: Integer; 
   nMonth, nDay, nYear: Word; 
begin 
     nDayCount := 0;
     DecodeDate( dDate, nYear, nMonth, nDay );
     For X := 1 to ( nMonth - 1 ) do 
     begin
          nDayCount := nDayCount + MonthDays( X, nYear ); 
     end;
     nDayCount := nDayCount + nDay; 
     Result := ( ( nDayCount div 7 ) + 1 );
end; 


// Used to test * and ? against a string
function WildCardMatch(AString, Pattern: string): boolean;
var
  i, n, n1, n2: integer;
  p1, p2: pchar;
label
  match, nomatch;
begin
  AString := UpperCase(AString);
  Pattern := UpperCase(Pattern);
  n1 := Length(AString);
  n2 := Length(Pattern);
  if n1 < n2 then n := n1 else n := n2;
  p1 := pchar(AString);
  p2 := pchar(Pattern);
  for i := 1 to n do begin
    if p2^ = '*' then goto match;
    if (p2^ <> '?') and (p2^ <> p1^) then goto nomatch;
    inc(p1); inc(p2);
  end;
  if n1 > n2 then begin
nomatch:
    Result := False;
    exit;
  end else if n1 < n2 then begin
    for i := n1 + 1 to n2 do begin
      if not (p2^ in ['*','?']) then goto nomatch;
      inc(p2);
    end;
  end;
match:
  Result := True;
end;


function SlashToBackSlash( const str: string ) : string;
var
  a: dword;
begin
     result := str;
     for a := 1 to length( result ) do
     begin
          if result[a] = '/' then
          begin
               result[a] := '\';
          end;
     end;
end;


function BackSlashToSlash( const str: string ) : string;
var
  a: dword;
begin
     result := str;
     for a := 1 to length( result ) do
     begin
          if result[a] = '\' then
          begin
               result[a] := '/';
          end;
     end;
end;


// Used for Date formats
// - Set before calling a date function
//   eg:       SetStandardDateTimeFormats;
//             mDate :=  StrToDate(DBEdit.Text);
// **** WARNING ****
// - Several programmers at enGenic have noticed that the date format will
//   sometimes change.  Therefore, whenever a date calculation is being done,
//   ALWAYS call this function!!!!!
//
//   Chris may have found a way of defeating this.  Add this into the FormCreate of your application
//
//     // Don't allow formation settings changes from other applications to hurt us
//     // - Date changes for example.
//     Application.UpdateFormatSettings   := False;
procedure SetStandardDateTimeFormats;
begin
     ShortDateFormat             := 'yyyy/mm/dd';
     DateSeparator               := '/';
     ShortTimeFormat             := 'hh:nn:ss'; // yes.. nn not mm
     TimeSeparator               := ':';
     LongTimeFormat              := 'hh:nn:ss'; // yes.. nn not mm
end;


// Create a standard timestamp
function TeleFlowTimeStamp: String;
begin
     // Return the current date time stamp
     // yyyy/mm/dd hh:nn:ss
     result := FormatDateTime('yyyy"/"mm"/"dd"-"hh":"nn":"ss', Now);
end;

// Return the current date as teleflow date
function GetNowAsTeleFlowDate: String;
begin
     result := RecordParseCustomDelimiter(TeleFlowTimeStamp,'-',1);
end;

// Return the current time as teleflow time
function GetNowAsTeleFlowTime: String;
begin
     result := RecordParseCustomDelimiter(TeleFlowTimeStamp,'-',2);
end;

// Create a standard timestamp with milliseconds
function TeleFlowTimeStampZZZ: String;
begin
     // Return the current date time stamp
     // yyyy/mm/dd hh:nn:ss
     result := FormatDateTime('yyyy"/"mm"/"dd"-"hh":"nn":"ss"."zzz', Now);
end;
(*  NOTE: I WAS TRYING TO USE GetTickCount to provide zzz, but becase we never know where
          the timer is at, its damn near impossible
var
   mDT    : TDateTime;
   mMs    : Real;
   mAdd   : String;
   mDiff  : String;
begin
     // Return the current date time stamp
     // yyyy/mm/dd hh:nn:ss
     mDT    := Now;
     result := FormatDateTime('yyyy"/"mm"/"dd"-"hh":"nn":"ss', mDT);
     mDiff  := FormatDateTime('zzz', mDT);
     // Milliseconds do not get properly reported by a PC clock, so...
     // - We will just take the last 000 of
     mMs    := Frac(GetTickCount / 1000);
     //mDiff  :=  // @@@
     mAdd   := '.---'; //Copy(FloatToStr(mMs - TimeStamp)+'000',2,4);  // 0.023 is .023

     result := result + mAdd;
end;
*)

// Get the appropriate Timezone
function GetCurrentTimeZoneName(pTimeZoneCode: String; pDayLightSavings: Boolean): String;
var
   mCode    : String;
begin
     // NOTE: This will change in the US as somepoint as they are pushing it back a month
     mCode := Uppercase(pTimeZoneCode);
     if mCode = 'A' then
     begin
     end
     else if mCode = 'E' then
     begin
     end
     else if mCode = 'C' then
     begin
     end
     else if mCode = 'M' then
     begin
     end
     else if mCode = 'P' then
     begin
     end
     else if mCode = 'A' then
     begin
     end;

     result := Uppercase(pTimeZoneCode + 'ST');
end; // GetCurrentTimeZoneName


// Math for timestamp numbers
// - Returns math on a timestamp kind of string
// - Returns only the stamp size submitted... ie: YYYYMM will return only YYYYMM
(*
     // *** TEST CODE ****
     mJunk := '20040811170720';
     mJunk := DateMathYYYYMMDDHHNNSSZZZ(mJunk, -(5*60));
     ShowMessage(mJunk);
*)
function DateMathYYYYMMDDHHNNSSZZZ(pDateStamp: String; pDiffSeconds: Integer): String;
var
   mSecondsInDay: Integer;
   mYYYY,
   mMM,
   mDD,
   mHH,
   mNN,
   mSS,
   mZZZ: Word;
begin
     //         12345678901234567
     mYYYY  := StrToIntDef(Copy(pDateStamp, 1,4),0);
     mMM    := StrToIntDef(Copy(pDateStamp, 5,2),0);
     mDD    := StrToIntDef(Copy(pDateStamp, 7,2),0);
     mHH    := StrToIntDef(Copy(pDateStamp, 9,2),0);
     mNN    := StrToIntDef(Copy(pDateStamp,11,2),0);
     mSS    := StrToIntDef(Copy(pDateStamp,13,2),0);
     mZZZ   := StrToIntDef(Copy(pDateStamp,15,3),0); // Milliseconds

     mSecondsInDay := 24*60*60;

     result := FormatDateTime(Copy('yyyymmddhhnnsszzz',1,length(pDateStamp)),
               EncodeDateTime(mYYYY,
                              mMM,
                              mDD,
                              mHH,
                              mNN,
                              mSS,
                              mZZZ) + (pDiffSeconds / mSecondsInDay));
end; // DateMathYYYYMMDDHHNNSSZZZ

// AmPm reversed to 24:00:00
function TimeAmPmTo24hour(pTime: String): String;
var
   mNumberP1        : Integer;
   mNumberP2        : Integer;
   mLen             : Integer;
   mSep             : String;
   mAmPm            : String;
   mTime            : String;
   mFormat          : String;
begin
     result := '';
     mTime  := pTime;

     if mTime <> '' then
     begin
          // What we have so far
          mFormat := LowerCase(mTime);

          // 1234567
          // x:xxam
          // xx:xxpm
          // Make sure everything is formated correctly
          if (length(mFormat) = 6) or
             (length(mFormat) = 7) then
          begin
               // Get the two parts of the number
               mLen := Length(mFormat);
               if mLen = 6 then
               begin
                    mNumberP1 := StrToIntDef(Copy(mFormat,1,1), -1);
                    mSep      :=             Copy(mFormat,2,1);
                    mNumberP2 := StrToIntDef(Copy(mFormat,3,2), -1);
                    mAmPm     :=             Copy(mFormat,5,2);
               end
               else
               begin
                    mNumberP1 := StrToIntDef(Copy(mFormat,1,2), -1);
                    mSep      :=             Copy(mFormat,3,1);
                    mNumberP2 := StrToIntDef(Copy(mFormat,4,2), -1);
                    mAmPm     :=             Copy(mFormat,6,2);
               end;

               if (mNumberP1 >=  1) and
                  (mNumberP1 <= 12) and
                  (mNumberP2 >=  0) and
                  (mNumberP2 <= 59) and
                  (mSep      = ':') and
                  ((mAmPm = 'am') or (mAmPm = 'pm')) then
               begin
                    if (mAmPm = 'am') then
                    begin
                         // We have a properly formated time
                         result := RightCopy('00'+IntToStr(mNumberP1),2)+':'+
                                   RightCopy('00'+IntToStr(mNumberP2),2)+':00';
                    end
                    else
                    // PM
                    begin
                         // Account for 12pm
                         if mNumberP1 = 12 then
                         begin
                              mNumberP1 := 0;
                         end;
                         result := RightCopy('00'+IntToStr(mNumberP1+12),2)+':'+
                                   RightCopy('00'+IntToStr(mNumberP2)   ,2)+':00';
                    end;
               end;
          end;
     end;
end; // TimeAmPmTo24hour


// Get a TDateTime from a TeleFlow date and time
// - See also function:  TimeToStr
function GetDateTimeFromTFDateandTFTime(pTFDate, pTFTime: String): TDateTime;
var
   mDate       : String;
   mComponents : String;
   mYear       : String;
begin
     SetStandardDateTimeFormats;

     mDate := pTFDate;
     if not IsValidTeleFlowDate(mDate) then
     begin
          mComponents := Trim(SpaceOutNonDigits(mDate));
          mYear := RecordParseCustomDelimiter(mComponents,' ',1);
          // Are we YYYY MM DD
          if Length(mYear) = 4 then
          begin
               mDate := MakeTeleFlowDate(mDate);
          end
          else
          // Are we DD MM YYYY
          begin
               mYear := RecordParseCustomDelimiter(mComponents,' ',3);
               if Length(mYear) = 4 then
               begin
                    // Contruct our best guess at a date
                    mDate := RecordParseCustomDelimiter(mComponents,' ',3) + '/' +
                             RecordParseCustomDelimiter(mComponents,' ',1) + '/' +
                             RecordParseCustomDelimiter(mComponents,' ',2);
               end;
          end;
     end;

     // An invalid date format will kill this
     try
        result := StrToDate(mDate)+StrToTime(pTFTime);
     except
        result := 0;
     end;
end;  // GetDateTimeFromTFDateandTFTime


// Get a TDateTime from a TeleFlow date
function GetDateFromTFDate(pTFDate: String): TDateTime;
var
   mDate       : String;
   mComponents : String;
   mYear       : String;
begin
     SetStandardDateTimeFormats;

     mDate := pTFDate;
     if not IsValidTeleFlowDate(mDate) then
     begin
          mComponents := Trim(SpaceOutNonDigits(mDate));
          mYear := RecordParseCustomDelimiter(mComponents,' ',1);
          // Are we YYYY MM DD
          if Length(mYear) = 4 then
          begin
               mDate := MakeTeleFlowDate(mDate);
          end
          else
          // Are we DD MM YYYY
          begin
               mYear := RecordParseCustomDelimiter(mComponents,' ',3);
               if Length(mYear) = 4 then
               begin
                    // Contruct our best guess at a date
                    mDate := RecordParseCustomDelimiter(mComponents,' ',3) + '/' +
                             RecordParseCustomDelimiter(mComponents,' ',1) + '/' +
                             RecordParseCustomDelimiter(mComponents,' ',2);
               end;
          end;
     end;

     // Turn it into a date
     result := StrToDate(mDate);
end;  // GetDateTimeFromTFDateandTFTime


// Do we have a valid TeleFlow variable?
function IsValidTeleFlowVar(pTFVar: String): Boolean;
var
   mText : String;
begin
     Result := False;
     if (Copy(pTFVar,1,1) = '@') then
     begin
          mText := Copy(pTFVar,2,99);
          if (mText = StripOutNonNamingChars(mText)) then
          begin
               // Are we at least two chars in the var name
               if (Length(mText) > 0) then
               begin
                    // It would appear we have a valid variable
                    result := True;
               end;
          end
     end;
end; // IsValidTeleFlowVar


// Do we have a valid TeleFlow date?
function IsValidTeleFlowDate(pTFDate: String): Boolean;
var
   mYYYY,
   mMM,
   mDD: Word;
   mS1: String;
   mS2: String;
begin
     result := False;
     try
        // Got to be 10 chars
        if length(pTFDate) = 10 then
        begin
             // 12345678901234567
             // 2006/01/01
             mYYYY  := StrToIntDef(Copy(pTFDate, 1,4),0);
             mS1    :=             Copy(pTFDate, 5,1);
             mMM    := StrToIntDef(Copy(pTFDate, 6,2),0);
             mS2    :=             Copy(pTFDate, 8,1);
             mDD    := StrToIntDef(Copy(pTFDate, 9,2),0);

             // Make sure we have a valid date
             if (mYYYY > 0) and (mMM > 0) and (mDD > 0) and (mS1 = '/') and (mS2 = '/') then
             begin
                  // This is only approximate
                  if (mYYYY <= 9999) and (mMM <= 23) and (mDD <= 31) then
                  begin
                       result := True;
                  end;
             end;
        end;
     except
     end;
end;

// Do we have a valid TeleFlow time?
function IsValidTeleFlowTime(pTFTime: String): Boolean;
var
   mHH,
   mNN,
   mSS     : Integer;
   //mZZZ    : Integer;
   mC1     : String;
   mC2     : String;

begin
     result := False;
     try
        // Time has got to be 5 or 8
        if (length(pTFTime) = 5) or (length(pTFTime) = 8) then
        begin
             // 12345678901234567
             // 22:01:01
             mHH    := StrToIntDef(Copy(pTFTime, 1,2),-1);
             mC1    :=             Copy(pTFTime, 3,1);
             mNN    := StrToIntDef(Copy(pTFTime, 4,2),-1);
             mC2    :=             Copy(pTFTime, 6,1);
             mSS    := StrToIntDef(Copy(pTFTime, 7,2),-1);

             // Make sure we have a valid time
             if (mHH > -1) and (mNN > -1) and (mSS > -1) and (mC1 = ':') and (mC2 = ':') then
             begin
                  // This is only approximate
                  if (mHH <= 24) and (mNN <= 59) and (mSS <= 59) then
                  begin
                       result := True;
                  end;
             end;
        end;
     except
     end;
end;


// Check to see if an email is valid
function IsValidEmail(const Value: string): boolean;
  function CheckAllowed(const s: string): boolean;
  var
    i: integer;
  begin
    Result:= false;
    for i:= 1 to Length(s) do
    begin
      // illegal char in s -> no valid address
      if not (s[i] in ['a'..'z','A'..'Z','0'..'9','_','-','.']) then
        Exit;
    end;
    Result:= true;
  end;
var
  i: integer;
  namePart, serverPart: string;
begin // of IsValidEmail
  Result:= false;
  i:= Pos('@', Value);
  if (i = 0) or (pos('..', Value) > 0) then
    Exit;
  namePart:= Copy(Value, 1, i - 1);
  serverPart:= Copy(Value, i + 1, Length(Value));
  if (Length(namePart) = 0)         // @ or name missing
    or ((Length(serverPart) < 4))   // name or server missing or
    then Exit;                      // too short
  i:= Pos('.', serverPart);
  // must have dot and at least 3 places from end
  if (i < 2) or (i > (Length(serverPart) - 2)) then
    Exit;
  Result:= CheckAllowed(namePart) and CheckAllowed(serverPart);
end;


// Do some basic checking for hash
function IsValidHash(const Value: string): boolean;
var
   mLoop : integer;
   mChar : String;
begin
     result := false;
     if (Length(Value) = 32) then
     begin
          result := true;
          // Loop though entire string
          for mLoop := 1 to length(Value) do
          begin
               mChar := (copy(UpperCase(Value),mLoop,1));
               // 0,1,2,3,4,5,6,7,8,9
               if (mChar >= #48) and (mChar <= #57) then
               begin
               end
               // A,B,C,D,E,F
               else if (mChar >= #65) and (mChar <= #70) then
               begin
               end
               // Bad
               else
               begin
                    result := false;
                    break;
               end
          end;
     end;
end; // IsValidHash


// Convert a TeleFlow Timestamp type to DateTime
function YYYYMMDDHHNNSStoDateTime(pDateStamp: String): TDateTime;
var
   mYYYY,
   mMM,
   mDD: Word;
   //mHH,
   //mNN,
   //mSS,
   //mZZZ: Word;

   mSYYYY,
   mSMM,
   mSDD,
   mSHH,
   mSNN,
   mSSS : String;
   //mSZZZ: String;

   // TeleFlow types
   mDate        : String;
   mTime        : String;
begin
     try
        //         12345678901234567
        mYYYY  := StrToIntDef(Copy(pDateStamp, 1,4),0);
        mMM    := StrToIntDef(Copy(pDateStamp, 5,2),0);
        mDD    := StrToIntDef(Copy(pDateStamp, 7,2),0);
        //mHH    := StrToIntDef(Copy(pDateStamp, 9,2),0);
        //mNN    := StrToIntDef(Copy(pDateStamp,11,2),0);
        //mSS    := StrToIntDef(Copy(pDateStamp,13,2),0);
        //mZZZ   := StrToIntDef(Copy(pDateStamp,15,3),0); // Milliseconds

        // Make sure we have a valid date
        if (mYYYY > 0) and (mMM > 0) and (mDD > 0) then
        begin
             mSYYYY  := (Copy(pDateStamp, 1,4));
             mSMM    := (Copy(pDateStamp, 5,2));
             mSDD    := (Copy(pDateStamp, 7,2));
             mSHH    := (Copy(pDateStamp, 9,2));
             mSNN    := (Copy(pDateStamp,11,2));
             mSSS    := (Copy(pDateStamp,13,2));
             //mSZZZ := (Copy(pDateStamp,15,3)); // Milliseconds

             mDate  := mSYYYY+'/'+mSMM+'/'+mSDD;
             mTime  := mSHH+':'+mSNN+':'+mSSS;

             // Return at TDateTime
             SetStandardDateTimeFormats;
             result := StrToDate(mDate) + StrToTime(mTime);
        end
        else
        begin
             // Something isnt valid
             result := 0;
        end;
     except
        result := 0;
     end;
end; // YYYYMMDDHHNNSSZZZtoDateTime


// Make sure that all the words for YES are included
function TrueOrYes(pWord: String): Boolean;
begin
     result := False;
     if Pos('~'+trim(uppercase(pWord))+'~','~YES~TRUE~AFFIRMATIVE~YUP~ON~Y~T~') > 0 then
     begin
          result := True;
     end;
end; //  TrueOrYes

// And for False stuff
function FalseOrNo(pWord: String): Boolean;
begin
     result := False;
     if Pos('~'+trim(uppercase(pWord))+'~','~NO~FALSE~NEGATIVE~NOPE~OFF~N~F~') > 0 then
     begin
          result := True;
     end;
end; //  TrueOrYes


// Mimics the wonderful Excel IFF function
// eg: iff(mVariableText = 'ON', True, False)
function IFF( condition: Boolean; ifvalue, elsevalue: variant):variant;
Begin
     if condition then
     begin
          result := ifvalue;
     end
     else
     begin
          result := elsevalue;
     end;
End;

// Yank out all the slashes and colons to create a nice unique number
// TeleFlow Types to YYYYMMDDhhmmss
function FormattedDateTimeToUniqueNumber(pDate, pTime: String): String;
begin
     result := copy(pDate,1,4)+
               copy(pDate,6,2)+
               copy(pDate,9,2)+
               copy(pTime,1,2)+
               copy(pTime,4,2)+
               copy(pTime,7,2);
end;


// Express the at time as relative age
// var
//      mAge     : TDateTime;
// begin
//     // Find the file age
//     mAge := FileDateToDateTime(FileAge(pFile));
//     // Display the data
//     FileAgeLabel.Caption := 'Age: '+ ExpressAge(mAge, '','','');
function ExpressAge(pDateThen: TDateTime; pDaysTitle, pHoursTitle, pMinutesTitle: String): String;
var
   mDaysTitle       : String;
   mHoursTitle      : String;
   mMinutesTitle    : String;
   mDaysTitleOne    : String;
   mHoursTitleOne   : String;

   mAge             : TDateTime;
   mValue           : String;
begin
     // Time
     mDaysTitle     := pDaysTitle;
     mHoursTitle    := pHoursTitle;
     mMinutesTitle  := pMinutesTitle;
     if mDaysTitle     = '' then mDaysTitle     := 'Days';
     if mHoursTitle    = '' then mHoursTitle    := 'Hrs';
     if mMinutesTitle  = '' then mMinutesTitle  := 'Mins';
     // Work out single name
     mDaysTitleOne      :=    mDaysTitle;
     mHoursTitleOne     :=    mHoursTitle;
     // Only do something if an s is that the end
     if RightCopy(UpperCase(mDaysTitleOne),1) = 'S' then
     begin
          mDaysTitleOne   := Copy(mDaysTitleOne,1,Length(mDaysTitleOne)-1);
     end;
     // Only do something if an s is that the end
     if RightCopy(UpperCase(mHoursTitleOne),1) = 'S' then
     begin
          mHoursTitleOne   := Copy(mHoursTitleOne,1,Length(mHoursTitleOne)-1);
     end;

     try
        SetStandardDateTimeFormats;

        mAge   := Now - pDateThen;

        if mAge >= 1 then // Days
        begin
             if trunc(mAge) = 1 then
             begin
                  // Chop off the 's'
                  mValue := mValue + IntToStr(trunc(mAge))+ ' ' + mDaysTitleOne;
             end
             else
             begin
                  mValue := mValue + IntToStr(trunc(mAge))+ ' ' + mDaysTitle;
             end;
        end
        else if mAge >= (1/24) then // Hours
        begin
             mValue := FormatDateTime('h',mAge);
             if mValue = '1' then
             begin
                  mValue := mValue + ' '+mHoursTitleOne;
             end
             else
             begin
                  mValue := mValue + ' '+mHoursTitle;
             end;
        end
        else
        begin // Minutes
             mValue := mValue + FormatDateTime('n',mAge)+ ' '+mMinutesTitle;
        end;
     except
        mValue := '';
     end;

     result := mValue;
end; // ExpressAge


// Swing through a list of digits, and add them together
// - Used for a really simple checksum operation for example
function AddDigitsTogether(pDigitsList: String): Integer;
var
   mLoop     : Integer;
   mTotal    : Integer;
begin
     mTotal  := 0;
     for mLoop := 1 to Length(pDigitsList) do
     begin
          mTotal := mTotal + StrToIntDef(Copy(pDigitsList,mLoop,1),0);
     end;
     result := mTotal;
end;


// Wrap text with double quotes for CSV
function DoubleQuoteWrap(pText: String): String;
const
   cDoubleQuote = '"';
begin
     result := cDoubleQuote+pText+cDoubleQuote;
end; // QuoteWrap

// Wrap text with double quotes for CSV
function SingleQuoteWrap(pText: String): String;
const
   cSingleQuote = '''';
begin
     result := cSingleQuote+pText+cSingleQuote;
end; // QuoteWrap

// Other spelling
function QuoteWrapDouble(pText: String): String;
begin
     result := DoubleQuoteWrap(pText);
end;

function QuoteWrapSingle(pText: String): String;
begin
     result := SingleQuoteWrap(pText);
end;

// Computer name
function CalcGetComputerName: String;
var
   buffer : array[0..255] of char;
   size : dword;
   UserName: String;
   ComputerName: String;
begin
     size := 256;
     GetUserName(buffer, size);
     UserName := buffer;
     size := MAX_COMPUTERNAME_LENGTH + 1;
     GetComputerName(buffer, size);
     ComputerName := buffer;
     result := ComputerName;
end;

// Current user
function CalcGetUserName: String;
var
   buffer : array[0..255] of char;
   size : dword;
   UserName: String;
   ComputerName: String;
begin
     size := 256;
     GetUserName(buffer, size);
     UserName := buffer;
     size := MAX_COMPUTERNAME_LENGTH + 1;
     GetComputerName(buffer, size);
     ComputerName := buffer;
     result := UserName;
end;




// Replace all instances of one single character in a string with another character or string,
// returning the modified string.
function ReplaceAllSingleChar(pString: String; pFrom: Char; pTo: String): String;
var
   mLoop: Integer;
   mBuild: String;
begin
     mBuild := '';
     for mLoop := 1 to Length(pString) do
     begin
          if pString[mLoop] = pFrom then
          begin
               mBuild := mBuild + pTo;
          end
          else
          begin
               mBuild := mBuild + pString[mLoop];
          end;
     end;
	result := mBuild;
end;


// Replace all instances of one string in a string with another string,
// returning the modified string.
// - Uses standard function
function StringReplaceAll(pOriginalString, pFindString, pReplaceString: String): String;
begin
     result := StringReplace(pOriginalString,pFindString,pReplaceString,[rfReplaceAll]);
end;

// Replace all instances of one string in a string with another string,
// returning the modified string.
function ReplaceAllSubStringsWithAnother(pFindString, pReplaceString, pOriginalString: String): String;
var
   mFindStringLen,
   mLoop: Integer;
   mBuild: String;
begin
     mBuild         := '';
     mFindStringLen := Length(pFindString);

     mLoop := 1;
     while mLoop <= Length(pOriginalString) do
     begin
          if Copy(pOriginalString,mLoop,mFindStringLen) = pFindString then
          begin
               // Put the replacement in place
               mBuild := mBuild + pReplaceString;
               // add a few to skip past the copied bit
               mLoop := mLoop + mFindStringLen - 1;
          end
          else
          begin
               // Add the next character
               mBuild := mBuild + Copy(pOriginalString,mLoop,1);
          end;

          inc(mLoop);
     end;
     result := mBuild;
end;

function GetYYYYMMDDDate(pDate: TDateTime; pDaysDiff: Integer): String;
begin
     result := Copy(FormatDateTime('yyyy"/"mm"/"dd', Now + pDaysDiff),1,10);
end;

function GetHHMMSS: String;
begin
     result := Copy(FormatDateTime('hh:nn:ss', Now),1,8);
end;

// Get a TDateTime from a TeleFlow Time
// - See also function:  TimeToStr
function GetTimeFromTFTime(pTFTime: String): TDateTime;
begin
     SetStandardDateTimeFormats;
     result := StrToTime(pTFTime);
end;

// Get a TeleFlow time from TDateTime
function GetTFTimeFromTime(pTime: TDateTime): String;
begin
     result := Copy(FormatDateTime('hh:nn:ss', pTime),1,8);
end;

function GetTFDateFromDate(pDate: TDateTime): String;
begin
     result := Copy(FormatDateTime('yyyy/mm/dd', pDate),1,10);
end;

function GetTFDateFromYYYYMMDD(pNumericDate: Integer): String;
var
   mDate : String;
begin
     mDate  := IntToStr(pNumericDate);
     result := MakeTeleFlowDate(mDate);
end;


// Convert 24 hour to Am/Pm so
// - 14:40:00  returns 2:40:00pm
// - 10:05     returns 10:05am
function Time24hourToAmPm(pTime: String): String;
var
   mTime24     : String;
   mHH         : Integer;
   mMM         : Integer;
   mSS         : Integer;
   mAP         : String;
begin
     result := '';

     // If it has a chance of being a real time...
     if Pos(':',pTime) > 0 then
     begin
          // So... :11:10:00:
          mTime24 := ':'+pTime+':';
          mHH     := StrToIntDef( RecordParseCustomDelimiter(mTime24,':',2), 0);
          mMM     := StrToIntDef( RecordParseCustomDelimiter(mTime24,':',3), 0);
          mSS     := StrToIntDef( RecordParseCustomDelimiter(mTime24,':',4), -1);

          // AM
          mAP := 'am';
          if mHH = 0 then
          begin
               mHH := 12;
          end
          else if mHH = 12 then
          begin
               mAP := 'pm';
               mHH := 12;
          end
          else if mHH = 24 then
          begin
               mAP := 'am';
               mHH := 12;
          end
          else if mHH > 12 then
          begin
               mAP := 'pm';
               mHH := mHH - 12 ;
          end;

          // Manufacture AM/PM time
          if mSS >= 0 then
          begin
               // With seconds
               result := IntToStr(mHH)+':'+
                         RightCopy('00'+IntToStr(mMM),2)+':'+
                         RightCopy('00'+IntToStr(mSS),2)+mAP;
          end
          else
          begin
               result := IntToStr(mHH)+':'+
                         RightCopy('00'+IntToStr(mMM),2)+mAP;
          end;
     end;
end; // Time24hourToAmPm



function Time24AddMinutes(pTime: String; pMins: Integer): String;
var
   mTimeScEnd     : String;
   mTimeWork      : TDateTime;
   mMinuteWork    : Integer;
begin
     mTimeWork      := GetTimeFromTFTime(pTime);
     mMinuteWork    := pMins;
     mTimeWork      := TimeMath(mTimeWork,'+',mMinuteWork,'M');
     mTimeScEnd     := GetTFTimeFromTime( mTimeWork );
end;



// Create as a correct 24 hour time
function Time24Add(pTime: String; pHours: Integer): String;
var
   iTime1 : integer;
   iTime2 : integer;
   mHrs   : String;
   mMins  : String;
begin
     // Get the hrs
     iTime1 := StrToIntDef(RecordParseCustomDelimiter(pTime,':',1), -1);
     // Get the mins
     iTime2 := StrToIntDef(RecordParseCustomDelimiter(pTime,':',2), -1);


     if (iTime1 >= 0) and (iTime2 >= 0) then
     begin
          iTime1 := iTime1 + pHours;

          // Hours
          if iTime1 > 9 then
          begin
               if iTime1 >= 24 then
               begin
                    iTime1 := 24;
                    iTime2 := 0;
               end;
               mHrs := IntToStr(iTime1);
          end
          else
          begin
               mHrs := '0'+IntToStr(iTime1);
          end;

          // Mins
          if iTime2 > 59 then
          begin
               iTime2 := 59;
          end;

          if iTime2 > 9 then
          begin
               mMins := IntToStr(iTime2);
          end
          else
          begin
               mMins := '0'+IntToStr(iTime2);
          end;

          // Slam em together
          result := mHrs+':'+mMins;
     end
     else
     begin
          // Invalid
          result := '00:00';
     end;
end;  // Time24Add


// Convert a time to a hours.00/100 decimal reprentation
function DecimalTime(pTime: TDateTime; pRoundMinutes: Integer): Real;
var
   mHourPortion    : Real;
begin
     // For excel et, get the hours into portions
     mHourPortion     := (StrToIntDef(FormatDateTime('nn',pTime),0) /60);  // Get percentage of the hour
     mHourPortion     := Int(mHourPortion * pRoundMinutes) / pRoundMinutes;  // Round to the nearest 8 minutes
     result           := (StrToIntDef(FormatDateTime('hh',pTime),0) + (mHourPortion));
end;


// Return the local computer name
function GetLocalComputerName: String;
var
     sBuffer: string;
     dwBuffSize: DWord;
begin
     result := '';
     dwBuffSize := MAX_COMPUTERNAME_LENGTH + 1;
     SetLength(sBuffer,dwBuffSize);
     if GetComputerName(PChar(sBuffer),dwBuffSize) then
     begin
          // Remove trailing #0's
          SetLength(sBuffer,dwBuffSize);
          Result := sBuffer;
     end;
end;

{
// Return the local computer's host name (ie. If the computer name is PLUTO, the
// host name might actually be PLUTO.DOMAIN.SOMEWHERE.COM)
function TSetupForm.GetLocalHostName: String;
var
     WSAData: TWSAData;

     sBuffer: string;
     dwBuffSize: DWord;
begin
     WSAStartup(2, WSAData);
     result := '';
     dwBuffSize := 255;
     SetLength(sBuffer,dwBuffSize);
     if GetHostName(PChar(sBuffer),dwBuffSize) = 0 then
     begin
          // Remove trailing #0's
          SetLength(sBuffer,dwBuffSize);
//          result := gethostbyname(PChar(sBuffer));
          result := sBuffer;
     end;
     WSACleanup;
end;
}


// Provide a full, easily readable date and time
// - requires:  LongDateFormat	 := 'dddd, mmmm dd/yyyy';
// - requires:  ShortTimeFormat  := 'hh:nn:ss'; // yes.. nn not mm
function VerboseDateOptionalTime(pDate, pTime: String): String; overload;
var
   mTime: String;
begin
     // Make certain we fall into the correct parameters
     mTime := pTime;
     if mTime < '00:00:00' then
     begin
          mTime := '00:00:00';
     end;
     if mTime > '23:59:59' then
     begin
          mTime := '23:59:59';
     end;

     try
        result := FormatDateTime(LongDateFormat,StrToDate(pDate));
        if mTime <> '' then
        begin
             result := result + ' ' + FormatDateTime(ShortTimeFormat,StrToTime(mTime));
        end;
     except
        result := 'Invalid Time';
     end;
end;

function VerboseDateOptionalTime(pDate, pDateTimeSeperator, pTime: String): String; overload;
var
   mTime: String;
begin
     // Make certain we fall into the correct parameters
     mTime := pTime;
     if mTime < '00:00:00' then
     begin
          mTime := '00:00:00';
     end;
     if mTime > '23:59:59' then
     begin
          mTime := '23:59:59';
     end;

     try
        result := FormatDateTime(LongDateFormat,StrToDate(pDate));
        if mTime <> '' then
        begin
             result := result + ' ' + pDateTimeSeperator + ' ' + FormatDateTime(ShortTimeFormat,StrToTime(mTime));
        end;
     except
        result := 'Invalid Time';
     end;
end;

// Double backslashes
function DoubleBackSlashes(pFile: String): String;
var
   mLoop: Integer;
   mBuild: String;
   mChar: String;
begin
     mBuild := '';
     for mLoop := 1 to length(pFile) do
     begin
          mChar := Copy(pFile,mLoop,1);
          if mChar = '\' then
          begin
               mBuild := mBuild + mChar;
          end;
          mBuild := mBuild + mChar;
     end;

     result := mBuild;
end; // DoubleBackSlashes


function CopyFromBetweenChars(pString,pCStart,pCEnd: String) :String;
var
   mText: String;
   mPos1,
   mPos2: Integer;
begin
     result := '';
     mPos1 := Pos(pCStart,pString);
     mText := Copy(pString,mPos1,9999);
     mPos2 := Pos(pCEnd,mText);
     if (mPos1 > 0) and
        (mPos2 > 0) then
     begin
          result := Copy(mText,2,mPos2-1);
     end;
end;  //CopyFromBetweenChars


// Create an Int from Hex numbers
function HexToInt(const HexStr: string): longint;
var
   iNdx: integer;
   cTmp: Char;
begin
     Result := 0;
     for iNdx := 1 to Length(HexStr) do
     begin
         cTmp := HexStr[iNdx];
         case cTmp of
           '0'..'9': Result := 16 * Result + (Ord(cTmp) - $30);
           'A'..'F': Result := 16 * Result + (Ord(cTmp) - $37);
           'a'..'f': Result := 16 * Result + (Ord(cTmp) - $57);
         else
           raise EConvertError.Create('Illegal character in hex string');
         end;
     end;
end;


// Compare fields to see if they match for x characts
function LeftCharUpperCaseCompare(pField1,pField2: String; pChars: Integer): Boolean;
var
   mField1,
   mField2: String;
begin
     mField1 := Copy(Uppercase(pField1),1,pChars);
     mField2 := Copy(Uppercase(pField2),1,pChars);

     result := False;
     if mField1 = mField2 then result := True;
end; //LeftCharUpperCaseCompare


// Compare fields to see if they match for x characts
function UpperCaseCompare(pField1,pField2: String): Boolean;
var
   mField1,
   mField2: String;
begin
     mField1 := (Uppercase(pField1));
     mField2 := (Uppercase(pField2));

     result := False;
     if mField1 = mField2 then result := True;
end; //LeftCharUpperCaseCompare



// Find the degree for an angle
// - Accounts for Divide by Zero
function GetDegreeAngle(x1,y1,x2,y2: Integer): Extended;
var
   mRads: Real;
begin
     mRads := (180/Pi * ArcTan2(y2-y1, x2-x1));
     if mRads < 0 then mRads := mRads + 360;
     result := mRads;
end; //GetDegreeAngle


// Return the right x most characters
function RightCopy(pString: String; pChars: Integer): String;
var
   mBack,
   mLen: Integer;
begin
     mLen   := Length(pString);
     mBack  := mLen - pChars + 1;
     result := Copy(pString,mBack,9999);
end; // RightCopy

// Extract the file name, c:/path/file.ext  returns file.ext
function ExtractFileNameNoPath(pPathFileName: String): String;
var
   mPath : String;
begin
     mPath  := IncludeTrailingPathDelimiter(ExtractFileDir(pPathFileName));
     result := StringReplace(pPathFileName, mPath, '', []);
end;


// Add days to a YYYY/MM/DD formated string
function DateStringAdd(pDate: String; pDays: Integer): String;
var
   mDate: String;
begin
     ShortDateFormat := 'yyyy/mm/dd';
     DateSeparator   := '/';
     mDate           := DateToStr(StrToDate(pDate)+pDays);
     result          := mDate;
end;  // DateStringAdd

// Subtract days from a YYYY/MM/DD formated string
function DateStringSubtract(pDate: String; pDays: Integer): String;
var
   mDate: String;
begin
     ShortDateFormat := 'yyyy/mm/dd';
     DateSeparator   := '/';
     mDate           := DateToStr(StrToDate(pDate)-pDays);
     result          := mDate;
end;  // DateStringSubtract


// Keep it simple for now, make it stronger later
function MakeTeleFlowDate(pDate: String): String;
var
   mYear   : String;
   mMonth  : String;
   mDay    : String;
begin
     result := '';
     if length(pDate) > 0 then
     begin
          if length(pDate) = 10 then
          begin
               // 1234/67/90
               mYear  := Copy(pDate,1,4);
               mMonth := Copy(pDate,6,2);
               mDay   := Copy(pDate,9,2);
          end;

          if length(pDate) = 8 then
          begin
               // 12345678
               mYear  := Copy(pDate,1,4);
               mMonth := Copy(pDate,5,2);
               mDay   := Copy(pDate,7,2);
          end;

          // Push it back
          result := mYear+'/'+mMonth+'/'+mDay;
     end;
end; // MakeTeleFlowDate



// Do date time math
// eg mTempTime := TimeMath(Now, '-', cPROCFREQ, 'M');
// eg mTempTime := TimeMath(Now, '-', 8, 'H')
function TimeMath(pTime: TDateTime;
                  pOpr: Char;
                  pValue: Integer;
                  pUnits: Char ): TDateTime;
var
   tmpHour,
   tmpMin,
   tmpSec,
   tmpMSec: Word;

   mHour,
   mMin,
   mSec: Integer;

   mAddDay,
   mAddHour,
   mAddMin,
   mAddSec: Integer;

   mDateMath: TDateTime;

begin
     (*
       Perform mathematical functions on the time values (only).
       Accepts input of a time (as a TDateTime type) and adds or subtracts
       a given unit of time.
       This function does not deal with the date portion of the TDateTime
       value.  That is discarded.  If a TimeMath operation results in a
       time value past or before midnight, the resulting value will wrap.
       This function only deals with hours, minutes and seconds.
       Milliseconds are ignored.
       Parameters:
           pTime = TDateTime value to perform math on
           pOpr  = '+' to add time, or
                   '-' to subtract time
           pValue = Value to add or subtract to the time
           pType = Units to add or subtract, valid values are
                   'H' for hours, or
                   'M' for minutes, or
                   'S' for seconds
     *)
     mAddDay  := 0;
     mAddHour := 0;
     mAddMin  := 0;
     mAddSec  := 0;

     DecodeTime(pTime, tmpHour, tmpMin, tmpSec, tmpMSec);
     mHour := tmpHour;
     mMin  := tmpMin;
     mSec  := tmpSec;

     if pUnits = 'H' then
     begin
        mAddDay  := trunc(pValue / 24);
        mAddHour := trunc(pValue - (mAddDay * 24));
     end
     else if pUnits = 'M' then
     begin
        mAddDay  := trunc(pValue / 1440);
        mAddHour := trunc((pValue - (mAddDay * 1440)) / 60);
        mAddMin  := trunc(pValue - (mAddDay * 1440) - (mAddHour * 60));
     end
     else if pUnits = 'S' then
     begin
        mAddDay  := trunc(pValue / 86400);
        mAddHour := trunc((pValue - (mAddDay * 86400)) / 3600);
        mAddMin  := trunc((pValue - (mAddDay * 86400) - (mAddHour * 3600)) / 60);
        mAddSec  := trunc(pValue - (mAddDay * 86400) - (mAddHour * 3600) - (mAddMin * 60));
     end;

     if pOpr = '+' then
     begin
        mSec := mSec + mAddSec;
        if mSec >= 60 then
        begin
           mSec := mSec - 60;
           mAddMin  := mAddMin + 1;
        end;

        mMin := mMin + mAddMin;
        if mMin >= 60 then
        begin
           mMin := mMin - 60;
           mAddHour := mAddHour + 1;
        end;

        mHour := mHour + mAddHour;
        if mHour >= 24 then
        begin
           mHour := mHour - 24;
           mAddDay := mAddDay + 1;
        end;
     end
     else
     if pOpr = '-' then
     begin
        mSec := mSec - abs(mAddSec);
        if mSec < 0 then
        begin
           mSec := mSec + 60;
           mAddMin  := mAddMin - 1;
        end;

        mMin := mMin - abs(mAddMin);
        if mMin < 0 then
        begin
           mMin := mMin + 60;
           mAddHour := mAddHour - 1;
        end;

        mHour := mHour - abs(mAddHour);
        if mHour < 0 then
        begin
           mHour := mHour + 24;
           mAddDay := mAddDay - 1;
        end;
     end;

     tmpHour   := mHour;
     tmpMin    := mMin;
     tmpSec    := mSec;
     mDateMath := (StrToDate(DateToStr(pTime)) + mAddDay) +
                  EncodeTime(tmpHour, tmpMin, tmpSec, tmpMSec);
     result    := mDateMath;
     (*
       Need to put the Date portion into the result because EncodeTime function
       will not include it.  Note: using DateToStr -> StrToDate to extract the date
       portion from the user supplied TDateTime value
     ReplaceDate(Result, StrToDate(DateToStr(pTime)));
     Result := Result + mAddDay;
     *)
end;  // TimeMath


// Return the number of hours difference
function HoursDifference(pDateTime1,pDateTime2: TDateTime): Real;
var
   mDifference: Real;
begin
     mDifference := abs(pDateTime1 - pDateTime2) * 24;
     result      := mDifference;
end;


// Return a specific comma delimited field
function RecordParse(pRecord: String; pFieldNum: Integer): String;
var
   mDoubleQuoteFlag: Boolean;

   mCommaCount,
   mLen,
   mLoop: Integer;

   mRecord,
   mChar,
   mField: String;
begin
     mDoubleQuoteFlag := False;

     // Put commas around the record to aid with the counting
     mRecord := ','+pRecord+',';

     mCommaCount := 0;
     mLen        := Length(mRecord);
     mField      := '';

     for mLoop := 1 to mLen do
     begin
          mChar := Copy(mRecord,mLoop,1);

          if mChar = ',' then
          begin
               // Only count if comma is not in quotes
               if not mDoubleQuoteFlag then
               begin
                    inc(mCommaCount);
               end
               else
               begin
                    // Add commas that are in quoted fields
                    if mCommaCount = pFieldNum then
                    begin
                         mField := mField + mChar;
                    end;
               end;
          end
          else
          if mChar = '"' then
          begin
               // Toggle True/False
               mDoubleQuoteFlag := not mDoubleQuoteFlag;
          end
          else
          if mCommaCount = pFieldNum then
          begin
               mField := mField + mChar;
          end;

     end; // mLoop

     result := trim(mField);

end; // RecordParse


// Return a specific comma delimited field
// Parse Right to Left
function RecordParseRight(pRecord: String; pFieldNum: Integer): String;
var
   mDoubleQuoteFlag: Boolean;

   mCommaCount,
   mLen,
   mLoop: Integer;

   mRecord,
   mChar,
   mFieldReverse,
   mField: String;
begin
     mDoubleQuoteFlag := False;

     // Put commas around the record to aid with the counting
     mRecord := ','+pRecord+',';

     mCommaCount := 0;
     mLen        := Length(mRecord);
     mField      := '';

     for mLoop := mLen downto 1 do
     begin
          mChar := Copy(mRecord,mLoop,1);

          if mChar = ',' then
          begin
               // Only count if comma is not in quotes
               if not mDoubleQuoteFlag then
               begin
                    inc(mCommaCount);
               end
               else
               begin
                    // Add commas that are in quoted fields
                    if mCommaCount = pFieldNum then
                    begin
                         mField := mField + mChar;
                    end;
               end;
          end
          else
          if mChar = '"' then
          begin
               // Toggle True/False
               mDoubleQuoteFlag := not mDoubleQuoteFlag;
          end
          else
          if mCommaCount = pFieldNum then
          begin
               mField := mField + mChar;
          end;

     end; // mLoop

     // Reverse the field
     mFieldReverse := '';
     for mLoop := length(mField) downto 1 do
     begin
          mFieldReverse := mFieldReverse + Copy(mField,mLoop,1);
     end;

     result := trim(mFieldReverse);

end; // RecordParseRight


// Tests to see if an expression is true or not
// - Expression checks existance in another string
//  eg:  ('Bob or Sue and Craig','SueBob'  = False
//  eg:  ('Bob and Sue or Craig','SueBob'  = True

function TestExpression(pExpression, pString: String): Boolean;
var
   mPosition,
   mCount: Integer;
   mField,
   mLastOperator,
   mExpression: String;

   mSkip,
   mSearchFlag,
   mTrueFlag: Boolean;
begin
     mExpression   := StripRepeatingChars(trim(pExpression),' ');
     mCount        := 0;
     mTrueFlag     := True;  // Prove us wrong
     mLastOperator := 'and'; // 'and' is assumed
     mSkip         := False;
     // Set only for a test
     mSearchFlag   := False;

     // Find each space
     repeat
           // Next word
           inc(mCount);
           mField := RecordParseCustomDelimiter(mExpression,' ',mCount);
           if mField <> '' then
           begin

                 // Are we dealing with an operator or text to search for
                 if (lowercase(mField) = 'and') or
                    (lowercase(mField) = 'or') or
                    (lowercase(mField) = '&') then
                 begin
                      mLastOperator := mField;

                      if mField = 'or' then
                      begin
                           mSkip := False;
                           // Check to see if the express has already evaluted to true
                           if mTrueFlag then
                           begin
                                break; // repeat - until
                           end
                      end;

                 end
                 else
                 begin
                      if not mSkip then
                      begin
                           // Set only for a test
                           mSearchFlag := False;

                           // See if the text is in the searchable record
                           mPosition := pos(mField,pString);
                           if mPosition > 0 then
                           begin
                                mSearchFlag := True;
                           end;
                      end;
                 end;

                 // Check result
                 if (mLastOperator = 'and') and
                    (mSearchFlag = True) then
                 begin

                 end;

                 if (mLastOperator = 'and') and
                    (mSearchFlag = False) then
                 begin
                      mTrueFlag := False;
                      mSkip     := True;
                 end;

                 if (mLastOperator = 'or') and
                    (mSearchFlag = True) then
                 begin
                      mTrueFlag := True;
                      mSkip     := False; //

                      // Reset to 'and', as it is assumed
                      mLastOperator := 'and';
                 end;


           end; // if mField
     until mField = '';

     // Final result
     result := mTrueFlag;

end; // TestExpression


// Return a specific custom delimited field
// - Starts with 1
function RecordParseCustomDelimiter(pRecord, pDelim: String; pFieldNum: Integer): String;
var
   mDoubleQuoteFlag: Boolean;

   mCommaCount,
   mLen,
   mLoop: Integer;

   mRecord,
   mChar,
   mField: String;
begin
     mDoubleQuoteFlag := False;

     // Put commas around the record to aid with the counting
     mRecord := pDelim+pRecord+pDelim;

     mCommaCount := 0;
     mLen        := Length(mRecord);
     mField      := '';

     for mLoop := 1 to mLen do
     begin
          mChar := Copy(mRecord,mLoop,1);

          if mChar = pDelim then
          begin
               // Only count if comma is not in quotes
               if not mDoubleQuoteFlag then
               begin
                    inc(mCommaCount);
               end
               else
               begin
                    // Add delims that are in quoted fields
                    if mCommaCount = pFieldNum then
                    begin
                         mField := mField + mChar;
                    end;
               end;
          end
          else
          if mChar = '"' then
          begin
               // Toggle True/False
               mDoubleQuoteFlag := not mDoubleQuoteFlag;
          end
          else
          if mCommaCount = pFieldNum then
          begin
               mField := mField + mChar;
          end;

     end; // mLoop

     result := trim(mField);
end; // RecordParseCustomDelimiter


// Return a specific custom delimited field
// Parse Right to Left
// - Starts with 1
function RecordParseCustomDelimiterRight(pRecord, pDelim: String; pFieldNum: Integer): String;
var
   mDoubleQuoteFlag: Boolean;

   mCommaCount,
   mLen,
   mLoop: Integer;

   mRecord,
   mChar,
   mFieldReverse,
   mField: String;
begin
     mDoubleQuoteFlag := False;

     // Put commas around the record to aid with the counting
     mRecord := pDelim+pRecord+pDelim;

     mCommaCount := 0;
     mLen        := Length(mRecord);
     mField      := '';

     for mLoop := mLen downto 1 do
     begin
          mChar := Copy(mRecord,mLoop,1);

          if mChar = pDelim then
          begin
               // Only count if comma is not in quotes
               if not mDoubleQuoteFlag then
               begin
                    inc(mCommaCount);
               end
               else
               begin
                    // Add delims that are in quoted fields
                    if mCommaCount = pFieldNum then
                    begin
                         mField := mField + mChar;
                    end;
               end;
          end
          else
          if mChar = '"' then
          begin
               // Toggle True/False
               mDoubleQuoteFlag := not mDoubleQuoteFlag;
          end
          else
          if mCommaCount = pFieldNum then
          begin
               mField := mField + mChar;
          end;

     end; // mLoop

     // Reverse the field
     mFieldReverse := '';
     for mLoop := length(mField) downto 1 do
     begin
          mFieldReverse := mFieldReverse + Copy(mField,mLoop,1);
     end;

     result := trim(mFieldReverse);

end; // RecordParseCustomDelimiterRight


// Capture the text from between two delimters
function RecordParseIsolateBetween(pRecord,pDelimiterStart,pDelimiterEnd: String): String;
var
   mFindDStart      : Integer;
   mFindDEnd        : Integer;
   mLenDStart       : Integer;
begin
     result := '';

     mFindDStart := Pos(pDelimiterStart,pRecord);
     mFindDEnd   := Pos(pDelimiterEnd,pRecord);

     // If we found the delimiters
     if  (mFindDEnd > 0) and
         (mFindDEnd > mFindDStart) then
     begin
          mLenDStart := Length(pDelimiterStart);
          result := Copy(pRecord,mFindDStart+mLenDStart,mFindDEnd-(mFindDStart+mLenDStart));
     end;
end; // RecordParseIsolateBetween


// This function will strip all repeating chars from a string
// - Strip multiple chars
// - eg:  "BOB  and    SUE" becomes "BOB and SUE"
function StripRepeatingChars(pString, pChar: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar = pChar) and
             (mLastChar = pChar) then
          begin
          end
          else
          begin
               // Add each character
               mConv := mConv + mChar;
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripRepeatingChars


function StripOutSpaces(pString: String): String;
begin
     result := StripOutChar(pString, ' ');
end;


// This function will strip all repeating chars from a string
// - Strip multiple chars
// - eg:  '100,000',',' becomes '100000'
function StripOutChar(pString, pChar: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar = pChar) then
          begin
          end
          else
          begin
               // Add each character
               mConv := mConv + mChar;
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripOutChar


// This function will remove all non-digits from a number
function StripOutNonDigits(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          // 0,1,2,3,4,5,6,7,8,9
          if (mChar >= #48) and (mChar <= #57) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Toss it away
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end;

// Spaces where non digits are
function SpaceOutNonDigits(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          // 0,1,2,3,4,5,6,7,8,9
          if (mChar >= #48) and (mChar <= #57) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Toss it away
               mConv := mConv + ' ';
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end;


// This function will remove all non-digits and non-alpha from a number
function StripOutNonDigitsOrAlpha(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          // 0,1,2,3,4,5,6,7,8,9
          if (mChar >= #48) and (mChar <= #57) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // A,B,C...Z
          else if (mChar >= #65) and (mChar <= #90) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // a,b,c...z
          else if (mChar >= #97) and (mChar <= #122) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Toss it away
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end;


// This function will remove all chars that do not name a variable
function StripOutNonNamingChars(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          // 0,1,2,3,4,5,6,7,8,9
          if (mChar >= #48) and (mChar <= #57) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // A,B,C...Z
          else if (mChar >= #65) and (mChar <= #90) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // a,b,c...z
          else if (mChar >= #97) and (mChar <= #122) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // Underscore
          else if (mChar = #95) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Toss it away
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end;


// This function will put a space in for all chars that do not name a variable
function SpaceOutNonNamingChars(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          // 0,1,2,3,4,5,6,7,8,9
          if (mChar >= #48) and (mChar <= #57) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // A,B,C...Z
          else if (mChar >= #65) and (mChar <= #90) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // a,b,c...z
          else if (mChar >= #97) and (mChar <= #122) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          // Underscore
          else if (mChar = #95) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Space it
               mConv := mConv + ' ';
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end;


function StripOutDelimiterChars(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar <> '''') and (mChar <> '"') and (mChar <> '~') and (mChar <> ',') then
          begin
               // Add each character
               mConv := mConv + mChar;
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripOutChar


function StripOutDelimiterCharsComplete(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar <> '''') and
             (mChar <> '`') and
             (mChar <> '"') and
             (mChar <> '|') and
             (mChar <> '^') and
             (mChar <> '~') and
             (mChar <> ',') then
          begin
               // Add each character
               mConv := mConv + mChar;
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripOutChar


// Remove end of record / line characters
function StripOutCRLF(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar <> #13) and (mChar <> #10) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Add a space instead
               mConv := mConv + ' ';
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripOutChar


// Convert a StringList to a String (used for Logging SQL commands etc)
function StringListToString(pStringList: TStringList): String;
var
   mList:     Integer;
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mLastChar := '';

     for mList := 0 to  pStringList.Count -1 do
     begin
          mNewField := pStringList[mList];

          // Loop though entire string
          for mLoop := 1 to length(mNewField) do
          begin
               mChar := copy(mNewField,mLoop,1);
               if (mChar <> #13) and (mChar <> #10) then
               begin
                    // Add each character
                    mConv := mConv + mChar;
               end
               else
               begin
                    // Add a space instead
                    mConv := mConv + ' ';
               end;
               mLastchar := mChar;
          end;
     end;

     // Return the variable
     result := mConv
end; // StringListToString


// Strips off outside single and double quotes
function StripOutsideQuotes(pString: String): String;
const
  // Quotes
  cQuote        = '''';
  cDoubleQuote  = '"';
begin
     if (Copy(pString,1,1)      = cQuote) and
        (RightCopy(pString,1)   = cQuote) and
        (length(pString)       >= 2)     then
     begin
          result := Copy(pString,2,length(pString)-2);
     end
     else
     if (Copy(pString,1,1)      = cDoubleQuote) and
        (RightCopy(pString,1)   = cDoubleQuote) and
        (length(pString)       >= 2)     then
     begin
          result := Copy(pString,2,length(pString)-2);
     end
     else
     begin
          result := pString;
     end;
end;


// Remove end of record / line characters
function StripOutCR(pString: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mLastChar,
   mChar,
   mConv:     String;
begin
     mNewField := pString;
     mLastChar := '';

     // Loop though entire string
     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar <> #13) then
          begin
               // Add each character
               mConv := mConv + mChar;
          end
          else
          begin
               // Add a space instead
               mConv := mConv + ' ';
          end;
          mLastchar := mChar;
     end;

     // Return the variable
     result := mConv
end; // StripOutChar

// Set up the DateFormat
function DateFormat(pDateIn, pDateFormatIn, pDateFormatOut: String): String;
var
   mPos,
   mFormat: Integer;
   mSepOut,
   mBuild,
   mD1,
   mD2,
   mD3: String;
begin
     result := '';

     // Defaults
     mSepOut := '/';

     // Figure out what the format for the date should be
     mFormat := length(trim(pDateIn));

     // Reduce the date to its components
     // Note:  Format of GlobDateFormatIn = Format of pDateIn
     //        eg: YYYY/MM/DD = YYYY/MM/DD
     if mFormat in [8,10] then
     begin
          // YYYY
          mPos := pos('Y',uppercase(pDateFormatIn));
          if mFormat = 10 then // YYYY
          begin
               mD1 := copy(pDateIn,mPos,4);
          end;

          if mFormat = 8 then  // YY
          begin
               mD1 := copy(pDateIn,mPos,2);
          end;

          // MM
          mPos := pos('M',uppercase(pDateFormatIn));
          mD2  := copy(pDateIn,mPos,2);

          // DD
          mPos := pos('D',uppercase(pDateFormatIn));
          mD3  := copy(pDateIn,mPos,2);


          // Create a new date field
          // How big does it have to be?
          mFormat := length(trim(pDateFormatOut));
          if mFormat in [8,10] then
          begin
               mBuild := copy('            ',1,mFormat);

               // Enter the Year
               mPos := pos('Y',uppercase(pDateFormatOut));
               if mFormat = 8 then
               begin
                    delete(mBuild,mPos,2);
                    // Find the separator .. YY types must be in third location
                    mSepOut := copy(mBuild,3,1);
               end;
               if mFormat = 10 then
               begin
                    delete(mBuild,mPos,4);
                    // Find the separtor... depending where the YYYY is located
                    if copy(uppercase(pDateFormatOut),1,1) = 'Y' then
                    begin
                         // YYYY at front
                         mSepOut := copy(pDateFormatOut,5,1);
                    end
                    else
                    begin
                         // YYYY elsewhere
                         mSepOut := copy(pDateFormatOut,3,1);
                    end;
               end;

               // If we are going for a YY to YYYY, then, add 20 in front of it
               if (Length(pDateFormatIn) = 8) and (Length(pDateFormatOut) = 10) then
               begin
                    mD1 := '20'+mD1;
               end;
               insert(mD1,mBuild,mPos);

               // Enter the Month
               mPos := pos('M',uppercase(pDateFormatOut));
               delete(mBuild,mPos,2);
               insert(mD2,mBuild,mPos);

               // Enter the Day
               mPos := pos('D',uppercase(pDateFormatOut));
               delete(mBuild,mPos,2);
               insert(mD3,mBuild,mPos);

               // Slashes in the right place
               while pos(' ',mBuild) > 0 do
               begin
                    mPos := pos(' ',mBuild);

                    delete(mBuild,mPos,1);
                    insert(mSepOut,mBuild,mPos);
               end;

               // Return the new date
               result := mBuild;

          end; // mFormat
     end; // mFormat
end; // DateFormat


// Modify the time according to convert string
// eg: TimeFormat('1:20:10pm','HH:MM:SS','');
// eg: TimeFormat('1:20:10pm','HH:MM','AMPM');
function TimeFormat(pTimeIn, pTimeFormatOut, pConvert: String): String;
var
   mHours            : Integer;
   mFind             : Integer;
   mT1,
   mT2,
   mT3               : String;
   mBuild            : String;
begin
     result := pTimeIn;

     mFind  := Pos(':',pTimeIn);
     if mFind > 0 then
     begin
          // 12345678
          // hh:mm:ss
          if mFind = 3 then
          begin
               mT1 := Copy(pTimeIn,1,2);
               mT2 := Copy(pTimeIn,4,2);
               mT3 := Copy(pTimeIn,7,2);
          end
          else
          // h:mm:ssp
          begin
               mT1 := Copy(pTimeIn,1,1);
               mT2 := Copy(pTimeIn,3,2);
               mT3 := Copy(pTimeIn,5,2);
          end;
          mHours := StrToIntDef(mT1,0);

          // Are we needing a daytime 24 time?
          // - 24 will assume PM hours for time less than 6
          if UpperCase(pConvert) = 'D24' then
          begin
               // if 12 time < 6 then add 12
               // - anything less than 6AM becomes PM
               if mHours < 6 then
               begin
                    mHours := mHours + 12;
               end;

          end
          else if UpperCase(pConvert) = 'AMPM' then
          begin
               // 12pm is noon, so make sure less
               if Pos('P',UpperCase(pTimeIn)) > 0 then
               begin
                    if mHours < 12 then
                    begin
                         mHours := mHours + 12;
                    end;
               end;
               // 12am is midnight, so, make sure is 0
               if Pos('A',UpperCase(pTimeIn)) > 0 then
               begin
                    if mHours = 12 then
                    begin
                         mHours := 0;
                    end;
               end
          end;


          // Reconstitute
          mBuild := RightCopy('00'+IntToStr(mHours),2)+':'+mT2;

          // See if we include seconds
          if Length(pTimeFormatOut) > 5 then
          begin
               if mT3 <> '' then
               begin
                    mBuild := mBuild + ':' + RightCopy('00'+mT3,2);
               end
               else
               begin
                    mBuild := mBuild + ':00';
               end;
          end;

          result := mBuild;
     end;
end;  // Time format


// This function will strip all spaces from a field, and uppercase the works
// - Strip spaces
// - Strip dashes
function UpperCaseSpaceStrip(pField: String): String;
var
   mLoop:     Integer;
   mNewField: String;
   mChar,
   mConv:     String;
begin
     mNewField := trim(UpperCase(pField));

     for mLoop := 1 to length(mNewField) do
     begin
          mChar := copy(mNewField,mLoop,1);
          if (mChar <> ' ') and (mChar <> '-') then
          begin
               mConv := mConv + mChar;
          end;
     end;

     // Return the variable
     result := mConv
end; // UpperCaseSpaceStrip



// Show disk space free information
function DiskInformation(pDriveList: String): String;
var
   mNumDrive: Byte;
   mFree,
   mLoop: Integer;
   mResult,
   mDrive,
   mParse: String;
begin
     mResult := '';
     mParse  := Trim(pDriveList);

     mResult := 'Space Free:  ';

     // Parse through info for drives to review
     for mLoop := 1 to Length(mParse) do
     begin
          mDrive := Uppercase(Copy(mParse,mLoop,1));

          if (mDrive >= 'A') and (mDrive <= 'Z') then
          begin
               mNumDrive := Pos(mDrive,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
               mFree := Round(DiskFree(mNumDrive) / (1024 * 1024));

               mResult := mResult + mDrive + ':' + IntToStr(mFree) + ' MB   ';
          end;
     end;
     Result := mResult;
end; // DiskInformation


function GetLocalHardDrives: string;
var 
  Drv: string; 
  C: Char; 
begin 
  Result := '';
  Drv := '*:\'; 
  for C := 'A' to 'Z' do 
  begin 
    Drv[1] := C; 
    if GetDriveType(PCHAR(Drv)) = DRIVE_FIXED then
      Result := Result + C; 
  end;
end;


// Pad string
// - Returns a nicely padded string
// - eg:  "BOB",5 becomes "BOB  "
function PadStringToLength(pString: String; pLen: Integer): String;
var
   mSpaces: String;
begin
     mSpaces := '                                            ';
     result := Copy(pString + mSpaces + mSpaces,0,pLen);
end; // PadStringToLength


// Returns an integer as a string, with commas for 1000's separation
function CommaIntToStr(pConvertInt: Integer): String;
var
     mThreeChars,
     mNumbersString,
     mCommaString: String;

     mIndex,
     mNumCommas,
     mStartPos,
     mCommaStringLen,
     mCSDivThree,
     mCSModThree: Integer;
begin
     mStartPos := 0;
     mNumbersString  := IntToStr(pConvertInt);
     mCommaString    := '';

     mCommaStringLen := Length(mNumbersString);
     mCSDivThree     := mCommaStringLen div 3;
     mCSModThree     := mCommaStringLen mod 3;

     if mCSDivThree >= 1 then
     begin
          mNumCommas := mCSDivThree;
          // If the string length divided by three is EVEN, we don't count one
          // of the sections of 3 characters when determining the number of commas
          if mCSModThree = 0 then
          begin
               dec(mNumCommas);
          end;
          if mNumCommas >= 1 then
          begin
               mIndex := mNumCommas;
               while mIndex >= 1 do
               begin
                    mStartPos   := mIndex * 3;
                    mStartPos   := (mCommaStringLen - mStartPos) + 1;
                    mThreeChars := Copy(mNumbersString, mStartPos, 3);
                    mCommaString := ',' + mThreeChars + mCommaString;
                    dec(mIndex);
               end;
               // We can determine what is left to chop from the primary string based on the
               // start position of the last chop segment.
               if ((mStartPos - 1) >= 1) then
               begin
                    mCommaString := Copy(mNumbersString, 1, (mStartPos-1)) + mCommaString;
               end;

          end
          else
          begin
               mCommaString := mNumbersString;
          end;
     end
     else
     begin
          // No need for a comma, this is less than 1000
          mCommaString := mNumbersString;   // May 17, 2006 vb
     end;

     // Return string populated with commas
     result := mCommaString;
end; // CommaIntToStr


// Replace an instance of one string in another string with another string. The original string with
// the substring in it is modified directly. (pass by reference)
// This was initially created as follows:
// Because the MySql components don't provide the 'standard' way to populate parameters (ParamByName),
// and we need to be able to populate params for both ADO and MySQL queries, this function takes the
// current query - in the form of a string - that has been set up to 'use parameters', and replaces
// those parameters with the requested string of information,
procedure FindAndReplaceString(var pChangeString: String; pFindString, pReplaceStr: String);
var
     mEndStrPos,
     mEndStrNumChars,
     mParmIndex,
     mParmStrLen,
     mFullStrLen: Integer;

     mBegString,
     mEndString: String;

     mStringFound: Boolean;
begin
     mStringFound := True;
     while mStringFound do
     begin
          // Get string that parameter is in up to the parameter
          mParmIndex       := Pos(pFindString, pChangeString);
          if mParmIndex >= 1 then
          begin
               mBegString       := Copy(pChangeString, 0, (mParmIndex - 1));

               // Get string that parameter is in AFTER the parameter
               mParmStrLen      := Length(pFindString);
               mEndStrPos       := mParmIndex + mParmStrLen;
               mFullStrLen      := Length(pChangeString) + 1;
               mEndStrNumChars  := mFullStrLen - mEndStrPos;
               mEndString       := Copy(pChangeString, mEndStrPos, mEndStrNumChars);

               // Piece together the beginning, replace string, and end string, into the string list,
               // replacing everything at the string list index for the parameter string.
               pChangeString := mBegString + pReplaceStr + mEndString;
          end
          else
          begin
               mStringFound := False;
          end;
     end;
end;

// Provided a string, this returns a string's numeric digit string in touch tones
function TTLetterDigits(pStringToConv: String): String;
var
     mCharInt,
     mIndex: Integer;
     mConvString,
     mConvertedString: String;
     mSingleChar: Char;
begin
     mConvString      := UpperCase(pStringToConv);
     mConvertedString := '';
     // Loop through string, 1 character at a time, converting the numbers to their
     // telephone keypad/touch tone equivalent.
     for mIndex := 1 to Length(mConvString) do
     begin
          mSingleChar := mConvString[mIndex];
          mCharInt    := Ord(mSingleChar);

          if                                                 (mSingleChar = '1') then
          begin
               mConvertedString := mConvertedString + '1';
          end
          // ABC
          else if ((mCharInt >= 65) AND (mCharInt <= 67)) or (mSingleChar = '2') then
          begin
               mConvertedString := mConvertedString + '2';
          end
          // DEF
          else if ((mCharInt >= 68) AND (mCharInt <= 70)) or (mSingleChar = '3') then
          begin
               mConvertedString := mConvertedString + '3';
          end
          // GHI
          else if ((mCharInt >= 71) AND (mCharInt <= 73)) or (mSingleChar = '4') then
          begin
               mConvertedString := mConvertedString + '4';
          end
          // JKL
          else if ((mCharInt >= 74) AND (mCharInt <= 76)) or (mSingleChar = '5') then
          begin
               mConvertedString := mConvertedString + '5';
          end
          // MNO
          else if ((mCharInt >= 77) AND (mCharInt <= 79)) or (mSingleChar = '6') then
          begin
               mConvertedString := mConvertedString + '6';
          end
          // PQRS
          else if ((mCharInt >= 80) AND (mCharInt <= 83)) or (mSingleChar = '7') then
          begin
               mConvertedString := mConvertedString + '7';
          end
          // TUV
          else if ((mCharInt >= 84) AND (mCharInt <= 86)) or (mSingleChar = '8') then
          begin
               mConvertedString := mConvertedString + '8';
          end
          // WXYZ
          else if ((mCharInt >= 87) AND (mCharInt <= 90)) or (mSingleChar = '9') then
          begin
               mConvertedString := mConvertedString + '9';
          end
          // 0
          else if                                            (mSingleChar = '0') then
          begin
               mConvertedString := mConvertedString + '0';
          end;
     end;
     result := mConvertedString;
end;


// Do we have a number (int, real)
function IsNumber(pString: String): Boolean;
var
  i: Integer;
  mPeriod: Boolean;
begin
    result  := False;
    mPeriod := False;
    for i := 1 to Length(pString) do
    case pString[i] of
      '0'..'9':;
      '.':
        begin
          if (mPeriod) then
          begin
               Exit;
          end
          else
          begin
               mPeriod := True;
          end;
        end;
      else
        Exit;
    end;
    result := True;
end;


// Estimate if we have a valid telephone
function IsValidTelephoneNo10(pTelephone: String): Boolean;
var
   mArea  : Integer;
   mExch  : Integer;
   mNum   : Integer;
   mTelNo : String;
begin
     result := False;
     mTelNo := pTelephone;
     // North america
     if Length(pTelephone) = 10 then
     begin
          mArea := StrToIntDef(Copy(mTelNo,1,3), -1);
          mExch := StrToIntDef(Copy(mTelNo,4,3), -1);
          mNum  := StrToIntDef(Copy(mTelNo,7,4), -1);

          if (mArea > 199) and   // Minimum value for tel area no is 200
             (mExch > 99) and    // Minimum value for tel exch no
             (mNum  > -1) then
          begin
               result := True;
          end;
     end;
end;

// Display a telephone number with spaces
function TelephoneNumberDisplay(pNumber: String): String;
const
   cS = ' ';
var
   mS: String;
   mLen:  Integer;
begin
     result := pNumber;
     mS     := Trim(pNumber);
     mLen   := Length(mS);

     case mLen of
     7:  result := copy(mS,1,3)+cS+copy(mS,4,99);
     10: result := copy(mS,1,3)+cS+copy(mS,4,3)+cS+copy(mS,7,99);
     11: result := copy(mS,1,1)+cS+copy(mS,2,3)+cS+copy(mS,5,3)+cS+copy(mS,8,99);
     end;

end;

// Determine if the value is valid
// - Return (xxx)xxx-xxxx
function TelephoneNumberClassic(pTelNo: String): String;
const
   cSpace = ' ';
var
   mTelNo : String;
   mArea  : Integer;
   mExch  : Integer;
   mNum   : Integer;

   mFormat : String;
   // -          1
   // - 1234567890123
   //   (xxx)xxx-xxxx
begin
     result  := '';

     // Did the user just type in a number?
     if pTelNo <> '' then
     begin
          // Strip out all none number stuff, and see if it looks like a 10 digit number
          mTelNo := StripOutNonDigits(pTelNo);

          // Only 10 digits will work from here
          if Length(mTelNo) = 10 then
          begin
               mArea := StrToIntDef(Copy(mTelNo,1,3), -1);
               mExch := StrToIntDef(Copy(mTelNo,4,3), -1);
               mNum  := StrToIntDef(Copy(mTelNo,7,4), -1);

               // Did the user type a 10 digit number?
               if (mArea > 99) and   // Minimum value for tel area no
                  (mExch > 99) and   // Minimum value for tel exch no
                  (mNum  > -1) then
               begin
                    if Length(mTelNo) = 10 then
                    begin
                         // Reformat
                         mFormat := '('+Copy(mTelNo,1,3)+')'+cSpace+
                                        Copy(mTelNo,4,3)+'-'+
                                        Copy(mTelNo,7,4);
                    end;
               end;

               // Make sure everything is formated correctly
               // (xxx) xxx-xxxx
               // 12345678901234
               if length(mFormat) = 14 then
               begin
                    if (Copy(mFormat,1,1)  = '(') and
                       (Copy(mFormat,5,1)  = ')') and
                       (Copy(mFormat,10,1) = '-') and
                       (StrToIntDef(Copy(mFormat,2,3),-1) > -1) and
                       (StrToIntDef(Copy(mFormat,7,3),-1) > -1) and
                       (StrToIntDef(Copy(mFormat,11,4),-1) > -1) then
                    begin
                         // We have a properly formated telephone number
                         result := mFormat;
                    end;
               end;
          end;
     end;
end; // TelephoneNoFix



// Reverse bytes in a number
function FourByteReverse(pVal: Cardinal): Cardinal;
var
   a,b,c,d: byte;
   mNew,
   mVal: Cardinal;
begin
     mVal := $9F010000;
     //mVal := $0000019F;

     mNew := mVal;

     a := mNew and $FF;
     mNew := mNew shr 8;
     b := mNew and $FF;
     mNew := mNew shr 8;
     c := mNew and $FF;
     mNew := mNew shr 8;
     d := mNew and $FF;

     //mNew := d + 256*c + 65536*b + 16777216*a;
     mNew := d + ($FF+1)*c + ($FFFF+1)*b + ($FFFFFF+1)*a;

     result := mNew;
end; // FourByteShift


////////////////////////////////
// HTML
////////////////////////////////

// Create the code at the start of an HTML logile
// Note all lines added to the log file must have a:
// <BR>
// at the end of it.  This is a CRLF in html
function LogHTMLStart: String;
begin
     result := '<!--(C) '+FormatDateTime('YYYY',Now)+' enGenic--><HTML><BODY><font face=courier size=2>';
     // Now log all lines like this:
     // 2005-09-20 20:45:34 - Reading Data from file<BR>
end;

// Not essential, but, it keeps things clean;
function LogHTMLEnd: String;
begin
     result := '</font></BODY></HTML>';
end;

// This fuction makes sure that all spaces are kept resident
// - In HTML '123    2.11   Code' becomes '123 2.11 Code' when displayed
// - Using hard spaces prevents this from happening, and keeps columns looking good
function HTMLHardSpace(pText: String): String;
begin
     // A non hard space will always be included if singular, so only doubles needed to replace
     result := StringReplace(pText,'  ','&nbsp;&nbsp;',[rfReplaceAll]);
end;


////////////////////////////////
// HTML for Tables
////////////////////////////////
(*
<table border="0"  width="100%" cellpadding="2" cellspacing="2" bgcolor="#ffffff">
  <tr><!-- Row Title -->
     <td bgcolor="#eeeeee">Name</td>
     <td bgcolor="#eeeeee" width="80">Days</td>
     <td bgcolor="#eeeeee" width="80">Remaing</td>
     <td bgcolor="#eeeeee" width="80">Amt Total</td>
     <td bgcolor="#eeeeee" width="80">Amt Remaining</td>
     <td bgcolor="#eeeeee" width="80"></td>
     <td bgcolor="#eeeeee" width="80"></td>
  </tr>
  <tr>
     <td>Tim Forner</td>
     <td>45</td>
     <td>3</td>
     <td>64</td>
     <td></td>
     <td></td>
     <td></td>
  </tr>
  <tr>
     <td bgcolor="#eeeeff"><a href="Vern.Html">Vern Baker</a></td>
     <td bgcolor="#eeeeff" align="Right">15.00</td>
     <td bgcolor="#eeeeff">16.13</td>
     <td bgcolor="#eeeeff">7</td>
     <td bgcolor="#eeeeff"></td>
     <td bgcolor="#eeeeff"></td>
     <td bgcolor="#eeeeff"></td>
  </tr>
</table>
*)

// Define table
function HTMLTableStart(pOptionalColor: String): String;
var
   mColor : String;
begin
     // Set up row for alternating color
     GlobHTMLRow := 1;

     // Setup the color
     mColor := HTMLColorBGSetup('#ffffff', pOptionalColor);
     // Result is the table
     result := '<table border="0" width="100%" cellpadding="2" cellspacing="2" bgcolor="'+mColor+'">'
end; //  HTMLTableStart


// End table
function HTMLTableEnd: String;
begin
     result := '</table>';
end;

// Line break
function HTMLBr: String;
begin
     result := '<br>';
end;


// Row start
function HTMLRowStart: String;
begin
     inc(GlobHTMLRow);
     result := '<tr>';
end;

// Row end
function HTMLRowEnd: String;
begin
     result := '</tr>';
end;

// Define the color for alternting rows
function HTMLCellAlternatingRowColor(pContents: String; pAlignRight: Boolean; pOptionalColor: String): String;
var
   mAlign  : String;
begin
     mAlign := '';
     if pAlignRight then
     begin
          // Make sure there is a space in front
          mAlign := ' align="Right"';
     end;

     if (GlobHTMLRow Mod 2) = 0 then
     begin
          result :=  '<td'+mAlign+'>'+pContents+'</td>';
     end
     else
     begin
          result :=  '<td'+mAlign+' bgcolor="'+HTMLColorBGSetup('#eeeeff', pOptionalColor)+'">'+pContents+'</td>';
     end;
end; // HTMLCellAlternatingRowColor


// Get the color for backgrounds
function HTMLColorBGSetup(pBaseColor, pColor: String): String;
var
   mColor : String;
begin
     // Setup the color
     mColor := pBaseColor;
     if pColor <> '' then
     begin
          if copy(pColor,1,1) <> '#' then
          begin
               mColor := '#'+pColor;
          end
          else
          begin
               mColor := pColor;
          end;
     end;
     result := mColor;
end; // HTMLColorBGSetup

// Standard oneliner error message.
function HTMLWrapErrorMessage(pError: String): String;
begin
     result := '<html><body><h1><font color=#EE0000>'+pError+'</font></h1></body></html>';
end;


// ************************************************************
// *** Debugging
// ************************************************************

(*
// Initialize with
FCTimeReportStart;    // Sets up defaults for a new report
// Repeat for each item (debug point)
FCTimeCountGo;        // Start counting milliseconds
FCTimeCountStop;      // Stop counting (this provides the total of ms)
FCTimeReportAdd('A'); // Adds as a next item to the report

// Report the output
QuickInfo(FlowTablet.TTTimeReport+'@'+IntToStr(FlowTablet.TTTimeCount)); // QuickInfo  ///////////// @@@@@ ///////////////
*)

// For testing and debugging
// - Sets up defaults for a new report
procedure FCTimeReportStart;
begin
     TTTimeCount  := 0;  // Counts up MSecs between ops
     TTTimeStamp  := DateTimeToTimeStamp(Now);
     TTTimeReport := '';
     TTTimeActive := True;
end;

// Adds as a next item to the report
function FCTimeReportAdd(pShortDesc: String): String;
var
   mMSThen               : Comp;
   mMSNow                : Comp;
   mMath                 : Comp;
begin
     if TTTimeReport <> '' then
     begin
          TTTimeReport := TTTimeReport+',';
     end;

     // Figure out the change in time
     mMSNow   := TimeStampToMSecs(DateTimeToTimeStamp(Now));
     mMSThen  := TimeStampToMSecs(TTTimeStamp);

     mMath    := mMSNow - mMSThen;

     //mTimeStamp := MSecsToTimeStamp(mMath);
     //DecodeTime(TimeStampToDateTime(mTimeStamp),Hour, Min, Sec, MSec);
     //mDis  := IntToStr((Min * 60 * 1000) + (Sec * 1000) + MSec);
     TTTimeReport := TTTimeReport+pShortDesc+':'+CompToStr(mMath);

     result := TTTimeReport;
end;

// Start counting milliseconds
procedure FCTimeCountGo;
begin
     TTTimeAdd := DateTimeToTimeStamp(Now);
end;

// Total the milliseconds
procedure FCTimeCountStop;
var
   mMSThen               : Comp;
   mMSNow                : Comp;
   mMath                 : Comp;
   //mTimeStamp            : TTimeStamp;
   //Hour, Min, Sec, MSec  : Word;
begin
     if TTTimeActive then
     begin
          // Figure out the change in time
          mMSNow   := TimeStampToMSecs(DateTimeToTimeStamp(Now));
          mMSThen  := TimeStampToMSecs(TTTimeStamp);

          mMath    := mMSNow - mMSThen;

          //mTimeStamp := MSecsToTimeStamp(mMath);
          //DecodeTime(TimeStampToDateTime(mTimeStamp),Hour, Min, Sec, MSec);
          // Add the difference in MSecs to time counter
          TTTimeCount :=  TTTimeCount + mMath; //(Min * 60 * 1000) + (Sec * 1000) + MSec;
     end;
     TTTimeActive := False;
end;


function CompToStr(N: comp): string;
var Low3:string[3];
    N1:extended;
begin
    if N<0 then begin;
        Result:='-'+CompToStr(-N);
    end else begin;
        N1:=N/1000;
        Str(Round(Frac(N1)*1000),Low3);
        N:=Int(N1);
        if N>0 then begin;
            while Length(Low3) < 3 do Low3 := '0' + Low3;
            Result:=CompToStr(N)+ThousandSeparator+Low3;
        end else begin;
            Result:=Low3;
        end;
    end;
end;

// Generate a combined stringlist with parameters
function BuildStringListWithParameters(pStatement: TStrings; pParams: String; var pSuccess: Boolean): TStringList;
var
   mReplace              : String;
   mSearch               : String;
   mLoop                 : Integer;
   mCount                : Integer;
   mParm                 : Integer;

   mCustomReportLine     : String;
begin
     // First, create the TStringList
     Result := TStringList.Create;


     // How many parameters are being passed
     mCount := 1;
     for mLoop := 1 to length(pParams) do
     begin
          if Copy(pParams,mLoop,1) = ',' then
          begin
               inc(mCount);
          end;
     end;


     // create processing
     try
        // Now, combine the values and the SQL statement
        for mLoop := 0 to pStatement.Count - 1 do
        begin
             mCustomReportLine :=  pStatement[mLoop];

             // See if there are params to replace
             // --P1 will replace %P1%
             // Anything but the parm lines
             if uppercase(copy(mCustomReportLine,1,2)) <> '--' then
             begin
                  // Check for each parm
                  for mParm := 1 to mCount do
                  begin
                       mSearch  := '%P'+IntToStr(mParm)+'%';
                       mReplace :=  RecordParse(pParams,mParm);

                       mCustomReportLine := ReplaceAllSubStringsWithAnother(mSearch, mReplace, mCustomReportLine);
                  end; // for mParm

             end;

             // -----------------------
             // Only add line, if valid
             // -----------------------
             if uppercase(copy(mCustomReportLine,1,2)) <> '--' then
             begin
                  result.Add(mCustomReportLine);
             end;
        end;
     finally
     end;
     // So, here is the completed statement
     // =  result
end;


// Get full names for states and provines
function GetStateProv(pCode: String; var pVarCountry: String): String;
var
   mTerr : String;
begin
     mTerr := '';
     if pCode = 'AL' then mTerr := 'US-Alabama';
     if pCode = 'AK' then mTerr := 'US-Alaska';
     if pCode = 'AZ' then mTerr := 'US-Arizona';
     if pCode = 'AR' then mTerr := 'US-Arkansas';
     if pCode = 'CA' then mTerr := 'US-California';
     if pCode = 'CO' then mTerr := 'US-Colorado';
     if pCode = 'CT' then mTerr := 'US-Connecticut';
     if pCode = 'DE' then mTerr := 'US-Delaware';
     if pCode = 'FL' then mTerr := 'US-Florida';
     if pCode = 'GA' then mTerr := 'US-Georgia';
     if pCode = 'HI' then mTerr := 'US-Hawaii';
     if pCode = 'ID' then mTerr := 'US-Idaho';
     if pCode = 'IL' then mTerr := 'US-Illinois';
     if pCode = 'IN' then mTerr := 'US-Indiana';
     if pCode = 'IA' then mTerr := 'US-Iowa';
     if pCode = 'KS' then mTerr := 'US-Kansas';
     if pCode = 'KY' then mTerr := 'US-Kentucky';
     if pCode = 'LA' then mTerr := 'US-Louisiana';
     if pCode = 'ME' then mTerr := 'US-Maine';
     if pCode = 'MD' then mTerr := 'US-Maryland';
     if pCode = 'MA' then mTerr := 'US-Massachusetts';
     if pCode = 'MI' then mTerr := 'US-Michigan';
     if pCode = 'MN' then mTerr := 'US-Minnesota';
     if pCode = 'MS' then mTerr := 'US-Mississippi';
     if pCode = 'MO' then mTerr := 'US-Missouri';
     if pCode = 'MT' then mTerr := 'US-Montana';
     if pCode = 'NE' then mTerr := 'US-Nebraska';
     if pCode = 'NV' then mTerr := 'US-Nevada';
     if pCode = 'NH' then mTerr := 'US-New Hampshire';
     if pCode = 'NJ' then mTerr := 'US-New Jersey';
     if pCode = 'NM' then mTerr := 'US-New Mexico';
     if pCode = 'NY' then mTerr := 'US-New York';
     if pCode = 'NC' then mTerr := 'US-North Carolina';
     if pCode = 'ND' then mTerr := 'US-North Dakota';
     if pCode = 'OH' then mTerr := 'US-Ohio';
     if pCode = 'OK' then mTerr := 'US-Oklahoma';
     if pCode = 'OR' then mTerr := 'US-Oregon';
     if pCode = 'PA' then mTerr := 'US-Pennsylvania';
     if pCode = 'RI' then mTerr := 'US-Rhode Island';
     if pCode = 'SC' then mTerr := 'US-South Carolina';
     if pCode = 'SD' then mTerr := 'US-South Dakota';
     if pCode = 'TN' then mTerr := 'US-Tennessee';
     if pCode = 'TX' then mTerr := 'US-Texas';
     if pCode = 'UT' then mTerr := 'US-Utah';
     if pCode = 'VT' then mTerr := 'US-Vermont';
     if pCode = 'VA' then mTerr := 'US-Virginia';
     if pCode = 'WA' then mTerr := 'US-Washington';
     if pCode = 'WV' then mTerr := 'US-West Virginia';
     if pCode = 'WI' then mTerr := 'US-Wisconsin';
     if pCode = 'WY' then mTerr := 'US-Wyoming';
     if pCode = 'DC' then mTerr := 'US-District of Columbia';
     if pCode = 'PR' then mTerr := 'US-Puerto Rico';
     if pCode = 'VI' then mTerr := 'US-Virgin Islands';
     if pCode = 'AB' then mTerr := 'CA-Alberta';
     if pCode = 'BC' then mTerr := 'CA-British Columbia';
     if pCode = 'MB' then mTerr := 'CA-Manitoba';
     if pCode = 'NB' then mTerr := 'CA-New Brunswick';
     if pCode = 'NL' then mTerr := 'CA-Newfoundland/Labrador';
     if pCode = 'NF' then mTerr := 'CA-Newfoundland/Labrador';
     if pCode = 'LB' then mTerr := 'CA-Newfoundland/Labrador';
     if pCode = 'NT' then mTerr := 'CA-Northwest Territories';
     if pCode = 'NS' then mTerr := 'CA-Nova Scotia';
     if pCode = 'NU' then mTerr := 'CA-Nunavut';
     if pCode = 'ON' then mTerr := 'CA-Ontario';
     if pCode = 'PE' then mTerr := 'CA-Prince Edward Island';
     if pCode = 'PQ' then mTerr := 'CA-Quebec';
     if pCode = 'QU' then mTerr := 'CA-Quebec';
     if pCode = 'QC' then mTerr := 'CA-Quebec';
     if pCode = 'SK' then mTerr := 'CA-Saskatchewan';
     if pCode = 'YK' then mTerr := 'CA-Yukon';

     // Break out the two results
     if mTerr <> '' then
     begin
          pVarCountry := Copy(mTerr,1,2);
          result      := Copy(mTerr,4,999);
     end
     else
     begin
          pVarCountry := '--';
          result      := '-'
     end;
end; // GetStateProv


// Some telephone area codes over lay others
// eg: 778 overlays 604 - so, search using 604, and not 778
function GetTelnoOverLay(pOverLayArea: Integer; var pInProvState: String): Integer;
begin
     result       := 0;
     pInProvState := '--';
     case pOverLayArea of
     778: begin pInProvState :='BC'; result := 604; end;
     424: begin pInProvState :='CA'; result := 310; end;
     720: begin pInProvState :='CO'; result := 303; end;
     829: begin pInProvState :='DR'; result := 809; end;
     786: begin pInProvState :='FL'; result := 305; end;
     321: begin pInProvState :='FL'; result := 407; end;
     754: begin pInProvState :='FL'; result := 954; end;
     678: begin pInProvState :='GA'; result := 404; end;
     770: begin pInProvState :='GA'; result := 404; end;
     762: begin pInProvState :='GA'; result := 706; end;
     224: begin pInProvState :='IL'; result := 847; end;
     774: begin pInProvState :='MA'; result := 508; end;
     857: begin pInProvState :='MA'; result := 617; end;
     339: begin pInProvState :='MA'; result := 781; end;
     351: begin pInProvState :='MA'; result := 978; end;
     240: begin pInProvState :='MD'; result := 301; end;
     443: begin pInProvState :='MD'; result := 410; end;
     947: begin pInProvState :='MI'; result := 248; end;
     980: begin pInProvState :='NC'; result := 704; end;
     551: begin pInProvState :='NJ'; result := 201; end;
     848: begin pInProvState :='NJ'; result := 732; end;
     862: begin pInProvState :='NJ'; result := 973; end;
     646: begin pInProvState :='NY'; result := 212; end;
     917: begin pInProvState :='NY'; result := 212; end;
     347: begin pInProvState :='NY'; result := 718; end;
   //917: begin pInProvState :='NY'; result := 718; end; // Three way overlay , default to 212
     234: begin pInProvState :='OH'; result := 330; end;
     567: begin pInProvState :='OH'; result := 419; end;
     647: begin pInProvState :='ON'; result := 416; end;
     226: begin pInProvState :='ON'; result := 519; end;
     289: begin pInProvState :='ON'; result := 905; end;
     971: begin pInProvState :='OR'; result := 503; end;
     267: begin pInProvState :='PA'; result := 215; end;
     878: begin pInProvState :='PA'; result := 412; end;
     484: begin pInProvState :='PA'; result := 610; end;
   //878: begin pInProvState :='PA'; result := 724; end; // Three way overlay, default to 412
     939: begin pInProvState :='PR'; result := 787; end;
     438: begin pInProvState :='QC'; result := 514; end;
     469: begin pInProvState :='TX'; result := 214; end;
     972: begin pInProvState :='TX'; result := 214; end;
     281: begin pInProvState :='TX'; result := 713; end;
     832: begin pInProvState :='TX'; result := 713; end;
     682: begin pInProvState :='TX'; result := 817; end;
     430: begin pInProvState :='TX'; result := 903; end;
     571: begin pInProvState :='VA'; result := 703; end;
     end;
end; // GetTelnoOverLay


///////////////////////////////////////
// XML STUFF
///////////////////////////////////////
//
// Element   = <to>Tove</to>
// Attribute = <to date="12/11/2002">   // Note: Attributes (date) must be double quoted

// Provide a header for XML
function XMLHeader: String;
begin
     result := '<?xml version="1.0" encoding="UTF-8"?>';  // UTF-8 is ideal for non-unicode
end;

// Provide a header for VXML
function VXMLHeader: String;
begin
     result := '<?xml version="1.0" encoding="UTF-8"?>'+cCrLf+
               '<vxml xmlns="http://www.w3.org/2001/vxml"'+cCrLf+
               '  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+cCrLf+
               '  xsi:schemaLocation="http://www.w3.org/2001/vxml'+cCrLf+
               '   http://www.w3.org/TR/voicexml20/vxml.xsd"'+cCrLf+
               '   version="2.0">';
end;


// Remove the XML header
function XMLHeaderRemove(pData: String): String;
var
   mFind   : Integer;
begin
     mFind  := Pos('?>', pData);
     if mFind > 0 then
     begin
          result := Copy(pData,mFind+2,999999);
     end
     else
     begin
          result := pData;
     end;
end; // XMLHeaderRemove


// Provide a packet start for XML
function XMLPacketStart: String;
begin
     result := '<datapacket>';
end;

// Provide a packet end for XML
function XMLPacketEnd: String;
begin
     result := '</datapacket>';
end;

// Get the value of an attribute from within a record (String)
// eg:
//  ('reportdate', '<systemhealth title="TFSentinel" reportdate="2007/05/01" reporttime="17:00:31">')
// would give you...2007/05/01
function XMLGetAttributeValue(pAttribute, pRecord: String): String;
var
   mField : String;
   mPos   : Integer;
begin
     result := '';
     mPos := Pos(pAttribute+'=', pRecord);
     if (mPos > 0) then
     begin
          mField := Copy(pRecord, mPos+1, 9999);
          // will give us..
          // eportdate="2007/05/01" reportti...

          // The goods are between the double quotes .. effectively, field 2
          result := RecordParseCustomDelimiter(mField, '"', 2);
     end;
end; // XMLGetAttributeValue


// Wrap a string of XML in a record
function XMLRecordWrap(pField: String; pData: String): String;
begin
     // Now, put the tag around it
     result := '<'+Trim(pField)+'>'+Trim(pData)+'</'+Trim(pField)+'>';
end;

// Wrap a string of XML in a record with elements
// NOTE:  This is badly worded... use XMLTagWrapWithAttributes instead
function XMLRecordWrapWithElements(pField: String; pElement, pData: String): String;
begin
     // Now, put the tag around it
     result := XMLTagWrapWithAttributes(pField, pElement, pData);
end;

// Wrap a string of XML in a record with elements
function XMLTagWrapWithAttributes(pTag: String; pAttributes, pValue: String): String;
begin
     // Now, put the tag around it
     if (pValue <> '') then
     begin
          result := '<'+Trim(pTag+' '+pAttributes)+'>'+Trim(pValue)+'</'+Trim(pTag)+'>';
     end
     else
     begin
          result := '<'+Trim(pTag+' '+pAttributes)+'/>';
     end;
end;


// Create an XML wrapper for the fields
function XMLTagWrap(pTag: String; pData: Variant): String;
var
   basicType       : Integer;
   mWrappedField   : String;
begin
     // Return nothing, unless we were given data
     result := '';

     // Make sure we have something to do
     //if not VarIsNull(pData) then       // or VarIsEmpty
     if not (trim(VarToStr(pData)) = '') then
     begin
          // Find the type of field
          basicType := VarType(pData) and VarTypeMask;

          // Set a string to match the type
          case basicType of
            varEmpty   : mWrappedField := XMLReplaceProhibitedChars(VarToStr(VarToStr(pData)));
            varUnknown : mWrappedField := XMLReplaceProhibitedChars(VarToStr(VarToStr(pData)));
            varStrArg  : mWrappedField := XMLReplaceProhibitedChars(VarToStr(VarToStr(pData)));
            varString  : mWrappedField := XMLReplaceProhibitedChars(VarToStr(VarToStr(pData)));
          else
                         mWrappedField := XMLReplaceProhibitedChars(VarToStr(VarToStr(pData)));
          end;

          // Now, put the tag around it
          result := '<'+Trim(pTag)+'>'+mWrappedField+'</'+Trim(pTag)+'> ';  // Space at end it make it pretty
     end;

     (*
     varEmpty     : typeString := 'varEmpty';
     varNull      : typeString := 'varNull';
     varSmallInt  : typeString := 'varSmallInt';
     varInteger   : typeString := 'varInteger';
     varSingle    : typeString := 'varSingle';
     varDouble    : typeString := 'varDouble';
     varCurrency  : typeString := 'varCurrency';
     varDate      : typeString := 'varDate';
     varOleStr    : typeString := 'varOleStr';
     varDispatch  : typeString := 'varDispatch';
     varError     : typeString := 'varError';
     varBoolean   : typeString := 'varBoolean';
     varVariant   : typeString := 'varVariant';
     varUnknown   : typeString := 'varUnknown';
     varByte      : typeString := 'varByte';
     varWord      : typeString := 'varWord';
     varLongWord  : typeString := 'varLongWord';
     varInt64     : typeString := 'varInt64';
     varStrArg    : typeString := 'varStrArg';
     varString    : typeString := 'varString';
     varAny       : typeString := 'varAny';
     varTypeMask  : typeString := 'varTypeMask';
     *)
end;  // XMLTagWrap


// Create an XML wrapper for elements ... which would then be wrapped in a tag
function XMLAttributeWrap(pAttribute: String; pData: Variant): String;
var
   basicType       : Integer;
   mWrappedField   : String;
begin
     // Return nothing, unless we were given data
     result := '';

     // Make sure we have something to do
     //if not VarIsNull(pData) then       // or VarIsEmpty
     if not (trim(VarToStr(pData)) = '') then
     begin
          // Find the type of field
          basicType := VarType(pData) and VarTypeMask;

          // Set a string to match the type
          case basicType of
            varEmpty   : mWrappedField := DoubleQuoteWrap(XMLReplaceProhibitedChars(VarToStr((pData))));
            varUnknown : mWrappedField := DoubleQuoteWrap(XMLReplaceProhibitedChars(VarToStr((pData))));
            varStrArg  : mWrappedField := DoubleQuoteWrap(XMLReplaceProhibitedChars(VarToStr((pData))));
            varString  : mWrappedField := DoubleQuoteWrap(XMLReplaceProhibitedChars(VarToStr((pData))));
          else
                         mWrappedField := DoubleQuoteWrap(XMLReplaceProhibitedChars(VarToStr((pData))));
          end;

          // Now, put the tag around it
          result := Trim(pAttribute)+'='+mWrappedField+' ';  // Space at end it make it pretty
     end;

     (*
     varEmpty     : typeString := 'varEmpty';
     varNull      : typeString := 'varNull';
     varSmallInt  : typeString := 'varSmallInt';
     varInteger   : typeString := 'varInteger';
     varSingle    : typeString := 'varSingle';
     varDouble    : typeString := 'varDouble';
     varCurrency  : typeString := 'varCurrency';
     varDate      : typeString := 'varDate';
     varOleStr    : typeString := 'varOleStr';
     varDispatch  : typeString := 'varDispatch';
     varError     : typeString := 'varError';
     varBoolean   : typeString := 'varBoolean';
     varVariant   : typeString := 'varVariant';
     varUnknown   : typeString := 'varUnknown';
     varByte      : typeString := 'varByte';
     varWord      : typeString := 'varWord';
     varLongWord  : typeString := 'varLongWord';
     varInt64     : typeString := 'varInt64';
     varStrArg    : typeString := 'varStrArg';
     varString    : typeString := 'varString';
     varAny       : typeString := 'varAny';
     varTypeMask  : typeString := 'varTypeMask';
     *)
end;  // XMLElementWrap


// Get the contents of a Tag
function XMLGetTag(pTagName, pXMLString: String): String;
var
   mStartTag : String;
   mEndTag   : String;
   mStartLen : Integer;
   mPos      : Integer;
   mPosEnd   : Integer;
begin
     result := '';

     if Copy(pTagName,1,1) <> '<' then
     begin
          // Wrap the tag name
          mStartTag := '<'+pTagName+'>';
     end
     else
     begin
          mStartTag := pTagName;
     end;
     // Form the end tag
     mEndTag   := '</'+Copy(mStartTag,2,99);

     // Now, find everything between the two
     mStartLen := Length(mStartTag);

     mPos      := Pos(mStartTag, pXMLString);
     if (mPos > 0) then
     begin
          mPosEnd := Pos(mEndTag, pXMLString);
          result  := Copy(pXMLString, mPos+mStartLen, mPosEnd-(mPos+mStartLen) ) ;
     end;

end; // XMLGetTag

// Make sure contents are properly escaped
// - Only used for contents, and then doublewrapquotes if needed afterwards.
// - Essential for any information going into XML
function XMLReplaceProhibitedChars(pValue: String): String;
var
   mContents: String;
begin
     mContents := StringReplace(pValue,    '<',  '&lt;',    [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '>',  '&gt;',    [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '`',  '&apos;',  [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '&',  '&amp;',   [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '"',  '&quot;',  [rfReplaceAll, rfIgnoreCase]);
     result    := mContents;
end;

// Make sure contents are human readable
// - Essential for any information coming out of XML
function XMLInstallProhibitedChars(pValue: String): String;
var
   mContents: String;
begin
     mContents := StringReplace(pValue,    '&lt;',   '<',   [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '&gt;',   '>',   [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '&apos;', '''',  [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '&amp;',  '&',   [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '&quot;', '"',   [rfReplaceAll, rfIgnoreCase]);
     result    := mContents;
end;


// Make sure contents are properly escaped
// - Only used for contents, and then doublewrapquotes if needed afterwards.
function XMLMagicQuoteSlash(pValue: String): String;
var
   mContents: String;
begin
     mContents := StringReplace(pValue,    '\', '\\', [rfReplaceAll, rfIgnoreCase]);
     mContents := StringReplace(mContents, '"', '\"', [rfReplaceAll, rfIgnoreCase]);
     result    := mContents;
end;


function GetMMForMonthName(pMonthIn: String): String;
var
     mMonthsArray: Array[1..12] of String;
     mFound: Boolean;

     mShortMonth: String;
     mIndex: Integer;
begin
     mMonthsArray[1]  := 'January';
     mMonthsArray[2]  := 'February';
     mMonthsArray[3]  := 'March';
     mMonthsArray[4]  := 'April';
     mMonthsArray[5]  := 'May';
     mMonthsArray[6]  := 'June';
     mMonthsArray[7]  := 'July';
     mMonthsArray[8]  := 'August';
     mMonthsArray[9]  := 'September';
     mMonthsArray[10] := 'October';
     mMonthsArray[11] := 'November';
     mMonthsArray[12] := 'December';

     mShortMonth := Copy(UpperCase(pMonthIn),1,3);
     mFound := False;
     for mIndex := 1 to 12 do
     begin
          if Pos(mShortMonth, UpperCase(mMonthsArray[mIndex])) >= 1 then
          begin
               mFound := True;
               break;
          end;
     end;

     result := '00';
     if mFound then
     begin
          result := RightCopy('00'+IntToStr(mIndex),2);
     end;

     (*
     if mIndex <= 9 then
     begin
          result := '0' + IntToStr(mIndex);
     end
     else if mIndex <= 12 then
     begin
          result := IntToStr(mIndex);
     end
     else
     begin
          result := '00';
     end;
     *)
end;


// ************************************************************
// Encryption system:  Used to encrypt strings.
//                     Its a very simple system.  Enough to make
//                     it confusing for someone.  The Key is used to
//                     garble progressive characters.  Therefor the
//                     SAME string sequence must be encrypted and decrypted
// eg:   result := StringEncrypt(SText,11424);
// ************************************************************

// Encrypt a string
function StringEncrypt(const S: AnsiString; Key: Word): AnsiString;
begin
  Result := PostProcess(InternalEncrypt(S, Key))
end;

// Decrypt a string
function StringDecrypt(const S: AnsiString; Key: Word): AnsiString;
begin
  Result := InternalDecrypt(PreProcess(S), Key)
end;

function Decode(const S: AnsiString): AnsiString;
const
  Map: array[Char] of Byte = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 0, 63, 52, 53,
    54, 55, 56, 57, 58, 59, 60, 61, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2,
    3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
    20, 21, 22, 23, 24, 25, 0, 0, 0, 0, 0, 0, 26, 27, 28, 29, 30,
    31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45,
    46, 47, 48, 49, 50, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0);
var
  I: LongInt;
begin
  case Length(S) of
    2:
      begin
        I := Map[S[1]] + (Map[S[2]] shl 6);
        SetLength(Result, 1);
        Move(I, Result[1], Length(Result))
      end;
    3:
      begin
        I := Map[S[1]] + (Map[S[2]] shl 6) + (Map[S[3]] shl 12);
        SetLength(Result, 2);
        Move(I, Result[1], Length(Result))
      end;
    4:
      begin
        I := Map[S[1]] + (Map[S[2]] shl 6) + (Map[S[3]] shl 12) +
          (Map[S[4]] shl 18);
        SetLength(Result, 3);
        Move(I, Result[1], Length(Result))
      end
  end
end;

function PreProcess(const S: AnsiString): AnsiString;
var
  SS: AnsiString;
begin
  SS := S;
  Result := '';
  while SS <> '' do
  begin
    Result := Result + Decode(Copy(SS, 1, 4));
    Delete(SS, 1, 4)
  end
end;

function InternalDecrypt(const S: AnsiString; Key: Word): AnsiString;
var
  I: Word;
  Seed: Word;
begin
  Result := S;
  Seed := Key;
  for I := 1 to Length(Result) do
  begin
    Result[I] := Char(Byte(Result[I]) xor (Seed shr 8));
    Seed := (Byte(S[I]) + Seed) * Word(TTC1) + Word(TTC2)
  end
end;


function Encode(const S: AnsiString): AnsiString;
const
  Map: array[0..63] of Char = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' +
    'abcdefghijklmnopqrstuvwxyz0123456789+/';
var
  I: LongInt;
begin
  I := 0;
  Move(S[1], I, Length(S));
  case Length(S) of
    1:
      Result := Map[I mod 64] + Map[(I shr 6) mod 64];
    2:
      Result := Map[I mod 64] + Map[(I shr 6) mod 64] +
        Map[(I shr 12) mod 64];
    3:
      Result := Map[I mod 64] + Map[(I shr 6) mod 64] +
        Map[(I shr 12) mod 64] + Map[(I shr 18) mod 64]
  end
end;

function PostProcess(const S: AnsiString): AnsiString;
var
  SS: AnsiString;
begin
  SS := S;
  Result := '';
  while SS <> '' do
  begin
    Result := Result + Encode(Copy(SS, 1, 3));
    Delete(SS, 1, 3)
  end
end;

function InternalEncrypt(const S: AnsiString; Key: Word): AnsiString;
var
  I: Word;
  Seed: Word;
begin
  Result := S;
  Seed := Key;
  for I := 1 to Length(Result) do
  begin
    Result[I] := Char(Byte(Result[I]) xor (Seed shr 8));
    Seed := (Byte(Result[I]) + Seed) * Word(TTC1) + Word(TTC2)
  end
end;

// Display as Money
function MoneyFormatDollars(pCents: Integer): String;
begin
     result := '$'+format('%f',[pCents/100]);
end;

// Return a description of the OS, and its number
function WhatOSisThis(var pNumber: Integer): String;
var
   Platform : String;
begin
     case Win32MajorVersion of
        3: //NT 3.51
                   Platform := 'Windows NT 3.51';

        4: // Win9x/ME/NT 4
           case Win32MinorVersion of
              0:   Platform := 'Windows 95';
              10:  Platform := 'Windows 98';
              90:  Platform := 'Windows ME';
              else if (Win32Platform and VER_PLATFORM_WIN32_NT) <> 0 then
                   Platform := 'Windows NT 4.0'
              else
                   Platform := '?';
           end;{ Win32MinorVersion }

        5: //Win2K/XP
           case Win32MinorVersion of
              0:   Platform := 'Windows 2000';
              1:   Platform := 'Windows XP/.NET server';
              2:   Platform := 'Windows 2003';
              else Platform := '?';
           end;{ Win32MinorVersion }

        else       Platform := '?';
     end;{ Win32MajorVersion }

     // Create an easy to determine number
     pNumber := (Win32MajorVersion * 1000) + Win32MinorVersion;
     // NT 3.51 = 3000
     // Win 98  = 4010 
     // Win XP  = 5001


     result := Platform;
end;  // WhatOSisThis

// Find the CPU speed
function GetCpuSpeed: String;
const
  DelayTime = 40; // Measure time in MS 
var
  dwTimerHi, dwTimerLo: DWord; //Cardinal;
  iPriority, iPriorityClass: Integer;
  mMHz : Integer;
begin
  iPriorityClass := GetPriorityClass(GetCurrentProcess);
  iPriority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS); 
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm 
    dw 310Fh
    mov dwTimerLo, eax
    mov dwTimerHi, edx
  end; 
  Sleep(DelayTime); 
  asm 
    dw 310Fh 
    sub eax, dwTimerLo 
    sbb edx, dwTimerHi 
    mov dwTimerLo, eax 
    mov dwTimerHi, edx
  end; 
  SetThreadPriority(GetCurrentThread, iPriority);
  SetPriorityClass(GetCurrentProcess, iPriorityClass);
  //Result := IntToStr(Round(dwTimerLo div (1000 * DelayTime) div 10) * 10);
  mMHz := (Round(dwTimerLo div (1000 * DelayTime) div 10) * 10);
  //Result := Format('%.1f GHz', [(Round(dwTimerLo div (1000 * DelayTime) div 1000) * 10)]);
  //Result := Format('%.1f GHz', [((t1 - t0) / 1E6) / 1000]);
  try
     Result := Format('%.1f GHz', [round(mMHz / 100) / 10]);
  except
     Result := IntToStr(mMHz)+' MHz';
  end;
(*
var
   t: DWORD;
   mhi, mlo, nhi, nlo: DWORD;
   t0, t1, chi, clo, shr32: Comp;
begin
     shr32 := 65536;
     shr32 := shr32 * 65536;

     t := GetTickCount;

     while t = GetTickCount do begin end;
     asm
       DB 0FH
       DB 031H
       mov mhi,edx
       mov mlo,eax
     end;

     while GetTickCount < (t + 1000) do begin end;
     asm
       DB 0FH
       DB 031H
       mov nhi,edx
       mov nlo,eax
     end;

     chi := mhi;
     if mhi < 0 then chi := chi + shr32;

     clo := mlo;
     if mlo < 0 then clo := clo + shr32;

     t0 := chi * shr32 + clo;

     chi := nhi;
     if nhi < 0 then chi := chi + shr32;

     clo := nlo;
     if nlo < 0 then clo := clo + shr32;

     t1 := chi * shr32 + clo;

     Result := Format('%.1f GHz', [((t1 - t0) / 1E6) / 1000]);
*)
end; // GetCpuSpeed



end.