unit DBWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  DBWorkUnit in 'DBWorkUnit.pas';
*)

(*

// Example for implementation
procedure TForm1.Button1Click(Sender: TObject);
var
   mSuccess: Boolean;
   mSQL: TStringList;
begin
     mSQL := TStringList.Create;

     mSQL.Clear;
     mSQL.LoadFromFile(Edit1.Text);
     // Build the SQL statement
     mSQL :=
     SQLBuildStatement(mSQL,
                       '12',
                       '11',
                       '',
                       '',
                       '',
                       '',
                       '',
                       '',
                       '',
                       mSuccess
                       );

      Memo1.Lines := mSQL;
end;

*)


// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! CalcWorkUnit must be in the USES section for each unit

interface

uses
  db, classes, dialogs,sysutils;

    function DataSetToASCII(const ADataSet: TDataSet; const ASCIIFile: TFileName; const Delimiter: Char; const QuoteStrings: Boolean; var Total: Integer): Boolean;

implementation


(*
procedure DataSetToASCII -
exports records from the ADataSet TDataSet
to specified ASCIIFile text file. Fields are
separated by provided Delimiter character.
Only fields with Tag property set to 0 (default)
are included in exporting. Records are separated
with line break characters and ordered as in
the ADataSet.
If QuoteStrings is True then fields of type
ftString,ftMemo,ftFmtMemo,ftFixedChar and ftWideString are
quoted in the output file - thanks Bill Artemik for this very important tip
*)

function DataSetToASCII(const ADataSet: TDataSet; const ASCIIFile: TFileName; const Delimiter: Char; const QuoteStrings: Boolean; var Total: Integer): Boolean;
var
   tmpList         : TStringList;
   mCount          : Integer;
   i,LastIndex     : LongInt;
   AsciiRecord     : String;
begin
  result := False;
  mCount := 0;

  tmpList:= TStringList.Create;

  try

    with ADataSet do
    begin
      LastIndex := Fields.Count - 1;

      First;

      while not EOF do
      begin
           AsciiRecord:= '';

           for i := 0 to LastIndex do
             if Fields.Fields[i].Tag = 0 then
             begin

               if QuoteStrings and
                  (Fields.Fields[i].DataType in [ftString,ftMemo,ftFmtMemo,ftFixedChar,ftWideString]) then
                 AsciiRecord:= AsciiRecord + QuotedStr(Fields.Fields[i].AsString)
               else
                 AsciiRecord:= AsciiRecord + Fields.Fields[i].AsString;

               if i < LastIndex then
                 AsciiRecord:= AsciiRecord + Delimiter;

             end;

           tmpList.Append(AsciiRecord);
           inc(mCount);

           Next;
      end;
    end;

    try
      if mCount > 0 then
      begin
           tmpList.SaveToFile(ASCIIFile);
      end;
      // The processing got this far successfully
      result := True;
    except

    end;

  finally
    tmpList.Free;
  end;

  Total := mCount;
end;


end.

