unit Excel;

//---------------------------------------------------------------------
// Excel unit : By Motaz Abdel Azeem
// Created :  Saturday,  1, April, 2000
//
// Added to:  Vern Baker
//            January 16, 2002
//---------------------------------------------------------------------

(*
Const xlNone = -4142 (&HFFFFEFD2)
Const xlOn = 1

Enum XlBorderWeight:
Const xlHairline = 1
Const xlThin = 2
Const xlMedium = -4138 (&HFFFFEFD6)
Const xlThick = 4

Enum XlBordersIndex:
Const xlDiagonalDown = 5
Const xlDiagonalUp = 6
Const xlEdgeLeft = 7
Const xlEdgeTop = 8
Const xlEdgeBottom = 9
Const xlEdgeRight = 10
Const xlInsideVertical = 11
Const xlInsideHorizontal = 12

Enum XlLineStyle:
Const xlContinuous = 1
Const xlDash = -4115 (&HFFFFEFED)
Const xlDashDot = 4
Const xlDashDotDot = 5
Const xlDot = -4118 (&HFFFFEFEA)
Const xlDouble = -4119 (&HFFFFEFE9)
Const xlLineStyleNone = -4142 (&HFFFFEFD2)
Const xlSlantDashDot = 13

Enum XlColorIndex:
Const xlColorIndexAutomatic = -4105 (&HFFFFEFF7)
Const xlColorIndexNone = -4142 (&HFFFFEFD2)
*)

interface

uses Graphics, Variants, Excel2000;

function ExcelCreate(FileName,SheetName: string; Show: Boolean = True): Variant;
procedure ExcelSave(ExcelObject: Variant);
procedure ExcelPut(ExcelObject: Variant; SheetName: string;
 Col, Row: Integer; Data: string; FontName: string = '';
 FontSize: Integer = 0; Color: Integer = clBlack; FontStyles: TFontStyles = []);
procedure ExcelClose(ExcelObject: Variant);
procedure ExcelColumn(ExcelObject: Variant; SheetName: string;
                      Col, Size: Integer);
procedure ExcelShowIt(ExcelObject: Variant);
procedure ExcelBorderThin(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2, Color: Integer);
procedure ExcelBorderMedium(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2, Color: Integer);
procedure ExcelBorderThick(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2, Color: Integer);
procedure ExcelAutoFit(ExcelObject: Variant; SheetName: string;
                      Col: Integer);
procedure ExcelFillColor(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2,Color: Integer; IncludeBorders: Boolean);

implementation

uses
 ComObj;

// ExcelCreate: Open Excel application
function ExcelCreate(Filename, SheetName: string; Show: Boolean = True): Variant;
const
     xlWBatWorkSheet = -4167;
var
   WorkBook: variant;
   V: Variant;
begin
     V:= CreateOleObject('Excel.Application');
     WorkBook := V.Workbooks.Add(xlWBatWorkSheet);
     //WorkBook.FileName := FileName;
     WorkBook.WorkSheets[1].Name := SheetName;
     V.Workbooks[1].SaveAs(FileName, EmptyParam, EmptyParam, EmptyParam, EmptyParam, False);
     // Do not show it inially... (it will build faster hidden)
     V.Visible := False;
     Result:= V;
end;

// Save the workbook
procedure ExcelSave(ExcelObject: Variant);
begin
     // Now show it.
     ExcelObject.WorkBooks[1].Save;
end;


procedure ExcelShowIt(ExcelObject: Variant);
begin
     // Now show it.
     ExcelObject.Visible := True;
end;

// ExcelPut: Put data into cells
procedure ExcelPut(ExcelObject: Variant; SheetName: string;
                   Col, Row: Integer; Data: string;
                   FontName: string = '';
                   FontSize: Integer = 0;
                   Color: Integer = clBlack;
                   FontStyles: TFontStyles = []);
var
   Sheet: variant;
begin
     //if Data <> '' then
     //begin
          Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
          Sheet.Cells[Col, Row].Value:= Data;
          Sheet.Cells[Col, Row].Font.Color:= Color;
          if FontName <> '' then
            Sheet.Cells[Col, Row].Font.Name:= FontName;
          if FontSize <> 0 then
            Sheet.Cells[Col, Row].Font.Size:= FontSize;
          if FontSize <> 0 then
            Sheet.Cells[Col, Row].Font.Size:= FontSize;
          Sheet.Cells[Col, Row].Font.Bold:= fsBold in FontStyles;
          Sheet.Cells[Col, Row].Font.Underline:= fsUnderline in FontStyles;
          Sheet.Cells[Col, Row].Font.Italic:= fsItalic in FontStyles;
     //end;
end;


// Setup a column
procedure ExcelColumn(ExcelObject: Variant; SheetName: string;
                      Col, Size: Integer);
var
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Sheet.Columns[Col].ColumnWidth := Size;
end;

procedure ExcelAutoFit(ExcelObject: Variant; SheetName: string;
                      Col: Integer);
var
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Sheet.Columns[Col].EntireColumn.Autofit;
end;


// Draw borders
procedure ExcelBorderThin(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2,Color: Integer);
var
   Rng: OleVariant;
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Rng := Sheet.Range[Sheet.Cells[Row1,Col1],
                        Sheet.Cells[Row2,Col2]];
     Rng.BorderAround(Excel2000.xlContinuous, Excel2000.xlThin, Color := Color);
end;


// Draw borders
procedure ExcelBorderMedium(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2,Color: Integer);
var
   Rng: OleVariant;
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Rng := Sheet.Range[Sheet.Cells[Row1,Col1],
                        Sheet.Cells[Row2,Col2]];
     Rng.BorderAround(Excel2000.xlContinuous, Excel2000.xlMedium, Color := Color);
end;


// Draw borders
procedure ExcelBorderThick(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2,Color: Integer);
var
   Rng: OleVariant;
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Rng := Sheet.Range[Sheet.Cells[Row1,Col1],
                        Sheet.Cells[Row2,Col2]];
     Rng.BorderAround(Excel2000.xlContinuous, Excel2000.xlThick, Color := Color);
end;


// Fill a color in a range
procedure ExcelFillColor(ExcelObject: Variant; SheetName: string;
                       Col1,Row1,Col2,Row2,Color: Integer; IncludeBorders: Boolean);
var
   mLine,
   mColor: Integer;
   Rng: OleVariant;
   Sheet: variant;
begin
     Sheet:= ExcelObject.WorkBooks[1].WorkSheets[SheetName];
     Rng := Sheet.Range[Sheet.Cells[Row1,Col1],
                        Sheet.Cells[Row2,Col2]];


     mLine       := xlThin; // xlHairline;   //
     mColor      := ColorToRGB(clSilver);

     if IncludeBorders then
     begin
          Rng.borders[xlEdgeLeft           ].lineStyle  := xlContinuous;
          Rng.borders[xlEdgeLeft           ].Weight     := mLine ;
          Rng.borders[xlEdgeLeft           ].ColorIndex := xlAutomatic;
          Rng.borders[xlEdgeLeft           ].Color      := mColor;

          Rng.borders[xlEdgeTop            ].lineStyle  := xlContinuous;
          Rng.borders[xlEdgeTop            ].Weight     := mLine;
          Rng.borders[xlEdgeTop            ].ColorIndex := xlAutomatic;
          Rng.borders[xlEdgeTop            ].Color      := mColor;

          Rng.borders[xlEdgeBottom         ].lineStyle  := xlContinuous;
          Rng.borders[xlEdgeBottom         ].Weight     := mLine ;
          Rng.borders[xlEdgeBottom         ].ColorIndex := xlAutomatic;
          Rng.borders[xlEdgeBottom         ].Color      := mColor;

          Rng.borders[xlEdgeRight          ].lineStyle  := xlContinuous;
          Rng.borders[xlEdgeRight          ].Weight     := mLine ;
          Rng.borders[xlEdgeRight          ].ColorIndex := xlAutomatic;
          Rng.borders[xlEdgeRight          ].Color      := mColor;

          Rng.borders[xlInsideVertical     ].lineStyle  := xlContinuous;
          Rng.borders[xlInsideVertical     ].Weight     := mLine ;
          Rng.borders[xlInsideVertical     ].ColorIndex := xlAutomatic;
          Rng.borders[xlInsideVertical     ].Color      := mColor;
     end;

     //Rng.Fill(Color := Color);
     Rng.Interior.Color := ColorToRGB(Color);

end;



// ExcelClose: Close opened application
procedure ExcelClose(ExcelObject: Variant);
begin
     //ExcelObject.Close;
     ExcelObject.Quit;
end;

//////////////////////////////////////////
// EXAMPLE CODE:
//////////////////////////////////////////

(*
// Must have
// X:\TeleFlow\CommonUnits in Project/Options/Directories/SearchPath
procedure TForm1.BuildExcel;
var
   mFontSize,
   mColor,
   mLine,
   mRow,mCol: Integer;
   mFontStyle: TFontStyles;
   mFontName,
   mData,
   mFile,
   mSheet: String;
   Obj: OleVariant;
begin
     mSheet := Edit1.Text;
     mFile  := 'c:\Vern.xls';

     if (not fileexists(mFile)) or
        (deletefile(mFile)) then
     begin

          // Create Excel
          Obj:= ExcelCreate(mFile,mSheet);

          // Create Header
          mLine := 1;
          mFontSize  := 14;
          mColor     := clBlue;
          mFontStyle := [fsBold];
          for mRow := 1 to Memo1.Lines.Count do
          begin
               mCol := 1;
               ExcelPut(Obj, mSheet, mLine, mCol, Memo1.Lines[mRow - 1], mFontName, mFontSize, mColor, mFontStyle);
               inc(mLine);
          end;

          // Create Titles
          // Set up columm widths - / 5 makes the Excel about the same as a stringgrid
          ExcelColumn(Obj, mSheet, 1, Round(StringGrid1.ColWidths[1 - 1] / 5));
          ExcelColumn(Obj, mSheet, 2, Round(StringGrid1.ColWidths[2 - 1] / 5));
          ExcelColumn(Obj, mSheet, 3, Round(StringGrid1.ColWidths[3 - 1] / 5));
          ExcelColumn(Obj, mSheet, 4, Round(StringGrid1.ColWidths[4 - 1] / 5));
          ExcelColumn(Obj, mSheet, 5, Round(StringGrid1.ColWidths[5 - 1] / 5));
          ExcelColumn(Obj, mSheet, 6, Round(StringGrid1.ColWidths[6 - 1] / 5));

          // Create Cells
          for mRow := 1 to StringGrid1.Rowcount do
          begin
              for mCol := 1 to StringGrid1.Colcount do
              begin
                   // Defaults
                   mFontSize  := 0; // Default size
                   mColor     := clBlack;
                   mFontStyle := [];
                   mFontName  := '';

                   // Put custom formating stuff here..
                   if mRow = 1 then
                   begin
                        mFontSize  := 12;
                        mColor     := clGreen;
                        mFontStyle := [fsBold];
                   end; // mRow = 1

                   // Enter the cell
                   mData := StringGrid1.Cells[mCol - 1,mRow - 1];
                   if mData <> '' then
                   begin
                        ExcelPut(Obj, mSheet, mLine, mCol, mData, mFontName, mFontSize, mColor, mFontStyle);
                   end;

              end;

              // Next row
              inc(mLine);

              if mRow = 1 then
              begin
                   // Extra space
                   inc(mLine);
              end;
          end;

          // Autofit the columns
          //ExcelAutoFit(Obj, mSheet, 1);
          ExcelAutoFit(Obj, mSheet, 2);
          ExcelAutoFit(Obj, mSheet, 3);
          ExcelAutoFit(Obj, mSheet, 4);
          ExcelAutoFit(Obj, mSheet, 5);
          ExcelAutoFit(Obj, mSheet, 6);

          //ExcelBorderThin(Obj,mSheet, 3,5,6,6, clBlue);
          ExcelBorderMedium(Obj,mSheet, 3,5,6,6, clBlue);
          //ExcelBorderThick(Obj,mSheet, 3,5,6,6, clBlue);

          ExcelFillColor(Obj,mSheet, 5,5,6,6, $001391F1);

          // Save updates to database
          ExcelSave(Obj);

          // Show it.
          ExcelShowIt(Obj);
     end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
     StringGrid1.Cells[0,0] := 'Employee';
     StringGrid1.Cells[1,0] := 'Name';
     StringGrid1.Cells[2,0] := 'Date off';
     StringGrid1.Cells[3,0] := 'Date back';
     StringGrid1.Cells[4,0] := 'Disability';
end;
*)

///////////////////////////////////////
// Other code...
///////////////////////////////////////
{*

  Rect: Excel2000.Shape;
  Fill: Excel2000.FillFormat;
..
  Rect := WS.Shapes.AddShape(
             msoShapeRectangle, 10, 100, 100, 100);
  Fill := Rect.Fill as Excel2000.FillFormat;
  Fill.ForeColor.RGB := clFuchsia;
  Fill.Visible := msoTrue;



var
  R: Range;
..
  R := WS.Range['A5', 'D5'];
  R.Borders.Item[xlEdgeTop].Weight := xlThick;
  R.Borders.Item[xlEdgeTop].Color := clYellow;

  R.Borders.Item[xlEdgeBottom].Linestyle :=  
integer(xlDouble);
  R.Borders.Item[xlEdgeBottom].Color := clYellow;

The Evaluate function is useful if you want to set several 
borders at once:
  WS.Evaluate('B6,C6,D6,E6,F6').Borders.Item[
            xlEdgeLeft].Linestyle :=  xlContinuous;




ExcelWorksheet.Cells.Item[1,1].EntireColumn.ColumnWidth := 6;


   Range("C10:L10").Select
   Selection.Borders(xlDiagonalDown).LineStyle = xlNone
   Selection.Borders(xlDiagonalUp).LineStyle = xlNone
   Selection.Borders(xlEdgeLeft).LineStyle = xlNone
   With Selection.Borders(xlEdgeTop)
       .LineStyle = xlContinuous
       .Weight = xlMedium
       .ColorIndex = xlAutomatic
   End With
   With Selection.Borders(xlEdgeBottom)
       .LineStyle = xlDouble
       .Weight = xlThick
       .ColorIndex = xlAutomatic
   End With
   Selection.Borders(xlEdgeRight).LineStyle = xlNone
   Selection.Borders(xlInsideVertical).LineStyle = xlNone
   Range("C14").Select



// Draw lines
  WS.Range['A5', 'D5'].Borders.Item[xlEdgeTop].Weight
    := xlThick; WS.Range['A5', 'D5'].Borders.Item[xlEdgeTop].Color
    := clYellow;

*}

(*
procedure WriteToExcel;
var 
 WorkBk : _WorkBook; //  Define a WorkBook
 WorkSheet : _WorkSheet; //  Define a WorkSheet 
 I, J, K, R, C : Integer; 
 IIndex : OleVariant;
 TabGrid : Variant;
begin 
 if GenericStringGrid.Cells[0,1] <> '' then 
  begin 
   IIndex := 1; 
   R := GenericStringGrid.RowCount;
   C := GenericStringGrid.ColCount; 
   // Create the Variant Array 
   TabGrid := VarArrayCreate([0,(R - 1),0,(C - 1)],VarOleStr); 
   I := 0; 
   //  Define the loop for filling in the Variant
   repeat 
   for J := 0 to (C - 1) do 
     TabGrid[I,J] := GenericStringGrid.Cells[J,I]; 
    Inc(I,1); 
   until
    I > (R - 1);
   // Connect to the server TExcelApplication
   XLApp.Connect;
    // Add WorkBooks to the ExcelApplication
   XLApp.WorkBooks.Add(xlWBatWorkSheet,0);
   // Select the first WorkBook
   WorkBk := XLApp.WorkBooks.Item[IIndex];
   // Define the first WorkSheet
   WorkSheet := WorkBk.WorkSheets.Get_Item(1) as _WorkSheet;
   // Assign the Delphi Variant Matrix to the Variant associated with the WorkSheet
   Worksheet.Range['A1',Worksheet.Cells.Item[R,C]].Value := TabGrid;
   // Customise the WorkSheet
   WorkSheet.Name := 'Customers';
   Worksheet.Columns.Font.Bold := True;
   Worksheet.Columns.HorizontalAlignment := xlRight;
   WorkSheet.Columns.ColumnWidth := 14;
   // Customise the first entire Column
   WorkSheet.Range['A' + IntToStr(1),'A' + IntToStr(R)].Font.Color := clBlue;
   WorkSheet.Range['A' + IntToStr(1),'A' + IntToStr(R)].HorizontalAlignment := xlHAlignLeft;
   WorkSheet.Range['A' + IntToStr(1),'A' + IntToStr(R)].ColumnWidth := 31;
   // Show Excel
   XLApp.Visible[0] := True; 
   // Disconnect the Server 
   XLApp.Disconnect; 
   // Unassign the Delphi Variant Matrix 
   TabGrid := Unassigned; 
  end; 
end;


procedure GetFromExcel;
var
 WorkBk : _WorkBook;
 WorkSheet : _WorkSheet;
 K, R, X, Y : Integer;
 IIndex : OleVariant;
 RangeMatrix : Variant;
 NomFich : WideString;
begin
 NomFich := 'C:\MyDirectory\NameOfFile.xls';
 IIndex := 1;
 XLApp.Connect;
 // Open the Excel File
 XLApp.WorkBooks.Open(NomFich,EmptyParam,EmptyParam,EmptyParam,EmptyParam, EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,0);
 WorkBk := XLApp.WorkBooks.Item[IIndex]; 
 WorkSheet := WorkBk.WorkSheets.Get_Item(1) as _WorkSheet; 
 // In order to know the dimension of the WorkSheet, i.e the number of rows and the 
 // number of columns, we activate the last non-empty cell of it
 WorkSheet.Cells.SpecialCells(xlCellTypeLastCell,EmptyParam).Activate; 
 // Get the value of the last row 
 X := XLApp.ActiveCell.Row; 
 // Get the value of the last column 
 Y := XLApp.ActiveCell.Column; 
 // Define the number of the columns in the TStringGrid 
  GenericStringGrid.ColCount := Y; 
 // Assign the Variant associated with the WorkSheet to the Delphi Variant Matrix 
  RangeMatrix := XLApp.Range['A1',XLApp.Cells.Item[X,Y]].Value;
 // Quit Excel and Disconnect the Server
  XLApp.Quit;
  XLApp.Disconnect;
//  Define the loop for filling in the TStringGrid
  K := 1;
  repeat
    for R := 1 to Y do
      GenericStringGrid.Cells[(R - 1),(K - 1)] := RangeMatrix[K,R];
    Inc(K,1);
    GenericStringGrid.RowCount := K + 1;
  until
   K > X;
// Unassign the Delphi Variant Matrix
   RangeMatrix := Unassigned;
end;


...also...

    ActiveChart.SeriesCollection.NewSeries
    ActiveChart.SeriesCollection(1).XValues = "=Data!R8C1:R32C1"
    ActiveChart.SeriesCollection(1).Values = "=Data!R8C2:R32C2"
    ActiveChart.SeriesCollection(1).Name = "=Data!R7C2"

    * important detail: in the Portuguese version the code generated for the macro in Excel is the same!!!

    // ....
    Excel := CreateOLEObject ('Excel.Application');
    //
    // ... (generates sheet)
    //
    Excel.Charts.Add;
    Excel.ActiveChart.ChartType := xlColumnClustered
    Excel.ActiveChart.ChartType := xlLineMarkers;
    //
    // ... (create series with SeriesCollection.NewSeries)
    //
    // The problem is below! This code works only in computers where is installed
    // the English version!
    //
    Excel.ActiveChart.SeriesCollection.Item[1].Name := '=Data!R7C2';
    Excel.ActiveChart.SeriesCollection.Item[1].XValues :='=Data!R8C1:R32C1';
    Excel.ActiveChart.SeriesCollection.Item[1].Values := '=Data!R8C2:R32C2';

*)

(*
procedure DumpDatasetToExcel(ds: TDataset; dsname : String; SaveAs : String);
var
  Save_Cursor:TCursor;

  XLApp: Variant;
  Sheet, Rng: Variant;
  iCol,jRow : Integer;
  arr, v   : OleVariant;

begin
   Save_Cursor := Screen.Cursor;
   Screen.Cursor := crHourglass;
   ds.DisableControls;
   try
      // Create a worksheet in a new instance of excel and get a handle to it to use below
      XLApp := CreateOLEObject('Excel.Application');
      XLApp.Visible := False;
      XLApp.Workbooks.Add[XLWBatWorksheet];
      XLApp.Workbooks[1].Worksheets[1].Name := Copy(dsname, 1, 31);
      Sheet := XLApp.Workbooks[1].Worksheets[Copy(dsname, 1, 31)];

      // Set the header line (jRow) and populate based on dataset
      jRow := 1;
      for iCol := 1 to ds.FieldCount do
      begin
         v := ds.Fields[iCol-1].FieldName;
         Sheet.Cells[jRow, iCol] := v;
      end;

      // Move to the next row (Inc(jRow)) and populate data in row major order
      // 1. Stuff the data into a variant array
      // 2. Set range in Excel
      // 3. Assign it.

      arr := VarArrayCreate([1,ds.RecordCount,1,ds.FieldCount],varVariant);
      ds.First;
      Inc(jRow);
      while not ds.EOF do
      begin
         for iCol := 1 to ds.FieldCount do
            arr[jRow-1, iCol] := ds.Fields[iCol-1].Value;
         Inc(jRow);  // move the next row on the sheet and the dataset
         if jRow mod 100 = 0 then Application.ProcessMessages; // keep the application "alive" during the loop
         ds.Next;
      end;

      Rng := Sheet.Range[Sheet.Cells[2,1], Sheet.Cells[ds.RecordCount+1,ds.FieldCount]];
      Rng.Cells.Value := arr;

      // set the first line to bold
      XLApp.Workbooks[1].WorkSheets[Copy(dsname, 1, 31)].Rows[1].EntireRow.Font.Bold := True;

      // auto size the columns
      for iCol := 1 to ds.FieldCount do
         XLApp.Workbooks[1].WorkSheets[Copy(dsname, 1, 31)].Columns[iCol].EntireColumn.Autofit;

      // if a filename was specified, save the excel file to it, suppressing prompts (the False parameter) and exceptions
      try
        if SaveAs <> '' then
          XLApp.workbooks[1].SaveAs(SaveAs, EmptyParam, EmptyParam, EmptyParam, EmptyParam, False);
      except
      end;

      XLApp.Visible := True;
   finally
      arr := Unassigned;
      XLApp := Unassigned;
      ds.EnableControls;
      Screen.Cursor := Save_Cursor;
   end;
end;

*)

end.