unit FileWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  FileWorkUnit in 'FileWorkUnit.pas';
*)

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

(*
   Program  // Add it here as well
   interface
   uses ..... ,FileWorkUnit;

*)

interface

{$WARN UNIT_PLATFORM OFF}

{$ifdef VER140} // Delphi 6
  {$WARN SYMBOL_PLATFORM OFF}
{$endif}

uses
    Windows,ShellAPI,Messages,SysUtils,Classes,Controls,StdCtrls,Dialogs,FileCtrl,Forms,
    Registry, Masks, CalcWorkUnit, FileVersionUnit;


resourcestring
  SWin32Error = 'Win32-Failure. Code: %d.'#10'%s';

type
  u_char = Char;
  u_short = Word;
  u_int = Integer;
  u_long = Longint;
  NET_API_STATUS = DWORD;

  SHARE_INFO_502 = record
     shi502_netname : PWChar;
     shi502_type : Integer;
     shi502_remark : PWChar;
     shi502_permissions : Integer;
     shi502_max_uses : Integer;
     shi502_current_uses : Integer;
     shi502_path : PWChar;
     shi502_passwd : PChar;
     shi502_reserved : Integer;
     shi502_security_descriptor : PSECURITY_DESCRIPTOR;
  end; // SHARE_INFO_502

  SHARE_INFO_2 = record
      shi2_netname        : pwidechar;
      shi2_type           : dword;
      shi2_remark         : pwidechar;
      shi2_permissions    : dword;
      shi2_max_uses       : dword;
      shi2_current_uses   : dword;
      shi2_path           : pwidechar;
      shi2_passwd         : pwidechar;
  end; // SHARE_INFO_2

  pshare_info_2 = ^share_info_2;

  // Access control types
  ACCESS_ALLOWED_ACE = record
      AceType     : Byte;
      AceFlags    : Byte;
      AceSize     : Word;
      Mask        : ACCESS_MASK;
      SidStart    : DWORD;
  end;
  ACCESS_DENIED_ACE = record
      AceType: BYTE;
      AceFlags: BYTE;
      AceSize: WORD;
      Mask: ACCESS_MASK;
      SidStart: DWORD;
  end;


  TNetShareGetInfo_SVRAPI   = function(servername : LPSTR;
                                       netname    : LPSTR;
                                       level      : DWORD;
                                       var buf;
                                       buflen     : DWORD;
                                       var totalavail: DWORD): NET_API_STATUS; stdcall;

  TNetShareGetInfo_NETAPI32 = function(servername : LPSTR;
                                       netname    : pwidechar;
                                       level      : DWORD;
                                       var buf): NET_API_STATUS; stdcall;

  NetAPIStatus = Integer;
  TShareTypes = ( stDisk, stPrintQueue, stCommDevice, stIPC );

  procedure GotoWebPage(pApplicationExe, pHtmlAddress: String);
  function  GetProgramFilesDir: string;
  function  GetWindowsDir: string;
  function  GetExeVersionInfo(pFileName: String): String;
  function  GetFileAgeDateTime(pFileName: STring): TDateTime;
  function  LogFileOutput(pLogFile, pLogEntry: String): Boolean;
  function  FileNameDriveFix(FileName, appFileName: String):String;
  function  FindRelativeLocation(FOCUSFileName, RELATIVEFileName: String): String;
  function  RelativePathFinder(FileFocus,FileLoc: String): String;
  function  CreateFullRelativePath(FileFocus,FileLoc: String): String;
  function  FileExistsRelative(FileFocus,FileLoc: String): Boolean;
  procedure DeletePath(PathName: String);
  procedure CopyDirectory(DirSource,DirDest,DirLevel: String);
  function  StripSpacesInFile(mString: String): String;
  function  CreateProperPathName(pDirectory, pFileName: String): String;
  function  TreeCopy(pDirFrom,pDirTo: String): Boolean;
  // IMPORTANT: Check function desc for differences between TreeCopy and TreeCopySilent
  function  TreeCopySilent(pDirFrom,pDirTo: String): Boolean;
  function  TreeMove(pDirFrom,pDirTo: String): Boolean;
  function  TreeDelete(pDirFrom: String): Boolean;
  function  FileCopy(pSource,pDest: String): Boolean;
  function  FileMove(pSource,pDest: String): Boolean;
  function  FileMoveSilent(pSource,pDest: String): Integer;
  function  FileOperation (const source, dest: string; op, flags: integer): integer;
  procedure OpenObject( sObjectPath : string );
  procedure OpenExplorerWindow( pExplorerPath : string );
  procedure ShellExternal(pApplicationExe, pProgram, pParameters: String);
  procedure ShellExternal_InDirectory(pApplicationExe, pProgram, pParameters: String);
  function  ShellExternalWithResult(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String): Integer;
  function  ShellExternalWaitForResult(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String): Integer;
  procedure ShellExternalNewConsole(pApplicationExe, pProgram, pParameters: String);
  procedure ShellExternalNewConsoleVisible(pApplicationExe, pProgram, pParameters: String);
  procedure ShellNewProgram(pApplicationExe, pProgram, pParameters: String);
  function  WinExecAndWait32V2( FileName: String; Visibility: integer ): DWORD;
  function  WinExecAndWait32V2LowPriority( FileName: String; Visibility: integer ): DWORD;
  procedure ShellExternalError(E: Exception);
  function  ExecuteAssociatedFile(const FileName, Params, DefaultDir:string; ShowCmd: Integer): THandle;
  procedure ScanDirectories(pPath: String);
  procedure ScanDirectory(pPath: String);
  procedure ScanListSubDirectories(pPath: String);
  procedure ScanDirRecurse(pPath: String);
  procedure ScanDirMask(pMask: String);
  function  ScanDirFetchNext: String;
  procedure ScanDirTop;
  function  ScanDirCount: Integer;
  function  FileSelectDirectory(pDir: String): String;
  function  DirectorySize(const sPath: TFileName): Int64;
  procedure PropertiesDialogShow(pFileName, pParameters: string; pHandle: THandle);
  function  GenerateAUniqueFileName: String;

  // Functions for NetShare and related
  function AddSharedDirectory(pPathToShare, pShareName, pShareRemark: String; pMaxUsers: Integer; var pVarRemoteSharePath: String): Boolean;
  function CreateShare(machineW, netName, comment, path : Widestring;
      MaxConnections: DWord; Sharetype :TShareTypes; passwd: String;
      permissions: DWord ): DWord;
  function NetShareAdd(serverName : PWChar; level: cardinal; buf:
     PChar; parm_err: PDWord): NetAPIStatus; stdcall;
  function NetShareDel(ServerName: PChar; NetName: PChar; Reserved: Word):
     Integer; StdCall;
  procedure FillShareInfo(var share : SHARE_INFO_502; netName, comment,
     path : Widestring; MaxConnections: DWord; FShareType : TShareTypes;
     passwd: String; permissions: DWord );
  procedure RaiseWin32Error(errorCode : DWord);
  function ConvertLocalUNCFileIDToLocalFileID(sLocalUNCFileID: string): string;
  function GetComputerNameStr: shortstring;
  function GetLocalShareInfo(sLocalShareName: string; var sPath,sRemark,sRWPassword,sROPassword: string) : boolean;
  function WNTGetShareInfo(sLocalShareName: string; var sPath,sRemark,sRWPassword,sROPassword: string): boolean;

  // FileSize/GetFileSize for files > 2GB
  function ReadFileSize(pFileName: String): Int64;
  function BinaryFileRead(pFileName: String; pLen: Integer): String;
  // Build system health
  procedure WriteSystemHealthEntry(pExeFileName, pTitle, pInfo: String; pMinsForGreen, pMinsForOrange: Integer);
  procedure WriteSystemHealthEntryExceptionInfo(pExeFileName, pTitle, pLastLog, pErrorInfo: String);
  function CreateSystemHealthRSSXML: TStringList;

const
   // NETHUB
   // Default log file location of TeleFlow Server
   //cTFServerEntry         =  'SOFTWARE\enGenic\TeleFlow Server';
   //cTSServerDir           =  'LOGDIRECTORY';
   // If not TeleFlow Server, then NetHubs
   cTFNetHubEntry           = 'SOFTWARE\enGenic\TFNetHub\Server';
   cTFNetHubWebDir          = 'HTTPRoot';
   cCrLf                    = #10#13;


   // SECURITY
   SECURITY_NULL_SID_AUTHORITY     = 0;
   SECURITY_WORLD_SID_AUTHORITY    = 1;
   SECURITY_LOCAL_SID_AUTHORITY    = 2;
   SECURITY_CREATOR_SID_AUTHORITY  = 3;
   SECURITY_NT_AUTHORITY           = 5;

   // These are a guess
   SECURITY_LOCAL_SYSTEM_RID       = 18; // Guess


   STYPE_DISKTREE          =0;
   STYPE_PRINTQ            =1;
   STYPE_DEVICE            =2;
   STYPE_IPC               =3;

   // Permissions
   SHI50F_RDONLY           = $0001;
   SHI50F_FULL             = $0002;
   SHI50F_DEPENDSON        = SHI50F_RDONLY OR SHI50F_FULL;
   SHI50F_ACCESSMASK       = SHI50F_RDONLY OR SHI50F_FULL;

   SHI50F_PERSIST          = $0100;
   SHI50F_SYSTEM           = $0200;

   SHI_USES_UNLIMITED      = DWORD(-1);
   MB_ERR_INVALID_CHARS    = $00000008;

   ACL_REVISION = 2;

implementation

var
   // START: Global Variables
   GlobErrorFlag                : Boolean;
   GlobDebug                    : String;

   gScanDirRecurseFoundFile     : Boolean;
   gScanDirRecurseMask          : String;
   gScanDirRecurseResults       : TStrings;
   gScanDirPosition             : Integer;
   gScanDirCount                : Integer;
   gScanDirSub                  : Boolean;
   gScanDirDirsOnly             : Boolean;
   // END: Global Variables


// Return the location of the current
function GetProgramFilesDir: string;
var
   reg: TRegistry;
begin
     reg := TRegistry.Create;
     try
       reg.RootKey := HKEY_LOCAL_MACHINE;
       reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion', False);
       Result := IncludeTrailingPathDelimiter(reg.ReadString('ProgramFilesDir'));
     finally
       reg.Free;
     end;
end;


// Return the file Version number or N/A
function GetExeVersionInfo(pFileName: String): String;
var
   mFV        : TrsFileVersion;
begin
     result := 'N/A';

     mFV := TrsFileVersion.Create;
     try
        // Get the version information from the exe
        if mFV.GetFileVersion(pFileName) then
        begin
            result           := IntToStr(mFV.Major)    +'.'+
                                IntToStr(mFV.Minor)    +'.'+
                                IntToStr(mFV.Release)  +'.'+
                                IntToStr(mFV.Build);
        end;
     finally
        mFV.Free;
     end;
end; // GetExeVersionInfo


// Windows path
function GetWindowsDir: string;
var
   mWindowsDir      : array [0..255] of Char;
begin
     // If the file exists... load up the calls in it.
     GetWindowsDirectory(mWindowsDir,255);
     result     := IncludeTrailingPathDelimiter(StrPas(mWindowsDir));
end;


// Pop up a web page in the default browser
procedure GotoWebPage(pApplicationExe, pHtmlAddress: String);
begin
     ExecuteAssociatedFile(pHtmlAddress,
                           '',
                           ExtractFileDir(pApplicationExe),
                           SW_SHOW);
end;


// Return the age of a file in TDateTime
function GetFileAgeDateTime(pFileName: STring): TDateTime;
var
   mAge     : TDateTime;
begin
     // Find the file age
     mAge   := FileDateToDateTime(FileAge(pFileName));
     result := mAge;
end;


// Log to standard output file
function LogFileOutput(pLogFile, pLogEntry: String): Boolean;
var
   F2 : TextFile;
begin
     result := True;
     try
         GlobDebug   := IntToStr(IOResult);  // This MUST happen before each write
         AssignFile (F2, pLogFile);
         { Create or add to text log file }
         if (FileExists(pLogFile)) then
         begin
              Append(F2)
         end
         else
         begin
              ReWrite(F2);
         end;

         // Write message information to file
         writeln(F2, FormatDateTime('yyyy/mm/dd hh:nn:ss.zzz:',now)+'  '+pLogEntry);

         { Close file }
         CloseFile (F2);
     except
         result := False;
     end;

     (* // Note: This is another way that is commonly used to write a log
        // - Just put here for reference
     // Write the entry
     try
        GlobDebug   := IntToStr(IOResult);  // This MUST happen before each write
        {$I-}
        AssignFile(GlobTextFile,mFile);
        FileMode    := 2;
        reset(GlobTextFile);
        if FileExists(mFile) then
        begin
             Append(GlobTextFile);
        end
        else
        begin
             Rewrite(GlobTextFile);
        end;
        Writeln(GlobTextFile, mMsg);
        // insert code here that would require a Flush before closing the file
        Flush(GlobTextFile);  // ensures that the text was actually written to file
        CloseFile(GlobTextFile);
        {$I+}

     except
     end;
     *)

end; { ErrorFileLog }


{ Adjust a file to assume the drive name of the TAP file }
{ Add drive letter if it is missing.  This will allow the
  system to remain somewhat drive independent }
function FileNameDriveFix(FileName, appFileName: String):String;
var
   { Compare flow chart info }
   mAppDrive,
   mAppPath,
   mAppFile: String;

   mFileDrive,
   mFilePath,
   mFileFile: String;

begin
     { Find the fully expanded path for a file }

     mAppDrive  := UpperCase(ExtractFileDrive (ExpandFileName(appFileName)));
     mAppPath   := UpperCase(ExtractFilePath  (ExpandFileName(appFileName)));
     mAppFile   := UpperCase(ExtractFileName  (ExpandFileName(appFileName)));

     mFileDrive := UpperCase(ExtractFileDrive (FileName));
     mFilePath  := UpperCase(ExtractFilePath  (FileName));
     mFileFile  := UpperCase(ExtractFileName  (FileName));


     { Do we need path and drive? }
     if (Length(Trim(mFilePath)) = 0) then
     begin
          result := mAppPath + FileName;
     end
     { Do we need a drive }
     else if (Length(Trim(mFileDrive)) = 0) then
     begin
          result := mAppDrive + FileName;
     end
     else
     begin
          // Create relative location
          result := RelativePathFinder(appFileName,FileName);        // @@@ Was TAPFileName for appFileName
     end;
end; { FileNameDriveFix }


// Remove the drive from a path name
function CreateProperPathName(pDirectory, pFileName: String): String;
begin
     result := pDirectory+'\'+pFileName;
     if ((Copy(pFileName,2,2) = ':\') or
         (Copy(pFileName,1,1) = '\')) then
     begin
          result := pFileName;
     end
     else
     begin
          if (Copy(pFileName,2,1) = ':') then
          begin
               result := pDirectory+'\'+Copy(pFileName,3,9999);
          end;
     end;
end;  // ExtractPathNoDrive



// Create the relative location for a file
function FindRelativeLocation(FOCUSFileName, RELATIVEFileName: String): String;
var
   { Compare flow chart info }
   mAppDrive,
   mAppPath,
   mAppFile: String;

   mProcDrive,
   mProcPath,
   mProcFile: String;
begin
     { Decide if the TAM file should be:
       o Just the file name
       o The file with directory location
       o The file with dir and drive location  }

     // First, check to see if the file is already a relative file name
     result := RELATIVEFileName;
     if (Copy(RELATIVEFileName,1,1) = '\') or
        (Copy(RELATIVEFileName,2,1) = ':') then  // Name is not relative
     begin

          // Second, check to see if the file is relatviely located
          result := RelativePathFinder(FOCUSFileName, RELATIVEFileName);
          // If a relative location is not returned, continue with a wider check
          if (result = RELATIVEFileName) then
          begin

               mAppDrive  := ExtractFileDrive (ExpandFileName(FOCUSFileName));
               mAppPath   := ExtractFilePath  (ExpandFileName(FOCUSFileName));
               mAppFile   := ExtractFileName  (ExpandFileName(FOCUSFileName));

               mProcDrive := ExtractFileDrive (ExpandFileName(RELATIVEFileName));
               mProcPath  := ExtractFilePath  (ExpandFileName(RELATIVEFileName));
               mProcFile  := ExtractFileName  (ExpandFileName(RELATIVEFileName));

               { On save drive? }
               if UpperCase(mAppDrive) = UpperCase(mProcDrive) then
               begin
                    { In same directory? }
                    if UpperCase(mAppPath) = UpperCase(mProcPath) then
                    begin
                         { BEST CASE: Just the file name only }
                         result := mProcFile;
                    end
                    else
                    begin
                         { NOT BEST CASE: Not in same dir, but on drive. }
                         { Get rid of drive letter now }
                         result := mProcPath+mProcFile;
                         if (pos(UpperCase(mProcDrive), UpperCase(result)) > 0) then
                         begin
                              { Extract all but the mandetory }
                              result := Copy(result,pos(mProcDrive, result)+
                                          Length(Trim(mProcDrive)),9999);
                         end;
                    end;
               end
               else
               begin
                    { WORST CASE: Not on same drive, must apply entire dir path. }
                    result := RELATIVEFileName;
               end;
          end; { Second }
     end; { First }
end; { FindRelativeLocation }


{ Returns the path relative to the TAP of a associated file }
function RelativePathFinder(FileFocus,FileLoc: String): String;
var
   mSize: Integer;
   mPath: String;
begin
     mPath := ExtractFilePath(FileFocus);
     mSize := Length(mPath);

     // If the path name matches, then remove the identical bits from the front
     if UpperCase(Copy(FileLoc,1,mSize)) = UpperCase(mPath) then
     begin
          result := Copy(FileLoc,(mSize+1),9999);
     end
     else
     begin
          // No match, so return the location unchanged
          result := FileLoc;
     end;
end;


{ Append relative path locations along with focus directory to create a full path }
function CreateFullRelativePath(FileFocus,FileLoc: String): String;
begin
     result := ExtractFilePath(FileFocus) + FileLoc;
end; { CreateFullRelativePath }


{ See if file exists relatively to focus directory }
function FileExistsRelative(FileFocus,FileLoc: String): Boolean;
begin
     result := FileExists(CreateFullRelativePath(FileFocus,FileLoc));
end; { FileExistsRelative }


{ Remove the path and all file from disk }
procedure DeletePath(PathName: String);
{$IFDEF MSWINDOWS}
var
   mName: String;
   DirInfo: TSearchRec;
   r : Integer;
{$ENDIF}
begin
{$IFDEF MSWINDOWS}
     GlobErrorFlag := False;
     mName := PathName+'\';

     r := FindFirst(mName+'*.*', FaAnyfile, DirInfo);
     while r = 0 do
     begin
          if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
              (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
          begin
               if DeleteFile(pChar(mName + DirInfo.Name)) = false then
               begin
                    // Unable to delete the file
                    GlobErrorFlag := True;
               end;
          end;
          r := FindNext(DirInfo);
     end;

     SysUtils.FindClose(DirInfo);

     if RemoveDirectory(pChar(PathName)) = false then
     begin
          // Unable to delete the directory
          GlobErrorFlag := True;
     end;
{$ELSE}
     ShowMessage('ERROR: This O/S needs modification with CopyDirectory function');
{$ENDIF}
end;


{ Copy all files in a direcotry }
procedure CopyDirectory(DirSource,DirDest,DirLevel: String);
{$IFDEF MSWINDOWS}
var
   mName: String;
   DirInfo: TSearchRec;
   r : Integer;
{$ENDIF}
begin
{$IFDEF MSWINDOWS}
     GlobErrorFlag := False;
     // Find source dir
     mName := DirSource+DirLevel + '\';

     r := FindFirst(mName+'*.*', FaAnyfile, DirInfo);
     while r = 0 do
     begin
          if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
              (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then
          begin
               if FileCopy((mName + DirInfo.Name),(DirDest + DirLevel + '\' + DirInfo.Name)) = false then
               begin
                    // Unable to delete the file
                    GlobErrorFlag := True;
               end;
          end;
          r := FindNext(DirInfo);
     end;

     SysUtils.FindClose(DirInfo);
{$ELSE}
     ShowMessage('ERROR: This O/S needs modification with CopyDirectory function');
{$ENDIF}
end; { CopyDirectory }


// Strip spaces from the file portion of a file name
// @@@ I dont like doing this, but for ease, TeleFlow is not easily
//     able to load files with spaces.  Hopefully this will suffice for now
function StripSpacesInFile(mString: String): String;
var
   mPart1,
   mPart2,
   mFileDrive,
   mFilePath,
   mFileFile: String;

   mFind: Integer;
begin
     result := mString;

     mFileDrive := ExtractFileDrive (mString);
     mFilePath  := ExtractFilePath  (mString);
     mFileFile  := ExtractFileName  (mString);

     // Find the file name section
     mFind := Pos(mFileFile, mString);
     if mFind > 0 then
     begin
          mPart1 := Copy(mString,1,mFind - 1);
          mPart2 := Copy(mString,mFind,9999);

          { Convert spaces to zeroes }
          while Pos(' ', mPart2) > 0 do
                mPart2[Pos(' ', mPart2)] := '_';

          // Rebuild the string
          result := mPart1 + mPart2;
     end;

end; //StripSpaces


// Generates a unique filename in the TEMP file workspace on the local computer.
function GenerateAUniqueFileName: String;
const
   TF1Prefix: PChar = 'TMP_';
var
   TempPath: array[0..1024] of Char;
   TempFileName: array[0..1024] of Char;
begin
     GetTempPath(SizeOf(TempPath), TempPath);
     GetTempFileName(TempPath, TF1Prefix, 0, TempFileName);
     Result := TempFileName;
end;


// Copy an entire tree
// - TreeCopy('c:\data', 'd:\backup');
// IMPORTANT: This function returns TRUE if it FAILS to copy files because the user aborts the operation.
// The other function - TreeCopySilent - returns true if the copy is successful.
function TreeCopy(pDirFrom,pDirTo: String): Boolean;
var
  OpStruc: TSHFileOpStruct;
  frombuf, tobuf: Array [0..128] of Char;
begin
     FillChar( frombuf, Sizeof(frombuf), 0 );
     FillChar( tobuf, Sizeof(tobuf), 0 );
     StrPCopy( frombuf, pDirFrom+'\*.*' );
     StrPCopy( tobuf, pDirTo );
     with OpStruc do
     begin
          Wnd    := 0; //Handle;
          wFunc  := FO_COPY;
          pFrom  := @frombuf;
          pTo    := @tobuf;
          //fFlags:= FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION or FOF_SIMPLEPROGRESS
          fFlags:= FOF_NOCONFIRMATION or
                   FOF_NOCONFIRMMKDIR;
          fAnyOperationsAborted:= False;
          hNameMappings:= Nil;
          lpszProgressTitle:= Nil;
     end;
     // Perform the copy
     ShFileOperation( OpStruc );

     // Did the user abort??
     result := OpStruc.fAnyOperationsAborted;
end;  // TreeCopy


// Copy an entire tree without a copy progress bar
// IMPORTANT: This function returns TRUE if it SUCCEEDS in copying files. The other function - TreeCopy -
// returns true if the copy is aborted. (Which seems BACKWARDS)
// - TreeCopy('c:\data', 'd:\backup');
function  TreeCopySilent(pDirFrom,pDirTo: String): Boolean;
var
  OpStruc: TSHFileOpStruct;
  frombuf, tobuf: Array [0..128] of Char;
  mResult: Boolean;
begin
     FillChar( frombuf, Sizeof(frombuf), 0 );
     FillChar( tobuf, Sizeof(tobuf), 0 );
     StrPCopy( frombuf, pDirFrom+'\*.*' );
     StrPCopy( tobuf, pDirTo );
     with OpStruc do
     begin
          Wnd    := 0; //Handle;
          wFunc  := FO_COPY;
          pFrom  := @frombuf;
          pTo    := @tobuf;
          //fFlags:= FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION or FOF_SIMPLEPROGRESS
          fFlags:= FOF_NOCONFIRMATION or
                   FOF_NOCONFIRMMKDIR or
                   FOF_SILENT; // No progress bar.
          fAnyOperationsAborted:= False;
          hNameMappings:= Nil;
          lpszProgressTitle:= Nil;
     end;
     // Perform the copy
     ShFileOperation( OpStruc );

     // Did the user abort??
     mResult := OpStruc.fAnyOperationsAborted;

     // Reverse mResult for return value: The function should return TRUE if the copy SUCCEEDS.
     // fAnyOperationsAborted returns TRUE if the copy FAILS
     if mResult then
     begin
          result := False;
     end
     else
     begin
          result := True;
     end;
end;  // TreeCopy


// Move an entire tree
// - TreeCopy('c:\data', 'd:\backup');
function TreeMove(pDirFrom,pDirTo: String): Boolean;
var
  OpStruc: TSHFileOpStruct;
  frombuf, tobuf: Array [0..128] of Char;
begin
     FillChar( frombuf, Sizeof(frombuf), 0 );
     FillChar( tobuf, Sizeof(tobuf), 0 );
     StrPCopy( frombuf, pDirFrom+'\*.*' );
     StrPCopy( tobuf, pDirTo );
     with OpStruc do
     begin
          Wnd:= 0; //Handle;
          wFunc:= FO_MOVE;
          pFrom:= @frombuf;
          pTo:=@tobuf;
          //fFlags:= FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION or FOF_SIMPLEPROGRESS
          fFlags:= FOF_NOCONFIRMATION or
                   FOF_NOCONFIRMMKDIR;
          fAnyOperationsAborted:= False;
          hNameMappings:= Nil;
          lpszProgressTitle:= Nil;
     end;
     // Perform the copy
     ShFileOperation( OpStruc );

     // Did the user abort??
     result := OpStruc.fAnyOperationsAborted;
end;  // TreeMove


// Delete an entire tree structure
// - The FOF_FILESONLY is required if you use the *.* and
//   don't want to delete sub directories.
function TreeDelete(pDirFrom: String): Boolean;
var
   //mResult: integer;
   mCompletePath: String;
   OpStruc:TSHFileOpStruct;
begin

     mCompletePath := pDirFrom;
     // Warning:
     // - There must not be a slash on the entry to delete a directory
     if Copy(pDirFrom,Length(pDirFrom),1) = '\' then
     begin
          mCompletePath := Copy(pDirFrom,1,length(pDirFrom)-1)+#0+#0;
     end
     else
     begin
          mCompletePath := mCompletePath+#0+#0;
     end;

     //mResult := 0;
     FillChar (OpStruc, SizeOf (OpStruc), 0);
     with OpStruc do
     begin
          Wnd   :=0;
          wFunc :=FO_DELETE;
          //pFrom:=frombuf;
          pFrom :=PChar(mCompletePath);
          //fFlags:=FOF_FILESONLY or FOF_ALLOWUNDO or FOF_SILENT or FOF_NOCONFIRMATION;
          fFlags:=FOF_SILENT or
                  FOF_NOCONFIRMATION;
          lpszProgressTitle:= PChar('Delete Files');
     end;
     // Perform the delete
     //mResult := SHFileOperation(OpStruc);
     SHFileOperation(OpStruc);

     // Did the user abort??
     result := OpStruc.fAnyOperationsAborted;
end;  // TreeDelete



// Copy a file
// !!!!!! DO NOT USE THIS APPROACH!!
// - There appears to be issues with it on some network systems
(*
function FileCopy(source,dest: String): Boolean;
var
  fSrc,fDst,len: Integer;
  size: Longint;
  buffer: packed array [0..2047] of Byte;
begin
  Result := False; { Assume that it WONT work }
  if source <> dest then begin
    fSrc := FileOpen(source,fmOpenRead);
    if fSrc >= 0 then begin
      size := FileSeek(fSrc,0,2);
      FileSeek(fSrc,0,0);
      fDst := FileCreate(dest);
      if fDst >= 0 then begin
        while size > 0 do begin
          len := FileRead(fSrc,buffer,sizeof(buffer));
          FileWrite(fDst,buffer,len);
          size := size - len;
        end;
        FileSetDate(fDst,FileGetDate(fSrc));
        FileClose(fDst);
        FileSetAttr(dest,FileGetAttr(source));
        Result := True;
      end;
      FileClose(fSrc);
    end;
  end;
end; // FileCopy
*)

// Copy file - The proper way
function FileCopy(pSource,pDest: String): Boolean;
var
   mCheck: Integer;
begin
     mCheck :=
     FileOperation (pSource,
                    pDest,
                    FO_COPY,
                    FOF_NOCONFIRMATION);
     // True = Success
     result := mCheck = 0;
end;


// Move file - The proper way
function FileMove(pSource,pDest: String): Boolean;
var
   mCheck: Integer;
begin
     mCheck :=
     FileOperation (pSource,
                    pDest,
                    FO_MOVE,
                    FOF_NOCONFIRMATION);
     // True = Success
     result := mCheck = 0;
end;

// Move file without progress bar/indicators of any kind - The proper way
function FileMoveSilent(pSource,pDest: String): Integer;
begin
     // 0 = Success
     result := 
     FileOperation (pSource,
                    pDest,
                    FO_MOVE,
                    FOF_NOCONFIRMATION or FOF_SILENT);
end;


// Perform file operations
//
//  Source:= 'C:\WINDOWS';
//  Dest := '';
//  FileOperation (Source, Dest, FO_DELETE, FOF_NOCONFIRMATION);
(* From Help

  FO_COPY         Copies the files specified by pFrom to the location specified by pTo.
  FO_DELETE       Deletes the files specified by pFrom (pTo is ignored).
  FO_MOVE         Moves the files specified by pFrom to the location specified by pTo.
  FO_RENAME       Renames the files specified by pFrom.

  FOF_ALLOWUNDO           Preserves undo information, if possible.
  FOF_FILESONLY           Performs the operation only on files if a wildcard filename is specified.
  FOF_MULTIDESTFILES      Indicates that the pTo member specifies multiple destination files (one for each source file) rather than one directory where all source files are to be deposited.
  FOF_NOCONFIRMATION      Responds with "yes to all" for any dialog box that is displayed.
  FOF_NOCONFIRMMKDIR      Does not confirm the creation of a new directory if the operation requires one to be created.
  FOF_RENAMEONCOLLISION   Gives the file being operated on a new name (such as "Copy #1 of...") in a move, copy, or rename operation if a file of the target name already exists.
  FOF_SILENT              Does not display a progress dialog box.
  FOF_SIMPLEPROGRESS      Displays a progress dialog box, but does not show the filenames.
  FOF_WANTMAPPINGHANDLE   Fills in the hNameMappings member. The handle must be freed by using the SHFreeNameMappings function.
*)
function FileOperation (const source, dest: string; op, flags: integer): integer;
var
   shf : TSHFileOpStruct;
   s1, s2 : string;
begin
     FillChar (shf, SizeOf (shf), #0);
     s1         := source + #0#0;
     s2         := dest + #0#0;
     shf.Wnd    := 0;
     shf.wFunc  := op;
     shf.pFrom  := PCHAR (s1);
     shf.pTo    := PCHAR (s2);
     shf.fFlags := flags;
     //Returns zero if successful or nonzero if an error occurs.
     result     := SHFileOperation(shf);
end;


// Start an object running in the operating system
procedure OpenObject( sObjectPath : string );
begin
     // Use for opening associated files.  CreateProcess for exe/bat
     ShellExecute( 0, Nil, PChar( sObjectPath ),
                   Nil, Nil, SW_NORMAL );
end;

// Start an object running in the operating system
procedure OpenExplorerWindow( pExplorerPath : string );
begin
     // Use for opening associated files.  CreateProcess for exe/bat
     ShellExecute( 0, 'explore', PChar( pExplorerPath ),
                   Nil, Nil, SW_SHOW );
end;



// Run a program
// - Runs a program hidden from view
// parm1 = Location of the Delphi App: Application.Exename
// parm2 = program to run (.cmd .exe etc)
// parm3 = any parameters
//
// WARNING:
// -- Do not use for starting GUI applications, as windows will not display them (any more)
procedure ShellExternal(pApplicationExe, pProgram, pParameters: String);
var
   mProg: String;
   WinProgram, WinParm: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
begin
     try
        WinProgram := '';
        WinParm    := '';
        StrPCopy(WinParm,pParameters);
        mProg := pProgram + ' ';
        StrPCopy(WinProgram, mProg);
        StrCat(WinProgram, WinParm);

        // Return to the exe directory to run programs from
        if pApplicationExe <> '' then
        begin
             ChDir(ExtractFileDir(pApplicationExe));  // I don't think this does what it looks like it should
        end;
        
        // CreateProcess
        // -------------
        // Needs:
        //   st : TStartupInfo;
        //   pp : TProcessInformation;
        // Now convert to c passable information and run
        fillchar(st,sizeof(st),#0);
        st.cb := sizeof(st);
        st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
        st.wShowWindow := SW_HIDE;
        fillchar(pp,sizeof(pp),#0);
        CreateProcess(nil,
                      WinProgram,
                      NIL,NIL,FALSE,
                      CREATE_DEFAULT_ERROR_MODE,
                      NIL,
                      NIL, //mCurDir,
                      st,
                      pp);
     except
          on E: Exception do ShellExternalError(E);
     end;


end;  // ShellExternal


procedure ShellExternalError(E: Exception);
begin
     ShowMessage(E.ClassName + ': ' + E.Message);
end;



// Run a program
// - Runs a program hidden from view
// parm1 = Location of the Delphi App: Application.Exename
// parm2 = program to run (.cmd .exe etc)
// parm3 = any parameters
procedure ShellExternal_InDirectory(pApplicationExe, pProgram, pParameters: String);
var
   mCurDir,
   mProg: String;
   WinProgram, WinParm, WinDir: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
begin
     WinProgram := '';
     WinParm    := '';
     StrPCopy(WinParm,pParameters);
     mProg := pProgram + ' ';
     StrPCopy(WinProgram, mProg);
     StrCat(WinProgram, WinParm);

     // Return to the exe directory to run programs from
     mCurDir := (ExtractFileDir(pApplicationExe));  //ChDir
     StrPCopy(WinDir,mCurDir);

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(st),#0);
     st.cb := sizeof(st);
     st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
//     st.wShowWindow := SW_HIDE;
     st.wShowWindow := SW_SHOW;
     fillchar(pp,sizeof(pp),#0);
     CreateProcess(nil,
                   WinProgram,
                   NIL,NIL,FALSE,
                   CREATE_DEFAULT_ERROR_MODE,
                   NIL,
                   PChar(mCurDir), //WinDir,
                   st,
                   pp);

end;  // ShellExternal_InDirectory


// Run a program
// - Runs a program hidden from view
// parm1 = Location of the Delphi App: Application.Exename
// parm2 = program to run (.cmd .exe etc)
// parm3 = any parameters
// MODS: VB: July 7/03 FIxed a horrible get stuck error (see: Sleep(200) + uses Forms
function ShellExternalWithResult(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String): Integer;
var
   mResult: Boolean;
   mProcResult: Dword;

   mProgramName: String;
   st : TStartupInfo;
   pp : TProcessInformation;
   //proc: THandle;
begin
     mProgramName := trim(pProgram + ' ' + pParameters);

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(TStartupInfo),#0);
     fillchar(pp,sizeof(TProcessInformation),#0);
     st.cb := sizeof(TStartupInfo);
     st.wShowWindow := 1;
     st.dwFlags := STARTF_USESHOWWINDOW;

     // Return Values
     // If the function succeeds, the return value is nonzero.
     // If the function fails, the return value is zero. To get extended error information, call GetLastError.
     mResult :=
     CreateProcess(nil,
                   PChar(mProgramName),
                   NIL,
                   NIL,
                   FALSE,
                   CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
                   //CREATE_DEFAULT_ERROR_MODE,
                   NIL,
                   NIL, //mCurDir,
                   st,
                   pp);

     // Get the error value on a fail
     if not mResult then
     begin
          result := GetLastError();
     end
     else
     begin
          result := 0;
          //Proc := pp.hProcess;
          //CloseHandle(pp.hThread);
          //WaitForSingleObject(pp.hProcess, Infinite);

          while True do
          begin
               // If we dont get an exit code then get the error...
               if not GetExitCodeProcess(pp.hProcess, mProcResult) then
               begin
                    result := GetLastError();
               end
               else
               begin
                    if mProcResult = STILL_ACTIVE then
                    begin
                         Sleep(200); // 200 ms
                         //ProcessMessages;
                         Application.ProcessMessages;
                    end
                    else
                    begin
                         // Finally done..
                         result := mProcResult;
                         break;
                    end;
               end;
          end; // endLess Loop
          CloseHandle(pp.hProcess);

          // Get the last error result received
          //result := GetLastError();
     end;
end; // ShellExternalWithResult
(*
var
   mResult: Boolean;
   mProcResult: Dword;
   mProg:   String;
   WinProgram, WinParm: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
   proc: THandle;
begin
     WinProgram := '';
     WinParm    := '';
     StrPCopy(WinParm,pParameters);
     mProg := pProgram + ' ';
     StrPCopy(WinProgram, mProg);
     StrCat(WinProgram, WinParm);
     // Return to the exe directory to run programs from
     ChDir(ExtractFileDir(pApplicationExe));

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(st),#0);
     st.cb := sizeof(st);
     st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
     if pVisible then
     begin
          st.wShowWindow := SW_SHOW; //SW_HIDE;
     end
     else
     begin
          st.wShowWindow := SW_HIDE;
     end;
     fillchar(pp,sizeof(pp),#0);

     // Return Values
     // If the function succeeds, the return value is nonzero.
     // If the function fails, the return value is zero. To get extended error information, call GetLastError.
     mResult :=
     CreateProcess(nil,
                   WinProgram,
                   NIL,
                   NIL,
                   FALSE,
                   CREATE_DEFAULT_ERROR_MODE,
                   NIL,
                   NIL, //mCurDir,
                   st,
                   pp);

     // Get the error value on a fail
     if not mResult then
     begin
          result := GetLastError();
     end
     else
     begin
          result := 0;
          Proc := pp.hProcess;
          CloseHandle(pp.hThread);
          if WaitForSingleObject(Proc, Infinite) <> Wait_Failed then
          begin
               // If we dont get an exit code then get the error...
               if not GetExitCodeProcess(Proc, mProcResult) then
               begin
                    result := GetLastError();
               end
               else
               begin
                    result := mProcResult;
               end;
          end;
          CloseHandle(Proc);

          // Get the last error result received
          //result := GetLastError();
     end;
end;  // ShellExternalWithResult
*)

// Run a program
// - Runs a program and waits for it to complete before returning
// Parm1 = Show application on the desktop?
// parm2 = Location of the Delphi App: Application.Exename
// parm3 = program to run (.cmd .exe etc)
// parm4 = any parameters
// MODS: VB: July 7/03 FIxed a horrible get stuck error (see: Sleep(200) + uses Forms
function ShellExternalWaitForResult(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String): Integer;
var
   mResult: Boolean;
   mProcResult: Dword;

   mProgramName: String;
   st : TStartupInfo;
   pp : TProcessInformation;
   //proc: THandle;
begin
     mProgramName := trim(pProgram + ' ' + pParameters);

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(TStartupInfo),#0);
     fillchar(pp,sizeof(TProcessInformation),#0);
     st.cb := sizeof(TStartupInfo);
     st.wShowWindow := 1;
     st.dwFlags := STARTF_USESHOWWINDOW;
     // Hide window?
     if pVisible then
     begin
          st.wShowWindow := SW_SHOW; //SW_HIDE;
     end
     else
     begin
          st.wShowWindow := SW_HIDE;
     end;


     // Return Values
     // If the function succeeds, the return value is nonzero.
     // If the function fails, the return value is zero. To get extended error information, call GetLastError.
     mResult :=
     CreateProcess(nil,
                   PChar(mProgramName),
                   NIL,
                   NIL,
                   FALSE,
                   CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
                   //CREATE_DEFAULT_ERROR_MODE,
                   NIL,
                   NIL, //mCurDir,
                   st,
                   pp);

     // Get the error value on a fail
     if not mResult then
     begin
          result := GetLastError();
     end
     else
     begin
          result := 0;
          //Proc := pp.hProcess;
          //CloseHandle(pp.hThread);
          //WaitForSingleObject(pp.hProcess, Infinite);


          while True do
          begin
               // If we dont get an exit code then get the error...
               if not GetExitCodeProcess(pp.hProcess, mProcResult) then
               begin
                    result := GetLastError();
               end
               else
               begin
                    if mProcResult = STILL_ACTIVE then
                    begin
                         Sleep(200); // 200 ms
                         //ProcessMessages;
                         Application.ProcessMessages;
                    end
                    else
                    begin
                         // Finally done..
                         result := mProcResult;
                         break;
                    end;
               end;
          end; // endLess Loop
          CloseHandle(pp.hProcess);

          // Get the last error result received
          //result := GetLastError();
     end;
end;  // ShellExternalWaitForResult



// Run a program
// - Runs a program hidden from view
// parm1 = Location of the Delphi App: Application.Exename
// parm2 = program to run (.cmd .exe etc)
// parm3 = any parameters
procedure ShellExternalNewConsole(pApplicationExe, pProgram, pParameters: String);
var
   mCurDir,
   mProg: String;
   WinProgram, WinParm, WinDir: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
begin
     WinProgram := '';
     WinParm    := '';
     StrPCopy(WinParm,pParameters);
     mProg := pProgram + ' ';
     StrPCopy(WinProgram, mProg);
     StrCat(WinProgram, WinParm);


     // Return to the exe directory to run programs from
     // - This does not work.... (needs to be handed with
     mCurDir := (ExtractFileDir(pApplicationExe));  //ChDir
     StrPCopy(WinDir,mCurDir);

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(st),#0);
     st.cb := sizeof(st);
     st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
     st.wShowWindow := SW_HIDE;
     fillchar(pp,sizeof(pp),#0);
     CreateProcess(nil,
                   WinProgram,
                   NIL,NIL,FALSE,
                   CREATE_NEW_CONSOLE,
                   NIL,
                   WinDir,     // VB: 2003/05/23 // NIL
                   st,
                   pp);

end;  // ShellExternalNewConsole

procedure ShellExternalNewConsoleVisible(pApplicationExe, pProgram, pParameters: String);
var
   mCurDir,
   mProg: String;
   WinProgram, WinParm, WinDir: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
begin
     WinProgram := '';
     WinParm    := '';
     StrPCopy(WinParm,pParameters);
     mProg := pProgram + ' ';
     StrPCopy(WinProgram, mProg);
     StrCat(WinProgram, WinParm);


     // Return to the exe directory to run programs from
     // - This does not work.... (needs to be handed with
     mCurDir := (ExtractFileDir(pApplicationExe));  //ChDir
     StrPCopy(WinDir,mCurDir);

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(st),#0);
     st.cb := sizeof(st);
     st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
     st.wShowWindow := SW_SHOW;  //SW_HIDE
     fillchar(pp,sizeof(pp),#0);
     CreateProcess(nil,
                   WinProgram,
                   NIL,NIL,FALSE,
                   CREATE_NEW_CONSOLE,
                   NIL,
                   WinDir,     // VB: 2003/05/23 // NIL
                   st,
                   pp);

end;  // ShellExternalNewConsoleVisible



// Run a program
// parm1 = Location of the Delphi App: Application.Exename
// parm2 = program to run (.cmd .exe etc)
// parm3 = any parameters
procedure ShellNewProgram(pApplicationExe, pProgram, pParameters: String);
var
   mProg: String;
   WinProgram, WinParm: array[0..259] of Char;
//PChar;

   st : TStartupInfo;
   pp : TProcessInformation;
begin
     WinProgram := '';
     WinParm    := '';
     StrPCopy(WinParm,pParameters);
     mProg := pProgram + ' ';
     StrPCopy(WinProgram, mProg);
     StrCat(WinProgram, WinParm);
     // Return to the exe directory to run programs from
     ChDir(ExtractFileDir(pApplicationExe));

     // CreateProcess
     // -------------
     // Needs:
     //   st : TStartupInfo;
     //   pp : TProcessInformation;
     // Now convert to c passable information and run
     fillchar(st,sizeof(st),#0);
     st.cb := sizeof(st);
     st.dwFlags     := STARTF_USESHOWWINDOW;  // Hides Cmd wins
     st.wShowWindow := SW_SHOWDEFAULT;
     fillchar(pp,sizeof(pp),#0);
     CreateProcess(nil,
                   WinProgram,
                   NIL,NIL,FALSE,
                   CREATE_DEFAULT_ERROR_MODE,
                   NIL,
                   NIL, //mCurDir,
                   st,
                   pp);

end;  // ShellExternal


{-- WinExecAndWait32V2
------------------------------------------------}
{: Executes a program and waits for it to terminate
@Param FileName contains executable + any parameters
@Param Visibility is one of the ShowWindow options, e.g. SW_SHOWNORMAL
@Returns -1 in case of error, otherwise the programs exit code
@Desc In case of error SysErrorMessage( GetlastError ) will return an
 error message. The routine will process paint messages and messages
 send from other threads while it waits.
}{ Created 27.10.2000 by P. Below
-----------------------------------------------------------------------
Example:

WinExecAndWait32V2('notepad.exe', SW_SHOWNORMAL);
WinExecAndWait32V2('batch.cmd',   SW_HIDE);  // Behind the scenes ???
// this line will execute after
ShowMessage('Hello');
}
function WinExecAndWait32V2( FileName: String; Visibility: integer ): DWORD;
   procedure WaitFor( processHandle: THandle );
   var
     msg: TMsg;
     ret: DWORD;
   begin
     repeat
       ret := MsgWaitForMultipleObjects(
                1, { 1 handle to wait on }
                processHandle, { the handle }
                False, { wake on any event }
                INFINITE, { wait without timeout }
                QS_PAINT or { wake on paint messages }
                QS_SENDMESSAGE { or messages from other threads }
                );
       if ret = WAIT_FAILED Then Exit; { can do little here }
       if ret = (WAIT_OBJECT_0 + 1) then
       begin
         { Woke on a message, process paint messages only. Calling
           PeekMessage gets messages send from other threads processed. }
         while PeekMessage( msg, 0, WM_PAINT, WM_PAINT, PM_REMOVE ) Do
         begin
              DispatchMessage( msg );
         end;
       end;
     until ret = WAIT_OBJECT_0;
   end; { Waitfor }
var { V1 by Pat Ritchey, V2 by P.Below }
   zAppName:array[0..512] of char;
   StartupInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
begin { WinExecAndWait32V2 }
   StrPCopy(zAppName,FileName);
   FillChar(StartupInfo,Sizeof(StartupInfo),#0);
   StartupInfo.cb := Sizeof(StartupInfo);
   StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
   StartupInfo.wShowWindow := Visibility;
   if not CreateProcess(nil,
                        zAppName, { pointer to command line string }
                        nil, { pointer to process security attributes }
                        nil, { pointer to thread security attributes }
                        false, { handle inheritance flag }
                        CREATE_NEW_CONSOLE or { creation flags }
                        NORMAL_PRIORITY_CLASS,     // BELOW_NORMAL_PRIORITY_CLASS
                        nil, { pointer to new environment block }
                        nil, { pointer to current directory name }
                        StartupInfo, { pointer to STARTUPINFO }
                        ProcessInfo) { pointer to PROCESS_INF }
   then
   begin
        Result := DWORD(-1) { failed, GetLastError has error code }
   end
   else
   begin
      Waitfor(ProcessInfo.hProcess);
      GetExitCodeProcess(ProcessInfo.hProcess, Result);
      CloseHandle( ProcessInfo.hProcess );
      CloseHandle( ProcessInfo.hThread );
   end; { Else }
end; { WinExecAndWait32V2 }

// Lower Priority Version
function WinExecAndWait32V2LowPriority( FileName: String; Visibility: integer ): DWORD;
   procedure WaitFor( processHandle: THandle );
   var
     msg: TMsg;
     ret: DWORD;
   begin
     repeat
       ret := MsgWaitForMultipleObjects(
                1, { 1 handle to wait on }
                processHandle, { the handle }
                False, { wake on any event }
                INFINITE, { wait without timeout }
                QS_PAINT or { wake on paint messages }
                QS_SENDMESSAGE { or messages from other threads }
                );
       if ret = WAIT_FAILED Then Exit; { can do little here }
       if ret = (WAIT_OBJECT_0 + 1) then
       begin
         { Woke on a message, process paint messages only. Calling
           PeekMessage gets messages send from other threads processed. }
         while PeekMessage( msg, 0, WM_PAINT, WM_PAINT, PM_REMOVE ) Do
         begin
              DispatchMessage( msg );
         end;
       end;
     until ret = WAIT_OBJECT_0;
   end; { Waitfor }
var { V1 by Pat Ritchey, V2 by P.Below }
   zAppName:array[0..512] of char;
   StartupInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
begin { WinExecAndWait32V2 }
   StrPCopy(zAppName,FileName);
   FillChar(StartupInfo,Sizeof(StartupInfo),#0);
   StartupInfo.cb := Sizeof(StartupInfo);
   StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
   StartupInfo.wShowWindow := Visibility;
   if not CreateProcess(nil,
                        zAppName, { pointer to command line string }
                        nil, { pointer to process security attributes }
                        nil, { pointer to thread security attributes }
                        false, { handle inheritance flag }
                        CREATE_NEW_CONSOLE or { creation flags }
                        IDLE_PRIORITY_CLASS,     // BELOW_NORMAL_PRIORITY_CLASS
                        nil, { pointer to new environment block }
                        nil, { pointer to current directory name }
                        StartupInfo, { pointer to STARTUPINFO }
                        ProcessInfo) { pointer to PROCESS_INF }
   then
   begin
        Result := DWORD(-1) { failed, GetLastError has error code }
   end
   else
   begin
      Waitfor(ProcessInfo.hProcess);
      GetExitCodeProcess(ProcessInfo.hProcess, Result);
      CloseHandle( ProcessInfo.hProcess );
      CloseHandle( ProcessInfo.hThread );
   end; { Else }
end; { WinExecAndWait32V2 }




// Open a document with an associated program
// Eg:  How to edit an ini file (assuming assoicated with notepad.exe
// ExecuteAssociatedFile(mIniFile, '', '', SW_SHOW);
function ExecuteAssociatedFile(const FileName, Params, DefaultDir:string; ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
     Result := ShellExecute(0, //Application.MainForm.Handle,
                            nil,
                            StrPCopy(zFileName, FileName),
                            StrPCopy(zParams, Params),
                            StrPCopy(zDir, DefaultDir),
                            ShowCmd);
                            (* For ShowCmd...
                            [in] Flags that specify how an application is to be displayed when it is opened. If lpFile specifies a document file, the flag is simply passed to the associated application. It is up to the application to decide how to handle it.
                            SW_HIDE
                            Hides the window and activates another window.
                            SW_MAXIMIZE
                            Maximizes the specified window.
                            SW_MINIMIZE
                            Minimizes the specified window and activates the next top-level window in the z-order.
                            SW_RESTORE
                            Activates and displays the window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when restoring a minimized window.
                            SW_SHOW
                            Activates the window and displays it in its current size and position.
                            SW_SHOWDEFAULT
                            Sets the show state based on the SW_ flag specified in the STARTUPINFO structure passed to the CreateProcess function by the program that started the application. An application should call ShowWindow with this flag to set the initial show state of its main window.
                            SW_SHOWMAXIMIZED
                            Activates the window and displays it as a maximized window.
                            SW_SHOWMINIMIZED
                            Activates the window and displays it as a minimized window.
                            SW_SHOWMINNOACTIVE
                            Displays the window as a minimized window. The active window remains active.
                            SW_SHOWNA
                            Displays the window in its current state. The active window remains active.
                            SW_SHOWNOACTIVATE
                            Displays a window in its most recent size and position. The active window remains active.
                            SW_SHOWNORMAL
                            Activates and displays a window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when displaying the window for the first time.
                            *)

end;  // ExecuteAssociatedFile


// Select a directory
function FileSelectDirectory(pDir: String): String;
const
  SELDIRHELP = 1000;
var
   mDir: String;
begin
     result := '';
     mDir := pDir;
     if SelectDirectory(mDir, [sdAllowCreate, sdPerformCreate, sdPrompt],SELDIRHELP) then
     begin
          result :=  mDir;
     end;
end;


// Find a directory size
function DirectorySize(const sPath: TFileName): Int64;
var
  rFind: TSearchRec;
  iSize: Int64;
begin
  Result := 0;
  if SysUtils.FindFirst(IncludeTrailingPathDelimiter(sPath) + '*', faAnyFile, rFind) = 0 then
  begin
    try
      repeat
        if rFind.Name <> StringOfChar('.', Length(rFind.Name)) then
        begin
          if (rFind.Attr and faDirectory) = faDirectory then
            Result := Result + DirectorySize(IncludeTrailingPathDelimiter(sPath) + rFind.Name)
          else
          begin
            iSize := (Int64(rFind.FindData.nFileSizeHigh) shl 32) or rFind.FindData.nFileSizeLow;
            Result := Result + iSize;
          end;
        end;
      until
        SysUtils.FindNext(rFind) <> 0;
    finally
      SysUtils.FindClose(rFind);
    end;
  end;
end;


// Directory Scan Recursion
// ========================
// How to implement
(*
            var
               mFileName: String;

               mCount,
               mLoop: integer;
            begin
                 ScanDirMask('*.Wav');
                 ScanDirectories(pDirectory);
                 // ... or ScanDirectory
                 ScanDirTop;

                 // build the file list
                 GlobFileItems.Clear;
                 for mLoop := 0 to ScanDirCount - 1 do
                 begin
                      mFileName := ScanDirFetchNext;
                      GlobFileItems.Add(mFileName);
                 end;
            end;
*)
// scans directory for files - puts them in the listbox
// Path does not have final backslash
// -- Include sub directories
procedure ScanDirectories(pPath: String);
begin
     // Reset the results
     gScanDirRecurseResults.Clear;
     gScanDirRecurseFoundFile := false;
     gScanDirPosition := 0;
     gScanDirCount    := 0;
     gScanDirSub      := True;
     gScanDirDirsOnly := False;
     // Run the search
     ScanDirRecurse(pPath);
end;  // ScanDirectories


// Scan just the directory
procedure ScanDirectory(pPath: String);
begin
     // Reset the results
     gScanDirRecurseResults.Clear;
     gScanDirRecurseFoundFile := false;
     gScanDirPosition := 0;
     gScanDirCount    := 0;
     gScanDirSub      := False;
     gScanDirDirsOnly := False;
     // Run the search
     ScanDirRecurse(pPath);
end;  // ScanDirectories


// Scan the directory for a list of first Sub Directories
procedure ScanListSubDirectories(pPath: String);
begin
     // Reset the results
     gScanDirRecurseResults.Clear;
     gScanDirRecurseFoundFile := false;
     gScanDirPosition := 0;
     gScanDirCount    := 0;
     gScanDirSub      := False;
     gScanDirDirsOnly := True;
     // Run the search
     ScanDirRecurse(pPath);
end;  // ScanDirectories


// Do the work of recursing according to the parameters above
procedure ScanDirRecurse(pPath: String);
const
   mSuccess : integer = 0;
var
   mExt1,
   mExt2,
   mFile,
   mDir: String;

   mRes: Integer;
   mF : TSearchRec;
begin

     mDir := IncludeTrailingPathDelimiter(pPath) + '*.*';
     mRes := FindFirst(mDir, faDirectory, mF);
     if mRes = 0 then
     begin
          repeat // until FindNext(f) <> Success
              if gScanDirDirsOnly then
              begin
                   // Scan for first level subdirectories only
                   if (mF.Attr and faDirectory) <> 0 then
                   begin
                        // If not this or parent directory
                        if (mF.Name[1] <> '.') then
                        begin
                             // Include the directoy name
                             mFile := IncludeTrailingPathDelimiter(pPath) + mF.Name;
                             gScanDirRecurseResults.Add(mFile);
                             // Add to the total
                             inc(gScanDirCount);
                        end; // if fname not .. or .
                   end; // and if mF.attr=fadirectory

              end
              else
              begin
                   // Scan for files only
                   gScanDirRecurseFoundFile := (mF.Name = pPath);
                   if (mF.Name[1] <> '.') then // not this or parent directory
                   begin
                        // See if we should add this file
                        mFile := IncludeTrailingPathDelimiter(pPath) + mF.Name;
                        mExt1 := Copy(gScanDirRecurseMask,Pos('.',gScanDirRecurseMask),9999);
                        mExt2 := Copy(mFile,Length(mFile)-Length(mExt1)+1,9999);

                        // Added the gScanDirRecurseMask check on Febuary 26 / 2008
                        if (UpperCase(mExt1) = UpperCase(mExt2)) or
                           (gScanDirRecurseMask = '*.*') then   // if *.*, then it was for everything
                        begin
                             // VB Added in 2006/02/13-11:43:41
                             // -- Account for a wider mask
                             // -- I blew it tho.. need to compare just the file 2006/06/07 (check mFile to mF.Name)
                             if MatchesMask(mF.Name, gScanDirRecurseMask) then
                             begin
                                  gScanDirRecurseResults.Add(mFile);
                                  // Add to the total
                                  inc(gScanDirCount);
                             end;
                        end;
                   end;

                   if (mF.Attr and faDirectory) <> 0 then
                   begin
                        // If not this or parent directory
                        if (mF.Name[1] <> '.') then
                        begin
                             if gScanDirSub then
                             begin
                                  // recurses all sub-directories
                                  ScanDirRecurse(IncludeTrailingPathDelimiter(pPath) + mF.Name);
                             end;
                        end; // if fname not .. or .
                   end; // and if mF.attr=fadirectory
              end;
          until (FindNext(mF) <> mSuccess) or gScanDirRecurseFoundFile;

          // Sysutils overrides the Windows FindClose routine
          Sysutils.FindClose(mF);
     end;  //if findfirst etc
end; // ScanDirRecurse


procedure ScanDirMask(pMask: String);
begin
     gScanDirRecurseMask := pMask;
end; // ScanDirMask

procedure ScanDirTop;
begin
     gScanDirPosition := 0;
end; // ScanDirTop

function ScanDirCount: Integer;
begin
     result := gScanDirCount;
end;

function ScanDirFetchNext: String;
begin
     result := gScanDirRecurseResults[gScanDirPosition];
     inc(gScanDirPosition);
     if gScanDirPosition > gScanDirCount then
     begin
          result := '';
          gScanDirPosition := gScanDirCount;
     end;
end;


procedure PropertiesDialogShow(pFileName, pParameters: string; pHandle: THandle);
var
  ExecuteInfo: TShellExecuteInfo;
begin
    // Uses ShellAPI
    with ExecuteInfo do
    begin
      FillChar(ExecuteInfo, SizeOf(ExecuteInfo), 0);
      cbSize := sizeof(TShellExecuteInfo);
      fMask  := SEE_MASK_INVOKEIDLIST;
      Wnd    := pHandle;
      lpVerb := 'Properties'; //nil;
      lpFile := PChar(pFileName);
      lpParameters := PChar(pParameters);
      lpDirectory  := nil;
      nShow := 0;
    end;
    ShellExecuteEx(@ExecuteInfo);
end;

//////////////////// Shared Folder Work /////////////////////////


function AddSharedDirectory(pPathToShare, pShareName, pShareRemark: String; pMaxUsers: Integer; var pVarRemoteSharePath: String): Boolean;
var
   mTest: Integer;
   mComputer,
   mPassword,
   mFileName : String;
   mPermissions: DWord;
begin
     result               := False;
     pVarRemoteSharePath  := '';

     mComputer    := GetComputerNameStr;
     mPassword    := '';

     { Values for permissions (find consts elsewhere if needed)
     ACCESS_READ
      Permission to read data from a resource and,
      by default, to execute the resource.
     ACCESS_WRITE
      Permission to write data to the resource.
     ACCESS_CREATE
      Permission to create an instance of the resource
      (such as a file); data can be written to the resource
      as the resource is created.
     ACCESS_EXEC
      Permission to execute the resource.
     ACCESS_DELETE
      Permission to delete the resource.
     ACCESS_ATRIB
      Permission to modify the resource's attributes
      (such as the date and time when a file was last modified).
     ACCESS_PERM
      Permission to modify the permissions
      (read, write, create, execute, and delete)
      assigned to a resource for a user or application.
     ACCESS_ALL
      Permission to read, write, create, execute, and delete
      resources, and to modify their attributes and permissions.
     }
     {
       - shi50f_RdOnly:    read-only access.
       - shi50f_Full:      read-only and read-write access.
       - shi50f_DependsOn: access depends on password.
       - shi50f_Persist:   share restored on system startup.
       - shi50f_System:    share not normally visible.
     }

     mPermissions := shi50f_RdOnly;  // Not likely to work in many environments

     // shi2_permissions structure member will
     // be ignored on a server running
     // user-level security
     // @@@
     // So, instead we need to set a global security descriptor
     // Google: TSecurity_Descriptor (serious work here)

     //mFileName := ExpandUNCFilename('C:\SharedDirectory');
     mFileName := ConvertLocalUNCFileIDToLocalFileID(pPathToShare);

     // Create the local directory to share
     if DirectoryExists(mFileName) then
     begin
          // ... and share it with 10 uesrs (-1 = max)
          mTest := CreateShare(mComputer,
                               pShareName,
                               pShareRemark,
                               mFileName,
                               pMaxUsers,  // -1 = Maximum users
                               stDisk,
                               mPassword,
                               mPermissions);
          if mTest = 0 then
          begin
               result := True;
               pVarRemoteSharePath := '\\'+mComputer+'\'+pShareName;
          end;
     end;
end; // AddSharedDirectory


function NetShareAdd;   external 'NETAPI32.DLL';
function NetShareDel;   external 'NETAPI32.DLL';


function CreateShare(machineW, netName, comment, path : Widestring;
      MaxConnections: DWord; Sharetype :TShareTypes; passwd: String;
      permissions: DWord ): DWord;
var
   share : SHARE_INFO_502;
begin
     FillShareInfo(share, netName, comment, path,
                   MaxConnections, ShareType,
                   passwd, permissions);
     result:= NetShareAdd(PWideChar(machineW),502,@share,nil);
     if result <> 0 then RaiseWin32Error(result);
end;


procedure FillShareInfo(var share : SHARE_INFO_502; netName, comment,
   path : Widestring; MaxConnections: DWord; FShareType : TShareTypes;
   passwd: String; permissions: DWord);
begin
     // Fill the SHARE_INFO_502 with our settings }
     FillChar(share,SizeOf(SHARE_INFO_502),0);
     share.shi502_netname:= PWideChar(netName);
     case FShareType of
       stDisk       : share.shi502_type:= STYPE_DISKTREE;
       stPrintQueue : share.shi502_type:= STYPE_PRINTQ;
       stCommDevice : share.shi502_type:= STYPE_DEVICE;
       stIPC        : share.shi502_type:= STYPE_IPC;
     end;
     share.shi502_type        := share.shi502_type or 0;
     share.shi502_remark      := PWideChar(comment);
     share.shi502_max_uses    := MaxConnections;
     share.shi502_path        := PWideChar(path);
     share.shi502_passwd      := PChar(passwd);
     share.shi502_permissions := permissions;
end;


// EWin32Error is deprecated, and has been replaced by EOSError
procedure RaiseWin32Error(errorCode : DWord);
var
   error : EOSError;
begin
     if errorCode <> 0 then
     begin
       error:= EOSError.CreateResFmt(@SWin32Error,[errorCode,SysErrorMessage(errorCode)]);
       error.ErrorCode:= errorCode;
       raise error;
     end;
end;


function ConvertLocalUNCFileIDToLocalFileID(sLocalUNCFileID: string): string;
var
  n             : integer;
  s,
  sShareName,
  sPath,
  sRemark,
  sRWPassword,
  sROPassword   : string;
begin
     Result := sLocalUNCFileID;

     // does it start with "\\"?
     if not (length(sLocalUNCFileID) < 4) or (copy(sLocalUNCFileID,1,2) <> '\\') then
     begin
          // work with a copy
          s := sLocalUNCFileID;

          // delete the "\\"
          delete(s,1,2);

          // find the next "\"
          n := pos('\',s);
          if n < 2 then
            exit;

          // make sure the server portion of the file ID is our local computer
          if CompareText(copy(s,1,n-1),GetComputerNameStr) <> 0 then
            exit;

          // delete the computer name portion
          delete(s,1,n);

          // find the trailing backslash, if any -- it is legal to pass "\\dan\vol1"
          n := pos('\',s);
          if n < 1 then
            n := length(s)+1;

          // pull out the share name
          sShareName := copy(s,1,n-1);

          // and remove it from the string
          delete(s,1,n);

          // using this share name, get the local path if possible
          if (GetLocalShareInfo(sShareName,sPath,sRemark,sRWPassword,sROPassword))
              and (sPath <> '') then
          begin
               // return the local drive letter plus the file ID
               Result := sPath+s;
          end;
     end;
end; // ConvertLocalUNCFileIDToLocalFileID


function GetComputerNameStr: shortstring;
var
   dwSize : dword;
begin
     dwSize := sizeof(Result)-2;
     GetComputerName(@Result[1],dwSize);
     Result[0] := char(dwSize);
end; // GetComputerNameStr


function GetLocalShareInfo(sLocalShareName: string; var sPath,sRemark,sRWPassword,sROPassword: string) : boolean;
begin
    Result := WNTGetShareInfo(sLocalShareName,sPath,sRemark,sRWPassword,sROPassword)
end; // ConvertLocalUNCFileIDToLocalFileID


function WNTGetShareInfo(sLocalShareName: string; var sPath,sRemark,sRWPassword,sROPassword: string): boolean;
var
   shi2               : share_info_2;
   pShi2              : pshare_info_2;
   hModule            : THandle;
   NetShareGetInfo    : TNetShareGetInfo_NETAPI32;
   bUnicodeShare,
   bUnicodePath,
   bUnicodeRemark,
   bUnicodeRWPassword : pwidechar;
begin
     bUnicodeShare := nil;
     bUnicodePath := nil;
     hModule := 0;
     Result := false;
     try
       // allocate storage for unicode (double-byte) string
       bUnicodeShare := GlobalAllocPtr(GHND,(length(sLocalShareName)*2)+2);
       if bUnicodeShare = nil then
         raise Exception.Create('Out of memory');
       bUnicodePath := GlobalAllocPtr(GHND,(256*2)*3);
       bUnicodeRemark := bUnicodePath + 512;
       bUnicodeRWPassword := bUnicodeRemark + 512;

       // Convert sharename to Unicode
       sLocalShareName := UpperCase(sLocalShareName);
       MultiByteToWideChar(CP_ACP,MB_ERR_INVALID_CHARS,
                           pchar(sLocalShareName),length(sLocalShareName),
                           bUnicodeShare,(length(sLocalShareName)*2)+2);

       fillchar(shi2,sizeof(shi2),0);
       shi2.shi2_netname := bUnicodeShare;
       shi2.shi2_remark := bUnicodeRemark;
       shi2.shi2_passwd := bUnicodeRWPassword;
       shi2.shi2_path := bUnicodePath;
       sROPassword := '';

       hModule := LoadLibrary('NETAPI32.DLL');
       if hModule = 0 then
         raise Exception.Create('Could not LoadLibrary(''NETAPI32.DLL'')');

       @NetShareGetInfo := GetProcAddress(hModule,'NetShareGetInfo');
       if not Assigned(NetShareGetInfo) then
         raise Exception.Create('Could not GetProcAddress(''NetShareGetInfo'' in NETAPI32.DLL');
       if NetShareGetInfo(nil,bUnicodeShare,2,shi2) = 0 then
       begin
         {This is weird...the netname member points to SHARE_INFO_2 instead of a
          name as expected. By casting a pointer, the whole thing works}
         SetLength(sRemark,128);
         SetLength(sPath,256);
         SetLength(sRWPassword,24);
         pShi2 := pshare_info_2(shi2.shi2_netname);
         WideCharToMultiByte(CP_ACP,WC_COMPOSITECHECK,
                             pShi2^.shi2_remark,-1,
                             pchar(sRemark),length(sRemark),
                             nil,nil);
         WideCharToMultiByte(CP_ACP,WC_COMPOSITECHECK,
                             pShi2^.shi2_path,-1,
                             pchar(sPath),length(sPath),
                             nil,nil);
         WideCharToMultiByte(CP_ACP,WC_COMPOSITECHECK,
                             pShi2^.shi2_passwd,-1,
                             pchar(sRWPassword),length(sRWPassword),
                             nil,nil);
         Result := true;
       end;
     finally
       if hModule <> 0 then
         FreeLibrary(hModule);
       if bUnicodeShare <> nil then
         GlobalFreePtr(bUnicodeShare);
       if bUnicodePath <> nil then
         GlobalFreePtr(bUnicodePath);
     end; {try..finally}
end; // WNTGetShareInfo

function ReadFileSize(pFileName: String): Int64;
var
   //FindData: TWin32FindData;
   //hFind: THandle;
   F3              : File Of Byte;
   mFileSize       : Int64;
begin
  (*
     // Open the file for read access
     // @@@ NOTE: Delphi says that this function should not be used
     mFileHandle := FileOpen(pFileName, fmOpenRead);
     // Get the file's size
     mFileSize := GetFileSize(mFileHandle, @mErrCode);
     FileClose(mFileHandle);
     if mErrCode = 0 then
     begin
          result := mFileSize;
     end
     else
     begin
          // Failed to get the size of the file, return -1
          result := -1;
     end;
  *)

  (* // This will read up to 4GB files
    Result := -1;
    hFind := FindFirstFile(PChar(pFileName), FindData);
    if hFind <> INVALID_HANDLE_VALUE then
    begin
      Windows.FindClose(hFind);
      if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
        Result := FindData.nFileSizeLow;
    end;
  *)

     {$I-}
     AssignFile(F3, pFileName);
     FileMode := 0;  // Set file access to read only
     Reset(F3);
     mFileSize := FileSize(F3);
     CloseFile(F3);
     {$I+}

     result := mFileSize;


end;


// Read the first few bytes
function BinaryFileRead(pFileName: String; pLen: Integer): String;
var
   mLoop  : Integer;
   mChars : String;
   mByte  : Byte;
   F3     : File of Byte;
begin
     mChars := '';
     {$I-}
     AssignFile(F3, pFileName);
     FileMode := 0;  // Set file access to read only
     Reset(F3);
     for mLoop := 1 to pLen do
     begin
          Read(F3,mByte);
          mChars := mChars + Chr(mByte);
     end;
     CloseFile(F3);
     {$I+}

     Result := mChars;
end;

// Write a SystemHealth entry for the NetHub Program
// pFileName         = 'DataLoad'
// pTitle            = 'File Transfer'
// pInfo             = 'Loaded 12 recorded';
// pMinsForGreen     = 30
// pMinsForOrange    = 60

// Write a "System Reports" entry as follows
//   File Contents  1........2....3..4
//   eg:  echo File Transfer~Info~10~30 >> FileTransfer.Rep
//   Where
//   1: Title on System Health
//   2: Information (eg: Number of records etc
//   3: Display as Green if FileAge (of rep) is 10 minutes or less
//   4: Display as Orange if FileAge (of rep) is 30 minutes or less
//      -- Otherwise, display Red
procedure WriteSystemHealthEntry(pExeFileName, pTitle, pInfo: String; pMinsForGreen, pMinsForOrange: Integer);
var
   mLogDir           : String;
   mRecord           : String;
   mFileName         : String;
   Registry          : TRegistry;
   mMemo             : TStringList;
begin
     // Start with the local file location
     mLogDir  := '\';

     Registry := TRegistry.Create;
     mMemo    := TStringList.Create;
     try
        // Now, see if we can hit some info in the reg
        Registry.RootKey:=HKEY_LOCAL_MACHINE;
        // First try TeleFlow Server
        try
           //if Registry.OpenKey(cTFServerEntry,False) then
           //begin
           //     mLogDir   := Registry.ReadString(cTSServerDir    );
           //end;

           // Try NetHub
           if Registry.OpenKey(cTFNetHubEntry,False) then
           begin
                try
                   mLogDir    := Registry.ReadString (cTFNetHubWebDir );
                except
                end;
           end;
        except
           mLogDir  := '\';
        end;


        // Create the REP file
        mFileName := IncludeTrailingPathDelimiter( mLogDir )+ ChangeFileExt(pExeFileName, '.Rep');
        // Build the record
        mRecord := pTitle+'~'+pInfo+'~'+IntToStr(pMinsForGreen)+'~'+IntToStr(pMinsForOrange);
        with mMemo do
        begin
             Clear;
             Add(mRecord);
             mMemo.SaveToFile(mFileName);
        end;


        // Create the XML file
        mFileName := IncludeTrailingPathDelimiter( mLogDir )+ ChangeFileExt(pExeFileName, '_rss.xml');
        // Build the record
        mRecord :=  '<systemhealth title='+DoubleQuoteWrap(pTitle)+' reportdate='+DoubleQuoteWrap(GetNowAsTeleFlowDate)+' reporttime='+DoubleQuoteWrap(GetNowAsTeleFlowTime)+'>'+cCrLf+
                    '   <program>'+pExeFileName+'</program>'+cCrLf+
                    iff(pInfo <> '', '   <info>'+pInfo+'</info>'+cCrLf,'')+
                    '   <mins maxfor="Green">'+IntToStr(pMinsForGreen)+'</mins>'+cCrLf+
                    '   <mins maxfor="Orange">'+IntToStr(pMinsForOrange)+'</mins>'+cCrLf+
                    '   <mins minfor="Red">'+IntToStr(pMinsForOrange)+'</mins>'+cCrLf+
                    '   <currentcolor>%COLOR%</currentcolor>'+cCrLf+
                    '   <status>%STATUS%</status>'+cCrLf+
                    '</systemhealth>';
        with mMemo do
        begin
             Clear;
             Add(mRecord);
             mMemo.SaveToFile(mFileName);
        end;


     finally
        mMemo.Free;
        Registry.Free;
     end;
end;


// Write a SystemHealth entry for the NetHub Program
// - This entry is specifically for exceptions (store in XML)
procedure WriteSystemHealthEntryExceptionInfo(pExeFileName, pTitle, pLastLog, pErrorInfo: String);
var
   mLogDir           : String;
   mRecord           : String;
   mFileName         : String;
   Registry          : TRegistry;
   mMemo             : TStringList;
begin
     // Start with the local file location
     mLogDir  := '\';

     Registry := TRegistry.Create;
     mMemo    := TStringList.Create;
     try
        // Now, see if we can hit some info in the reg
        Registry.RootKey:=HKEY_LOCAL_MACHINE;
        // First try TeleFlow Server
        try
           //if Registry.OpenKey(cTFServerEntry,False) then
           //begin
           //     mLogDir   := Registry.ReadString(cTSServerDir    );
           //end;

           // Try NetHub
           if Registry.OpenKey(cTFNetHubEntry,False) then
           begin
                try
                   mLogDir    := Registry.ReadString (cTFNetHubWebDir );
                except
                end;
           end;
        except
           mLogDir  := '\';
        end;


        // Create the XML file
        mFileName := IncludeTrailingPathDelimiter( mLogDir )+ ChangeFileExt(pExeFileName, '_error_rss.xml');
        // Build the record
        mRecord :=  '<systemhealthexception title='+DoubleQuoteWrap(pTitle)+' date='+DoubleQuoteWrap(GetNowAsTeleFlowDate)+' time='+DoubleQuoteWrap(GetNowAsTeleFlowTime)+'>'+cCrLf+
                    '   <program>'+pExeFileName+'</program>'+cCrLf+
                    '   <lastlog>'+pLastLog+'</lastlog>'+cCrLf+
                    '   <error>'+pErrorInfo+'</error>'+cCrLf+
                    '</systemhealthexception>';
        with mMemo do
        begin
             Clear;
             // ADD to the error log
             if FileExists(mFileName) then
             begin
                  try
                     mMemo.LoadFromFile(mFileName);
                  except
                  end;

                  // Trim back if we have too much stuff loading up.
                  while true do
                  begin
                       if mMemo.Count > 100 then
                       begin
                            while (Pos('<systemhealth', mMemo[0]) = 0) and
                                  (mMemo.Count > 10) do
                            begin
                                 // Knock off line at the top
                                 mMemo.Delete(0);
                            end;
                       end
                       else
                       begin
                           break;
                       end;
                  end;

             end;

             // Add new entry
             Add(mRecord);
             mMemo.SaveToFile(mFileName);
        end;


     finally
        mMemo.Free;
        Registry.Free;
     end;
end; //  WriteSystemHealthEntryExceptionInfo


// Read all SystemHealth RSS entries into an aggregate
// - This entry is specifically for exceptions (store in XML)
function CreateSystemHealthRSSXML: TStringList;
var
   mLogDir           : String;
   mRecord           : String;
   mFileName         : String;
   Registry          : TRegistry;
   mMemo             : TStringList;
   mXMLFile          : TStringList;

   // Scan for *_rss.xml
   mLoop             : integer;

   // Date and time stuff
   mDate             : String;
   mTime             : String;
   mField            : String;
   mMinsDif          : Integer;

   mColor            : String;
   mStatus           : String;
   mGreen            : Integer;
   mOrange           : Integer;

begin
     // First, create the TStringList
     Result := TStringList.Create;


     // Start with the local file location
     mLogDir  := '\';

     Registry := TRegistry.Create;
     mMemo    := TStringList.Create;
     mXMLFile := TStringList.Create;

     // Start the Feed off
     mMemo.Add('<?xml version="1.0" encoding="ISO-8859-1" ?>');
     //mMemo.Add('<?xml-stylesheet title="XSL_formatting" type="text/xsl" href="nolsol.xsl"?>
     mMemo.Add('<rss version="2.0"><channel>');

     try
        // Now, see if we can hit some info in the reg
        Registry.RootKey:=HKEY_LOCAL_MACHINE;
        // First try TeleFlow Server
        try
           //if Registry.OpenKey(cTFServerEntry,False) then
           //begin
           //     mLogDir   := Registry.ReadString(cTSServerDir    );
           //end;

           // Try NetHub
           if Registry.OpenKey(cTFNetHubEntry,False) then
           begin
                try
                   mLogDir    := Registry.ReadString (cTFNetHubWebDir );
                except
                end;
           end;
        except
           mLogDir  := '\';
        end;

        // Read through all the entires and pull togther a list of RSS XML files


        // SYSTEM HEALTHS FIRST
        ScanDirMask('*_rss.xml');
        ScanDirectory(mLogDir);
        // ... or ScanDirectory
        ScanDirTop;
        // build the file list
        for mLoop := 0 to ScanDirCount - 1 do
        begin
             mFileName := ScanDirFetchNext;
             mXMLFile.LoadFromFile(mFileName);
             mMemo.Add(' ');
             mMemo.Add('<item>');
             mMemo.AddStrings(mXMLFile);
             mMemo.Add('</item>');
        end;

        // SYSTEM EXCEPTIONS NEXT
        ScanDirMask('*error_rss.xml');
        ScanDirectory(mLogDir);
        // ... or ScanDirectory
        ScanDirTop;
        // build the file list
        for mLoop := 0 to ScanDirCount - 1 do
        begin
             mFileName := ScanDirFetchNext;
             mXMLFile.LoadFromFile(mFileName);
             mMemo.Add(' ');
             mMemo.Add('<item>');
             mMemo.AddStrings(mXMLFile);
             mMemo.Add('</item>');
        end;

        // End it off
        mMemo.Add(' ');
        mMemo.Add('</channel>');
        mMemo.Add('</rss>');


        ///////////////////////
        // Now, go through and replace variables
        ///////////////////////


        // Last date and time is what we do the math with
        mDate    := '';
        mTime    := '';
        mGreen   := -1;
        mOrange  := -1;
        mMinsDif := 0;

        // Now, loop through it.
        // - Update the values to the correct number
        for mLoop := 0 to mMemo.Count -1 do
        begin
             mRecord := mMemo[mLoop];
             begin
                  // Are we reading a header
                  if Pos('<systemhealth', mRecord) > 0 then
                  begin
                       mField := XMLGetAttributeValue('reportdate', mRecord);
                       if mField <> '' then
                       begin
                            // Get ready to do time math
                            mDate := mField;
                            mTime := XMLGetAttributeValue('reporttime', mRecord);

                            // Create time
                            // minutesold  = round( (Now - DateTime) * 1440 )
                            mMinsDif := Abs(Round((Now - GetDateTimeFromTFDateandTFTime(mDate,mTime)) * 1440));
                       end;
                  end;

                  // Doing this quickly.... without full checks.
                  if Pos('"Green"', mRecord) > 0 then
                  begin
                       // eg: <mins maxfor="Green">10</mins>
                       //                        ">  </
                       mField  := RecordParseIsolateBetween(mRecord, '">', '</');
                       mGreen  := StrToIntDef(mField, -1);
                  end;
                  if Pos('"Orange"', mRecord) > 0 then
                  begin
                       // eg: <mins maxfor="Orange">20</mins>
                       //                         ">  </
                       mField  := RecordParseIsolateBetween(mRecord, '">', '</');
                       mOrange := StrToIntDef(mField, -1);
                  end;

                  // See if we have a replacement to make
                  if (Pos('%COLOR%', mRecord) > 0) or
                     (Pos('%STATUS%', mRecord) > 0) then
                  begin
                       mColor  := 'Black';
                       mStatus := 'UNKNOWN';

                       // Remember, we are always going on last values red :S
                       if (mGreen > 0) and (mOrange > 0) then
                       begin
                            if (mMinsDif <= mGreen) then
                            begin
                                 mColor  := 'Green';
                                 mStatus := 'NOMINAL';
                            end
                            else if (mMinsDif <= mOrange) then
                            begin
                                 mColor  := 'Orange';
                                 mStatus := 'WARNING';
                            end
                            else
                            begin
                                 mColor  := 'Red';
                                 mStatus := 'ALARM';
                            end;
                       end;

                       // Update the record with the new values
                       mRecord := StringReplace(mRecord, '%COLOR%',  mColor, []);
                       mRecord := StringReplace(mRecord, '%STATUS%', mStatus, []);
                       // Add an attribute for age
                       mRecord := StringReplace(mRecord, '<status>', '<status agemins="'+IntToStr(mMinsDif)+'">', []);
                  end;
             end;

             // Add to result
             // Add the files to the
             result.Add(mRecord);
        end; // Loop
     finally
        mMemo.Free;
        mXMLFile.Free;
        Registry.Free;
     end;

end; // CreateSystemHealthRSSXML


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// Initialization  (MUST BE AT END OF CODE, before finalization)
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

initialization

begin
     gScanDirRecurseResults := TStringList.Create;
     gScanDirRecurseMask    := '*.Wav';
end;


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// finalization  (MUST BE AT END OF CODE)
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

finalization

begin
     gScanDirRecurseResults.Free;
end;

end.
