unit InstallWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  InstallWorkUnit in 'InstallWorkUnit.pas';
*)

// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! SoundWorkUnit must be in the USES section for each unit

interface

uses
  ShellAPI,Messages,SysUtils,Classes,Windows,
  ShlObj, ActiveX, Registry, ComObj
  ;

    function CreateDeskTopLink(pFileName, pTitle: String): String;
    function CreateStartMenuLink(pFileName, pFolder, pTitle: String): String;

const
   // NetHub
   apNetHubRegEntry           = 'SOFTWARE\enGenic\TFNetHub';
   apNetHubServerRegEntry     = apNetHubRegEntry +'\Server';
   apNetHubFTPRegEntry        = apNetHubRegEntry +'\FTP';
   apNetHubCreditRegEntry     = apNetHubRegEntry +'\Credit';
   apNetHubSMSRegEntry        = apNetHubRegEntry +'\SMS';
   apNetHubOffChatRegEntry    = apNetHubRegEntry +'\OffChat';


implementation


// Create a link on the DeskTop
function CreateDeskTopLink(pFileName, pTitle: String): String;
var
   MyObject  : IUnknown;
   MySLink   : IShellLink;
   MyPFile   : IPersistFile;
   FileName  : String;
   Directory : String;
   WFileName : WideString;
   MyReg     : TRegIniFile;
begin
     result   := '';
     MyObject := CreateComObject(CLSID_ShellLink);
     MySLink  := MyObject as IShellLink;
     MyPFile  := MyObject as IPersistFile;
     FileName := pFileName; // eg 'C:\WINDOWS\MREntryScreen.exe';

     with MySLink do
     begin
          SetPath(PChar(FileName));
          SetWorkingDirectory(PChar(ExtractFilePath(FileName)));
     end;

     MyReg     := TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');
     try
        Directory := MyReg.ReadString('Shell Folders','Desktop','');
        WFileName := Directory+'\'+pTitle+'.lnk';
        result    := WFileName;

        MyPFile.Save(PWChar(WFileName),False);
     finally
        MyReg.Free;
     end;
end; // CreateDeskTopLink



// Create start menu link
function CreateStartMenuLink(pFileName, pFolder, pTitle: String): String;
var
   MyObject  : IUnknown;
   MySLink   : IShellLink;
   MyPFile   : IPersistFile;
   FileName  : String;
   Directory : String;
   WFileName : WideString;
   MyReg     : TRegIniFile;
begin
     result   := '';
     MyObject := CreateComObject(CLSID_ShellLink);

     MySLink  := MyObject as IShellLink;
     MyPFile  := MyObject as IPersistFile;
     FileName := pFileName;

     with MySLink do
     begin
          SetPath(PChar(FileName));
          SetWorkingDirectory(PChar(ExtractFilePath(FileName)));
     end;

     MyReg     := TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');
     try
        Directory := MyReg.ReadString('Shell Folders','Start Menu','')+'\Programs\'+pFolder;
        CreateDir(Directory);

        WFileName := Directory+'\'+pTitle+'.lnk';
        result    := WFileName;

        MyPFile.Save(PWChar(WFileName),False);
     finally
        MyReg.Free;
     end;
end; //  CreateStartMenuLink



end.