// NetHub Commands Processor
(*

WARNING:  Inserting this Code will mess with your ability to set up Events from Components

This code:

//////////////////////////////////////////////
// Commands Processor Start
//////////////////////////////////////////////
{ (string)I  NetHubCommandsProcessor.pas}


Goes in after "implementation" but, before "{$R *.dfm}"


*)


const
   // Header system for TF commands
   cTFHeader           = '/&~';   // This is at the start of the TFCommands
   // Note: http includes: http://127.0.0.1:5048/&
   //       tcp  is ~TFLog etc
   //                     Command             //     Remote program method
   // HTTP or TCP
   // ===========
   // -- Log to daily log file
   cTFLog              = 'TFLog';             // [_] http://127.0.0.1:5048/&~TFLog~Program.exe~1.0.0.123~UserName~ComputerName~Ip~Code...
   // -- Interact with array
   cTFPut              = 'TFPut';             // [_] http://127.0.0.1:5048/&~TFPut~1001~A8888~~Header|Rec|Rec|Rec|...|Rec
   cTFPutWait          = 'TFPutWait';         // [_] http://127.0.0.1:5048/&~TFPutWait~1001~A8888~100000~Header|Rec|Rec|Rec|...|Rec
   cTFPutXML           = 'TFPutXML';          // [_] http://127.0.0.1:5048/data/<?xml version='1.0' encoding='utf-8'?><REQUEST action='Add'>...
   cTFGet              = 'TFGet';             // [_] http://127.0.0.1:5048/&~TFGet
   cTFGetReadOnly      = 'TFGetReadOnly';     // [_] http://127.0.0.1:5048/&~TFGetReadOnly
   cTFGetXML           = 'TFGetXML';          // [_] http://127.0.0.1:5048/&~TFGetXML
   cTFPush             = 'TFPush';            // [_] http://127.0.0.1:5048/&~TFPush~1001~A8888~umbriel:80~Header|Rec|Rec|Rec|...|Rec
   cTFAnswer           = 'TFAnswer';          // [_] http://127.0.0.1:5048/&~TFPut~1001~A8888~20060301204327356~Data
   cTFKill             = 'TFKill';            // [_] http://127.0.0.1:5048/&~TFKill~1001~A8888
   cTFKillAll          = 'TFKillAll';         // [_] http://127.0.0.1:5048/&~TFKillAll
   // -- TeleFlow application information
   cTFEvent            = 'TFEvent';           // [_] http://127.0.0.1:5048/&~TFEvent~TFApp~6046396391~Var1~Var2...
   // -- Email
   cTFEmail            = 'TFEmail';           // [_] http://127.0.0.1:5048/&~TFEmail~ (( See documentation ))
   cTFEmailTemplate    = 'TFEmailTemplate';   // [_] http://127.0.0.1:5048/&~TFEmailTemplate~mail.engenic.com~25~0~engenic01@engenic.com~~vbaker@engenic.com~vbaker@engenic.com~tdavis@engenic.com~jcoulter@engenic.com~IMPORTANT:%20MedicalRelay%20Login%20Instructions~Email.html~0~No~~3037,s33cd332~
   // -- Chat
   cTFMessenger        = 'TFMessenger';       // [_]
   cTFCreditCard       = 'TFCreditCard';      // [_]
   // -- EXE version numbers
   cTFProgVersion      = 'TFProgVersion';     // [_] http://127.0.0.1:5048/&~TFProgVersion~Program.exe
   // -- Information about nethub and the computer
   cTFNetHubVersion    = 'TFNetHubVersion';   // [_] http://127.0.0.1:5048/&~TFNetHubVersion
   cTFNetHubOperations = 'TFNetHubOperations';// [_] http://127.0.0.1:5048/&~TFNetHubOperations
   cTFNetHubPing       = 'TFNetHubPing';      // [_] http://127.0.0.1:5048/&~TFNetHubPing
   cTFSystemHealth     = 'TFSystemHealth';    // [_] http://127.0.0.1:5048/&~TFSystemHealth
   // -- Get location for downloads (use to override current NetHub, go to teleflowrelay.com etc)
   cTFDownloadHost     = 'TFDownloadHost';    // [_] http://127.0.0.1:5048/&~TFDownloadHost
   // -- Processes
   cTFProcessStart     = 'TFProcessStart';    // [_] http://127.0.0.1:5048/&~TFProcessStart~Program.Exe~Parm1~Parm2... (( Returns Process ID, -1 = Program not found ))
   cTFProcessEnd       = 'TFProcessEnd';      // [_] http://127.0.0.1:5048/&~TFProcessEnd~4321  (( Process Id ))
   cTFProcessBreak     = 'TFProcessBreak';    // [_] http://127.0.0.1:5048/&~TFProcessBreak~4321  (( Process Id ))
   // HTTP only
   // =========
   // -- File transfer
   cTFReceiveFile      = 'TFReceiveFile';     // [_]
   cTFSendFile         = 'TFSendFile';        // [_] http://127.0.0.1:5048/&~TFSendFile~FileName.Wav
   cTFSendScreenCap    = 'TFSendScreenCap';   // [_] http://127.0.0.1:5048/&~TFSendScreenCap~Program.exe~UserName~ComputerName


   (*
   cTFLog              =  Logs an event for later review by other programs
   cTFPut              =  Puts an entry on the command list for a system and/or client
   cTFPutXML
   cTFPutWait          =  Puts an entry on the command list, and waits for a response
   cTFGet              =  Reads and pops commands for system and/or client
   cTFGetReadOnly      =  Read all and returns as an HTML list, but does not remove entries
   cTFGetXML
   cTFPush             =  Puts an entry on one NetHub to push to a remote NetHub
   cTFAnswer           =  Internal Only: Response to a TFPutWait
   cTFKill             =  Kills Specific lists
   cTFKillAll          =  Kills All Commands
   cTFEvent            =  Places an event to the Queue
   cTFEmail            =  Creates an email entry to send through NetHub
   cTFMessenger        =  Messenger Communiciations
   cTFCreditCard       =  Credit Card processing
   cTFProgVersion      =  Get the version and build (1.1.5.423) of a program
   cTFReceiveFile      =  Download (stream) a file to NetHub
   cTFSendFile         =  Upload (stream) a file to NetHub
   cTFNetHubVersion    =  Provide the version of the installed nethub
   cTFNetHubOperations =  Provide information about when nethub started, and what it is doing
   cTFNetHubPing       =  Ping for the existance of a NetHub
   cTFProcessStart     =  Start a program and recieve its PID
   cTFProcessEnd       =  End a program (PID)
   cTFProcessBreak     =  Sends a CTRL_BREAK_EVENT to a program (PID)
   *)

   // Process Codes
   cTFTaskCompleted    = '~TFTaskCompleted~';      // Run as a general success statement
   cTFResponse         = '~TFResponse~';           // A general response indicating success
   cTFReady            = '~TFReady~';              // Ready for a new action
   cTFNothing          = '~TFNothingToProcess~';   // Nothing to Get
   cTFPutAccepted      = '~TFPutAccepted~';        // Put was accepted
   cTFPutXMLAccepted   = 'XMLAccepted';
   cTFPushAccepted     = '~TFPushAccepted~';       // Push was accepted on remote NetHub
   cTFPushFailed       = '~TFPushFailed~';         // Push failed to be accepted on remote NetHub
   cTFPutWaitTimeOut   = '~TFPutWaitTimeOut~';     // PutWait did not receive a response before timeout (TFAnswer remains behind)
   cTFNetHubShutdown   = '~TFNetHubShutdown~';     // NetHub is being shutdown.
   cTFHTTPOnly         = '~TFHTTPOnly~';           // Command only available in HTTP

   // Record structure of &~TF commands
   cTFCommCommand      = 2;
   cTFCommSystem       = 3;  // System and/or file
   cTFCommFile         = 3;  // System and/or file
   cTFCommClient       = 4;
   cTFCommData         = 5;  // For Push (IP)
   // Return codes
   cTFCommReceive      = 6;  // Get ready to receive file
   cTFCommScreenCap    = 7;  // Get ready to receive screencapture
   cTFCommProcessStart = 8;  // Start a process
   cTFCommProcessEnd   = 9;  // End a process
   cTFCommProcessBreak = 10; // Break a process


   // Internal messages
   cTFCommSuccess      = 1;
   cTFCommErrOverRide  = -1;  // Override
   cTFCommErrNoth2     = -2;  // Nothing to read
   cTFCommErrNoth3     = -3;  // Nothing to read
   cTFCommErrHTTPOnly  = -4;  // Only HTTP may provide service
   cTFCommErrEMAIL     = -5;  // Error with email send
   cTFCommErrFile      = -6;  // File not found

   // Command Maximum size
   cURLCommMaxSize     = 9999;
   // Body Maximum size
   cRespBodyMaxSize    = 9999;

(*
This is assuming local host, but could just as easily be umbriel:80
 
Set up three browsers, and populate the addresses respectively with:

   http://127.0.0.1:5048/&~TFPutWait~1001~A8888~100000~Header|Rec|Rec|Rec|...|Rec
   http://127.0.0.1:5048/&~TFGet~
   http://127.0.0.1:5048/&~TFPut~1001~A8888~
 

Run the first address.  It will wait 100000 ms before timing out.  Pretend this is TeleFlow Server


Run the second browser address.  It will return the following (but with a different timestamp):
 
   000001~2006/03/01-19:38:28~GUID~127.0.0.1~!~TFPut~1001~A8888~20060301193828259~Header|Rec|Rec|Rec|...|Rec
 

Copy the TimeStamp (eg: 20060301193828259) to the end of the third browser's address, and add custom text.  eg:
 
   http://127.0.0.1:5048/&~TFPut~1001~A8888~20060301193828259~ResultsFromMedical
   
 
Now look at the first address again.  It waited for a response, and provided it as soon as 
you pressed go on the last browser. 

   000001~2006/03/01-19:39:16~GUID~127.0.0.1~!~TFAnswer~1001~A8888~20060301193828259~ResultsFromMedical


The text: "ResultsFromMedical" can now be processed

*)


/////////////////////////////////////////////////////
////  start COMMANDS
/////////////////////////////////////////////////////

// Create an entry with published data (Put & PutWait)
function GlobPublishCommandsWrite(pCommandIP, pCommandText, pCommandType: String; var pLine: String): Integer;
var
   mLine      : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}
     try
        // Default to reject
        result := 0;
        pLine  := '';

        // Format
        // - Must not be larger than 9999 bytes
        //
        // Date,Time,Guid,IP,Type: Data
        if Length(pCommandText) <= cRespBodyMaxSize then
        begin
             //Accepted
             // - Note: Use the ! (bang) to break the header from the records
             mLine  := '~GUID~'+pCommandIP+'~!'+pCommandText;
             //GlobPublishCommands.Add(TeleFlowTimeStamp + mLine);
             GlobPublishCommands.Add(GetYYYYMMDDHHNNSSZZZ + mLine);
             pLine  := mLine;
             result := GlobPublishCommands.Count;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishWrite


// Read the entry - Provide for a Get
// [_] - Add code to allow only Get access by some IP addresses
function GlobPublishRead(pCommandIP, pSystem, pClientCode: String; pXML: Boolean): String;
const
   cHeaderFields = 3;
   cCrLf         = #10#13;
var
   mRow         : Integer;
   mLine        : String;
   mBuildResult : String;
   mReadCommand : String;
   mReadSystem  : String;
   mReadClient  : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}

     try
        result := '';
        if pCommandIP = cTFGetReadOnly then
        begin
             result := LogHTMLStart;
        end;


        mRow   := 0;

        // Only respond if we have somethign to do
        if GlobPublishCommands.Count > 0 then
        begin
             while mRow <= (GlobPublishCommands.Count - 1)  do
             begin
                  // Get the line (start from the top) - FIFO
                  mLine        := GlobPublishCommands[mRow];

                  // XML or TF Command mode
                  if pXML then
                  begin
                       // Return the line, put the line number that we picked it from
                       // NOTE: - We cannot return '?'s in the GET method.
                       //       - Convert them
                       //result := StringReplace(mLine,'?','+', [rfReplaceAll]);
                       //result := Copy(mLine, Pos('?>',mLine)+2, 99999);

                       result := RecordParseCustomDelimiter(mLine, '!', 2);

                      // Remove the line .. next will take current mRows place
                       GlobPublishCommands.Delete(mRow);

                       // We got it.
                       break;
                  end
                  else
                  begin
                       mReadCommand := RecordParseCustomDelimiter(mLine, '~', cTFCommCommand + cHeaderFields);
                       mReadSystem  := RecordParseCustomDelimiter(mLine, '~', cTFCommSystem + cHeaderFields);
                       mReadClient  := RecordParseCustomDelimiter(mLine, '~', cTFCommClient + cHeaderFields);

                       // Puts only
                       if mReadCommand = cTFPut then
                       begin
                            // Allow system to grab a line if the requests match
                            if (mReadSystem = pSystem) or
                               (pSystem = '') then
                            begin
                                 if (mReadClient = pClientCode) or
                                    (pClientCode = '') then
                                 begin
                                      mBuildResult := RightCopy('000000'+IntToStr(GlobPublishCommands.Count),6)+'~'+mLine;
                                      if pCommandIP = cTFGet then
                                      begin
                                           // Return the line, put the line number that we picked it from
                                           result := mBuildResult;

                                          // Remove the line .. next will take current mRows place
                                           GlobPublishCommands.Delete(mRow);

                                           // We got it.
                                           break;
                                      end
                                      else
                                      begin
                                           // Build up the list of results
                                           // - No deleting, or breaking
                                           result := result + mBuildResult + '<BR>';
                                      end;
                                 end;
                            end;
                       end;
                  end;

                  // Next row
                  inc(mRow);
             end;
        end;

        if pCommandIP = cTFGetReadOnly then
        begin
             result := result + LogHTMLEnd;
        end;

     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishRead


// Read the entry - Provide for a Get
// [_] - Add code to allow only Get access by some IP addresses
function GlobPublishKill(pSystem, pClientCode: String): String;
const
   cHeaderFields = 3;
var
   mRow         : Integer;
   mLine        : String;
   mReadCommand : String;
   mReadSystem  : String;
   mReadClient  : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}

     try
        result := '';
        mRow   := 0;

        // Only respond if we have somethign to do
        if GlobPublishCommands.Count > 0 then
        begin
             while mRow <= (GlobPublishCommands.Count - 1)  do
             begin
                  // Get the line (start from the top) - FIFO
                  mLine        := GlobPublishCommands[mRow];

                  mReadCommand := RecordParseCustomDelimiter(mLine, '~', cTFCommCommand + cHeaderFields);
                  mReadSystem  := RecordParseCustomDelimiter(mLine, '~', cTFCommSystem + cHeaderFields);
                  mReadClient  := RecordParseCustomDelimiter(mLine, '~', cTFCommClient + cHeaderFields);

                  // Allow system to grab a line if the requests match
                  if (mReadSystem = pSystem) or
                     (pSystem = '') then
                  begin
                       if (mReadClient = pClientCode) or
                          (pClientCode = '') then
                       begin
                            // Return the line, put the line number that we picked it from
                            result := RightCopy('000000'+IntToStr(GlobPublishCommands.Count),6)+'~'+mLine;

                            // Remove the line .. next will take current mRows place
                            GlobPublishCommands.Delete(mRow);
                       end
                       else
                       begin
                            // Next row
                            inc(mRow);
                       end;
                  end
                  else
                  begin
                       // Next row
                       inc(mRow);
                  end;

             end;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishKill


// Expire PutWaits that were not processed
function GlobPublishExpirePutWait(pUniqueId: String): String;
const
   cHeaderFields = 3;
var
   mRow         : Integer;
   mLine        : String;
   mReadCommand : String;
   mReadSystem  : String;
   mReadClient  : String;
   mReadData    : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}

     try
        result := '';
        mRow   := 0;

        // Only respond if we have somethign to do
        if GlobPublishCommands.Count > 0 then
        begin
             while mRow <= (GlobPublishCommands.Count - 1)  do
             begin
                  // Get the line (start from the top) - FIFO
                  mLine        := GlobPublishCommands[mRow];

                  mReadCommand := RecordParseCustomDelimiter(mLine, '~', cTFCommCommand + cHeaderFields);
                  mReadSystem  := RecordParseCustomDelimiter(mLine, '~', cTFCommSystem + cHeaderFields);
                  mReadClient  := RecordParseCustomDelimiter(mLine, '~', cTFCommClient + cHeaderFields);
                  mReadData    := RecordParseCustomDelimiter(mLine, '~', cTFCommData  + cHeaderFields);

                  // Allow system to grab a line if the requests match
                  if (mReadData = pUniqueId) then
                  begin
                       // Return the line, put the line number that we picked it from
                       result := RightCopy('000000'+IntToStr(GlobPublishCommands.Count),6)+'~'+mLine;

                       // Remove the line .. next will take current mRows place
                       GlobPublishCommands.Delete(mRow);
                       // There will only be one
                       Break;
                  end
                  else
                  begin
                       // Next row
                       inc(mRow);
                  end;
             end;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishExpirePutWait


// Read the entry - Provide for a Get
// [_] - Add code to allow only Get access by some IP addresses
function GlobPublishReadAnswer(pId: String): String;
const
   cHeaderFields = 3;
var
   mRow         : Integer;
   mLine        : String;
   mReadCommand : String;
   mReadSystem  : String;
   mReadClient  : String;
   mReadData    : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}
     try
        result := '';
        mRow   := 0;

        // Only respond if we have somethign to do
        if GlobPublishCommands.Count > 0 then
        begin
             while mRow <= (GlobPublishCommands.Count - 1)  do
             begin
                  // Get the line (start from the top) - FIFO
                  mLine        := GlobPublishCommands[mRow];

                  mReadCommand := RecordParseCustomDelimiter(mLine, '~', cTFCommCommand + cHeaderFields);
                  mReadSystem  := RecordParseCustomDelimiter(mLine, '~', cTFCommSystem  + cHeaderFields);
                  mReadClient  := RecordParseCustomDelimiter(mLine, '~', cTFCommClient  + cHeaderFields);
                  mReadData    := RecordParseCustomDelimiter(mLine, '~', cTFCommData    + cHeaderFields);


                  // Puts only
                  if mReadCommand = cTFAnswer then
                  begin
                       // Allow system to grab a line if the requests match
                       if (mReadData = pId) then
                       begin
                            // Return the line, put the line number that we picked it from
                            result := RightCopy('000000'+IntToStr(GlobPublishCommands.Count),6)+'~'+mLine;

                            // Remove the first line
                            GlobPublishCommands.Delete(mRow);

                            // We got it.
                            break;
                       end;
                  end;

                  // Next row
                  inc(mRow);
             end;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishRead

/////////////////////////////////////////////////////
////  end COMMANDS
/////////////////////////////////////////////////////


/////////////////////////////////////////////////////
////  start EVENTS
/////////////////////////////////////////////////////

// Create an entry with published data (Put & PutWait)
function GlobPublishEventsWrite(pCommandIP, pCommandText, pCommandType: String; var pLine: String): Integer;
var
   mLine      : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}
     try
        // Default to reject
        result := 0;
        pLine  := '';

        // Format
        // - Must not be larger than 9999 bytes
        //
        // Date,Time,Guid,IP,Type: Data
        if Length(pCommandText) <= cRespBodyMaxSize then
        begin
             //Accepted
             // - Note: Use the ! (bang) to break the header from the records
             mLine  := '~GUID~'+pCommandIP+'~!'+pCommandText;
             GlobPublishEvents.Add(GetYYYYMMDDHHNNSSZZZ + mLine);
             pLine  := mLine;
             result := GlobPublishEvents.Count;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;
end; // GlobPublishEvents


// Expire events after a certain age
function GlobPublishEventsExpire(pAgeMins: Integer): Integer;
const
   cHeaderFields = 3;
var
   mRow         : Integer;
   mCount       : Integer;
   mDateLine    : String;
   mDateExpire  : String;
begin
     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}

     mCount := 0;
     mRow   := 0;
     try

        // Check to see if enough time has passed before doing latest expire
        // -- Only do every 5 minutes
        if FormatDateTime('yyyymmddhhnnsszzz', (Now - (5 / 1440))) > GlobPublishEventsLastExpire then
        begin
             // Mark that we have done a clean up
             GlobPublishEventsLastExpire := GetYYYYMMDDHHNNSSZZZ;

             // Only respond if we have somethign to do
             if GlobPublishEvents.Count > 0 then
             begin
                  while mRow <= (GlobPublishEvents.Count - 1)  do
                  begin
                       // Get the line (start from the top) - FIFO
                       mDateLine    := Copy(GlobPublishEvents[mRow],1,Length('yyyymmddhhnnsszzz'));
                       // YYYYMMDDHHNNSSZZZ
                       mDateExpire  := FormatDateTime('yyyymmddhhnnsszzz', (Now - (pAgeMins / 1440)));

                       if mDateExpire > mDateLine then
                       begin
                            // Remove the line .. next will take current mRows place
                            GlobPublishEvents.Delete(mRow);
                            inc(mCount);
                       end
                       else
                       begin
                            inc(mRow);
                       end;
                  end;
             end;
        end;
     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}
     end;

     result := mCount;
end; // GlobPublishExpireEvents

/////////////////////////////////////////////////////
////  end EVENTS
/////////////////////////////////////////////////////


// Get a file using HTTP
function GlobGetFile(pURL, pCommand: String; var pVarHeader: String): String;
var
   idHttp                : TIdHTTP;
   mDataStream           : TMemoryStream;
   mLine                 : String;
   // These two separated by a !
   mHeader               : String;
   mBody                 : String;
   mURLRequest           : String;
   mIP                   : String;
   mFind                 : Integer;
   mText                 : TStringList;
begin
     result := '';

     // Define variables
     mText       := TStringList.Create;
     mDataStream := TMemoryStream.Create;
     try
        // First line only
        mURLRequest  :=  pURL+'/&~'+pCommand;

        // Submit as a request, and recieve response
        idHttp := TIdHTTP.Create(nil);
        try
          idHttp.Get(mURLRequest, mDataStream);
        finally
          idHttp.Free;
        end;

        // Save the file
        mDataStream.Position := 0;
        mText.Clear;
        mText.LoadFromStream(mDataStream);


        // Populate the
        mLine      := mText[0];
        mFind      := Pos('!', mLine);
        mHeader    := Copy(mLine,1,mFind -1);
        mBody      := Copy(mLine,mFind +1, cRespBodyMaxSize);

        //Prepend result with the IP  which is 1,4 !,~
        mIP := RecordParseCustomDelimiter(RecordParseCustomDelimiter(mLine, '~', 4),'!',1);

        // Return the basic values
        result     := '~'+mIP +mBody;

     finally
        mDataStream.Free;
        mText.Free;
     end;

end; // GetFileByHTTP


// Request using HTTP
function GetHTTPRequest(pURL, pCommand: String): String;
var
   idHttp                : TIdHTTP;
   mDataStream           : TMemoryStream;
   mURLRequest           : String;
   mText                 : TStringList;
begin
     result := '';

     // Define variables
     mText       := TStringList.Create;
     mDataStream := TMemoryStream.Create;
     try
        // First line only
        mURLRequest  :=  pURL+'/&'+pCommand;


        // Submit as a request, and recieve response
        idHttp := TIdHTTP.Create(nil);
        try
          idHttp.Get(mURLRequest, mDataStream);
        finally
          idHttp.Free;
        end;

        // Save the file
        mDataStream.Position := 0;
        mText.Clear;
        mText.LoadFromStream(mDataStream);


        (* Old way
        mLine      := mText[0];
        mFind      := Pos('!', mLine);
        mHeader    := Copy(mLine,1,mFind -1);
        mBody      := Copy(mLine,mFind +1, cRespBodyMaxSize);

        //Prepend result with the IP  which is 1,4 !,~
        mIP := RecordParseCustomDelimiter(RecordParseCustomDelimiter(mLine, '~', 4),'!',1);
        *)

        // Return the basic values stored in the first line
        result     := mText[0]; //'~'+mIP +mBody;

     finally
        mDataStream.Free;
        mText.Free;
     end;

end; // GetHTTPRequest


// Send
function GlobSendEmail(pMailServerOut           : String;
                       pMailServerPortOut,
                       pAuthenticationType      : Integer;
                       pAccountUser,
                       pAccPassword,
                       pEmailSender,
                       pEmailRecipients,
                       pEmailCCs,
                       pEmailBccs,
                       pEmailSubject,
                       pEmailBody               : String;
                       pEmailPriority           : Integer;
                       pEmailReceipt            : Boolean;
                       pEmailAttachment         : String): String;
var
   SMTP       : TIdSMTP;
   IdMsgSend  : TIdMessage;
   IdAttach   : TIdAttachmentFile;
begin
     result    := ''; // Assume successful email send

     SMTP      := TIdSMTP.Create(nil);
     IdMsgSend := TIdMessage.Create(nil);
     try
        // Populate all of the necessary fields for the email send

        // authentication settings
        case pAuthenticationType of
        0: SMTP.AuthType := atNone;
        1: SMTP.AuthType := atDefault; // (was atLogin) Simple Login
        end;

        // General setup
        SMTP.Host      := pMailServerOut;
        SMTP.Port      := pMailServerPortOut;
        // Email account setup
        SMTP.Username  := pAccountUser;
        SMTP.Password  := pAccPassword;


        with IdMsgSend do
        begin
             Body.Clear;
             Body.Add(pEmailBody);
             From.Text                 := pEmailSender;
             Recipients.EMailAddresses := pEmailRecipients;                   // To: header
             CCList.EMailAddresses     := pEmailCCs;                          // CC
             BccList.EMailAddresses    := pEmailBccs;                         // BBC
             Subject                   := pEmailSubject;                      // Subject: header
             // mpHighest, mpHigh, mpNormal, mpLow, mpLowest / 0 through 4
             Priority                  := TIdMessagePriority(pEmailPriority); // Message Priority
             if pEmailReceipt then
             begin
                  // Set receipt recipient to From E-Mail address
                  ReceiptRecipient.Text := From.Text;
             end
             else
             begin
                  // Indicate there is no receipt recipiant
                  ReceiptRecipient.Text := '';
             end;
        end;

        // Attachments
        if fileexists(pEmailAttachment) then
        begin
             //TIdAttachment.Create(IdMsgSend.MessageParts); //, @@@@ pEmailAttachment);
             IdAttach := TIdAttachmentFile.Create(IdMsgSend.MessageParts, pEmailAttachment);
        end;


        // Send the message
        try
           try
              SMTP.Connect; // Connect(1000) as an option;
              SMTP.Send(IdMsgSend);
           except
              on E:Exception do
              begin
                   result := 'ERROR00: '+E.Message +' ('+ IntToStr(E.HelpContext)+')';
              end;
           end;
        finally
           if SMTP.Connected then
           begin
                SMTP.Disconnect;
           end;
        end;


     finally
         SMTP.Free;
         IdMsgSend.Free;
         if Assigned(IdAttach) then
         begin
              IdAttach.Free;
         end;
     end;
end; // GlobSendEmail



// Send an Email
function GlobSendEmailTemplate(pMailServerOut           : String;
                               pMailServerPortOut,
                               pAuthenticationType      : Integer;
                               pAccountUser,
                               pAccPassword,
                               pEmailSender,
                               pEmailRecipients,
                               pEmailCCs,
                               pEmailBccs,
                               pEmailSubject,
                               pEmailTemplateFile       : String;
                               pEmailPriority           : Integer;
                               pEmailReceipt            : Boolean;
                               pEmailAttachment,
                               pEmailParams             : String): String;
var
   html                : TStrings;
   htmpart, txtpart    : TIdText;
   bmppart             : TIdAttachmentFile;

   mFilename           : string;
   mEmailTemplate      : string;
   mSuccess            : Boolean;
   mDebug              : String;

   SMTP       : TIdSMTP;
   IdMsgSend  : TIdMessage;
   IdAttach   : TIdAttachmentFile;
begin
     result    := ''; // Assume successful email send

     html      := TStringList.Create();
     SMTP      := TIdSMTP.Create(nil);
     IdMsgSend := TIdMessage.Create(nil);
     try
        // Populate all of the necessary fields for the email send

        // authentication settings
        case pAuthenticationType of
        0: SMTP.AuthType := atNone;
        1: SMTP.AuthType := atDefault; //atLogin; // Simple Login
        end;

        // General setup
        SMTP.Host      := pMailServerOut;
        SMTP.Port      := pMailServerPortOut;
        // Email account setup
        SMTP.Username  := pAccountUser;
        SMTP.Password  := pAccPassword;

        // Templatefile
        mEmailTemplate := IncludeTrailingPathDelimiter(Glob_Reg_VMSDir)+
                          IncludeTrailingPathDelimiter(apOfficeTemplatesEmail)+
                          pEmailTemplateFile;

        // Check that the file exists
        if FileExists(mEmailTemplate) then
        begin
             html.LoadFromFile(mEmailTemplate);


             // Now, populate the parameters
             html :=
             BuildStringListWithParameters(html,
                                           pEmailParams,
                                           mSuccess);

             // Build the HTML Message
             htmpart := TIdText.Create(IdMsgSend.MessageParts, nil);
             htmpart.Body.AddStrings(html);
             htmpart.ContentType                       := 'text/html';


             // Attached Gif
             mFilename := ChangeFileExt( mEmailTemplate  , '.gif');
             if FileExists(mFileName) then
             begin
                  bmppart := TIdAttachmentFile.Create(IdMsgSend.MessageParts, mFilename);
                  bmppart.ContentID      := '12345';
                  bmppart.ContentType    := 'image/gif';
                  bmppart.FileName       := extractfilename(mFilename);
             end;

             // Attached Jpg
             mFilename := ChangeFileExt( mEmailTemplate  , '.jpg');
             if FileExists(mFileName) then
             begin
                  bmppart := TIdAttachmentFile.Create(IdMsgSend.MessageParts, mFilename);
                  bmppart.ContentID      := '67890';
                  bmppart.ContentType    := 'image/jpeg';
                  bmppart.FileName       := extractfilename(mFilename);
             end;


             // Build the message
             with IdMsgSend do
             begin
                  //ContentType          := 'text/plain';
                  //ContentType          := 'multipart/mixed';
                  //ContentType          := 'multipart/alternative';
                  ContentType := 'multipart/related; type="text/html"';   // if includes graphics

                  From.Text                 := pEmailSender;
                  Recipients.EMailAddresses := pEmailRecipients;                   // To: header
                  CCList.EMailAddresses     := pEmailCCs;                          // CC
                  BccList.EMailAddresses    := pEmailBccs;                         // BBC
                  Subject                   := pEmailSubject;                      // Subject: header
                  // mpHighest, mpHigh, mpNormal, mpLow, mpLowest / 0 through 4
                  Priority                  := TIdMessagePriority(pEmailPriority); // Message Priority
                  if pEmailReceipt then
                  begin
                       // Set receipt recipient to From E-Mail address
                       ReceiptRecipient.Text := From.Text;
                  end
                  else
                  begin
                       // Indicate there is no receipt recipiant
                       ReceiptRecipient.Text := '';
                  end;
             end;


             // Attachments
             if fileexists(pEmailAttachment) then
             begin
                  //TIdAttachment.Create(IdMsgSend.MessageParts); // @@@@, pEmailAttachment);
                  IdAttach := TIdAttachmentFile.Create(IdMsgSend.MessageParts, pEmailAttachment);
             end;

             // Send the message
             try
                try
                   mDebug := 'Connect';
                   SMTP.Connect; // Connect(1000) as an option;
                   mDebug := 'Send';
                   SMTP.Send(IdMsgSend);
                except
                   on E:Exception do
                   begin
                        //result := 'ERROR: ' + E.Message;
                        result := 'ERROR00'+mDebug+': '+E.Message +' ('+ IntToStr(E.HelpContext)+')';
                   end;
                end;
             finally
                if SMTP.Connected then
                begin
                     SMTP.Disconnect;
                end;
             end;
        end
        else
        begin
             // We are missing an important file
             result := 'ERROR01: TemplateMissing: '+mEmailTemplate;
        end;

     finally
         SMTP.Free;
         IdMsgSend.Free;
         if Assigned(IdAttach) then
         begin
              IdAttach.Free;
         end;

         html.Free();
     end;
end; // GlobSendEmailTemplate


// Find data from executables to update
// -- GlobPublishExeVersions holds the data for the program executables...
// Field 1: Program.exe
// Field 2: Timestamp
// Field 3: Version & Build (1.1.3.432)
// -- Results = N/A  or  ERROR  or  1.2.3.432  (for example)
function GetProgramFileVersion(pFileExe: String): String;
var
   mLoop      : Integer;
   mProg      : String;
   mLine      : String;
   mPath1     : String;
   mPath2     : String;
   mFind      : Integer;

   mTimeStamp : String;
   mDT        : TDatetime;
   mVersion   : String;

   mField1    : String;
   mField2    : String;
   mField3    : String;

   mResult    : String;
   mFV        : TrsFileVersion;
begin
     mResult  := 'N/A';
     result   := mResult;

     // If not screen mode, then lock
     {$ifndef SCREENMODE}
     ConsoleLock.Acquire;
     {$endif}


     mFV := TrsFileVersion.Create;
     try
        // Default to reject
        mProg   := UpperCase(pFileExe);

        mField1 := '';
        mField2 := '';
        mField3 := '';
        mFind   := -1;

        // Format
        // - Must be an EXE only
        if ExtractFileExt(mProg) = '.EXE' then
        begin
             try
                mResult := 'C001';

                // See if we have loaded it yet
                // ----------------------------
                for mLoop := 0 to GlobPublishExeVersions.Count - 1 do
                begin
                     mLine    := GlobPublishExeVersions[mLoop];
                     mField1  := RecordParseCustomDelimiter(mLine,'~',1);
                     if mField1 = mProg then
                     begin
                          // We have an instance
                          mField1 := RecordParseCustomDelimiter(mLine,'~',1);  // Program
                          mField2 := RecordParseCustomDelimiter(mLine,'~',2);  // DateTime
                          mField3 := RecordParseCustomDelimiter(mLine,'~',3);  // Version

                          // Found it, next
                          mFind   := mLoop;
                          break;
                     end;
                end;

                mResult := 'C002-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind);

                // Does the file exist?
                // ---------------------
                mPath1 := IncludeTrailingPathDelimiter(Glob_Reg_VMSDir)+
                          IncludeTrailingPathDelimiter('updates')      + mProg;
                mPath2 := IncludeTrailingPathDelimiter(Glob_Reg_VMSDir)+ mProg;
                if FileExists(mPath1) then
                begin
                     // Good
                end
                else
                if FileExists(mPath2) then
                begin
                     // Rename file
                     mPath1 := mPath2
                end
                else
                begin
                     // Not Found
                     mPath1 := '';
                end;

                mResult := 'C003-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;

                // If we have a file there
                // -----------------------
                if mPath1 <> '' then
                begin
                     // Get the age
                     mDT := FileAge(mPath1);
                     mTimestamp := FormatDateTime('yyyymmddhhnnsszzz', mDT);

                     mResult := 'C004-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;


                     // If we found it, lets process
                     if mFind > -1 then
                     begin
                          // Is it newer?
                          if mTimestamp > mField2 then
                          begin

                               mResult := 'C005-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;

                               // Get the version information from the exe
                               if mFV.GetFileVersion(mPath1) then
                               begin
                                   //Version.Text  := FV.Version;
                                   mVersion         := IntToStr(mFV.Major)    +'.'+
                                                       IntToStr(mFV.Minor)    +'.'+
                                                       IntToStr(mFV.Release)  +'.'+
                                                       IntToStr(mFV.Build);
                               end;

                               // Replace the entry
                               GlobPublishExeVersions.Delete(mFind);
                               // Add to end
                               GlobPublishExeVersions.Add(mProg +'~'+ mTimestamp +'~'+ mVersion);

                               mResult := 'C006-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;

                               // Give the version
                               mResult := mVersion;
                          end
                          else
                          begin
                               // Just return the current value
                               mResult := mField3;
                          end;
                     end
                     else
                     begin
                          mResult := 'C007-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;

                          // Get the version information from the exe
                          if mFV.GetFileVersion(mPath1) then
                          begin
                              //Version.Text  := FV.Version;
                              mVersion         := IntToStr(mFV.Major)    +'.'+
                                                  IntToStr(mFV.Minor)    +'.'+
                                                  IntToStr(mFV.Release)  +'.'+
                                                  IntToStr(mFV.Build);
                          end;

                          mResult := 'C008-'+IntToSTr(GlobPublishExeVersions.Count)+'-'+IntToStr(mFind)+'-'+mPath1;


                          // Add the entry
                          GlobPublishExeVersions.Add(mProg +'~'+ mTimestamp +'~'+ mVersion);
                          // Give the version
                          mResult := mVersion;
                     end;
                     

                     // Send back the find result
                     /////////////////////////////
                     result := mResult;
                end;

             except
                result := 'ERROR: '+ mResult;
             end;
        end;

     finally
        {$ifndef SCREENMODE}
        ConsoleLock.Release;
        {$endif}

        mFV.Free;
     end;
end; // GetProgramFileVersion






(*
Put Command on list (eg: ALTAPOINT Client)
[_] - TFPut = Command (TFPut or TFGet)
[_] - 1001 = System (any text)
[_] - A8888 = ClientCode (any text)
[_] - 127.27.1.1 = Additional data (must be blank except for TFPush)

http://127.0.0.1:80/&~TFPut~1001~A8888~~Header|Rec|Rec|Rec|...|Rec

Push environment

http://127.0.0.1:80/&~TFPut~1001~A8888~~Header|Rec|Rec|Rec|...|Rec


Get command from List (eg: TeleFlow Server)
[_] - Must limit what computers can send a TFGet - IP address for example (or internal only)

http://127.0.0.1:80/&~TFGet~1001~A8888   // Will Get the next job for a specific system and client
http://127.0.0.1:80/&~TFGet~1001         // Will get the next job for specific system
http://127.0.0.1:80/&~TFGet              // Will get the next job


*)


// Incoming commands from HTTP requests
// - Allow TFPut and TFGet only
// [_] - Restrict who is allowed to write in here
// - pServType 0 = HTTP, 1 =TCP
function ProcessCommands(pServType: Integer; pCommandIP, pPassedCommands, pVersion: String; var pCommand: Integer): string;
var
   mHeader                : String;
   mTFCmd                 : String;
   mBody                  : String;
   mBodyEmail             : String;
   mCode                  : Integer;
   mPos                   : Integer;
   mSystem                : String;
   mClient                : String;
   mResultCommand         : String;
   mPushNetHubIP          : String;
   mNewCommand            : String;
   mPassedCommands        : String;
   mUniqueId              : String;
   mData                  : String;
   mResult                : String;
   mMBSrvd                : String;
   mMBRcvd                : String;
   mSize                  : Integer;
   mWait                  : Integer;
   mCount                 : Integer;
   mLoop                  : Integer;
   // Email fields
   mMailServerOut         : String;
   mMailServerPortOut,
   mAuthenticationType    : Integer;
   mAccountUser,
   mAccPassword,
   mEmailSender,
   mEmailRecipients,
   mEmailCCs,
   mEmailBccs,
   mEmailSubject,
   mEmailBody             : String;
   mEmailPriority         : Integer;
   mEmailReceipt          : Boolean;
   mEmailAttachment       : String;
   // Email Template additional fields
   mEmailTemplateFile     : String;
   mEmailParams           : String;

   mProcessIt             : Boolean;
begin
     result   := '';   // @@@ No idea why this gives us a warning on Compile
     mCode    := 0;

     try
        // Test the first few values in the record
        // Note: cURLCommMaxSize is used to reconfigure mHeader in later instances

        // There are two types of commands:
        // 1) '~&'

        mHeader    := Copy(pPassedCommands,1,length(cTFHeader));

        mProcessIt := False;

        // If a TF Commands???
        if mHeader = cTFHeader then
        begin
             // Issolate the command
             mTFCmd     := RecordParseCustomDelimiter(pPassedCommands,'~', cTFCommCommand);
             // Get the body of the command
             mBody      := pPassedCommands;
             mProcessIt := True;
        end
        else
        begin
             // Decide if we should make it into one
             // - First 100 chars should be enough to cover the page name
             if (Pos('<?xml', lowercase(Copy(pPassedCommands,1,200))) > 0) then
             begin
                  mTFCmd     := cTFPutXML;
                  mProcessIt := True;
             end;
        end;


        // Lets do some work on this request
        // =================================
        if mProcessIt then
        begin

             // PUT - and receive acceptance message
             // NOTE: Leave as FIRST!!!!
             // <> Manages internal
             if mTFCmd = cTFPut then
             begin
                  // TFPut
                  mData           :=  RecordParseCustomDelimiter(mBody,'~', cTFCommData);
                  if mData = '' then
                  begin
                       result          := cTFPutAccepted;
                       mCode           := GlobPublishCommandsWrite(pCommandIP, pPassedCommands, mTFCmd, mResultCommand);
                  end
                  else
                  // TFPut answer to a TFPutWait
                  begin
                       mPos            := PosOccurance('~',pPassedCommands,5);
                       if mPos > 0 then
                       begin
                            result          := cTFPutAccepted;

                            // Recreate entry as an Answer
                            mSystem         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommSystem);
                            mClient         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommClient);
                            mData           :=  RecordParseCustomDelimiter(mBody,'~', cTFCommData);

                            // Reformat command
                            mNewCommand     :=  '~'+cTFAnswer+'~'+mSystem+'~'+mClient+'~'+mData+'~';

                            // Send it using HTTP
                            mPassedCommands := mNewCommand + Copy(pPassedCommands, mPos+1,cURLCommMaxSize);
                            mCode           := GlobPublishCommandsWrite(pCommandIP, mPassedCommands, cTFAnswer, mResultCommand);
                       end;
                  end;

                  // Also, Log the the log file (Makes it recoverable this way
                  if mCode > 0 then
                  begin
                       // This entry will be logged from the location calling ProcessCommands
                       GlobCommandLogEntry := mTFCmd+':Queued@'+RightCopy('000000'+IntToStr(mCode),6)+': '+ mResultCommand;
                  end;
             end


             // PUT - XML
             else if mTFCmd = cTFPutXML then
             begin
                  result          := cTFPutXMLAccepted;
                  mCode           := GlobPublishCommandsWrite(pCommandIP, pPassedCommands, mTFCmd, mResultCommand);
             end

             
             // PUT - and WAIT for a GET response
             else if mTFCmd = cTFPutWait then
             begin
                  // Do we have a valid entry
                  mPos := PosOccurance('~',pPassedCommands,5);
                  if mPos > 0 then
                  begin
                       result          := cTFPutAccepted;

                       mSystem         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommSystem);
                       mClient         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommClient);
                       mData           :=  RecordParseCustomDelimiter(mBody,'~', cTFCommData);
                       mWait           :=  StrToIntDef(mData, 3000); // Invalid wait to 3000 ms

                       mUniqueId       :=  GetYYYYMMDDHHNNSSZZZ;
                       // Reformat command
                       mNewCommand     :=  '~'+cTFPut+'~'+mSystem+'~'+mClient+'~'+mUniqueId+'~';

                       // Send it using HTTP
                       mPassedCommands := mNewCommand + Copy(pPassedCommands, mPos+1,cURLCommMaxSize);
                       mCode           := GlobPublishCommandsWrite(pCommandIP, mPassedCommands, cTFPut, mResultCommand);

                       // Wait for Answer
                       result         := cTFPutWaitTimeOut;
                       mResultCommand := '';
                       mCount         := (Round(mWait / 50));
                       for mLoop := 1 to mCount do
                       begin
                            // Sleep and test again
                            sleep(50);

                            // The Screen is being shutdown
                            if GlobShuttingDown then
                            begin
                                 mCode  := 1;
                                 result := cTFNetHubShutdown;
                                 Break;
                            end;

                            // Test for response
                            mResultCommand := GlobPublishReadAnswer(mUniqueId);
                            if mResultCommand <> '' then
                            begin
                                 mCode  := 1;
                                 result := mResultCommand;
                                 Break;
                            end;

                       end;


                       // Expire the PutWait from the command if it was not lifted by Get
                       if result = cTFPutWaitTimeOut then
                       begin
                            GlobPublishExpirePutWait(mUniqueId);
                       end;


                       // Also, Log the the log file (Makes it recoverable this way
                       if mResultCommand <> '' then
                       begin
                            // This entry will be logged from the location calling ProcessCommands
                            GlobCommandLogEntry := mTFCmd+':Answered@'+RightCopy('000000'+IntToStr(mCode),6)+': '+ mResultCommand;
                       end;

                  end; // mPos
             end


             // LOG - just a simple log
             else if mTFCmd = cTFLog then
             begin
                  mCode     := cTFCommSuccess;
                  // Write directly to a log
                  result    := Copy(pPassedCommands,1,cURLCommMaxSize);  // Done in the calling program
             end


             // PUSH - and receive acceptance message from remote NetHub
             else if mTFCmd = cTFPush then
             begin
                  result := cTFPushFailed;

                  // Find the Push to Ip address
                  mPushNetHubIP   :=  RecordParseCustomDelimiter(pPassedCommands,'~', cTFCommData);
                  mSystem         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommSystem);
                  mClient         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommClient);
                  // Reformat command
                  mNewCommand     :=  '~'+cTFPut+'~'+mSystem+'~'+mClient+'~'+GetLocalIP+'~';

                  // Add the rest of the record
                  mPos            := Pos(mPushNetHubIP, pPassedCommands);
                  // Send it using HTTP
                  mPassedCommands := mNewCommand + Copy(pPassedCommands,mPos + Length(mPushNetHubIP) + 1,cURLCommMaxSize);
                  mResultCommand  := GetHTTPRequest('http://'+mPushNetHubIP, mPassedCommands);

                  // Did we succeed
                  if mResultCommand = cTFPutAccepted then
                  begin
                       result := cTFPushAccepted;
                       mCode  := 1;  // We had success
                  end;
             end


             // GET - response
             else if (mTFCmd = cTFGet) or (mTFCmd = cTFGetReadOnly) then
             begin
                  result    := cTFNothing;
                  mCode     := cTFCommErrNoth2;  // Nothing to read

                  // Pass paramters to Reader
                  mSystem         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommSystem);
                  mClient         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommClient);

                  mResultCommand  :=  GlobPublishRead(mTFCmd, mSystem, mClient, False);
                  if mResultCommand <> '' then
                  begin
                       // Anything to process?
                       result  := mResultCommand;
                       mCode   :=  cTFCommErrOverRide;  // Override error
                  end;
             end

             // GETXML - response
             else if (mTFCmd = cTFGetXML) then
             begin
                  result    := cTFNothing;
                  mCode     := cTFCommErrNoth2;  // Nothing to read

                  // Pass paramters to Reader
                  mResultCommand  :=  GlobPublishRead('', '', '', True);
                  if mResultCommand <> '' then
                  begin
                       // Anything to process?
                       result  := mResultCommand;
                       mCode   :=  cTFCommErrOverRide;  // Override error
                  end;
             end

             // PROCESSSTART - Start a process
             // [_] http://127.0.0.1:5048/&~TFProcessStart~Program.Exe~Parm1~Parm2...
             else if mTFCmd = cTFProcessStart then
             begin
                  result    := trim(
                               RecordParseCustomDelimiter(mBody,'~', 3)+'~'+  // Program (~) Paramaters
                               RecordParseCustomDelimiter(mBody,'~', 4)+' '+  // ... parameters
                               RecordParseCustomDelimiter(mBody,'~', 5)+' '+
                               RecordParseCustomDelimiter(mBody,'~', 6)+' '+
                               RecordParseCustomDelimiter(mBody,'~', 7)+' '+
                               RecordParseCustomDelimiter(mBody,'~', 8)+' '+
                               RecordParseCustomDelimiter(mBody,'~', 9)
                               );
                  mCode     := cTFCommProcessStart;
             end

             // PROCESSEND - End a process
             // [_] http://127.0.0.1:5048/&~TFProcessEnd~4837
             else if mTFCmd = cTFProcessEnd then
             begin
                  result    := trim(RecordParseCustomDelimiter(mBody,'~', 3));  // PID
                  mCode     := cTFCommProcessEnd;
             end

             // ProcessBreak - Break a process
             // [_] http://127.0.0.1:5048/&~TFProcessBreak~4837
             else if mTFCmd = cTFProcessBreak then
             begin
                  result    := trim(RecordParseCustomDelimiter(mBody,'~', 3));  // PID
                  mCode     := cTFCommProcessBreak;
             end

             // KILL - clear specific entries
             else if mTFCmd = cTFKill then
             begin
                  // Pass paramters to Reader
                  mSystem         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommSystem);
                  mClient         :=  RecordParseCustomDelimiter(mBody,'~', cTFCommClient);

                  // Clears only some
                  GlobPublishKill(mSystem, mClient);
                  result    := cTFTaskCompleted;
                  mCode     := cTFCommSuccess;
             end


             // KILLALL - clear entries
             else if mTFCmd = cTFKillAll then
             begin
                  // Clears the entire list
                  GlobPublishKill('','');
                  result    := cTFTaskCompleted;
                  mCode     := cTFCommSuccess;
             end


             // EVENT - TeleFlow application provides an event
             else if mTFCmd = cTFEvent then
             begin
                  mCode     := GlobPublishEventsWrite(pCommandIP, pPassedCommands, mTFCmd, mResultCommand);
                  result    := cTFResponse;

                  // Do a clean up on occassion
                  GlobPublishEventsExpire(5); //@@@
             end

             // NETHUBPING - says hello to a response
             else if mTFCmd = cTFNetHubPing then
             begin
                  // Response with timestamp.
                  result    := cTFResponse + GetYYYYMMDDHHNNSSZZZ +'~';
                  mCode     := cTFCommSuccess;
             end

             // NETHUBVERSION - What version are we running
             else if mTFCmd = cTFNetHubVersion then
             begin
                  // Clears the entire list
                  result    := '~'+pVersion+'~';
                  mCode     := cTFCommSuccess;
             end

             // NETHUBOPERATIONS - What time did NetHub start
             else if mTFCmd = cTFNetHubOperations then
             begin
                  mSize    := Round(Glob_Bytes_Served   / (1024 * 1024));
                  mMBSrvd  := CommaIntToStr(mSize);
                  mSize    := Round(Glob_Bytes_Received / (1024 * 1024));
                  mMBRcvd  := CommaIntToStr(mSize);

                  // Clears the entire list
                  result    := '~'+pVersion+
                               '~'+FormatDateTime('YYYY/MM/DD',GlobNetHubStartTimeStamp)+
                               '~'+FormatDateTime('hh:nn:ss',GlobNetHubStartTimeStamp)+
                               '~'+mMBSrvd+
                               '~'+mMBRcvd;
                  mCode     := cTFCommSuccess;
             end

             // SYSTEMHEALTH - responds with XML containing system health
             else if mTFCmd = cTFSystemHealth then
             begin
                  // If not screen mode, then lock
                  {$ifndef SCREENMODE}
                  ConsoleLock.Acquire;
                  {$endif}
                  try
                     mSize    := Round(Glob_Bytes_Served   / (1024 * 1024));
                     mMBSrvd  := CommaIntToStr(mSize);
                     mSize    := Round(Glob_Bytes_Received / (1024 * 1024));
                     mMBRcvd  := CommaIntToStr(mSize);

                     // Response with XML generated in NetHubGenerateSystemHealth
                     // - Found in NetHubWorkUnit.pas
                     // >> The HTML Version would be created by Sentinel using NetHub's values
                     // >> This is requested of NetHub directly
                     NetHubGenerateSystemHealth('', '', False,
                                                FormatDateTime('YYYY/MM/DD',GlobNetHubStartTimeStamp),
                                                FormatDateTime('hh:nn:ss',GlobNetHubStartTimeStamp),
                                                mMBSrvd,
                                                mMBRcvd);
                  finally
                     {$ifndef SCREENMODE}
                     ConsoleLock.Release;
                     {$endif}
                  end;


                  result    := GlobHealthInfo;  // Generated above
                  mCode     := cTFCommSuccess;
             end

             // DOWNLOADHOST - Where should we download from?
             else if mTFCmd = cTFDownloadHost then
             begin
                  // Clears the entire list
                  if (Glob_Reg_DL_HTTPHost = '') or (Glob_Reg_DL_HTTPPort = 0) then
                  begin
                       // Default (current nethub)
                       result    := '~N/A~N/A~';
                  end
                  else
                  begin
                       // From the registry
                       result    := '~'+Glob_Reg_DL_HTTPHost+'~'+IntToStr(Glob_Reg_DL_HTTPPort)+'~';
                  end;
                  mCode     := cTFCommSuccess;
             end


             // SENDFILE  (client to NetHub )
             else if mTFCmd = cTFSendFile then
             begin
                  // HTTP only
                  if pServType = 0 then
                  begin
                       // Receive the file name
                       result    := RecordParseCustomDelimiter(pPassedCommands,'~', cTFCommFile);
                       mCode     := cTFCommReceive;

                       // Back in NetHubHTTPProcessor, cTFCommReceive will be checked to see if a file should be saved
                  end
                  else
                  begin
                       // Error
                       result    := cTFHTTPOnly;
                       mCode     := cTFCommErrHTTPOnly;
                  end;
             end

             // SENDSCREENCAP  (client to NetHub )
             else if mTFCmd = cTFSendScreenCap then
             begin
                  // HTTP only
                  if pServType = 0 then
                  begin
                       // Receive a file name
                       // http://127.0.0.1:5048/&~TFSendScreenCap~Program.exe~UserName~ComputerName
                       result    := mTFCmd+'-'+
                                    GetYYYYMMDDHHNNSSZZZ+'-'+
                                    ChangeFileExt(RecordParseCustomDelimiter(mBody,'~', 3),'')+'-'+
                                    RecordParseCustomDelimiter(mBody,'~', 4)+'-'+
                                    RecordParseCustomDelimiter(mBody,'~', 5)+'.png';
                       mCode     := cTFCommScreenCap;
                  end
                  else
                  begin
                       // Error
                       result    := cTFHTTPOnly;
                       mCode     := cTFCommErrHTTPOnly;
                  end;

             end

             // EMAIL
             // [_] - http://127.0.0.1:5048/&~TFEmail~mail.engenic.com~25~0~engenic01@engenic.com~~MedicalRelay~vbaker@engenic.com~tdavis@engenic.com~jcoulter@engenic.com~IMPORTANT: MedicalRelay Login Instructions~Instructions~0~No~~
             else if mTFCmd = cTFEmail then
             begin
                  // Get more for emails
                  mBodyEmail := Copy(pPassedCommands,1,cURLCommMaxSize);

                  mMailServerOut        :=             RecordParseCustomDelimiter(mBodyEmail,'~',3 );
                  mMailServerPortOut    := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',4 ),25);
                  mAuthenticationType   := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',5 ),0);
                  mAccountUser          :=             RecordParseCustomDelimiter(mBodyEmail,'~',6 );
                  mAccPassword          :=             RecordParseCustomDelimiter(mBodyEmail,'~',7 );
                  mEmailSender          :=             RecordParseCustomDelimiter(mBodyEmail,'~',8 );   // Name
                  mEmailRecipients      :=             RecordParseCustomDelimiter(mBodyEmail,'~',9 );   // emails;email
                  mEmailCCs             :=             RecordParseCustomDelimiter(mBodyEmail,'~',10);
                  mEmailBccs            :=             RecordParseCustomDelimiter(mBodyEmail,'~',11);
                  mEmailSubject         :=             RecordParseCustomDelimiter(mBodyEmail,'~',12);
                  mEmailBody            :=             RecordParseCustomDelimiter(mBodyEmail,'~',13);
                  mEmailPriority        := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',14),2);  // 0 = Highest
                  mEmailReceipt         :=  TrueOrYes( RecordParseCustomDelimiter(mBodyEmail,'~',15));
                  mEmailAttachment      :=             RecordParseCustomDelimiter(mBodyEmail,'~',16);

                  // Send an email
                  mResult := GlobSendEmail( mMailServerOut        ,
                                            mMailServerPortOut    ,
                                            mAuthenticationType   ,
                                            mAccountUser          ,
                                            mAccPassword          ,
                                            mEmailSender          ,
                                            mEmailRecipients      ,
                                            mEmailCCs             ,
                                            mEmailBccs            ,
                                            mEmailSubject         ,
                                            mEmailBody            ,
                                            mEmailPriority        ,
                                            mEmailReceipt         ,
                                            mEmailAttachment      );

                  // It worked if there was a '' response
                  if mResult = '' then
                  begin
                       // Success
                       mCode  := cTFCommSuccess;
                       result := cTFTaskCompleted;
                  end
                  else
                  begin
                       // Log the error message
                       mCode  := cTFCommErrEMAIL;
                       result := mResult;
                  end;
             end

             // EMAILTEMPLATE
             // http://127.0.0.1:5048/&~TFEmailTemplate~mail.engenic.com~25~0~engenic01@engenic.com~~vbaker@engenic.com~vbaker@engenic.com~tdavis@engenic.com~jcoulter@engenic.com~IMPORTANT:%20MedicalRelay%20Login%20Instructions~Email.html~0~No~~3037,s33cd332~
             else if mTFCmd = cTFEmailTemplate then
             begin
                  // Get more for emails
                  mBodyEmail := Copy(pPassedCommands,1,cURLCommMaxSize);

                  mMailServerOut        :=             RecordParseCustomDelimiter(mBodyEmail,'~',3 );
                  mMailServerPortOut    := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',4 ),25);
                  mAuthenticationType   := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',5 ),0);
                  mAccountUser          :=             RecordParseCustomDelimiter(mBodyEmail,'~',6 );
                  mAccPassword          :=             RecordParseCustomDelimiter(mBodyEmail,'~',7 );
                  mEmailSender          :=             RecordParseCustomDelimiter(mBodyEmail,'~',8 );   // Name
                  mEmailRecipients      :=             RecordParseCustomDelimiter(mBodyEmail,'~',9 );   // emails;email
                  mEmailCCs             :=             RecordParseCustomDelimiter(mBodyEmail,'~',10);
                  mEmailBccs            :=             RecordParseCustomDelimiter(mBodyEmail,'~',11);
                  mEmailSubject         :=             RecordParseCustomDelimiter(mBodyEmail,'~',12);
                  mEmailTemplateFile    :=             RecordParseCustomDelimiter(mBodyEmail,'~',13);
                  mEmailPriority        := StrToIntDef(RecordParseCustomDelimiter(mBodyEmail,'~',14),2);  // 0 = Highest
                  mEmailReceipt         :=  TrueOrYes( RecordParseCustomDelimiter(mBodyEmail,'~',15));
                  mEmailAttachment      :=             RecordParseCustomDelimiter(mBodyEmail,'~',16);
                  mEmailParams          :=             RecordParseCustomDelimiter(mBodyEmail,'~',17);

                  // Send an email (This function located above)
                  mResult := GlobSendEmailTemplate( mMailServerOut        ,
                                                    mMailServerPortOut    ,
                                                    mAuthenticationType   ,
                                                    mAccountUser          ,
                                                    mAccPassword          ,
                                                    mEmailSender          ,
                                                    mEmailRecipients      ,
                                                    mEmailCCs             ,
                                                    mEmailBccs            ,
                                                    mEmailSubject         ,
                                                    mEmailTemplateFile    ,
                                                    mEmailPriority        ,
                                                    mEmailReceipt         ,
                                                    mEmailAttachment      ,
                                                    mEmailParams );
                  // It worked if there was a '' response
                  if mResult = '' then
                  begin
                       // Success
                       mCode  := cTFCommSuccess;
                       result := cTFTaskCompleted;
                  end
                  else
                  begin
                       // Log the error message
                       mCode  := cTFCommErrEMAIL;
                       result := mResult;
                  end;
             end


             // PROGVERSION - What version are we running
             else if mTFCmd = cTFProgVersion then
             begin
                  // Clears the entire list
                  result    := '~'+GetProgramFileVersion(RecordParseCustomDelimiter(mBody,'~', cTFCommFile))+'~';
                  mCode     := cTFCommSuccess;
             end


             // Invalid command
             else
             begin
                  result    := '';
                  mCode     := cTFCommErrNoth3;  // Nothing to read
             end;

        end;

     except

     end;

     // Error?
     if mCode  = 0 then
     begin
          result := 'ERROR';
     end;


     // Command result
     pCommand    := mCode;
end;  // ProcessCommands


//////////////////////////////////////////////
// Commands Processor End
//////////////////////////////////////////////

