// Used to PROCESS TCP requests
var
   mCommand        : String;
   mCommandResult  : String;
   mCommandIP      : String;
   mCode           : Integer;
   mFile           : String;
   mParms          : String;
   mMsg            : String;
   mSuccess        : Boolean;
begin
     if AContext.Connection.Connected then
     begin
          // Get the command passed in
          mCommand   := AContext.Connection.IOHandler.ReadLn;
          Glob_Bytes_Received := Glob_Bytes_Received + Length(mCommand);

          (*
          mCommandIp := '(unavailable)';

          // Capture the IP - Access Violations have been killing this... return in Indy 10
          The problem is that we get Acc Viols after enough time passes.  Eventually,
          threads start dying, and before long the entire server fails.  I have decided to
          remove this someout useless piece of information until we can move to Indy 10.
          As much as I would love to keep this data, its too much work to track down just now.

          Google: "Get Client IP OnDisconnect" Event AThread Connection Binding PeerIP access violation

          I think this one says it best as to what is going on here

          UPDATE:  Giving it another go as of March 28, 2007 - VB

          *)

          mCommandIP := TIdIOHandlerSocket(AContext.Connection.IOHandler).Binding.PeerIP;
          // Log the request
          LogEventMessage(Format('TCP COMMAND:  %s received from %s:%d',
                                 [mCommand,
                                 TIdIOHandlerSocket(AContext.Connection.IOHandler).Binding.PeerIP,
                                 TIdIOHandlerSocket(AContext.Connection.IOHandler).Binding.PeerPort]),
                          True, mCommandIP);

          (*
          // Log the request
          LogEventMessage(Format('TCP COMMAND:  %s received from %s',
                                 [mCommand, mCommandIP]),
                          True, mCommandIp);
          *)

          // Test for a command (1 = TCP mode)
          mCommandResult := ProcessCommands(1,mCommandIP, mCommand, GlobVersionNetHub, mCode);
          if mCommandResult = cTFPutAccepted then
          begin
               LogEventMessage(GlobCommandLogEntry, True, mCommandIP);
          end;

          /////////////////////////
          // SCREEN ONLY
          // - Refresh data
          {$ifdef SCREENMODE}
          CommandsMemoUpdate;
          {$endif}
          /////////////////////////

          if mCommandResult <> '' then
          begin
               // SEND File to NetHub
               if mCode = cTFCommReceive then
               begin
                    // Error
                    mCommandResult := cTFHTTPOnly;
               end;

               // SEND a Screencapture to NetHub
               if mCode = cTFCommScreenCap then
               begin
                    // Error
                    mCommandResult := cTFHTTPOnly;
               end;

               // START a Process
               if mCode = cTFCommProcessStart then
               begin
                    // Error
                    mFile  := RecordParseCustomDelimiter(mCommandResult,'~',1);
                    mParms := RecordParseCustomDelimiter(mCommandResult,'~',2);
                    LogEventMessage('ProcessStart: '+mFile,  True, cApplication);
                    LogEventMessage('+ Parameters: '+mParms, True, cApplication);
                    mCommandResult := ProcessStart(mFile, mParms);
               end;

               // END a Process
               if mCode = cTFCommProcessEnd then
               begin
                    // Error
                    mParms  := RecordParseCustomDelimiter(mCommandResult,'~',1);
                    LogEventMessage('ProcessEnd:', True, cApplication);
                    LogEventMessage('+ PID: '+mParms, True, cApplication);
                    mSuccess := ProcessEnd(mParms);
                    if mSuccess then
                    begin
                         LogEventMessage('+ Success', True, cApplication);
                    end
                    else
                    begin
                         LogEventMessage('+ Failed', True, cApplication);
                    end;
               end;

               // BREAK a Process
               if mCode = cTFCommProcessBreak then
               begin
                    // Error
                    mParms  := RecordParseCustomDelimiter(mCommandResult,'~',1);
                    LogEventMessage('ProcessBreak:', True, cApplication);
                    LogEventMessage('+ PID: '+mParms, True, cApplication);
                    mSuccess := ProcessBreak(mParms);
                    if mSuccess then
                    begin
                         LogEventMessage('+ Success', True, cApplication);
                    end
                    else
                    begin
                         LogEventMessage('+ Failed', True, cApplication);
                    end;
               end;



               // LOG the result
               if (RecordParseCustomDelimiter(mCommandResult, '~', cTFCommCommand) = cTFLog) then
               begin
                    // Drop in what we have - into a file that creates monthly
                    mFile := IncludeTrailingPathDelimiter(Glob_Reg_LogDir)+LowerCase(cAppName+'-'+cTFLog+'-'+FormatDateTime('yyyy"-"mm',Now)+'.log');
                    CreateLogEntry(mFile, mCommandResult)
               end
               else
               begin
                    // Just respond with text from ProcessCommads
                    AContext.Connection.IOHandler.WriteLn(mCommandResult);
                    Glob_Bytes_Served := Glob_Bytes_Served + Length(mCommandResult);

                    LogEventMessage('CommandReponse: '+mCommandResult, True, cApplication);
               end;
          end
          else
          begin
               // Missing or malformed
               mMsg := '~N/A~';
               AContext.Connection.IOHandler.WriteLn(mMsg);
               Glob_Bytes_Served := Glob_Bytes_Served + Length(mMsg);
          end;

     end;
//end; // TCPServerExecute  (Leave off... must be in calling code)

