unit NetHubWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  CalcWorkUnit in 'CalcWorkUnit.pas';
*)

// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! CalcWorkUnit must be in the USES section for each unit

interface

{$ifdef VER140} // Delphi 6
  {$WARN SYMBOL_PLATFORM OFF}
{$endif}


uses
    Windows, Messages, SysUtils, Classes,
    CalcWorkUnit, FileWorkUnit, TCPIPWorkUnit, TaskWorkUnit, DateUtils, Registry,
    idTCPClient, idGLobal, IdObjs;

    function  NetHubCreateProcedure(pHomeDir: String): String;
    procedure NetHubDestroyProcedure;
    procedure NetHubHTMLHeader(pRefreshMins: Integer; pWinTitle, pImage, pSysName, pDate, pTime: String; var pStringListStatusBar: TStringList);
    procedure NetHubHTML(pLine: String; var pStringListStatusBar: TStringList);
    procedure NetHubHTMLFooter(var pStringListStatusBar: TStringList);
    procedure NetHubStatusBarAdd(pSection, pTitle, pColor: String; pPercent: Integer; var pStringListStatusBar: TStringList);
    procedure NetHubStatusText(pSection, pTitle, pText, pColor: String; var pStringListStatusBar: TStringList);
    procedure NetHubInputField(pTitle, pName, pValue, pColor: String; pSize, pMaxLength: Integer; var pStringListStatusBar: TStringList);
    procedure NetHubSubmitButton(pValue, pColor: String; var pStringListStatusBar: TStringList);
    procedure NetHubStatusSpacer(var pStringListStatusBar: TStringList);
    // Custom pages
    function  NetHubTabTrim(pText: String): String;
    procedure NetHubMessageAdd(pSeverity, pSection, pIssue, pStatus: String);
    function  NetHubGenerateMessage(pMessage: String): TStringList;
    function  NetHubGenerateHomePage(pHostAsKnownByRequestor, pFileName: String): TStringList;
    function  NetHubGenerateConference(pHostAsKnownByRequestor, pFileName: String): TStringList;
    function  NetHubGenerateConferenceAccess(pHostAsKnownByRequestor, pConfNum, pWebAdd: String): TStringList;
    function  NetHubGenerateWordVerify(pHostAsKnownByRequestor, pFileName: String): TStringList;
    function  NetHubGenerateSystemHealth(pHostAsKnownByRequestor, pFileName: String; pIncludeFileScans: Boolean; pStartDate, pStartTime, pMBServed, pMBReceived: String): TStringList;
    function  NetHubGenerateMonitor(pHostAsKnownByRequestor, pFileName: String): TStringList;
    function  NetHubDetermineServerName(pHost: String): String;
    // Gather data from TeleFlow monitor
    function  TeleFlowMonitorClient(pHost: String; pDisplayProblemsOnly: Boolean; var pNormal, pStopped, pRestarted, pEnded: Integer): TStringList;
    //
    procedure FindLogSize(Str: string);
    procedure RegistryRead;
    function GetOSInfo: string;
    function GetPhysicalMemory: String;
    function GetNumberProcessors: Integer;
    function GetVirtualMemory: String;
    function BtoMB(pIn: Integer): Integer;
    function AcquireFileBaseDirectory(): String;
    // Call CollectCPUData to refresh information about CPU usage
    procedure CollectCPUData;
    // Call it to obtain the number of CPU's in the system
    function GetCPUCount: Integer;
    // Call it to obtain the % of usage for given CPU
    function GetCPUUsage(Index: Integer): Double;
    procedure StringToRecord(var Rec; RecSize : integer; var s: string);
    procedure RecordToString(var Rec; RecSize : integer; var s: string);


type
  // For getting processor information
  TPDWord = ^DWORD;

  TSystem_Basic_Information = packed record
    dwUnknown1: DWORD;
    uKeMaximumIncrement: ULONG;
    uPageSize: ULONG;
    uMmNumberOfPhysicalPages: ULONG;
    uMmLowestPhysicalPage: ULONG;
    uMmHighestPhysicalPage: ULONG;
    uAllocationGranularity: ULONG;
    pLowestUserAddress: Pointer;
    pMmHighestUserAddress: Pointer;
    uKeActiveProcessors: ULONG;
    bKeNumberProcessors: byte;
    bUnknown2: byte;
    wUnknown3: word;
  end;

var
  NtQuerySystemInformation: function(infoClass: DWORD;
    buffer: Pointer;
    bufSize: DWORD;
    returnSize: TPDword): DWORD; stdcall = nil;

   // NetHub start timestamp
   GlobNetHubStartTimeStamp    : TDateTime;
   // Data
   Glob_Bytes_Served           : Int64;
   Glob_Bytes_Received         : Int64;

   // Registry entries
   Glob_RegistryRead           : Boolean;
   //
   Glob_Reg_ServerName         : String;
   Glob_Reg_Notes              : String;
   Glob_Reg_TELServer          : String;
   Glob_Reg_TELPort            : Integer;
   Glob_Reg_TELSessions        : Integer;
   Glob_Reg_AutoSignon         : Integer;
   Glob_Reg_TELUser            : String;
   Glob_Reg_UserFind           : String;
   Glob_Reg_TELPass            : String;
   Glob_Reg_PassFind           : String;
   Glob_Reg_CloseWhen          : String;
   Glob_Reg_ResultPrefix       : String;
   Glob_Reg_NetTimeOut         : Integer;
   Glob_Reg_TextRequests       : String;
   Glob_Reg_VMSDir             : String;
   Glob_Reg_FTPPort            : Integer;
   Glob_Reg_FTPData            : Integer;
   Glob_Reg_HTTPRoot           : String;
   Glob_Reg_HTTPPort           : Integer;
   Glob_Reg_HTTPVMSP           : Integer;
   Glob_Reg_TCPPort            : Integer;
   Glob_Reg_TCPVMSP            : Integer;
   Glob_Reg_HTTPRefresh        : Integer;
   Glob_Reg_HTTPStealth        : Integer;
   Glob_Reg_DL_HTTPHost        : String;
   Glob_Reg_DL_HTTPPort        : Integer;
   //Credit Card
   Glob_Reg_CredCardIP         : String;
   Glob_Reg_CredCardPort       : Integer;      
   Glob_Reg_CredCardSesn       : Integer;      
   //Office Chat
   Glob_Reg_OffChatIP          : String;
   Glob_Reg_OffChatPort        : Integer;
   Glob_Reg_OffChatSesn        : Integer;
   //Settings
   Glob_Reg_Activation         : Integer;
   Glob_Reg_Authenticate       : Integer;
   Glob_Reg_ConnOnStart        : Integer;
   Glob_Reg_EnableLog          : Integer;
   Glob_Reg_ReduceLog          : Integer;
   Glob_Reg_NonLocalLogOnly    : Integer;
   Glob_Reg_LogDir             : String;
   Glob_Reg_ManageSesns        : Integer;
   Glob_Reg_UseSSL             : Integer;
   Glob_Reg_SSLPass            : String;
   Glob_Reg_BatchDay           : String;
   Glob_Reg_BatchHour          : String;
   Glob_Reg_BatchMinute        : String;
   //SMS
   Glob_Reg_SMSIP              : String;
   Glob_Reg_SMSPort            : Integer;
   Glob_Reg_SMSSesn            : Integer;
   // SSL
   //Glob_Reg_SSL                : Boolean;
   Glob_SSL_ActivePort         : Integer;
   // Sessions
   Glob_Reg_AuthOn             : Boolean;
   Glob_Reg_ManSess            : Boolean;
   // Other controls
   GlobEnableLog               : Boolean;
   GlobReduceLog               : Boolean;
   GlobNonLocalLogOnly         : Boolean;
   GlobVersionNetHub           : String;


   // List of files string
   ///////////////////////////
   GlobFileRead                : TStringList;
   GlobFileItems               : TStringList;
   GlobLogLines                : TStringList;
   GlobClients                 : TList;
   GlobClientList              : TStringList; // TStringList;
   GlobSessionList             : TList;
   GlobServicesList            : TStringList; // Services to watch for
   GlobPublishCommandsReadFile : String;
   GlobPublishCommands         : TStringList;
   GlobPublishEvents           : TStringList;
   GlobPublishEventsLastExpire : String;
   GlobPublishExeVersions      : TStringList;
   // TCP Clients
   GlobTCPClients              : TThreadList;     // Holds the data of all clients

   // Count ups
   GlobReconnectRequest        : Boolean;    // Count of number of reconnect requests
   GlobTotalRequests           : Integer;    // Count of number of files requested
   GlobTotalServed             : Integer;    // Count of number of files served

   // Command
   GlobCommandLogEntry         : String;

   // Shutdown
   GlobShuttingDown            : Boolean;

   // Timer Events
   Glob_Last_BatchDay          : Integer;
   Glob_Last_BatchHour         : Integer;
   Glob_Last_BatchMinute       : Integer;


   GlobTotalSizeTestTime       : TDateTime;
   GlobTotalSize               : Integer;

   // Compiler trick
   GlobDebugInt                : Integer;

   // Webpage creation
   // --- WARNING:  This must be loaded from other environments
   Glob_TeleFlowInstalled      : Boolean;
   // From TeleFlow
   GlobRegMAXLOGFILESIZE       : Integer;
   GlobRegLOGLINES             : Integer;
   GlobRegLOGDIRECTORY         : String;
   GlobRegINSTALLDIRECTORY     : String;
   GlobRegEXPDATE              : String;
   GlobRegNUMPORTS             : String;
   GlobRegWINSTART             : String;

   // SystemHealth information
   GlobHealthInfo              : String;
   GlobHealthWarnings          : String;
   GlobHealthErrors            : String;
   GlobHealthMsgs              : Integer;

   GlobalKeep                  : Integer;
const
   apGlobRegEntry          = 'SOFTWARE\enGenic\TFNetHub';
   apServerRegEntry        = apGlobRegEntry +'\Server';
   apFTPRegEntry           = apGlobRegEntry +'\FTP';
   apCreditRegEntry        = apGlobRegEntry +'\Credit';
   apSMSRegEntry           = apGlobRegEntry +'\SMS';
   apOffChatRegEntry       = apGlobRegEntry +'\OffChat';

   apOfficeTemplatesEmail  = 'templates\email';
   apOfficeUpload          = 'upload';

   // Related files
   apServicesFile          = 'TFNetHubServices.cfg';
   apCommandsListFile      = 'TFNetHubCommandsList.sav';

   sauthenticationrealm    = 'http server';

// For USE with TFMonitor protocol
{$I TFMonitorConsts.pas}


   cLocalHost              = '127.0.0.1'; // 'umbriel';   // @@@ 127.0.0.1  or Localhost (might have issues with a name)
   cRestartTxt             = '&nbsp;<span class="style8">[n/m] = Restarts / Maximum Restarts</span>';

   // Web Page creation
   // =================
   // System info
   SystemBasicInformation   = 0;

   // Formating for SystemHelth
   cSystemHealthRSS         = 'systemhealth_rss.xml';
   cSysError                = 'Error';
   cSysWarning              = 'Warning';
   cTabIn                   = '<img src="images/systembullet.jpg"> ';  // '- - ';
   cLightNormal             = '<img src="images/monitor_normal.jpg"> ';
   cLightStopped            = '<img src="images/monitor_stopped.jpg"> ';
   cLightRestarted          = '<img src="images/monitor_restarted.jpg"> ';
   cLightEnded              = '<img src="images/monitor_ended.jpg"> ';

   // SErvices List
   cTFServices = 'TFServer,TFServerDChan01,TFServerDChan02,TFServerDChan03,TFServerDChan04,FileWatcher,DataManagerService,IVRManager,CCMediaManager,TFSentinel,TFNetHub,CTDaemon,MySQL,LVSRE_Server,vtsvc,recserver,dlgc_srv';

   (*
       NeoSpeech's TTS3.0 now
          Service Name: VT Server
          Display Name: VT Server
          executable: vtsvc.exe

       The Nuance 7.x we support does not run as a service.
          nlm.exe  (Nuance License Manager)
          recserver.exe (Nuance recognition server)

       CTDaemon:
          Service Name: ctdaemon
          Display Name: NMS CT daemon
          executable: ctdaemon.exe

       TeleFlow D-Channel:
          This one is tricky.  Could be TFDChan01.bat, TFDChan02.bat, etc., one for every trunk.
          They could have other names, like tfdchan, tfdchanl, tfdchan1.  I SUGGEST WE STANDARDIZE THESE NAMES!!!!!
          It is also being served by SRVANY.EXE (this makes testing for it impossible.

       Dialogic:
          Service Name: Dialogic
          Display Name: Dialogic
          executable: dlgc_srv.exe
   *)


   // Service states
   cSTOPPED                 = 'STOPPED';
   cSTART_PENDING           = 'START PENDING';
   cSTOP_PENDING            = 'STOP PENDING';
   cRUNNING                 = 'RUNNING';
   cCONTINUE_PENDING        = 'CONTINUE PENDING';
   cPAUSE_PENDING           = 'PAUSE PENDING';
   cPAUSED                  = 'PAUSED';

   // Standards colours
   clEngYellow              = $00BBFFFF;
   clEngGreen               = $00D2FFD2;
   clEngAqua                = $00FFFFBD;
   clEngRed                 = $008C8CFF;
   clEngOrange              = $0072A9F3;

   clEngHTMLDefault         = '#FFFFFF'; // lt gray  // #EFF7FF
   clEngHTMLYellow          = '#FFFF99';
   clEngHTMLGreen           = '#31CF63';
   clEngHTMLAqua            = '#BDFFFF';
   clEngHTMLRed             = '#FF6600';
   clEngHTMLOrange          = '#FFCC00';

   cMissing                 = 'Not Installed';
   cUnreg                   = 'Unregistered';
   cHTMLSpace               = '&nbsp;';


   // Registry Information for "TeleFlow Server"
   cpRegistryEntry         =  'SOFTWARE\enGenic\TeleFlow Server';

   cMAXLOGFILESIZE         =  'MAXLOGFILESIZE';
   cLOGLINES               =  'LOGLINES';
   cLOGDIRECTORY           =  'LOGDIRECTORY';
   cINSTALLDIRECTORY       =  'INSTALLDIRECTORY';
   cEXPDATE                =  'EXPDATE';
   cNUMPORTS               =  'NUMPORTS';
   cWINSTART               =  'WINSTART';


// For USE with TFMonitor protocol
{$I TFMonitorTypes.pas}


implementation

// CPU Usage stuff
type
    TInt64 = Int64;
type
    PInt64 = ^TInt64;
type
    TPERF_DATA_BLOCK = record
        Signature : array[0..4 - 1] of WCHAR;
        LittleEndian : DWORD;
        Version : DWORD;
        Revision : DWORD;
        TotalByteLength : DWORD;
        HeaderLength : DWORD;
        NumObjectTypes : DWORD;
        DefaultObject : Longint;
        SystemTime : TSystemTime;
        Reserved: DWORD;
        PerfTime : TInt64;
        PerfFreq : TInt64;
        PerfTime100nSec : TInt64;
        SystemNameLength : DWORD;
        SystemNameOffset : DWORD;
    end;

    PPERF_DATA_BLOCK = ^TPERF_DATA_BLOCK;

    TPERF_OBJECT_TYPE = record
        TotalByteLength : DWORD;
        DefinitionLength : DWORD;
        HeaderLength : DWORD;
        ObjectNameTitleIndex : DWORD;
        ObjectNameTitle : LPWSTR;
        ObjectHelpTitleIndex : DWORD;
        ObjectHelpTitle : LPWSTR;
        DetailLevel : DWORD;
        NumCounters : DWORD;
        DefaultCounter : Longint;
        NumInstances : Longint;
        CodePage : DWORD;
        PerfTime : TInt64;
        PerfFreq : TInt64;
    end;

    PPERF_OBJECT_TYPE = ^TPERF_OBJECT_TYPE;

type
    TPERF_COUNTER_DEFINITION = record
        ByteLength : DWORD;
        CounterNameTitleIndex : DWORD;
        CounterNameTitle : LPWSTR;
        CounterHelpTitleIndex : DWORD;
        CounterHelpTitle : LPWSTR;
        DefaultScale : Longint;
        DetailLevel : DWORD;
        CounterType : DWORD;
        CounterSize : DWORD;
        CounterOffset : DWORD;
    end;

    PPERF_COUNTER_DEFINITION = ^TPERF_COUNTER_DEFINITION;

    TPERF_COUNTER_BLOCK = record
        ByteLength : DWORD;
    end;

    PPERF_COUNTER_BLOCK = ^TPERF_COUNTER_BLOCK;

    TPERF_INSTANCE_DEFINITION = record
        ByteLength : DWORD;
        ParentObjectTitleIndex : DWORD;
        ParentObjectInstance : DWORD;
        UniqueID : Longint;
        NameOffset : DWORD;
        NameLength : DWORD;
    end;

    PPERF_INSTANCE_DEFINITION = ^TPERF_INSTANCE_DEFINITION;

type
    TInt64F = Int64;
    FInt64  = TInt64F;
    Int64D  = TInt64;

const
    Processor_IDX_Str = '238';
    Processor_IDX = 238;
    CPUUsageIDX = 6;

type
    AInt64F = array[0..$FFFF] of TInt64F;
    PAInt64F = ^AInt64F;

var
    _PerfData : PPERF_DATA_BLOCK;
    _BufferSize: Integer;
    _POT : PPERF_OBJECT_TYPE;
    _PCD: PPerf_Counter_Definition;
    _ProcessorsCount: Integer;
    _Counters: PAInt64F;
    _PrevCounters: PAInt64F;
    _SysTime: TInt64F;
    _PrevSysTime: TInt64F;

//------------------------------------------------------------------------------
function GetCPUCount: Integer;
begin
     if _ProcessorsCount < 0 then CollectCPUData;
     result:=_ProcessorsCount;
end;

//------------------------------------------------------------------------------
function GetCPUUsage(Index: Integer): Double;
begin
     if _ProcessorsCount < 0 then CollectCPUData;
     if (Index >= _ProcessorsCount) or (Index < 0) then
         raise Exception.Create('CPU index out of bounds');
     if _PrevSysTime = _SysTime then result:=0 else
     result:=1-(_Counters[index] - _PrevCounters[index])/(_SysTime-_PrevSysTime);
end;

var VI: TOSVERSIONINFO;

//------------------------------------------------------------------------------
procedure CollectCPUData;
var BS: integer;
    i: Integer;
    _PCB_Instance: PPERF_COUNTER_BLOCK;
    _PID_Instance: PPERF_INSTANCE_DEFINITION;
    ST: TFileTime;
begin
     BS:=_BufferSize;
     while RegQueryValueEx( HKEY_PERFORMANCE_DATA, Processor_IDX_Str, nil, nil,
             PByte(_PerfData), @BS ) = ERROR_MORE_DATA do
     begin
         // Get a buffer that is big enough.
         INC(_BufferSize,$1000);
         BS:=_BufferSize;
         ReallocMem( _PerfData, _BufferSize );
     end;

     // Locate the performance object
     _POT := PPERF_OBJECT_TYPE(DWORD(_PerfData) + _PerfData.HeaderLength);
     for i := 1 to _PerfData.NumObjectTypes do
     begin
         if _POT.ObjectNameTitleIndex = Processor_IDX then Break;
         _POT := PPERF_OBJECT_TYPE(DWORD(_POT) + _POT.TotalByteLength);
     end;

     // Check for success
     if _POT.ObjectNameTitleIndex <> Processor_IDX then
         raise Exception.Create('Unable to locate the "Processor" performance object');

     if _ProcessorsCount < 0 then
     begin
         _ProcessorsCount:=_POT.NumInstances;
         GetMem(_Counters,_ProcessorsCount*SizeOf(TInt64));
         GetMem(_PrevCounters,_ProcessorsCount*SizeOf(TInt64));
     end;

     // Locate the "% CPU usage" counter definition
     _PCD := PPERF_Counter_DEFINITION(DWORD(_POT) + _POT.HeaderLength);
     for i := 1 to _POT.NumCounters do
     begin
         if _PCD.CounterNameTitleIndex = CPUUsageIDX then break;
         _PCD := PPERF_COUNTER_DEFINITION(DWORD(_PCD) + _PCD.ByteLength);
     end;

     // Check for success
     if _PCD.CounterNameTitleIndex <> CPUUsageIDX then
         raise Exception.Create('Unable to locate the "% of CPU usage" performance counter');

     // Collecting coutners
     _PID_Instance := PPERF_INSTANCE_DEFINITION(DWORD(_POT) + _POT.DefinitionLength);
     for i := 0 to _ProcessorsCount-1 do
     begin
         _PCB_Instance := PPERF_COUNTER_BLOCK(DWORD(_PID_Instance) + _PID_Instance.ByteLength );

         _PrevCounters[i]:=_Counters[i];
         _Counters[i]:=FInt64(PInt64(DWORD(_PCB_Instance) + _PCD.CounterOffset)^);

         _PID_Instance := PPERF_INSTANCE_DEFINITION(DWORD(_PCB_Instance) + _PCB_Instance.ByteLength);
     end;

     _PrevSysTime:=_SysTime;
     SystemTimeToFileTime(_PerfData.SystemTime, ST);
     _SysTime:=FInt64(TInt64(ST));
end;

// Create string lists etc.
Function NetHubCreateProcedure(pHomeDir: String): String;
var
   mFileString  : TStringList;
   mFile        : String;
   mRecord      : String;
   mLoop        : Integer;
begin
     // Time started timestamp
     GlobNetHubStartTimeStamp := Now; //GetYYYYMMDDHHNNSSZZZ;

     GlobShuttingDown         := False;
     // Create
     GlobPublishCommands      := TStringList.Create;
     GlobPublishEvents        := TStringList.Create;
     GlobPublishExeVersions   := TStringList.Create;
     GlobServicesList         := TStringList.Create;
     // Threads
     GlobTCPClients           := TThreadList.Create;

     // Counters for data served
     Glob_Bytes_Served        := 0;
     Glob_Bytes_Received      := 0;

     // Determine if we have SSL running on a port.
     // - Default to none
     Glob_SSL_ActivePort      := -1;

     // Load in any published commands (saved from last shutdown)
     GlobPublishCommandsReadFile := pHomeDir + apCommandsListFile;
     if FileExists(GlobPublishCommandsReadFile) Then
     begin
          // Clear to be sure
          GlobPublishCommands.Clear;
          GlobPublishCommands.LoadFromFile(GlobPublishCommandsReadFile);
          DeleteFile(GlobPublishCommandsReadFile);
     end;

     // Load in services
     mFileString              := TStringList.Create;
     try
        // Load contents from Services list file, if it exists
        mFile := pHomeDir + apServicesFile;
        if FileExists(mFile) Then
        begin
             result := 'Watching Services: '+mFile;
             // Clear to be sure
             GlobServicesList.Clear;

             // Only accept good service names
             mFileString.LoadFromFile(mFile);
             for mLoop := 0 to mFileString.Count - 1 do
             begin
                  mRecord := mFileString[mLoop];
                  // No comments, and no blank lines
                  if (Copy(mRecord,1,1) <> '-') and
                     (mRecord  <> '') then
                  begin
                       // Add a service display name to watch for
                       GlobServicesList.Add(mRecord);
                  end;
             end;
        end
        else
        begin
             // No File found
             result := 'Services File Not Defined: '+mFile;
        end;

     finally
        mFileString.Free;
     end;
end; // NetHubCreateProcedure


// Destroy variables etc
procedure NetHubDestroyProcedure;
begin
     // Save any commands that may be waiting to be processed before closeing
     if FileExists(GlobPublishCommandsReadFile) Then
     begin
          DeleteFile(GlobPublishCommandsReadFile);
     end;
     if GlobPublishCommands.Count > 0 then
     begin
          GlobPublishCommands.SaveToFile(GlobPublishCommandsReadFile);
     end;

     // Free up the lists
     GlobPublishCommands.Free;
     GlobPublishEvents.Free;
     GlobPublishExeVersions.Free;
     GlobServicesList.Free;
     GlobTCPClients.Free;
end;


procedure RegistryRead;
var
{$I  NetHubRegistryRead.pas}
end;

// HTML Header
procedure NetHubHTMLHeader(pRefreshMins: Integer; pWinTitle, pImage, pSysName, pDate, pTime: String; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          // First, get the information from the Registry
          RegistryRead;

          try
             add(trim('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"                                                                                    '));
             add(trim('"http://www.w3.org/TR/html4/loose.dtd">                                                                                                           '));
             add(trim('<html>                                                                                                                                            '));
             add(trim('<head>                                                                                                                                            '));
             add(trim('<title>'+pWinTitle+'</title>                                                                                                                      '));
             add(trim('<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">                                                                          '));
             add(trim('<style type="text/css">                                                                                                                           '));
             add(trim('<!--                                                                                                                                              '));
             add(trim('body {                                                                                                                                            '));
             add(trim('        background-color: #DDDED8;                                                                                                                '));
             add(trim('        border: none;                                                                                                                             '));
             add(trim('}                                                                                                                                                 '));
             add(trim('.style8 {                                                                                                                                         '));
             add(trim('        color: #666699;                                                                                                                           '));
             add(trim('        font-family: Arial, Helvetica, sans-serif;                                                                                                '));
             add(trim('        font-size: 12px;                                                                                                                          '));
             add(trim('        font-weight: 400;                                                                                                                         '));
             add(trim('        font-style: normal;                                                                                                                       '));
             add(trim('}                                                                                                                                                 '));
             add(trim('.style9 {                                                                                                                                         '));
             add(trim('        font-family: Arial, Helvetica, sans-serif;                                                                                                '));
             add(trim('        font-size: 14px;                                                                                                                          '));
             add(trim('        font-weight: 400;                                                                                                                         '));
             add(trim('        font-style: normal;                                                                                                                       '));
             add(trim('}                                                                                                                                                 '));
             add(trim('.style10 {                                                                                                                                        '));
             add(trim('        color: #000094;                                                                                                                           '));
             add(trim('        font-family: Arial, Helvetica, sans-serif;                                                                                                '));
             add(trim('        font-size: 14px;                                                                                                                          '));
             add(trim('        font-style: normal;                                                                                                                       '));
             add(trim('        line-height: normal;                                                                                                                      '));
             add(trim('        font-weight: normal;                                                                                                                      '));
             add(trim('        font-variant: normal;                                                                                                                     '));
             add(trim('}                                                                                                                                                 '));
             add(trim('-->                                                                                                                                               '));
             add(trim('</style>                                                                                                                                          '));
             add(trim('<script>                                                                                                                                          '));
             add(trim('<!--                                                                                                                                              '));
             add(trim('                                                                                                                                                  '));
             add(trim('var limit="'+IntToStr(pRefreshMins)+':00"                                                                                                         '));
             add(trim('                                                                                                                                                  '));
             add(trim('if (document.images){                                                                                                                             '));
             add(trim('var parselimit=limit.split(":")                                                                                                                   '));
             add(trim('parselimit=parselimit[0]*60+parselimit[1]*1                                                                                                       '));
             add(trim('}                                                                                                                                                 '));
             add(trim('function beginrefresh(){                                                                                                                          '));
             add(trim('if (!document.images)                                                                                                                             '));
             add(trim('return                                                                                                                                            '));
             add(trim('if (parselimit==1)                                                                                                                                '));
             add(trim('window.location.reload()                                                                                                                          '));
             add(trim('else{                                                                                                                                             '));
             add(trim('parselimit-=1                                                                                                                                     '));
             add(trim('curmin=Math.floor(parselimit/60)                                                                                                                  '));
             add(trim('cursec=parselimit%60                                                                                                                              '));
             add(trim('if (curmin!=0)                                                                                                                                    '));
             add(trim('curtime=curmin+" minute(s) and "+cursec+" seconds remaining until refresh"                                                                        '));
             add(trim('else                                                                                                                                              '));
             add(trim('curtime=cursec+" seconds remaining until refresh"                                                                                                 '));
             add(trim('window.status=curtime                                                                                                                             '));
             add(trim('setTimeout("beginrefresh()",1000)                                                                                                                 '));
             add(trim('}                                                                                                                                                 '));
             add(trim('}                                                                                                                                                 '));
             add(trim('                                                                                                                                                  '));
             add(trim('window.onload=beginrefresh                                                                                                                        '));
             add(trim('//-->                                                                                                                                             '));
             add(trim('</script>                                                                                                                                         '));
             add(trim('</head>                                                                                                                                           '));
             add(trim('                                                                                                                                                  '));
             add(trim('<body background="images/systemback.jpg" >                                                                                                        '));
             add(trim('<TABLE cellSpacing=0 cellPadding=1 width=550 align=center bgColor=#666666 border=0>                                                               '));
             add(trim('  <TBODY>                                                                                                                                         '));
             add(trim('    <TR>                                                                                                                                          '));
             add(trim('      <TD>                                                                                                                                        '));
             add(trim('        <TABLE width=550 height="61" border=0 cellPadding=0 cellSpacing=0 bgColor=#FFFFFF>                                                        '));
             add(trim('          <TBODY>                                                                                                                                 '));
             add(trim('            <TR>                                                                                                                                  '));
             add(trim('              <TD valign="top">                                                                                                                   '));
             add(trim('                <img src="'+pImage+'" width="550" height="72" border="0" usemap="#Map">                                                           '));
             add(trim('                           </TD>                                                                                                                  '));
             add(trim('            </TR>                                                                                                                                 '));
             add(trim('          </TBODY>                                                                                                                                '));
             add(trim('        </TABLE>                                                                                                                                  '));
             add(trim('        <TABLE cellSpacing=0 cellPadding=5 width="100%" bgColor=#ffffff border=0>                                                                 '));
             add(trim('          <TBODY>                                                                                                                                 '));
             add(trim('            <TR>                                                                                                                                  '));
             add(trim('                                                                                                                                                  '));
             add(trim('            </TR>                                                                                                                                 '));
             add(trim('            <TR>                                                                                                                                  '));
             add(trim('                                                                                                                                                  '));
             add(trim('            </TR>                                                                                                                                 '));
             add(trim('            <TR>                                                                                                                                  '));
             add(trim('              <TD>                                                                                                                                '));
             add(trim('                <TABLE cellSpacing=0 cellPadding=1 width="100%" bgColor=#cccccc  border=0>                                                        '));
             add(trim('                  <TBODY>                                                                                                                         '));
             add(trim('                    <TR>                                                                                                                          '));
             add(trim('                      <TD>                                                                                                                        '));
             add(trim('                        <TABLE cellSpacing=0 cellPadding=5 width="100%"  bgColor=#ffffff border=0>                                                '));
             add(trim('                          <TBODY>                                                                                                                 '));
             add(trim('                            <TR>                                                                                                                  '));
             add(trim('                              <TD>                              <table width="100%"  border="0" cellspacing="0" cellpadding="0">                  '));
             add(trim('                                <tr valign="top">                                                                                                 '));
             add(trim('                                  <td class="style10">System Name </td>                                                                           '));
             add(trim('                                  <td>&nbsp;</td>                                                                                                 '));
             add(trim('                                  <td class="style9"><strong>'+pSysName+'</strong></td>                                                           '));
             add(trim('                                </tr>                                                                                                             '));
             add(trim('                                <tr valign="top">                                                                                                 '));
             add(trim('                                  <td class="style10">&nbsp;</td>                                                                                 '));
             add(trim('                                  <td>&nbsp;</td>                                                                                                 '));
             add(trim('                                  <td class="style9">&nbsp;</td>                                                                                  '));
             add(trim('                                </tr>                                                                                                             '));
             if pDate <> '' then
             begin
             add(trim('                                <tr valign="top">                                                                                                 '));
             add(trim('                                  <td width="34%" class="style10"><span class="style9"><span class="style10">Report Created</span></span></td>       '));
             add(trim('                                  <td width="5%">&nbsp;</td>                                                                                      '));
             add(trim('                                  <td width="61%" class="style9"><span class="style9">'+pDate+' '+pTime+'</span></td>                                       '));
             add(trim('                                </tr>                                                                                                             '));
             end;
             (*
             if pTime <> '' then
             begin
             add(trim('                                <tr valign="top">                                                                                                 '));
             add(trim('                                  <td class="style10"><span class="style9"><span class="style10">Report Time</span></span></td>                   '));
             add(trim('                                  <td>&nbsp;</td>                                                                                                 '));
             add(trim('                                  <td class="style9"><span class="style9"><b>'+pTime+'</b></span></td>                                            '));
             add(trim('                                </tr>                                                                                                             '));
             end;
             *)
          except
          end;
     end;
end;


// HTML code only
procedure NetHubHTML(pLine: String; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim(pLine));
          except
          end;
     end;
end;


// Remove leading tabs
function NetHubTabTrim(pText: String): String;
begin
     if Copy(pText,1,Length(cTabIn)) = cTabIn then
     begin
          result := Trim(Copy(pText,Length(cTabIn)+1,999));
     end
     else
     begin
          result := Trim(pText);
     end;
end; // NetHubTabTrim


procedure NetHubMessageAdd(pSeverity, pSection, pIssue, pStatus: String);
begin
     inc(GlobHealthMsgs);

     if pSeverity = cSysError then
     begin
          GlobHealthErrors  := GlobHealthErrors +
                                '<message>'+
                                     '<severity>' +pSeverity+ '</severity>'+
                                     '<section>'  +pSection+  '</section>'+
                                     '<issue>'    +pIssue+    '</issue>'+
                                     '<status>'   +pStatus+   '</status>'+
                                '</message>';
     end
     else
     if pSeverity = cSysWarning then
     begin
          GlobHealthWarnings := GlobHealthWarnings +
                                '<message>'+
                                     '<severity>' +pSeverity+ '</severity>'+
                                     '<section>'  +pSection+  '</section>'+
                                     '<issue>'    +pIssue+    '</issue>'+
                                     '<status>'   +pStatus+   '</status>'+
                                '</message>';
     end;
end; // NetHubMessageAdd


// Status bar with percent
procedure NetHubStatusBarAdd(pSection, pTitle, pColor: String; pPercent: Integer; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('<tr valign="top">                                                                                                 '));
             if NetHubTabTrim(pTitle) = pTitle then
             begin
             // Title
             add(trim('  <td class="style10"><span class="style9"><span class="style10">'+pTitle+'</span>&nbsp;</span></td>              '));
             end
             else
             begin
             // Bullet
             add(trim('  <td class="style10"><span class="style9"><span class="style8">'+pTitle+'</span>&nbsp;</span></td>              '));
             end;
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td class="style9"><table width="99%" height="2" border="0" cellpadding="0" cellspacing="0" bgcolor="#33CC66">  '));
             add(trim('    <tr>                                                                                                          '));
             add(trim('      <td width="'+IntToStr(      pPercent)+'%" bgcolor="'+pColor+'">&nbsp;</td>                                  '));
             add(trim('      <td width="'+IntToStr(100 - pPercent)+'%" bgcolor="#EFF7FF">&nbsp;</td>                                     '));
             add(trim('    </tr>                                                                                                         '));
             add(trim('  </table></td>                                                                                                   '));
             add(trim('</tr>                                                                                                             '));
          except
          end;
     end;

     // Use the colors to determine how to add errors and warnings
     if pColor = clEngHTMLOrange then
     begin
          NetHubMessageAdd(cSysWarning, pSection, NetHubTabTrim(pTitle), IntToStr(pPercent)+'%');
     end
     else
     if pColor = clEngHTMLRed then
     begin
          NetHubMessageAdd(cSysError,   pSection, NetHubTabTrim(pTitle), IntToStr(pPercent)+'%');
     end;
end; // NetHubStatusBarAdd


// Text only
procedure NetHubStatusText(pSection, pTitle, pText, pColor: String; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('<tr valign="top">                                                                                                 '));
             if NetHubTabTrim(pTitle) = pTitle then
             begin
             // Title
             add(trim('  <td class="style10"><span class="style9"><span class="style10">'+pTitle+'</span>&nbsp;</span></td>              '));
             end
             else
             begin
             // Bullet
             add(trim('  <td class="style10"><span class="style9"><span class="style8">'+pTitle+'</span>&nbsp;</span></td>              '));
             end;
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td class="style9"><table width="99%" height="2" border="0" cellpadding="0" cellspacing="0" bgcolor="#33CC66">  '));
             add(trim('    <tr>                                                                                                          '));
             add(trim('      <td bgcolor="'+pColor+'">'+pText+'</td>                                                                     '));
             add(trim('    </tr>                                                                                                         '));
             add(trim('  </table></td>                                                                                                   '));
             add(trim('</tr>                                                                                                             '));
          except
          end;
     end;

     // Use the colors to determine how to add errors and warnings
     if pColor = clEngHTMLOrange then
     begin
          NetHubMessageAdd(cSysWarning, pSection,  NetHubTabTrim(pTitle), Trim(pText));
     end
     else
     if pColor = clEngHTMLRed then
     begin
          NetHubMessageAdd(cSysError,   pSection,  NetHubTabTrim(pTitle), Trim(pText));
     end;
end; // NetHubStatusText


// Input Field
procedure NetHubInputField(pTitle, pName, pValue, pColor: String; pSize, pMaxLength: Integer; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('<tr valign="top">                                                                                                 '));
             add(trim('  <td class="style10"><span class="style9"><span class="style10">'+pTitle+'</span>&nbsp;</span></td>              '));
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td bgcolor="'+pColor+'">                                                                                       '));
             add(trim('     <INPUT NAME='+pName+' size='+IntToStr(pSize)+' maxlength='+IntToStr(pMaxLength)+' VALUE="'+pValue+'">        '));
             add(trim('  </td>                                                                                                           '));
             add(trim('</tr>                                                                                                             '));
          except
          end;
     end;
end;


// Input Field
procedure NetHubSubmitButton(pValue, pColor: String; var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('<tr valign="top">                                                                                                 '));
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td bgcolor="'+pColor+'">                                                                                       '));
             add(trim('     <INPUT TYPE=SUBMIT VALUE='+pValue+'>                                                                          '));
             add(trim('  </td>                                                                                                           '));
             add(trim('</tr>                                                                                                             '));
          except
          end;
     end;
end;

// HTML Footer
procedure NetHubHTMLFooter(var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('                              </table>                                </TD>                                                                       '));
             add(trim('                            </TR>                                                                                                                 '));
             add(trim('                          </TBODY>                                                                                                                '));
             add(trim('                      </TABLE></TD>                                                                                                               '));
             add(trim('                    </TR>                                                                                                                         '));
             add(trim('                  </TBODY>                                                                                                                        '));
             add(trim('              </TABLE></TD>                                                                                                                       '));
             add(trim('            </TR>                                                                                                                                 '));
             add(trim('          </TBODY>                                                                                                                                '));
             add(trim('        </TABLE>                                                                                                                                  '));
             add(trim('      </TD>                                                                                                                                       '));
             add(trim('    </TR>                                                                                                                                         '));
             add(trim('  </TBODY>                                                                                                                                        '));
             add(trim('</TABLE>                                                                                                                                          '));
             add(trim('<DIV align=center><FONT color="#999999" size="1" face="Arial, Helvetica, sans-serif"><br>                                                         '));
             add(trim('<a href="http://www.engenic.com">&copy; 2006 enGenic Corporation</a></FONT></DIV>                                                                    '));
             (*
             add(trim('<map name="Map">                                                                                                                                  '));
             add(trim('  <area shape="rect" coords="5,10,103,47" href="http://support.engenic.com" target="_blank" alt="click here to enter support">                    '));
             add(trim('</map>                                                                                                                                            '));
             *)
             add(trim('</body>                                                                                                                                           '));
             add(trim('</html>                                                                                                                                           '));
          except
          end;
     end;
end;



// Add a pleasant space
procedure NetHubStatusSpacer(var pStringListStatusBar: TStringList);
begin
     with pStringListStatusBar do
     begin
          try
             add(trim('<tr valign="top">                                                                                                 '));
             add(trim('  <td class="style10">&nbsp;</td>                                                                                 '));
             add(trim('  <td>&nbsp;</td>                                                                                                 '));
             add(trim('  <td class="style9">&nbsp;</td>                                                                                  '));
             add(trim('</tr>                                                                                                             '));
          except
          end;
     end;
end;


// Generate a message.html
function NetHubGenerateMessage(pMessage: String): TStringList;
var
   mStringListSts  : TStringList;
begin
     // First, create the TStringList
     Result := TStringList.Create;

     // Create StringLists
     mStringListSts    := TStringList.Create;
     try
        // Define custom data
        SetStandardDateTimeFormats;

        ////////// HEADER /////////////////
        // Refresh every so many minutes (NetHub Editor sets)
        NetHubHTMLHeader(60, 'enGenic: NetHub Message', 'images/systemblank.jpg', Glob_Reg_ServerName, '', '', mStringListSts);
        ////////// HEADER /////////////////

        // Message
        NetHubStatusText('', 'Message:', pMessage,       clEngHTMLDefault, mStringListSts);

        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

        // Write it
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

     finally
        mStringListSts     .Free;
     end;
end;  // NetHubGenerateMessage


// Figure out what HTTP... to show
function NetHubDetermineServerName(pHost: String): String;
begin
     if (pHost = '') then
     begin
          //result := '%HOSTNAME%';
          result := '..';
     end;
end; // NetHubDetermineServerName


// Generate the index.html
function NetHubGenerateHomePage(pHostAsKnownByRequestor, pFileName: String): TStringList;
var
   mDate           : String;
   mTime           : String;

   mStringListSts  : TStringList;
   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);

     // First, create the TStringList
     Result := TStringList.Create;

     // Create StringList
     mStringListSts    := TStringList.Create;

     try
        // Define custom data
        SetStandardDateTimeFormats;
        mDate         := FormatDateTime('YYYY/MM/DD',Now)+' - <b>'+FormatDateTime('dddd',Now)+'</b>';
        mTime         := FormatDateTime('hh:nn:ss',Now);

        ////////// HEADER /////////////////
        // Refresh every so many minutes (NetHub Editor sets)
        NetHubHTMLHeader(Glob_Reg_HTTPRefresh, 'enGenic: NetHub', 'images/systemhome.jpg', Glob_Reg_ServerName, mDate, mTime, mStringListSts);
        ////////// HEADER /////////////////
        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

        // Write it
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

     finally
        mStringListSts     .Free;
     end;
end;  // NetHubGenerateHomePage


// Generate the conference.html
function NetHubGenerateConference(pHostAsKnownByRequestor, pFileName: String): TStringList;
var
   mDate           : String;
   mTime           : String;

   mStringListSts  : TStringList;

   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);

     // First, create the TStringList
     Result := TStringList.Create;

     // Create StringList
     mStringListSts    := TStringList.Create;

     try
        // Define custom data
        SetStandardDateTimeFormats;
        mDate         := FormatDateTime('YYYY/MM/DD',Now)+' - <b>'+FormatDateTime('dddd',Now)+'</b>';
        mTime         := FormatDateTime('hh:nn:ss',Now);

        ////////// HEADER /////////////////
        // Refresh every so many minutes
        NetHubHTMLHeader(60, 'TeleFlow Conference', 'images/systemconf.jpg', Glob_Reg_ServerName, mDate, mTime, mStringListSts);
        ////////// HEADER /////////////////

        //NetHubHTML('<FORM method=GET  action="http://localhost:5048/">', mStringListSts);
        // pHostAsKnownByRequestor??
        NetHubHTML('<FORM method=GET  action="../conferenceaccess.html">', mStringListSts);

        // Add a gap
        NetHubStatusSpacer(mStringListSts);
        NetHubInputField('Conference Number', 'ConfNum', '', clEngHTMLDefault,  10,  10, mStringListSts);
        NetHubInputField('Your Contact Info', 'ConfCon', '', clEngHTMLDefault,  50, 100, mStringListSts);
        // Add a gap
        NetHubStatusSpacer(mStringListSts);
        NetHubSubmitButton('Join', clEngHTMLDefault, mStringListSts);

        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

        // Write it
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

     finally
        mStringListSts     .Free;
     end;
end;  // NetHubGenerateConference


// Create the page for a conference that is created
function NetHubGenerateConferenceAccess(pHostAsKnownByRequestor, pConfNum, pWebAdd: String): TStringList;
var
   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);
     // First, create the result TStringList
     Result := TStringList.Create;

     // Does conference exist in the list?
     if true then
     begin
          NetHubGenerateMessage('Conference '+pConfNum+' is not currently available');
     end;
end;


// Generate the wordverify.html
function NetHubGenerateWordVerify(pHostAsKnownByRequestor, pFileName: String): TStringList;
var
   mDate           : String;
   mTime           : String;

   mStringListSts  : TStringList;

   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);

     // First, create the result TStringList
     Result := TStringList.Create;

     // Create StringList
     mStringListSts    := TStringList.Create;

     try
        // Define custom data
        SetStandardDateTimeFormats;
        mDate         := FormatDateTime('YYYY/MM/DD',Now)+' - <b>'+FormatDateTime('dddd',Now)+'</b>';
        mTime         := FormatDateTime('hh:nn:ss',Now);

        ////////// HEADER /////////////////
        // Refresh every so many minutes
        NetHubHTMLHeader(60, 'TeleFlow WordVerify', 'images/systemwordverify.jpg', Glob_Reg_ServerName, mDate, mTime, mStringListSts);
        ////////// HEADER /////////////////

        NetHubHTML('<FORM method=GET  action="../wordverifyaccess.html">', mStringListSts);

        // Add a gap
        NetHubStatusSpacer(mStringListSts);
        NetHubInputField('Callout Telephone #', 'ConfNum', '', clEngHTMLDefault,  10,  10, mStringListSts);
        // Add a gap
        NetHubStatusSpacer(mStringListSts);
        NetHubSubmitButton('View', clEngHTMLDefault, mStringListSts);

        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

        // Write it
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

     finally
        mStringListSts     .Free;
     end;
end;  // NetHubGenerateConference



// Generate the full Monitor Client report
function  NetHubGenerateMonitor(pHostAsKnownByRequestor, pFileName: String): TStringList;
var
   mStringListSts  : TStringList;
   mMonitorInfo    : TStringList;

   // Gather data
   mDate           : String;
   mTime           : String;
   mTemp           : String;
   mColor          : String;
   mRecord         : String;

   // TeleFlow Monitor information
   mStNormal       : Integer;
   mStStopped      : Integer;
   mStRestarted    : Integer;
   mStEnded        : Integer;

   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);

     // First, create the TStringList
     Result := TStringList.Create;

     mMonitorInfo       := TStringList.Create;
     mStringListSts     := TStringList.Create;
     try
        // Define custom data
        SetStandardDateTimeFormats;
        mDate         := FormatDateTime('YYYY/MM/DD',Now)+' (<b>'+FormatDateTime('dddd',Now)+'</b>)';
        mTime         := FormatDateTime('hh:nn:ss',Now());


        ////////// HEADER /////////////////
        // Refresh every so many minutes (NetHub Editor sets)
        NetHubHTMLHeader(Glob_Reg_HTTPRefresh, 'enGenic: Monitor System', 'images/monitor.jpg', Glob_Reg_ServerName, mDate, mTime, mStringListSts);
        ////////// HEADER /////////////////

        // TeleFlow Monitor Information gather
        ////////////////////////////////////////
        // Add a gap
        NetHubStatusSpacer(mStringListSts);

        try
           // TeleFlow Monitor Information gather
           mMonitorInfo := TeleFlowMonitorClient( cLocalHost,
                                                  False,        // Include only errors
                                                  mStNormal,
                                                  mStStopped,
                                                  mStRestarted,
                                                  mStEnded );
           // Display the totals
           mColor   := clEngHTMLDefault;
           NetHubStatusText('', 'Monitor',         cHTMLSpace,                mColor,           mStringListSts);

           mColor   := clEngHTMLDefault;
           mTemp    := 'Normal';
           mRecord  := IntToStr(mStNormal   );
           NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightNormal    +mRecord,         mColor,           mStringListSts);
           mColor   := clEngHTMLDefault;
           mTemp    := 'Stopped';
           mRecord  := IntToStr(mStStopped   );
           if mStStopped > 0 then
           begin
                mColor   := clEngHTMLRed;
           end;
           NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightStopped   +mRecord,         mColor,           mStringListSts);
           mColor   := clEngHTMLDefault;
           mTemp    := 'Restarted';
           mRecord  := IntToStr(mStRestarted   );
           if mStRestarted > 0 then
           begin
                mColor   := clEngHTMLOrange;
                mRecord  := mRecord + cRestartTxt;
           end;
           NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightRestarted +mRecord,         mColor,           mStringListSts);
           mColor   := clEngHTMLDefault;
           mTemp    := 'Ended';
           mRecord  := IntToStr(mStEnded   );
           NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightEnded     +mRecord,         mColor,           mStringListSts);
           // ---
           // Add a gap
           NetHubStatusSpacer(mStringListSts);
           // Add the monitor info here
           mStringListSts.AddStrings(mMonitorInfo);
        except

        end;

        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

     finally
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

        mStringListSts     .Free;
        mMonitorInfo       .Free;
     end;

end; // NetHubGenerateMonitor



// Generate the System health report
function NetHubGenerateSystemHealth(pHostAsKnownByRequestor, pFileName: String; pIncludeFileScans: Boolean; pStartDate, pStartTime, pMBServed, pMBReceived: String): TStringList;
const
   // .Exe(s) that are running on the system
   cTFServer      = 'TFServer';
   cFileWatcher   = 'FileWatcher';
   cDataManager   = 'DataManager';

var
   mStringListWeb  : TStringList;
   mStringListSts  : TStringList;
   mStringListFiles: TStringList;
   mStringListCont : TStringList;
   mServicesList   : TStringList;
   mMonitorInfo    : TStringList;

   // Gather data
   mTotal          : Integer;
   mLoop           : Integer;
   mLoop2          : Integer;
   mCount          : Integer;
   mLines          : Integer;
   mDate           : String;
   mTime           : String;
   mTemp           : String;
   mDrive          : String;
   mDriveList      : String;
   mNumDrive       : Integer;
   mFree           : Integer;
   mSize           : Integer;
   mFileSize       : Integer;
   mPercent        : Integer;
   mFound          : Boolean;

   // Other
   //F3              : TextFile;
   F3              : File Of Byte;
   b               : array[0..3] of byte;
   mRecord         : String;
   mColor          : String;
   mFileName       : String;
   mLogDir         : String;
   mUpdatesDir     : String;
   mVersion        : String;
   mStarted        : String;
   mDays           : String;
   mFileAge        : Real;
   mRef            : String;
   mInfo           : String;

   // Rep Fields
   mField01        : String;
   mField02        : String;
   mField03        : String;
   mField04        : String;

   // Time tests
   mTimeGreen      : Integer;
   mTimeOrange     : Integer;
   mHoursStarted   : Integer;
   mDateTime       : TDateTime;

   // Ip Address
   mIpAddress      : String;

   // TeleFlow Monitor information
   mStNormal       : Integer;
   mStStopped      : Integer;
   mStRestarted    : Integer;
   mStEnded        : Integer;

   mHost           : String;
begin
     mHost  := NetHubDetermineServerName(pHostAsKnownByRequestor);

     // First, create the TStringList
     Result := TStringList.Create;

     // Create StringList
     mStringListWeb     := TStringList.Create;
     mStringListSts     := TStringList.Create;
     mStringListFiles   := TStringList.Create;
     mStringListCont    := TStringList.Create;
     mServicesList      := TStringList.Create;
     mMonitorInfo       := TStringList.Create;

     // Clear the HealthStrings, and set to XML
     GlobHealthInfo     := XMLHeader;
     GlobHealthWarnings := '';
     GlobHealthErrors   := '';
     GlobHealthMsgs     := 0;

     try
        // Define custom data
        SetStandardDateTimeFormats;
        mDate         := FormatDateTime('YYYY/MM/DD',Now)+' (<b>'+FormatDateTime('dddd',Now)+'</b>)';
        mTime         := FormatDateTime('hh:nn:ss',Now());


        ////////// HEADER /////////////////
        // Refresh every so many minutes (NetHub Editor sets)
        NetHubHTMLHeader(Glob_Reg_HTTPRefresh, 'enGenic: System Health System', 'images/systemhealth.jpg', Glob_Reg_ServerName, mDate, mTime, mStringListSts);
        ////////// HEADER /////////////////

        // Add a gap
        NetHubStatusSpacer(mStringListSts);

        // Determine how long the system has been running for
        mHoursStarted := round(HoursDifference(GlobNetHubStartTimeStamp, Now));
        mDate         := FormatDateTime('YYYY/MM/DD',GlobNetHubStartTimeStamp)+' (<b>'+FormatDateTime('dddd',GlobNetHubStartTimeStamp)+'</b>)';
        mTime         := FormatDateTime('hh:nn:ss',GlobNetHubStartTimeStamp);
        // Format
        NetHubStatusText('', 'NetHub Started',        mDate+' '+mTime,                clEngHTMLDefault, mStringListSts);
        // Put some colors in place to give an indication of trouble
        mColor := clEngHTMLDefault;
        mTemp  := Format('%.2f', [round((HoursDifference(GlobNetHubStartTimeStamp, Now) * 100)) / 100])+' Hours';
        // If the server was started recently, perhaps there was a problem
        if mHoursStarted < 18 then
        begin
             mColor := clEngHTMLOrange;
             mTemp  := mTemp + ' (Review Status)';
        end;
        NetHubStatusText('System', cTabIn+'Run Time',       mTemp,                              mColor, mStringListSts);

        // NetHub Version
        mColor := clEngHTMLDefault;
        mTemp  := RecordParseCustomDelimiter(GlobVersionNetHub,'~',2) + ' ('+RecordParseCustomDelimiter(GlobVersionNetHub,'~',5)+')';
        NetHubStatusText('', cTabIn+'Version',   mTemp,                              mColor, mStringListSts);

        // Bytes served
        mColor := clEngHTMLDefault;
        NetHubStatusText('', cTabIn+'Data Served',   pMBServed+' MB',                              mColor, mStringListSts);
        NetHubStatusText('', cTabIn+'Data Received', pMBReceived+' MB',                              mColor, mStringListSts);

        // Add a gap
        NetHubStatusSpacer(mStringListSts);

        // Notes and instructions
        NetHubStatusText('', 'Notes',        Glob_Reg_Notes,                      clEngHTMLDefault, mStringListSts);
        if fileExists(IncludeTrailingPathDelimiter(Glob_Reg_HTTPRoot)+'instructions.html') then
        begin
             mRef  := '<a href="instructions.html">System Instructions</a>';
             NetHubStatusText('', '',   mRef ,                                         clEngHTMLDefault, mStringListSts);
        end;

        // Add a gap
        NetHubStatusSpacer(mStringListSts);

        // GetOSInfo
        ////////////////
        NetHubStatusText('', 'Computer Name',GetLocalComputerName,                clEngHTMLDefault, mStringListSts);
        NetHubStatusText('', cTabIn+'Operating System',GetOSInfo,                    clEngHTMLDefault, mStringListSts);

        // GetCPU Speed
        ////////////////
        NetHubStatusText('', cTabIn+'CPU', GetCpuSpeed,                              clEngHTMLDefault, mStringListSts);
        // Number processors
        mTotal := GetNumberProcessors;
        if mTotal > 1 then
        begin
             mRecord := IntToStr(mTotal) + ' ('+IntToStr(Round(mTotal / 2))+' if Hyperthreaded)';
        end
        else
        begin
             mRecord := IntToStr(mTotal);
        end;
        NetHubStatusText('', cTabIn+'# Processors', mRecord,   clEngHTMLDefault, mStringListSts);

        // Get Memory
        ////////////////
        NetHubStatusText('', cTabIn+'RAM: Physical',GetPhysicalMemory,               clEngHTMLDefault, mStringListSts);
        NetHubStatusText('', cTabIn+'RAM: Virtual',GetVirtualMemory,                 clEngHTMLDefault, mStringListSts);

        // Get IPs
        ////////////////
        try
           mStringListFiles := GetLocalIps;
           for mLoop := 0 to mStringListFiles.Count - 1 do
           begin
                if mLoop = 0 then
                begin
                     // Lets assume the first IP Address is best
                     mIpAddress := Trim(mStringListFiles[mLoop]);
                end;
                NetHubStatusText('', cTabIn+'IP Address',mStringListFiles[mLoop],       clEngHTMLDefault, mStringListSts);
           end;
        except
        end;

        // Drive space
        ////////////////
        try
           mDriveList    := GetLocalHardDrives;
           for mLoop := 1 to length(mDriveList) do
           begin
                mDrive := Copy(mDriveList,mLoop,1);
                if (mDrive >= 'A') and (mDrive <= 'Z') then
                begin
                     mNumDrive := Pos(mDrive,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
                     mSize     := Round(DiskSize(mNumDrive) / (1024 * 1024 * 1024));
                     mFree     := Round(DiskFree(mNumDrive) / (1024 * 1024 * 1024));

                     //mResult := mResult + mDrive + ':' + IntToStr(mFree) + ' MB   ';
                     mPercent  := Round(mFree / mSize * 100);

                     mColor := clEngHTMLGreen;
                     if mFree <= 1 then
                     begin
                          // If we are red, then reset the bar to make it as big as possible!
                          mColor   := clEngHTMLRed;
                          mPercent := 100;
                     end
                     else
                     if mFree <= 3 then
                     begin
                          mColor := clEngHTMLOrange;
                     end;

                     // Add as as status bar
                     NetHubStatusBarAdd('Harddrive', cTabIn+'Drive '+mDrive+': = '+CommaIntToStr(mFree)+' GB Free', mColor, mPercent, mStringListSts);
                end;
           end; // drivespace
        except
        end;

        // Other Settings (registry
        //NetHubStatusText('', cTabIn+'Log Dir ',         GlobRegLOGDIRECTORY,                mColor,           mStringListSts);


        // Add a gap
        NetHubStatusSpacer(mStringListSts);


        // Get system reports
        // ========================
        try
           mLogDir   := IncludeTrailingPathDelimiter(Glob_Reg_HTTPRoot); //GlobRegLOGDIRECTORY);
           if DirectoryExists(mLogDir) then
           begin
                mColor   := clEngHTMLDefault;
                NetHubStatusText('', 'System Reports',   Glob_Reg_HTTPRoot+cHTMLSpace,   mColor,           mStringListSts);

                // Add the RSS Feed home
                mRecord := mHost;
                mRef  := '<a href="'+mRecord+'/'+cSystemHealthRSS+'">'+mRecord+'/'+cSystemHealthRSS+'</a>';
                NetHubStatusText('', cTabIn+'RSS Feed',  mRef,    clEngHTMLDefault, mStringListSts);

                // Find the reports and add them
                ScanDirMask('*.rep');
                // Just the current dir
                ScanDirectory(mLogDir);
                ScanDirTop;

                if ScanDirCount = 0 then
                begin
                     NetHubStatusText('', cTabIn+'None found',   cHTMLSpace,               mColor,           mStringListSts);
                end
                else
                begin
                     // build the file list
                     mStringListFiles.Clear;
                     for mLoop := 0 to ScanDirCount - 1 do
                     begin
                          mFileName := ScanDirFetchNext;
                          mStringListFiles.Add(mFileName);
                     end;
                     // Order list
                     mStringListFiles.Sort;

                     // Roll through the strings
                     for mLoop := 0 to mStringListFiles.Count - 1 do
                     begin
                          mFileName := mStringListFiles[mLoop];
                          mFileAge  := FileDateToDateTime(FileAge(mFileName));

                          // Load the data
                          mStringListCont.LoadFromFile(mFileName);
                          // File Contents  1........2....3..4
                          // eg:  echo File Transfer~Info~10~30 >> FileTransfer.Rep
                          // Where
                          // 1: Title on System Health
                          // 2: Information (eg: Number of records etc
                          // 3: Display as Green if FileAge (of rep) is 10 minutes or less
                          // 4: Display as Orange if FileAge (of rep) is 30 minutes or less
                          // -- Otherwise, display Red

                          // Loop through up to 10 entries
                          for mLines := 0 to mStringListCont.Count - 1 do
                          begin
                               mField01 := RecordParseCustomDelimiter(mStringListCont[mLines],'~',1);
                               mField02 := RecordParseCustomDelimiter(mStringListCont[mLines],'~',2);
                               mField03 := RecordParseCustomDelimiter(mStringListCont[mLines],'~',3);
                               mField04 := RecordParseCustomDelimiter(mStringListCont[mLines],'~',4);

                               // Get the times worked out
                               mTimeOrange := StrToIntDef(mField04,-1);
                               mTimeGreen  := StrToIntDef(mField03,-1);

                               // Decide if we have enough to display
                               if mField01 <> '' then
                               begin
                                    mColor := clEngHTMLRed;
                                    if (mTimeOrange > 0) and (mTimeGreen > 0) then
                                    begin
                                         // Less than an hour?
                                         if (mFileAge + mTimeOrange/3600) > Now then
                                         begin
                                              mColor := clEngHTMLOrange;
                                         end;

                                         // Less than an hour?
                                         if (mFileAge + mTimeGreen/3600) > Now then
                                         begin
                                              mColor := clEngHTMLGreen;
                                         end;
                                    end;

                                    // Write it to the page
                                    mRef  := mField02 + ' (' + ExpressAge(mFileAge, '','','') + ')';

                                    NetHubStatusText('SystemReport', cTabIn+''+mField01,   mRef ,  mColor,           mStringListSts);
                               end;

                               // No more than 10 lines processed
                               if mLines > 9 then
                               begin
                                    break;
                               end
                          end;
                     end;
                end;
           end;
        except
        end;


        // Add a gap
        NetHubStatusSpacer(mStringListSts);


        // Get Services List
        try
           // Do we have a defined list of services?
           if GlobServicesList.Count > 0 then
           begin
                mColor   := clEngHTMLDefault;
                NetHubStatusText('', 'Service Display Names',         cHTMLSpace,                mColor,           mStringListSts);

                // Get list of services.  Second Parm = '' to get full list
                EnumServicesList(mServicesList, '');

                // Loop through our list of services that are definde the TFNetHubServices.cfg file
                // -- Is the service located in the list?
                for mLoop2 := 0 to GlobServicesList.Count - 1 do
                begin
                     // Do we have the name
                     mTemp    := GlobServicesList[mLoop2];
                     mRecord  := 'NOT INSTALLED';
                     mColor   := clEngHTMLOrange;

                     // Roll through the list of installed services
                     for mLoop := 0 to mServicesList.Count - 1 do
                     begin
                          // Break up the fields of each service enumerated
                          mField01 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',1);  // Exename
                          mField02 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',2);  // Status
                          mField03 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',3);  // Display name

                          //cSTOPPED
                          //cSTART_PENDING
                          //cSTOP_PENDING
                          //cCONTINUE_PENDING
                          //cPAUSE_PENDING
                          //cPAUSED

                          // Did we find it?
                          if UpperCase(mTemp) = UpperCase(mField03) then
                          begin
                               mRecord  := mField02+' ('+mField01+')';
                               mColor   := clEngHTMLRed;

                               if mField02 = cRUNNING then
                               begin
                                    mColor   := clEngHTMLGreen;
                               end;
                               break;
                          end;
                     end;

                     // Display it
                     NetHubStatusText('Service', cTabIn+''+mTemp,        mRecord,         mColor,           mStringListSts);
                end; // for
           end
           else
           // Roll through our standard list of services
           begin
                mColor   := clEngHTMLDefault;
                NetHubStatusText('', 'Services (Standard)',         cHTMLSpace,                mColor,           mStringListSts);

                // Get list of services.  Second Parm = '' to get full list
                EnumServicesList(mServicesList, cTFServices);

                // Roll through the list of installed services
                for mLoop := 0 to mServicesList.Count - 1 do
                begin
                     // Break up the fields of each service enumerated
                     mField01 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',1);  // Exename
                     mField02 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',2);  // Status
                     mField03 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',3);  // Display name

                     //cSTOPPED
                     //cSTART_PENDING
                     //cSTOP_PENDING
                     //cCONTINUE_PENDING
                     //cPAUSE_PENDING
                     //cPAUSED
                     mRecord  := mField02+' ('+mField01+')';
                     mColor   := clEngHTMLRed;


                     // Test for a few "standard" services
                     // -- Is our service running?
                     if LeftCharUpperCaseCompare(cRUNNING ,mField02, 6) then
                     begin
                          mColor   := clEngHTMLDefault;
                     end
                     // Test for Task modes
                     else
                     begin
                          // TeleFlow???
                          if  LeftCharUpperCaseCompare(cTFServer, mField01, 8) then
                          begin
                               // See if there is a task
                               if WindowsTaskExists(cTFServer) then
                               begin
                                    mColor   := clEngHTMLOrange;
                                    mRecord  := 'Running in Task Mode';
                               end;
                          end
                          // DataManager???
                          else if  LeftCharUpperCaseCompare(cDataManager, mField03, 8) then
                          begin
                               // See if there is a task
                               if WindowsTaskExists(cDataManager) then
                               begin
                                    mColor   := clEngHTMLOrange;
                                    mRecord  := cDataManager+' in Task Mode';
                               end;
                          end
                          // FileWatcher???
                          else if  LeftCharUpperCaseCompare(cFileWatcher, mField03, 8) then
                          begin
                               // See if there is a task
                               if WindowsTaskExists(cFileWatcher) then
                               begin
                                    mColor   := clEngHTMLOrange;
                                    mRecord  := cFileWatcher + ' in Task Mode';
                               end;
                          end
                     end;

                     // Display it
                     NetHubStatusText('Service', cTabIn+''+mField03,        mRecord,         mColor,           mStringListSts);
                end;
           end;
        except
        end; // Services



        // Only if TeleFlow exists on this system
        if Glob_TeleFlowInstalled then
        begin

             // Add a gap
             NetHubStatusSpacer(mStringListSts);

             try
                // Get Registry Settings
                SetStandardDateTimeFormats;
                mColor := clEngHTMLDefault;
                if (GlobRegEXPDATE = cUnreg) or (GlobRegEXPDATE = '') then
                begin
                     mInfo  := 'for Demonstration Only';
                     mColor := clEngHTMLOrange;
                end
                else
                begin
                     mInfo  := 'Until '+GlobRegEXPDATE;
                     // Are we within 2 weeks
                     if DateStringSubtract(GlobRegEXPDATE, 14) < FormatDateTime('yyyy/mm/dd', Now) then
                     begin
                          mColor := clEngHTMLRed;
                          mInfo  := mInfo + ' (' + IntToStr(Round(StrToDate(Copy(GlobRegEXPDATE,1,10)) - Now)) + ' Days)';
                     end
                     else
                     // Are we within 3 months
                     if DateStringSubtract(GlobRegEXPDATE, 90) < FormatDateTime('yyyy/mm/dd', Now) then
                     begin
                          mColor := clEngHTMLOrange;
                          mInfo  := mInfo + ' (' + IntToStr(Round(StrToDate(Copy(GlobRegEXPDATE,1,10)) - Now)) + ' Days)';
                     end;
                end;
                if Copy(GlobRegEXPDATE,1,4) = '9999' then
                begin
                     mInfo := 'No Expiry';
                end;


                // TeleFlow
                //////////////////
                NetHubStatusText('', 'TeleFlow Licensed',        mInfo+cHTMLSpace,           mColor,           mStringListSts);
                NetHubStatusText('', cTabIn+'For Ports',            GlobRegNUMPORTS+cHTMLSpace, mColor,           mStringListSts);

                // How long has it been since windows started
                mDateTime := YYYYMMDDHHNNSStoDateTime(GlobRegWINSTART);
                // Determine how long the system has been running for
                mHoursStarted := round(HoursDifference(mDateTime, Now));
                mDate         := FormatDateTime('YYYY/MM/DD',mDateTime)+' (<b>'+FormatDateTime('dddd',mDateTime)+'</b>)';
                mTime         := FormatDateTime('hh:nn:ss',mDateTime);
                // Format
                NetHubStatusText('', cTabIn+'Server Started',        mDate+' '+mTime,                clEngHTMLDefault, mStringListSts);
                // Put some colors in place to give an indication of trouble
                mColor := clEngHTMLDefault;
                mTemp  := Format('%.2f', [round((HoursDifference(mDateTime, Now) * 100)) / 100])+' Hours';
                // If the server was started recently, perhaps there was a problem
                if mHoursStarted < 18 then
                begin
                     mColor := clEngHTMLOrange;
                     mTemp  := mTemp + ' (Review Status)';
                end;
                NetHubStatusText('TeleFlow', cTabIn+'Run Time',       mTemp,                              mColor, mStringListSts);


                // Get Log information
                mColor    := clEngHTMLDefault;
                mLogDir   := IncludeTrailingPathDelimiter(GlobRegLOGDIRECTORY);

                // ****WARNING**** This file is locked by TFServer when running... must read with readonly
                if pIncludeFileScans then
                begin
                     try
                        // Scan for the last TFServer_20xx-xx-xx.log file
                        ScanDirMask('*.Log');
                        // Just the current dir
                        ScanDirectory(mLogDir);
                        ScanDirTop;

                        // build the file list
                        mStringListFiles.Clear;
                        for mLoop := 0 to ScanDirCount - 1 do
                        begin
                             mFileName := ScanDirFetchNext;
                             // //                                    1234567890
                             // if Copy(UpperCase(mFileName),1,10) = 'TFSERVER_2' then
                             begin
                                  mStringListFiles.Add(mFileName);
                             end;
                        end;
                        // Order list, and get teh last entry
                        mStringListFiles.Sort;


                        mFileName := '';
                        if mStringListFiles.Count > 0 then
                        begin
                             mFileName := mStringListFiles.Strings[mStringListFiles.Count - 1];
                        end;


                        if FileExists(mFilename) then
                        begin
                             // NOTE: This does not work because TFServer has a read lock on the file
                             //mStringListCont.LoadFromFile(mFilename);
                             //mRecord        := mStringListCont[0];


                             (* This should work... but it still failed so....
                             {$I-}
                             AssignFile(F3, mFileName);
                             FileMode := 0;  // Set file access to read only
                             Reset(F3);
                             while not(eof(F3)) do
                             begin
                                  Readln (F3, mRecord);
                                  // We only want the first line
                                  break;
                             end;
                             CloseFile(F3);
                             {$I+}
                             *)

                             mCount  := 0;
                             mRecord := '';
                             // F3 : File Of Byte;
                             // b : array[0..3] of byte;
                             GlobDebug   := IntToStr(IOResult);  // This MUST happen before each write
                             {$I-}
                             AssignFile(F3,mFileName);
                             FileMode := 0; // Set file access to read only
                             reset(F3);
                             //size := FileSize(F3);
                             while not(eof(F3)) do
                             begin
                                 BlockRead(F3,b[0],1);

                                 // Only one line
                                 if Char(b[0]) = #13 then
                                 begin
                                      // add a ~
                                      mRecord := mRecord + '~';

                                      mCount := mCount + 1;
                                      if mCount = 8 then
                                      begin
                                           break;
                                      end;
                                 end
                                 else
                                 begin
                                      mRecord := mRecord + Char(b[0]);
                                 end;
                             end;
                             CloseFile(F3);
                             {$I+}


        //  NetHubStatusText('', 'mRecord',        mRecord,           mColor,           mStringListSts);
                             (*
                                enGenic TeleFlow: Build 2006.0210
                                (c) 1994 - 2006 enGenic
                                All rights reserved.

                                2006/02/14 13:06:38.781:  Dynamically loading board DLL at run-time.
                                2006/02/14 13:06:38.781:  LoadBoardFunctions: Start
                                2006/02/14 13:06:38.828:  LoadBoardFunctions: Success.
                             *)

                             mField01 := 'Unknown';
                             mField02 := 'Unknown';
                             // Search for a Build number
                             mCount  := 0;
                             while mCount < 5 do
                             begin
                                  mField01 := RecordParseCustomDelimiter(mRecord,'~',mCount);
                                  if Pos(':',mField01) > 0 then
                                  begin
                                       // Get all the data from relative positions
                                       mField01 := RecordParseCustomDelimiter(mRecord,'~',mCount);  // Build
                                       mCount := mCount + 4;
                                       mField02 := RecordParseCustomDelimiter(mRecord,'~',mCount);  // Start time

                                       // Pull out the relevant pull
                                       mField01 := Trim(RecordParseCustomDelimiter(mField01,':',2));
                                       mField02 := Trim(Copy(mField02,1,29));
                                       mField02 := Copy(mField02,1,16) + '  ('+ IntToStr(DaysBetween(Now, StrToDate(Copy(mField02,1,10))))+ ' days)';

                                       break;
                                  end;

                                  inc(mCount);
                             end;

                             //NetHubStatusText('', mRecord,  '*'+mRecord+'*',  mColor,   mStringListSts);
                             // eg: enGenic TeleFlow: Build 2006.0210
                             mVersion       := mField01;
                             //NetHubStatusText('', mVersion,  '*'+mVersion+'*',  mColor,   mStringListSts);
                             mStarted       := mField02;
                             //NetHubStatusText('', mStarted,  '*'+mStarted+'*',  mColor,   mStringListSts);
                        end
                        else
                        begin
                             mColor         := clEngHTMLOrange;
                             mVersion       := 'Not Yet Initiated';
                             mStarted       := 'Not Running';
                        end;

                        // Version
                        NetHubStatusText('', cTabIn+'Version',              mVersion,                mColor,           mStringListSts);
                        // Start time (days = over midnights)
                        NetHubStatusText('', cTabIn+'Last Started',         mStarted,                mColor,           mStringListSts);
                     except
                     end;
                end; // if pIncludeFileScans

                mColor := clEngHTMLDefault;
                if not DirectoryExists(GlobRegINSTALLDIRECTORY) then
                begin
                     mColor := clEngHTMLRed;
                end;
                NetHubStatusText('', cTabIn+'Installed Dir',        GlobRegINSTALLDIRECTORY,  mColor,           mStringListSts);
                mColor := clEngHTMLDefault;
                if not DirectoryExists(GlobRegLOGDIRECTORY) then
                begin
                     mColor := clEngHTMLRed;
                end
                else
                begin
                     // Test once an hour
                     if GlobTotalSizeTestTime < (Now - 1/12) then
                     begin
                          // Save new test time
                          GlobTotalSizeTestTime := Now;

                          // Reset the size (so that we dont add)
                          GlobTotalSize := 0;
                          // WARNING: This is very SLOW, because it rolls through everyfile to read its size
                          FindLogSize(GlobRegLOGDIRECTORY);
                     end;
                end;
                NetHubStatusText('', cTabIn+'Log Dir',              GlobRegLOGDIRECTORY,      mColor,            mStringListSts);
                // Log lines size
                if GlobRegMAXLOGFILESIZE < 0 then
                begin
                     mRecord := IntToStr(GlobRegLOGLINES)+' / Unlimited';
                end
                else
                begin
                     mRecord := IntToStr(GlobRegLOGLINES)+' / '+IntToStr(GlobRegMAXLOGFILESIZE);
                end;
                NetHubStatusText('', cTabIn+'Log Lines/Max',        mRecord,                  clEngHTMLDefault,  mStringListSts);
                // How big is the log file
                mColor := clEngHTMLDefault;
                if BtoMB(Abs(GlobTotalSize)) > 2000 then // GB
                begin
                     mColor := clEngHTMLOrange;
                end;
                if BtoMB(Abs(GlobTotalSize)) > 8000 then // GB
                begin
                     mColor := clEngHTMLRed;
                end;
                NetHubStatusText('', cTabIn+'Log Size',              IntToStr(Abs(BtoMB(GlobTotalSize)))+' MB'                            , clEngHTMLDefault,  mStringListSts);


                // TeleFlow Monitor Information gather
                ////////////////////////////////////////
                // Add a gap
                NetHubStatusSpacer(mStringListSts);
  (*  OFF UNTIL WE FIX THE PROBLEM
                // TeleFlow Monitor Information gather
                mMonitorInfo := TeleFlowMonitorClient( cLocalHost,
                                                       true,        // Include only errors
                                                       mStNormal,
                                                       mStStopped,
                                                       mStRestarted,
                                                       mStEnded );
                // Display the totals
                mColor   := clEngHTMLDefault;
                NetHubStatusText('', 'TeleFlow Monitor',         cHTMLSpace,                mColor,           mStringListSts);

                mColor   := clEngHTMLDefault;
                mTemp    := 'Normal';
                mRecord  := IntToStr(mStNormal   );
                NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightNormal    +mRecord,         mColor,           mStringListSts);
                mColor   := clEngHTMLDefault;
                mTemp    := 'Stopped';
                mRecord  := IntToStr(mStStopped   );
                if mStStopped > 0 then
                begin
                     mColor   := clEngHTMLRed;
                end;
                NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightStopped   +mRecord,         mColor,           mStringListSts);
                mColor   := clEngHTMLDefault;
                mTemp    := 'Restarted';
                mRecord  := IntToStr(mStRestarted   );
                if mStRestarted > 0 then
                begin
                     mColor   := clEngHTMLOrange;
                     mRecord  := mRecord + cRestartTxt;
                end;
                NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightRestarted +mRecord,         mColor,           mStringListSts);
                mColor   := clEngHTMLDefault;
                mTemp    := 'Ended';
                mRecord  := IntToStr(mStEnded   );
                NetHubStatusText('Monitor', cTabIn+''+mTemp,        cLightEnded     +mRecord,         mColor,           mStringListSts);
                // ---
                // Add the monitor info here
                mStringListSts.AddStrings(mMonitorInfo);
  *)
             except
             end;


             // Add a gap
             NetHubStatusSpacer(mStringListSts);


             // Log Files scan
             // ========================
             if pIncludeFileScans then
             begin
                  try
                     mLogDir   := IncludeTrailingPathDelimiter(GlobRegLOGDIRECTORY);
                     if DirectoryExists(mLogDir) then
                     begin
                          mColor   := clEngHTMLDefault;
                          NetHubStatusText('', 'TeleFlow Logging',         cHTMLSpace,                mColor,           mStringListSts);

                          ScanDirMask('*.log');
                          // Just the current dir
                          ScanDirectory(mLogDir);
                          ScanDirTop;

                          // build the file list
                          mStringListFiles.Clear;
                          for mLoop := 0 to ScanDirCount - 1 do
                          begin
                               mFileName := ScanDirFetchNext;
                               mStringListFiles.Add(mFileName);
                          end;
                          // Order list
                          mStringListFiles.Sort;


                          // Roll through the strings
                          for mLoop := 0 to mStringListFiles.Count - 1 do
                          begin
                               mFileName := mStringListFiles[mLoop];

                               mFileSize := ReadFileSize(mFileName);
                               if BtoMB(mFileSize) < 1 then
                               begin
                                    mInfo := ' ('+IntToStr(Round(mFileSize / 1024))+' KB)';
                               end
                               else
                               begin
                                    mInfo := ' ('+IntToStr(BtoMB(mFileSize))+' KB)';
                               end;

                               if not ((Pos('TFSERVER',     UpperCase(ExtractFileName(mFileName))) > 0) or
                                       (Pos('TFSIMULATOR',  UpperCase(ExtractFileName(mFileName))) > 0)) then
                               begin
                                    mFileAge := FileDateToDateTime(FileAge(mFileName));

                                    mColor   := clEngHTMLDefault;
                                    mDays := ' ('+ ExpressAge(mFileAge, '','','')+')';

                                    // Less than an hour?
                                    if (mFileAge + 1/24) > Now then
                                    begin
                                         mColor := clEngHTMLDefault; // clEngHTMLRed;
                                         mDays := ' ('+ ExpressAge(mFileAge, '','','')+')';
                                    end
                                    else
                                    // Within three days
                                    if (mFileAge + 3) > Now then
                                    begin
                                         mColor := clEngHTMLDefault; // clEngHTMLOrange;
                                         mDays := ' <b>('+ ExpressAge(mFileAge, '','','')+')</b>';
                                    end;

                                    //mRecord := 'http://'+mIpAddress+':'+IntToStr(Glob_Reg_HTTPVMSP);
                                    mRecord := mHost;

                                    // Write it to the page
                                    //mDays := ' ('+ IntToStr(DaysBetween(Now, mFileAge))+' days)';
                                    mRef  := '<a href="'+mRecord+'/'+ExtractFileName(mFileName)+'">'+ExtractFileName(mFileName)+mDays+mInfo+'</a>';

                                    NetHubStatusText('', cTabIn+'Log File '+RightCopy('000'+IntToStr(mLoop + 1),3),   mRef ,  mColor,           mStringListSts);
                               end;
                          end;

                     end
                     else
                     begin
                          mColor := clEngHTMLRed;
                          NetHubStatusText('', 'TeleFlow Logging',     'Missing Log Directory: '+mLogDir,  mColor,     mStringListSts);
                     end;
                  except
                  end;
             end; // if pIncludeFileScans
        end;


        // Add a gap
        NetHubStatusSpacer(mStringListSts);


        // Get system downloads
        // ========================
        if pIncludeFileScans then
        begin
             try
                mUpdatesDir := IncludeTrailingPathDelimiter(AcquireFileBaseDirectory() + IncludeTrailingPathDelimiter('updates'));

                if DirectoryExists(mUpdatesDir) then
                begin
                     mColor   := clEngHTMLDefault;
                     NetHubStatusText('', 'System Downloads',         cHTMLSpace,                mColor,           mStringListSts);

                     ScanDirMask('*.zip');
                     // Just the current dir
                     ScanDirectory(mUpdatesDir);
                     ScanDirTop;

                     // build the file list
                     mStringListFiles.Clear;
                     for mLoop := 0 to ScanDirCount - 1 do
                     begin
                          mFileName := ScanDirFetchNext;
                          mStringListFiles.Add(mFileName);
                     end;
                     // Order list
                     mStringListFiles.Sort;

                     // Roll through the strings
                     for mLoop := 0 to mStringListFiles.Count - 1 do
                     begin
                          mFileName := mStringListFiles[mLoop];
                          mFileAge  := FileDateToDateTime(FileAge(mFileName));

                          // The main http page
                          //mRecord := 'http://'+mIpAddress+':'+IntToStr(Glob_Reg_HTTPVMSP);
                          mRecord := mHost;

                          // Write it to the page
                          mDays := ' ('+ ExpressAge(mFileAge, '','','')+')';
                          mRef  := '<a href="'+mRecord+'/'+ExtractFileName(mFileName)+'">'+ExtractFileName(mFileName)+mDays+'</a>';
                          //mRef  := '<A HREF="./'+ExtractFileName(mFileName)+'">'+ExtractFileName(mFileName)+mDays+'</A>';

                          NetHubStatusText('', cTabIn+''+UpperCase(RightCopy(ExtractFileExt(mFileName),3))+' File '+RightCopy('000'+IntToStr(mLoop + 1),3),   mRef ,  mColor,           mStringListSts);

                     end;
                
                end;
             except
             end;
        end; // if pIncludeFileScans

        // Add a gap
        NetHubStatusSpacer(mStringListSts);


        // Add support
        mColor   := clEngHTMLDefault;
        NetHubStatusText('', 'Support',        '',                                                           mColor,           mStringListSts);
        NetHubStatusText('', cTabIn+'Hotline (Clients)',    '604.639.6391 then say "Support"',                  mColor,           mStringListSts);
        NetHubStatusText('', cTabIn+'Web',                  '<a href="http://devnet.engenic.com">DevNet</a>',   mColor,           mStringListSts);


        // Build the Web
        with mStringListWeb do
        begin
             // Status bar section
             ////////////////////////
             AddStrings(mStringListSts);
        end; // mStringListWeb


        ////////// FOOTER /////////////////
        NetHubHTMLFooter(mStringListSts);
        ////////// FOOTER /////////////////

     finally
        //mStringListSts.SaveToFile(pFileName);
        result.AddStrings( mStringListSts );

        mStringListWeb     .Free;
        mStringListSts     .Free;
        mStringListFiles   .Free;
        mStringListCont    .Free;
        mServicesList      .Free;
        mMonitorInfo       .Free;
     end;

     // Finish the HealthPackets (XML)
     GlobHealthInfo  := GlobHealthInfo +
                        '<systemhealth systemname="'+Glob_Reg_ServerName+'" count="'+IntToStr(GlobHealthMsgs)+'">'+
                        GlobHealthErrors +
                        GlobHealthWarnings +
                        '</systemhealth>';

end; // SystemHealth


function GetOSInfo: string;
const
   SUnknown = 'Unknown';
var
   Platform: string;
   BuildNumber: integer;
begin
      case Win32MajorVersion of
         3: //NT 3.51
            Platform := 'Windows NT 3.51';
         4: // Win9x/ME/NT 4
            case Win32MinorVersion of
               0:  Platform := 'Windows 95';
               10: Platform := 'Windows 98';
               90: Platform := 'Windows ME';
               else if (Win32Platform and VER_PLATFORM_WIN32_NT) <> 0 then
                   Platform := 'Windows NT 4.0'
               else
                   Platform := SUnknown;
            end;{ Win32MinorVersion }
         5: //Win2K/XP
            case Win32MinorVersion of
               0:  Platform := 'Windows 2000';
               1:  Platform := 'Windows XP/.NET server';
               2:  Platform := 'Windows 2003';
               else Platform := SUnknown;
            end;{ Win32MinorVersion }
         else Platform := SUnknown;
      end;{ Win32MajorVersion }

      case Win32Platform of
         VER_PLATFORM_WIN32_WINDOWS:
            BuildNumber := Win32BuildNumber and $0000FFFF;
         VER_PLATFORM_WIN32_NT:
            BuildNumber := Win32BuildNumber;
         else
            BuildNumber := 0;
      end;{ Win32Platform }

      if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) 
            or (Win32Platform = VER_PLATFORM_WIN32_NT) then begin 
         if Win32CSDVersion = '' then 
            Result := Format('%s (Build %d)', [Platform, BuildNumber])
         else
            Result := Format('%s (Build %d: %s)', [Platform, BuildNumber, Win32CSDVersion]);
      end
      else
         Result := Platform;
end;{ GetOSInfo }


// Find the number of processors on the system
function GetNumberProcessors: Integer;
var
   status: Longint; {long}
   SysBaseInfo: TSystem_Basic_Information;
begin
     result := 1;

     if @NtQuerySystemInformation = nil then
       NtQuerySystemInformation := GetProcAddress(GetModuleHandle('ntdll.dll'),
         'NtQuerySystemInformation');

     status := NtQuerySystemInformation(SystemBasicInformation, @SysBaseInfo, SizeOf(SysBaseInfo), nil);
     if status <> 0 then Exit;

     result := SysBaseInfo.bKeNumberProcessors;
end;


function GetPhysicalMemory: String;
var
   raminf : MEMORYSTATUS;
   mPhysical     : String;
   mPhysicalFree : String;
begin
     GlobalMemoryStatus(raminf);
     mPhysical      := IntToStr(Round(raminf.dwTotalPhys/1048576))+' MB';
     mPhysicalFree  := IntToStr(Round(raminf.dwAvailPhys/1048576))+' MB';

     Result :=  mPhysicalFree +' Free of ' +mPhysical+ ' Total';
end;


function GetVirtualMemory: String;
var
   raminf : MEMORYSTATUS;
   mVirtual      : String;
   mVirtualFree  : String;
begin
     GlobalMemoryStatus(raminf);
     mVirtual       := IntToStr(Round(raminf.dwTotalVirtual/1048576))+' MB';
     mVirtualFree   := IntToStr(Round(raminf.dwAvailVirtual/1048576))+' MB';

     Result :=  mVirtualFree +' Free of ' +mVirtual+ ' Total';
end;

// Find size of a directory
procedure FindLogSize(Str: string);
var
  MySearch: TSearchRec;
  FindResult: Integer;
begin
     FindResult:=FindFirst(Str+'\*.*',
                           faArchive+faHidden+
                           faAnyFile+faVolumeID+
                           faSysFile+faReadOnly+faDirectory,
                           MySearch);
     while FindResult=0 do
     begin
       if (MySearch.Attr=faDirectory) and
          (MySearch.Name<>'.') and
          (MySearch.Name<>'..') then
         FindLogSize(Str+'\'+MySearch.Name)
       else
         GlobTotalSize := GlobTotalSize + Abs(MySearch.Size);
       FindResult:=FindNext(MySearch);
     end;
     FindClose(MySearch);
     //result := round(TotalSize / (1024 * 1024));
end;


// Conversion
function BtoMB(pIn: Integer): Integer;
begin
     result := round(pIn / (1024 * 1024));
end;

procedure StringToRecord(var Rec; RecSize : integer; var s: string);
begin
     if Length(S) = RecSize then
     begin
          Move(S[1], Rec, RecSize);
     end;
end;

procedure RecordToString(var Rec; RecSize : integer; var s: string);
begin
     SetLength(S, RecSize);
     Move(Rec, S[1], RecSize);
end;

// Load TeleFlow Monitor Client into array
function TeleFlowMonitorClient(pHost: String; pDisplayProblemsOnly: Boolean; var pNormal, pStopped, pRestarted, pEnded: Integer): TStringList;
var
   mLoop: Integer;

   mTFRequest        : tfMonRequest;
   mTFResponse       : tfMonResponse;
   mTFRecord         : tfMonRecord;

   mMax              : String;
   mStatus           : Char;
   mRestartCnt       : Integer;
   mTemp             : String;
   mRecord           : String;

   //mMonitorArray     : Array[0..1000] of tfMonRecord;
   mTCPMonClient     : TIdTCPClient;

   mProblem          : Boolean;
   mStringListSts    : TStringList;
   mBuffer           : TMemoryStream;
   mStream           : TIdStream;
   //mTBBuffer         : TBytes;
   mSize             : Integer;
   mResult           : LongInt;
   mLine             : ansistring;
   //mLength           : Integer;
   mCount            : integer;
begin
     // First, create the TStringList
     Result := TStringList.Create;

     // Populate request
     mTFRequest.Id        := TELEFLOW_MON_REQUEST;   // "102"
     //mTFRequest.cause     := 255;
     //mTFRequest.value     := 255;
     //mTFRequest.dataSize  := 255;
     //mTFRequest.data      := 255;

     // Defaults
     pNormal      := 0;
     pStopped     := 0;
     pRestarted   := 0;
     pEnded       := 0;

     mBuffer         := TMemoryStream.Create;
     mStream         := TIdStream.Create;
     mTCPMonClient   := TIdTCPClient.Create(nil);
     // Create StringLists
     mStringListSts  := TStringList.Create;
     try
        try
           // Not secure
           with mTCPMonClient do
           begin
                ReadTimeout  := 200;        // Its local, dont wait too long
                Host         := pHost;      // 127.0.0.1  or Localhost
                Port         := 5050;       // Monitor port

                try
                   // Try and connect to TeleFlow Server
                   Connect;

                   if Connected then
                   begin
                   try
                      // Send the request
                      //IoHandler.WriteBuffer( mTFRequest, sizeof(mTFRequest), True);
                      // Get the response
                      //IoHandler.ReadBuffer( mTFResponse, sizeof(mTFResponse));

                      mSize   := sizeof(mTFRequest);
                      mResult := mBuffer.write(mTFRequest, mSize);

                      RecordToString(mTFRequest, mSize, mLine);

                      IoHandler.MaxLineLength := 9999;
                      IoHandler.WriteBufferOpen;
                      IOHandler.WriteBufferClear;
                      IOHandler.WriteLn( mLine );
                      IoHandler.WriteBufferClose;

                      (* KIND OF WORKS....
                      // @@@ Something here messes the read... we only get 1872 bytes... and
                      //     we seem to loose chunks of data after that
                      mLine   :=  IOHandler.ReadLnWait(10);
                      mRecord := Copy(mLine,1,20);
                      if (Length(mLine) >= mSize) then
                      begin
                           StringToRecord(mTFResponse, SizeOf(mTFResponse), mRecord);

                           //Get the rest of the record NOTE: There is no more
                           //mLength + Length(mLine);
                           while Length(mLine) < mTFResponse.dataSize do
                           begin
                                mRecord := IOHandler.ReadLnWait(10);

                                if mRecord <> '' then
                                begin
                                     mLine   := mLine + mRecord;
                                end
                                else
                                begin
                                     Break;
                                end;
                           end;
                      end;
                      // @@@@Result.Add(mLine);
                      // @@@@Result.SaveToFile('e:\vern.txt');
                      mRecord := (IntToStr(Length(mLine)));
                      *)

                      //IOHandler.Capture(mStream);
                      mLine  := '';
                      mCount := 0;
                      while  IOHandler.Connected do
                      begin
                           mRecord   :=  IOHandler.ReadLn;
                           if mRecord <> '' then
                           begin
                                mLine := mLine + mRecord;
                                mCount := 0;
                           end;
                           inc(mCount);
                           Sleep(10);
                           if mCount > 10 then break;
                           //Application.ProcessMessages;
                      end;
                      // mRecord := (IntToStr());

                      GlobalKeep := Length(mLine);
                      mRecord    := Copy(mLine,1,20);
                      StringToRecord(mTFResponse, SizeOf(mTFResponse), mRecord);


                      if mTFResponse.Id = TELEFLOW_MON_RESPONSE then
                      begin
                           //MainOutput.Items.Add(IntToStr(mTFResponse.Id));
                           // Loop through all
                           for mLoop := 0 to round(mTFResponse.dataSize / SizeOf(mTFRecord)) - 1 do
                           begin
                                // Get all the records now
                                // Old: ReadBuffer( mTFRecord, sizeof(mTFRecord));

                                mRecord := Copy(mLine, SizeOf(mTFResponse)+1+(mLoop*sizeof(mTFRecord)), sizeof(mTFRecord));
                                if (Length(mRecord) = sizeof(mTFRecord)) then
                                begin
                                    StringToRecord(mTFRecord, sizeof(mTFRecord), mRecord);
                                end;

                                mTemp   := '';
                                mRecord := '';

                                //mMonitorArray[mLoop] := mTFRecord;

                                // Define what problems
                                mProblem     := False;

                                mStatus      := mTFRecord.status;
                                case Ord(mStatus) of
                                //-1:  mTemp := '-1';
                                0: begin
                                        mTemp := mTemp + cLightStopped;
                                        inc(pStopped); // @@@
                                        mProblem     := True;
                                   end;
                                1: begin
                                        mTemp := mTemp + cLightNormal;
                                        inc(pNormal);
                                   end;
                                2: begin
                                        mTemp := mTemp + cLightRestarted;
                                        inc(pRestarted);
                                        mProblem     := True;
                                   end;
                                3: begin
                                        mTemp := mTemp + cLightStopped;
                                        inc(pStopped);  // @@@
                                        mProblem     := True;
                                   end;
                                4: begin
                                        mTemp := mTemp + cLightEnded;
                                        inc(pEnded);
                                   end;
                                else
                                   begin
                                        mTemp := mTemp + '('+IntToStr(Ord(mStatus))+')';
                                   end;
                                end;

                                // Put the display together
                                //mTemp   := mTemp + ' '+IntToStr(mTFRecord.appId)+': ';
                                mTemp   := mTemp + mTFRecord.appNm;

                                mRestartCnt  := mTFRecord.restartCnt;
                                if (mTFRecord.restartMax > -1) then
                                begin
                                     mMax  := IntToStr(mTFRecord.restartMax);
                                     if mTFRecord.restartMax = 0 then
                                     begin
                                          mMax := '0';
                                     end;
                                     mTemp := mTemp + ' ['+ IntToStr(mRestartCnt) +'/' +(mMax)+'] ';
                                end
                                else
                                begin
                                     mTemp := mTemp + ' ['+ IntToStr(mRestartCnt) +'] ';
                                end;

                                // Display Everything, or Display Only problems
                                if (pDisplayProblemsOnly = False) or (pDisplayProblemsOnly and mProblem) then
                                begin
                                     // Message
                                     mRecord := ChangeFileExt(mTFRecord.appFile,'') + '&nbsp;<span class="style8">'+mTFRecord.StepName+'</span>';
                                     NetHubStatusText('Monitor', mTemp,  mRecord,       clEngHTMLDefault, mStringListSts);
                                end;
                           end;

                      end
                      else
                      begin
                           NetHubStatusText('Monitor', 'ERROR',  'TeleFlow Server did not Respond',       clEngHTMLRed, mStringListSts);
                      end;
                   finally
                      Disconnect;
                   end;
                   end;
                except
                   NetHubStatusText('Monitor', 'ERROR',  'TeleFlow Server did not Respond',       clEngHTMLRed, mStringListSts);
                end;

                // Did we have a timeout somewhere
                if IoHandler.ReadLnTimedOut then
                begin
                     NetHubStatusText('Monitor', 'ERROR',  'NetHub Timed Out communicating with TeleFlow Server',       clEngHTMLRed, mStringListSts);
                end;
           end;

           // Write it
           //mStringListSts.SaveToFile(pFileName);
           result.AddStrings( mStringListSts );
        except
           NetHubStatusText('', 'ERROR',  'NetHub Monitor Read Failed',       clEngHTMLRed, mStringListSts);
           result.AddStrings( mStringListSts );
        end;
     finally
        mStringListSts     .Free;
        mTCPMonClient      .Free;
        mStream.Free;
        mBuffer.Free;
     end;
end;  // TeleFlowMonitorClient


// Create the base location where the files will be found
function AcquireFileBaseDirectory(): String;
begin
     if DirectoryExists(Glob_Reg_VMSDir) then
     begin
          // Interprete the command to it's final path (avoid sending files in parent folders)
          result := ExpandFileName(IncludeTrailingPathDelimiter(Glob_Reg_VMSDir));
     end
     else
     begin
          // Interprete the command to it's final path (avoid sending files in parent folders)
          result := ExpandFileName(SlashToBackSlash('\' + IncludeTrailingPathDelimiter(Glob_Reg_VMSDir)));
     end;
end; // AcquireFileBaseDirectory

initialization
    _ProcessorsCount:= -1;
    _BufferSize:= $2000;
    _PerfData := AllocMem(_BufferSize);

    VI.dwOSVersionInfoSize:=SizeOf(VI);
    if not GetVersionEx(VI) then raise Exception.Create('Can''t get the Windows version');
finalization
    FreeMem(_PerfData);
end.