unit SQLWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  SQLWorkUnit in 'SQLWorkUnit.pas';
*)

(*

// Example for implementation
procedure TForm1.Button1Click(Sender: TObject);
var
   mSuccess: Boolean;
   mSQL: TStringList;
begin
     mSQL := TStringList.Create;

     mSQL.Clear;
     mSQL.LoadFromFile(Edit1.Text);
     // Build the SQL statement
     mSQL :=
     SQLBuildStatement(mSQL,
                       '12',
                       '11',
                       '',
                       '',
                       '',
                       '',
                       '',
                       '',
                       '',
                       mSuccess
                       );

      Memo1.Lines := mSQL;
end;

*)


// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! CalcWorkUnit must be in the USES section for each unit

interface

uses
  ShellAPI,Messages,SysUtils,Classes,Windows, Math;

    function SQLBuildStatement(pSQLStatement: TStrings; p01,p02,p03,p04,p05,p06,p07,p08,p09: String; var pSuccess: Boolean): TStringList;
    function ReplaceAllSubStringsWithAnother(pFindString, pReplaceString, pOriginalString: String): String;

implementation

// Generate the combined SQL from parameters and the SQL code
// - User has clicked execute at this point
// - Get the screen fields to override the globals, then combine
function SQLBuildStatement(pSQLStatement: TStrings; p01,p02,p03,p04,p05,p06,p07,p08,p09: String; var pSuccess: Boolean): TStringList;
var
   mSearch               : String;
   mLoop                 : Integer;
   mParm                 : Integer;
   mVParms               : Array [1..10] of String;
   mCustomReportTitle    : Array [1..10] of String;
   mCustomReportTTot     : Integer;
   mCustomReportEnd      : Array [1..10] of String;
   mCustomReportETot     : Integer;
   mCustomReportTotFlds  : String;     // Fields for totals

   mCustomReportLine     : String;
begin
     // First, create the TStringList
     Result := TStringList.Create;

     // Upload values
     mVParms[1] := p01;
     mVParms[2] := p02;
     mVParms[3] := p03;
     mVParms[4] := p04;
     mVParms[5] := p05;
     mVParms[6] := p06;
     mVParms[7] := p07;
     mVParms[8] := p08;
     mVParms[9] := p09;

     mCustomReportTTot := 0;
     mCustomReportETot := 0;

     // create processing
     try
        // Now, combine the values and the SQL statement
        for mLoop := 0 to pSQLStatement.Count - 1 do
        begin
             mCustomReportLine :=  pSQLStatement[mLoop];

             // Check the start of the line for the Title Text
             if copy(uppercase(mCustomReportLine),1,8) = '--TITLE:' then
             begin
                  inc(mCustomReportTTot);
                  mCustomReportTitle[mCustomReportTTot] := trim(copy( mCustomReportLine,9,999));
             end;
             // Check the start of the line for the End Text
             if copy(uppercase(mCustomReportLine),1,6) = '--END:' then
             begin
                  inc(mCustomReportETot);
                  mCustomReportEnd[mCustomReportETot] := trim(copy( mCustomReportLine,7,999));
             end;

             // Remember fields for use with totaling
             if UpperCase(copy(mCustomReportLine,1,14)) = '--TOTALFIELDS:' then
             begin
                  mCustomReportTotFlds := trim(copy( mCustomReportLine,15,999))
             end;

             // See if there are params to replace
             // --P1 will replace %P1%
             // Anything but the parm lines
             if uppercase(copy(mCustomReportLine,1,3)) <> '--P' then
             begin
                  // Check for each parm
                  for mParm := 01 to 09 do
                  begin
                       mSearch := '%P'+IntToStr(mParm)+'%';

                       mCustomReportLine := ReplaceAllSubStringsWithAnother(mSearch,mVParms[mParm],mCustomReportLine);
                  end; // for mParm

             end;

             // -----------------------
             // Only add line, if valid
             // -----------------------
             if uppercase(copy(mCustomReportLine,1,2)) <> '--' then
             begin
                  result.Add(mCustomReportLine);
             end;
        end;
     finally
     end;
     // So, here is the completed statement
     // =  result
end;


// Replace all instances of one string in a string with another string,
// returning the modified string.
function ReplaceAllSubStringsWithAnother(pFindString, pReplaceString, pOriginalString: String): String;
var
   mFindStringLen,
   mLoop: Integer;
   mBuild: String;
begin
     mBuild         := '';
     mFindStringLen := Length(pFindString);

     mLoop := 1;
     while mLoop <= Length(pOriginalString) do
     begin
          if Copy(pOriginalString,mLoop,mFindStringLen) = pFindString then
          begin
               // Put the replacement in place
               mBuild := mBuild + pReplaceString;
               // add a few to skip past the copied bit
               mLoop := mLoop + mFindStringLen - 1;
          end
          else
          begin
               // Add the next character
               mBuild := mBuild + Copy(pOriginalString,mLoop,1);
          end;

          inc(mLoop);
     end;
     result := mBuild;
end;


end.

