unit SoundWorkUnit;

// In the Project .DPR file, the FileWorkUnit must be set up as follows
(*
program Project1;

uses
  Forms,
  Unit1 in 'Unit1.pas' {Form1},
  CalcWorkUnit in 'SoundWorkUnit.pas';
*)

// !!!!! MUST NOT HAVE \\MARS\Source$\ or such. !!!!!

// In the Project->Options->Directories/Conditionals,
// ... Search Path = X:\TeleFlow\CommonUnits

// !!! SoundWorkUnit must be in the USES section for each unit

interface

uses
  ShellAPI,Messages,SysUtils,Classes,Windows, Math, DateUtils;

  function VolumeNormalizer(pVolumeStart, pVolumeMax: Integer): integer;

implementation

// Make the volume more normal across the dial
//     // Code to adjust volume
//     // Adjust volume through filtergraph
//     FilterGraph.Volume := VolumeNormalizer(mPosition);
function VolumeNormalizer(pVolumeStart, pVolumeMax: Integer): integer;
const
   cMaxVol = 10000;
var
   mPosition,
   I : Integer;
   T,C,V : Real;
begin
     result := 0;
     mPosition := pVolumeStart;
     if mPosition > cMaxVol then
     begin
          mPosition := cMaxVol;
     end;

     // Better way to corect volume...
     if mPosition <> 0 then   // Protect Division by Zero
     begin
        V := (LogN(16,mPosition));
        if V <> 0 then   // Protect Division by Zero
        begin
           T := 1/V;
           C := (pVolumeMax -mPosition) * T;
           I := Trunc(cMaxVol - C);
           result := I;
        end;
     end;
end; // VolumeNormalizer

end.