// TeleFlow Monitor protocol types definitions
// - NOTE:  TFMonitorConsts.pas include the TELEFLOW_APP... etc information

// TFMonitor REQUEST: This gets sent to TeleFlow Server
type tfMonRequest =  record
   id       : Integer;   //4B  unsigned long    "102"
   cause    : Integer;   //4B  unsigned long    0
   value    : Integer;   //4B  int              0
   dataSize : Integer;   //4B  long             0 ~  Non-NULL if additional structure follows.
   data     : Integer;   //4B  void          *  0
end;

// TFMonitor RESPONSE: This data returns from TeleFlow Server
type tfMonResponse =  record
   id       : Integer;   //4B unsigned long    "201"
   cause    : Integer;   //4B unsigned long    0
   value    : Integer;   //4B int              0
   dataSize : Integer;   //4B long             Size of the information that will follow
   data     : Integer;   //4B void          *  0
end;


// TFMonitor LINE RECORDS: This follows the above structure
// So: This will also align on Quad Word alignment
type tfMonRecord =  record
   ivLog           : Integer;                                   // GUILog*
   msgNo           : Integer;                                   // long   Msg seq number (1 - 1,000,000). (IGNOR)
   appID           : Integer;                                   // long   Unique application ID. (1001 and on...)
   appNm           : array[0..TELEFLOW_APP_NAME_MAX ] of char;  // char   Application name.
   appFile         : array[0..TELEFLOW_TAP_NAME_MAX ] of char;  // char   .TAP file name
   lineNo          : Integer;                                   // long   Line number if phone off-hook. (Port)
   stepNo          : Integer;                                   // long   Current step number.
   currentTAMName  : array[0..TELEFLOW_TAM_NAME_MAX ] of char;  // char   Current procedure.
   stepName        : array[0..TELEFLOW_STEP_NAME_MAX ] of char; // char   Step name (e.g. "Wait For Call").
   stepData        : array[0..TELEFLOW_SYS_INFO_MAX ] of char;  // char   Extra information about the step.
   status          : Char;                                      // char   App status. (Values = 0,1...= get from Sean)
   license         : Integer;                                   // int    1, 0, -1 (How is TeleFlow Licensed?)
   restartCnt      : Integer;                                   // int    Number of times restarted.
   restartMax      : Integer;                                   // int    Maximum restart count.
end;
