unit TaskWorkUnit;

interface

uses
  //ShellAPI,Messages,SysUtils,Classes,Windows, ComCtrls,  ExtCtrls,
  Windows, Messages, SysUtils, Variants, Classes, StdCtrls, ToolWin,
  ComCtrls, ExtCtrls, TlHelp32, Psapi, WinSvc;

  // Procedures
  function WindowsTaskExists(pName: String): Boolean;
  function ProcessTaskExists(pName: String): Boolean;
  function EnumServicesList(var pStrList: TStringList; pTestForProcesses: string) : boolean;
  function EnumProcess(hHwnd: HWND;lParam : integer): boolean; stdcall;
  function AgeOfSelection(mSelect: Integer; mSupressOutput: Boolean): Integer;
  procedure GetProcessList(var List: TstringList);
  procedure CreateWinNTProcessList(List: TstringList);
  function ProcessTerminate(pPid: DWord): Boolean;
  function ProcessCreate(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String; var pError: String): DWord;


const
   cTitle   = 0;
   cExeNam  = 1;
   cPID     = 2;
   //cProcess = 3;
   cHWND    = 4;
   cAge     = 5;
   cDate    = 6;
   cWinVis  = 7;

   // Services list
   cSrvcSTOPPED                 = 'STOPPED';
   cSrvcSTART_PENDING           = 'START PENDING';
   cSrvcSTOP_PENDING            = 'STOP PENDING';
   cSrvcRUNNING                 = 'RUNNING';
   cSrvcCONTINUE_PENDING        = 'CONTINUE PENDING';
   cSrvcPAUSE_PENDING           = 'PAUSE PENDING';
   cSrvcPAUSED                  = 'PAUSED';


var
   GlobProcessDetails         : Array[0..8,0..400] of String;
   GlobSelectedProcess        : Integer;
   GlobCount                  : Integer;
   GlobDebug                  : String;
   GlobRepFile                : String;
   GlobAppName                : string;

   GlobWatchList,
     lp : integer;


implementation


// Terminate a process base on the Windows handle
function ProcessTerminate(pPid: DWord): Boolean;
var
   mProcess     : DWord;
begin
     mProcess := OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPid);
     result := TerminateProcess(mProcess, ExitCode);
end; // ProcessTerminate


// Create a Process
// Parm1 = Show application on the desktop?
// parm2 = Location of the Delphi App: Application.Exename
// parm3 = program to run (.cmd .exe etc)
// parm4 = any parameters
// Parm5 = Error message (if any)
// return = Process Id, which can be passed  ProcessTerminate
function ProcessCreate(pVisible: Boolean; pApplicationExe, pProgram, pParameters: String; var pError: String): DWord;
var
   mSuccess      : Boolean;
   mProgramName  : String;
   mProgramPath  : String;
   st            : TStartupInfo;
   pp            : TProcessInformation;
   //proc: THandle;
begin
     mSuccess := False;
     pError   := '';
     result   := 0;
     try
        mProgramPath := trim(ExtractFilePath(pProgram));
        mProgramName := trim('"'+(pProgram)+'" '+ pParameters);


        //mProgramName := trim('"'+pProgram +'" '+ pParameters);

        // CreateProcess
        // -------------
        // Needs:
        //   st : TStartupInfo;
        //   pp : TProcessInformation;
        // Now convert to c passable information and run
        fillchar(st,sizeof(TStartupInfo),#0);
        fillchar(pp,sizeof(TProcessInformation),#0);
        st.cb          := sizeof(TStartupInfo);
        st.wShowWindow := 1;
        st.dwFlags     := STARTF_USESHOWWINDOW;
        // Hide window?
        if pVisible then
        begin
             st.wShowWindow := SW_SHOW; //SW_HIDE;
        end
        else
        begin
             st.wShowWindow := SW_HIDE;
        end;


        // Return Values
        // If the function succeeds, the return value is nonzero.
        // If the function fails, the return value is zero. To get extended error information, call GetLastError.
        mSuccess :=
        CreateProcess(nil,
                      PChar(mProgramName),
                      NIL,
                      NIL,
                      FALSE,
                      (CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS),
                      //CREATE_DEFAULT_ERROR_MODE,
                      NIL,
                      PChar(mProgramPath),
                      st,
                      pp);

        (*
        BOOL CreateProcess( 
             LPCTSTR lpApplicationName,                 // name of executable module
             LPTSTR lpCommandLine,                      // command line string
             LPSECURITY_ATTRIBUTES lpProcessAttributes, // SD
             LPSECURITY_ATTRIBUTES lpThreadAttributes,  // SD
             BOOL bInheritHandles,                      // handle inheritance option
             DWORD dwCreationFlags,                     // creation flags
             LPVOID lpEnvironment,                      // new environment block
             LPCTSTR lpCurrentDirectory,                // current directory name
             LPSTARTUPINFO lpStartupInfo,               // startup information
             LPPROCESS_INFORMATION lpProcessInformation // process information
             ); *)

        // Return the process id (for termination later if needed)
        result := pp.dwProcessId;

        // Clean up
        if mSuccess then
        begin
             CloseHandle(pp.hProcess);
             CloseHandle(pp.hThread);
        end;
     except
          on E: Exception do
          begin
               pError := Format('Exception: %s. Error is:"%s".', [e.ClassName, e.Message]);
          end;
     end;

     // Get the error value on a fail
     if not mSuccess then
     begin
          pError := 'Error: '+IntToStr(GetLastError());
     end
end;  // ProcessCreate



////// ALL PROCESSES ////////////
function ProcessTaskExists(pName: String): Boolean;
var
   mLoop               : Integer;
   ProcessListBox      : TstringList;
   mExeName            : String;
begin
     result := False;
     ProcessListBox := TStringList.Create;
     try
       GetProcessList(ProcessListBox);
       if ProcessListBox = nil then Exit;
       for mLoop := 0 to GlobCount - 1 do
       begin
            // Do we have the task running??
            mExeName := GlobProcessDetails[cExeNam, mLoop];
            if UpperCase(pName) = UpperCase(mExeName) then
            begin
                 result := True;
            end;
            //ListBox1.Items.Add(ProcessListBox.Strings[mLoop]);
       end;

       // Save it (DEBUG)
       //ProcessListBox.SaveToFile('c:\vern.txt');

     finally
       ProcessListBox.Free;
     end;
end;


////// WINDOWS PROCESSES ////////////
function WindowsTaskExists(pName: String): Boolean;
var
   mExeName            : string;
   mLoop               : Integer;

   ProcessListBox  : TStringList;
begin
     result := False;
     ProcessListBox := TStringList.Create;
     try
         try
              GlobCount  := 0;
              lp := 0;
              if EnumWindows(@EnumProcess,lp) = false then
              begin
                   //result := False;
                   //ShowMessage('Error: Could not obtain process window hook from system.');
              end
              else
              begin
                   ProcessListBox.Clear;
                   for mLoop := 0 to GlobCount-1 do
                   begin
                        //mProcessWHndl := StrToIntDef(GlobProcessDetails[cHwnd,mLoop],-2); //never used

                        ///////////////////////////////////////////////
                        // Add the program to the list
                        ///////////////////////////////////////////////
                        ProcessListBox.Add('['+GlobProcessDetails[cExeNam,  mLoop] +']~"'+
                                               GlobProcessDetails[cWinVis,  mLoop] + '"~' +
                                               GlobProcessDetails[cAge,     mLoop] + '~"' +
                                               GlobProcessDetails[cTitle,   mLoop] + '"');

                        ///////////////////////////////////////////////
                        // Determine if the task needs to be terminated
                        ///////////////////////////////////////////////
                        mExeName := GlobProcessDetails[cExeNam,  mLoop];
                        // Get age in minutes, and supress output
                        //mAgeOld  := AgeOfSelection(mLoop, True);

                        // Do we have the task running??
                        // Test: Are we ignoring the extension?
                        if ChangeFileExt(pName,'') = pName then
                        begin
                             if UpperCase(ChangeFileExt(pName,'')) = UpperCase(Trim(ChangeFileExt(GlobProcessDetails[cExeNam, mLoop],''))) then
                             begin
                                  result := True;
                             end;
                        end
                        else if UpperCase(pName) = UpperCase(Trim(GlobProcessDetails[cExeNam, mLoop])) then
                        begin
                             result := True;
                        end;
                   end; // Loop through all processes

                   // Save it (DEBUG)
                   //processlistbox.SaveToFile('c:\vern.txt');

              end;
         except
              // Error encountered during enumeration process
         end;

     finally
        ProcessListBox.Free;
     end;
end; // GetTaskList


// Return list of services
// Parms
// 1 = TStringList to return
// 2 = Comma delimited list to limit by (for specific processes
//     Blank = return all
// TStringList will have"  ServiceExe~Status~DisplayName
(*
   // s/b in global const
   cSrvcSTOPPED                 = 'STOPPED';
   cSrvcSTART_PENDING           = 'START PENDING';
   cSrvcSTOP_PENDING            = 'STOP PENDING';
   cSrvcRUNNING                 = 'RUNNING';
   cSrvcCONTINUE_PENDING        = 'CONTINUE PENDING';
   cSrvcPAUSE_PENDING           = 'PAUSE PENDING';
   cSrvcPAUSED                  = 'PAUSED';

// .....  Code Example ....

        // Get list of services.  Second Parm = '' to get full list
        EnumServicesList(mServicesList,cTFServices);
        // Roll through the strings
        for mLoop := 0 to mServicesList.Count - 1 do
        begin
             mField01 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',1);  // Exename
             mField02 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',2);  // Status
             mField03 := RecordParseCustomDelimiter(mServicesList[mLoop],'~',3);  // Display name

             // If not running, show as RED
             mColor   := clEngHTMLRed;
             if LeftCharUpperCaseCompare(cRUNNING ,mField02, 6) then
             begin
                  mColor   := clEngHTMLDefault;
             end;
             NetHubStatusText(' - - '+mField01,        mField02+' ('+mField03+')',         mColor,           mStringListSts);
        end;
*)
function EnumServicesList(var pStrList: TStringList; pTestForProcesses: string) : boolean;
type
  pEnumServiceStatus = ^TEnumServiceStatus;
var
  hSCM                    : THandle;
  pEnumStatus             : ^TEnumServiceStatus;
  dwByteNeeded            : DWORD;
  dwNumOfService          : DWORD;
  dwResumeHandle          : DWORD;
  mCurrentState           : DWORD;
  nI                      : integer;
  display_currentstate    : String;
  mServiceName            : String;
  mDisplayName            : String;

begin
  pEnumStatus := nil;
  dwByteNeeded := 0;
  dwResumeHandle := 0;
  try
    hSCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
    if not EnumServicesStatus(hSCM,
                              SERVICE_WIN32 or SERVICE_DRIVER,
                              SERVICE_ACTIVE or SERVICE_INACTIVE,
                              pEnumStatus^,
                              0,
                              dwByteNeeded,
                              dwNumOfService,
                              dwResumeHandle) then
    begin
         if GetLastError = ERROR_MORE_DATA then
         begin
              GetMem(pEnumStatus, dwByteNeeded);
              if not EnumServicesStatus(hSCM,
                                        SERVICE_WIN32 or SERVICE_DRIVER,
                                        SERVICE_ACTIVE or SERVICE_INACTIVE,
                                        pEnumStatus^,
                                        dwByteNeeded,
                                        dwByteNeeded,
                                        dwNumOfService,
                                        dwResumeHandle) then
              begin
                   result := false;
                   Exit;
              end;
         end
         else
         begin
              result := false;
              exit;
         end;
    end;

    pStrList.Clear;
    for nI := 0 to dwNumOfService-1 do
    begin
         mServiceName  := TEnumServiceStatus(pEnumServiceStatus(pChar(pEnumStatus) + ni*SizeOf(TEnumServiceStatus))^).lpServiceName;
         mDisplayName  := TEnumServiceStatus(pEnumServiceStatus(pChar(pEnumStatus) + ni*SizeOf(TEnumServiceStatus))^).lpDisplayName;

         mCurrentState := TEnumServiceStatus(pEnumServiceStatus(pChar(pEnumStatus) + ni*SizeOf(TEnumServiceStatus))^).ServiceStatus.dwcurrentstate;


         case mCurrentState of
         SERVICE_STOPPED :            display_currentstate := cSrvcSTOPPED;
         SERVICE_START_PENDING :      display_currentstate := cSrvcSTART_PENDING;
         SERVICE_STOP_PENDING :       display_currentstate := cSrvcSTOP_PENDING;
         SERVICE_RUNNING :            display_currentstate := cSrvcRUNNING;
         SERVICE_CONTINUE_PENDING :   display_currentstate := cSrvcCONTINUE_PENDING;
         SERVICE_PAUSE_PENDING :      display_currentstate := cSrvcPAUSE_PENDING;
         SERVICE_PAUSED :             display_currentstate := cSrvcPAUSED;
         end;

         // Display services that are included in the list
         if pTestForProcesses = '' then
         begin
              // Include them all
              pStrList.Add(mServiceName+'~'+display_currentstate+'~'+mDisplayName+'~');
         end
         else
         begin
              if    (Pos(','+UpperCase(mServiceName),UpperCase(','+pTestForProcesses)) > 0)
                 or (Pos(','+UpperCase(mDisplayName),UpperCase(','+pTestForProcesses)) > 0) then
              begin
                   // Only running services
                   pStrList.Add(mServiceName+'~'+display_currentstate+'~'+mDisplayName+'~');
              end;
         end;
    end;
    CloseServiceHandle(hSCM);
    Result := true;
  finally
    if Assigned(pEnumStatus) then FreeMem(pEnumStatus);
  end;
end;   // EnumServicesList


// Find all the processes currently available.
function EnumProcess(hHwnd: HWND;lParam : integer): boolean; stdcall;
     {
     function GetExenameForProcessUsingPSAPI(pid: DWord): String;
     var
       i: Integer;
       cbNeeded: DWord;
       modules: array [1..1024] of hInst;
       ProcHandle: THandle;
       filename: array [0..512] of Char;
     begin
       SetLastError(0);
       result := '';
       ProcHandle := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, false, pid);
       if (ProcHandle <> 0) then
       try
         if (EnumProcessModules(ProcHandle, @modules[1], SizeOf(modules), cbNeeded)) then
           for i := 1 to cbNeeded div SizeOf(hInst) do
           begin
             if (GetModuleFilenameEx(ProcHandle, modules[i], filename, SizeOf(filename)) > 0) then
               if (AnsiStrIComp(PChar(ExtractFileExt(filename) + #0), '.exe' ) = 0) then
               begin
                 Result := filename;
                 break;
               end;
           end;
       finally
         CloseHandle(ProcHandle);
       end;
     end;
     }
     function GetExenameForProcess(pid: DWord): String;
     var
       snapshot: THandle;
       procentry: TProcessEntry32;
       ret: bool;
     begin
         { if (Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion <= 5) then
          begin
               Result := GetExenameForProcessUsingPSAPI(pid);
          end
          else
         }begin
               SetLastError(0);
               Result := '';
               snapshot:= CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
               if (snapshot <> INVALID_HANDLE_VALUE) then
               try
                 procentry.dwSize := Sizeof(procentry);
                 ret := Process32FIRST(snapshot, procentry);
                 while ret do
                 begin
                   if (procentry.th32ProcessID = pid) then
                   begin
                     Result := procentry.szExeFile;
                     break;
                   end else
                     ret := Process32Next(snapshot, procentry);
                 end;
               finally
                 CloseHandle(snapshot);
               end;
          end;
     end;
     function GetExenameForWindow(wnd: hWnd): String;
     var
       pid: DWord;
     begin
          result := '';
          if isWindow(Wnd) then
          begin
            GetWindowThreadProcessID(Wnd, @pid);
            if (pid <> 0) then Result := GetExenameForProcess(pid);
          end;
     end;
var
   pProcess,
   pPid : DWORD;
   title, className : string;
   CreateTime, ExitTime, KernelTime, UserTime :  TFileTime;
   SysTime : TSystemTime;
   mLocalFileTime      : TFileTime;
   mProcessTime        : TDateTime;
   mAgeDiff            : Real;
   mExeName            : string;
   //mLoop               : Integer;   //Never Used
   mFlag               : Boolean;
   //mPattern            : String;    //Never Used
   mWindowVisible      : String;
begin
  result := True;

  if(hHwnd=NULL) then
  begin
       result := false;
  end
  else
  begin
       // See if the window is visible
       if IsWindowVisible(hHwnd) then
       begin
            mWindowVisible := 'Y';
       end
       else
       begin
            mWindowVisible := 'N';
       end;


       GetWindowThreadProcessId(hHwnd,pPid);
       SetLength(className, 255);
       SetLength(className, GetClassName(hHwnd, PChar(className), Length(className)));
       SetLength(title, 255);
       SetLength(title, GetWindowText(hHwnd, PChar(title), Length(title)));


       //mFlag    := False;   //Never Used
       mExeName := GetExenameForProcess(pPid);

       (*
       // Go through the memo of watch
       for mLoop := 0 to GlobWatchList.Count - 1 do
       begin
            mPattern := GlobWatchList[mLoop];
            // Are we allowed to display this?
            if WildCardMatch(LowerCase(mExeName), LowerCase(mPattern)) then
            begin
                 mFlag := true;
            end;
       end;
       *)

       // Watch em all
       mFlag := True;

       // If we are allowed to display this pattern, then...
       if mFlag then
       begin
            //ProcessForm.ProcessListBox.Items.Add('Class Name = ' + className + '; Title = ' + title + '; HWND = ' + IntToStr(hHwnd) + '; Pid = ' + IntToStr(pPid));
            //ProcessForm.ProcessListBox.Items.Add(title);

            GlobProcessDetails[cTitle,   GlobCount] := title;
            GlobProcessDetails[cExeNam,  GlobCount] := mExeName;
            GlobProcessDetails[cPID,     GlobCount] := IntToStr(pPid);
            GlobProcessDetails[cWinVis,  GlobCount] := mWindowVisible;
            GlobProcessDetails[cHWND,    GlobCount] := IntToStr(hHwnd);


            pProcess := OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPID);
            //GlobProcessDetails[cProcess, GlobCount] := IntToStr(pProcess);



            if GetProcessTimes( pProcess, CreateTime, ExitTime, KernelTime, UserTime) Then
            begin
              //FileTimeToSystemTime(CreateTime, SysTime);
              //FileTimeToLocalFileTime(lpUserTime, lpLocalFileTime);
              FileTimeToLocalFileTime(CreateTime, mLocalFileTime);
              FileTimeToSystemTime(mLocalFileTime, SysTime);

              with SysTime do
              begin
                   mProcessTime := (EncodeDate(wYear, wMonth, wDay) +  EncodeTime(wHour, wMinute, wSecond, wMilliseconds));
                   GlobProcessDetails[cDate, GlobCount] := DateTimeToStr(mProcessTime);

                   try
                      mAgeDiff     :=  Now - mProcessTime;
                      if mAgeDiff < 100000 then
                      begin
                           GlobProcessDetails[cAge, GlobCount] := FormatFloat('0.00000',mAgeDiff);
                      end
                      else
                      begin
                           GlobProcessDetails[cAge, GlobCount] := 'n/a';
                      end;
                   except
                      // Incase anything goes wrong
                      GlobProcessDetails[cAge, GlobCount] := 'n/a';
                   end;
              end;
            end;

            GlobCount := GlobCount + 1;
       end; // if pattern match
  end;
end;



// Show the age of the selected entry on the screen
function AgeOfSelection(mSelect: Integer; mSupressOutput: Boolean): Integer;
var
   mDays,
   mHours,
   mMinutes:  integer;

   mAge       : real;
   mMath      : real;
begin
     // Create time
     //LabelCreate.Caption := GlobProcessDetails[cDate, mSelect];

     try
        // This only gets the approximate age...
        mAge      := StrToFloat(GlobProcessDetails[cAge ,mSelect]);
        mDays     := Trunc(mAge);

        mMath     := (mAge - mDays) * (24*3600);  // Makes it into seconds
        mHours    := Trunc(mMath / 3600);
        mMinutes  := Trunc((mMath - (mHours * 3600)) / 60);

        // Show the age
        (*
        LabelAge.Caption := IntToStr(mDays)    + ' Days '+
                            IntToStr(mHours)   + ' Hrs '+
                            IntToStr(mMinutes) + ' Mins ';
        *)

        // Find how many minutes old this is
        result :=  (mDays * 60 * 24) + (mHours * 60) + mMinutes;
     except
        // In case the numbers are off
        result := 0;
     end;

end; // AgeOfSelection


procedure GetProcessList(var List: TstringList);
begin
    CreateWinNTProcessList(List);
end;

procedure CreateWinNTProcessList(List: TstringList);
var
   PIDArray         : array [0..1023] of DWORD;
   cb               : DWORD;
   mLoop            : Integer;
   //ProcCount        : Integer;   //Never Used
   hMod             : HMODULE;
   hProcess         : THandle;
   ModuleName       : array [0..300] of Char;
   mFileName        : String;
begin
     if List = nil then Exit;
     EnumProcesses(@PIDArray, SizeOf(PIDArray), cb);
     GlobCount := cb div SizeOf(DWORD);
     for mLoop := 0 to GlobCount - 1 do
     begin
          hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or
                      PROCESS_VM_READ,
                      False,
                      PIDArray[mLoop]);
          if (hProcess <> 0) then
          begin
               EnumProcessModules(hProcess, @hMod, SizeOf(hMod), cb);
               GetModuleFilenameEx(hProcess, hMod, ModuleName, SizeOf(ModuleName));
               mFileName := ModuleName;
               List.Add('['+ExtractFileName(mFileName)+']~"'+mFileName+'"');
               CloseHandle(hProcess);

               GlobProcessDetails[cTitle,   mLoop] := mFileName;
               mFileName := ExtractFileName(mFileName);
               GlobProcessDetails[cExeNam,  mLoop] := mFileName;
               GlobProcessDetails[cWinVis,  mLoop] := 'N';
               GlobProcessDetails[cAge,     mLoop] := '';
          end;
     end;
end;

(*
function EXE_Running(FileName: string; bFullpath: Boolean): Boolean;
var
  i: Integer;
  MyProcList: TstringList;
begin
  MyProcList := TStringList.Create;
  try
    GetProcessList(MyProcList);
    Result := False;
    if MyProcList = nil then Exit;
    for i := 0 to MyProcList.Count - 1 do
    begin
      if not bFullpath then
      begin
        if CompareText(ExtractFileName(MyProcList.Strings[i]), FileName) = 0 then
          Result := True
      end
      else if CompareText(MyProcList.strings[i], FileName) = 0 then Result := True;
      if Result then Break;
    end;
  finally
    MyProcList.Free;
  end;
end;
*)





end.
