// procedure SomeScreenorUnitName.TeleFlowRegistryRead;
(*  Note: The following is defined in NetHubWorkUnit.
          - Put this in your Uses clause to take advantage of

   // Registry Information
   cpRegistryEntry         =  'SOFTWARE\enGenic\TeleFlow Server';

   cMAXLOGFILESIZE         =  'MAXLOGFILESIZE';
   cLOGLINES               =  'LOGLINES';
   cLOGDIRECTORY           =  'LOGDIRECTORY';
   cINSTALLDIRECTORY       =  'INSTALLDIRECTORY';
   cEXPDATE                =  'EXPDATE';
   cNUMPORTS               =  'NUMPORTS';
*)
// var

   // Registry Information
   Registry: TRegistry;
begin
     Glob_TeleFlowInstalled     := False;

     GlobRegMAXLOGFILESIZE      := 0;
     GlobRegLOGLINES            := 0;
     GlobRegLOGDIRECTORY        := cMissing;
     GlobRegINSTALLDIRECTORY    := cMissing;
     GlobRegEXPDATE             := '';
     GlobRegNUMPORTS            := '';
     GlobRegWINSTART            := '';

     Registry:=TRegistry.Create;
     try
        Registry.RootKey:=HKEY_LOCAL_MACHINE;
        //False because we do not want to create it if it doesnt exist
        Registry.OpenKey(cpRegistryEntry,False);

        if Registry.ValueExists(cMAXLOGFILESIZE) then
        begin
             GlobRegMAXLOGFILESIZE      :=                  Registry.ReadInteger(cMAXLOGFILESIZE  );
        end;
        if Registry.ValueExists(cLOGLINES) then
        begin
             GlobRegLOGLINES            :=                  Registry.ReadInteger(cLOGLINES        );
        end;
        if Registry.ValueExists(cLOGDIRECTORY) then
        begin
             GlobRegLOGDIRECTORY        :=                  Registry.ReadString (cLOGDIRECTORY    );
        end;
        if Registry.ValueExists(cINSTALLDIRECTORY) then
        begin
             GlobRegINSTALLDIRECTORY    :=                  Registry.ReadString (cINSTALLDIRECTORY);
        end;
        if Registry.ValueExists(cEXPDATE) then
        begin
             GlobRegEXPDATE             := MakeTeleFlowDate(Registry.ReadString (cEXPDATE         ));
        end;
        if Registry.ValueExists(cNUMPORTS) then
        begin
             GlobRegNUMPORTS            :=                  Registry.ReadString (cNUMPORTS        );
        end;
        if Registry.ValueExists(cWINSTART) then
        begin
             GlobRegWINSTART            :=                  Registry.ReadString (cWINSTART        );
        end;

        // If all read, then TeleFlow is installed
        if GlobRegINSTALLDIRECTORY <> cMissing then
        begin
             Glob_TeleFlowInstalled     := True;
        end;

        // Assign to NetHub Just in case, these vars have been defined locally
        // Note: Probably redundant
        NetHubWorkUnit.Glob_TeleFlowInstalled     :=    Glob_TeleFlowInstalled;
        NetHubWorkUnit.GlobRegMAXLOGFILESIZE      :=    GlobRegMAXLOGFILESIZE;
        NetHubWorkUnit.GlobRegLOGLINES            :=    GlobRegLOGLINES;
        NetHubWorkUnit.GlobRegLOGDIRECTORY        :=    GlobRegLOGDIRECTORY;
        NetHubWorkUnit.GlobRegINSTALLDIRECTORY    :=    GlobRegINSTALLDIRECTORY;
        NetHubWorkUnit.GlobRegEXPDATE             :=    GlobRegEXPDATE;
        NetHubWorkUnit.GlobRegNUMPORTS            :=    GlobRegNUMPORTS;
        NetHubWorkUnit.GlobRegWINSTART            :=    GlobRegWINSTART;

        // Close the key
        Registry.CloseKey;

     finally
        Registry.Free;

        // Set defaults
        if GlobRegEXPDATE = '' then
        begin
             GlobRegEXPDATE := cUnreg;
        end;

        if GlobRegNUMPORTS = '' then
        begin
             GlobRegNUMPORTS := cUnreg;
        end;

        // If the TeleFlow log file directory does not exist then go with the log dir of NetHub
        if GlobRegLOGDIRECTORY = cMissing then
        begin
             GlobRegLOGDIRECTORY := Glob_Reg_LogDir;
        end;

     end;



