unit engMP3andWAVConverter;
{ Converts MP3 or WAV to standard TeleFlow WAV

}

// ADD THIS CODE TO YOUR PROGRAM
{

   // VoiceConvertForm.VoxtoWav(SoundsListBox.FileName, mTempFile, 8000, 8000);
   // FileConvertCreate(mFileNameFrom, mFileNameTo);
   // Convert Wav File
   procedure FileConvertCreate(pFileNameFrom, pFileNameTo: String; pHz: Integer);
   var
      mFileMode: playmodes;
      mMessage: String;
      engMP3Converter1: TengMP3Converter;
   begin
        // Check the file type.
        // Then convert it
        engMP3Converter1 := TengMP3Converter.Create(nil);  // We are handling the destructor

        try
           if UpperCase(ExtractFileExt(pFileNameFrom)) = '.VOX' then
           begin
                // Vox
                // Convert the file
                engMP3Converter1.VoxtoWav(pFileNameFrom, pFileNameTo, 8000, 8000);
           end
           else
           begin
                // Wav
                // Convert the file
                with engMP3Converter1 do
                begin
                     WAVFormatCheck(pFileNameFrom,mFileMode);
                     voxtype          := mFileMode; //VT_ADPCM;
                     wavtype          := VT_ADPCM; //mFileMode;  //VT_ADPCM,VT_PCM,VT_ALAW,VT_MULAW
                     downsamplefilter := True;
                     waveout16bit     := True;
                     mMessage         := WavtoVox(pFileNameFrom, pFileNameTo, 8000);
                end;

                // See if there was a problem
                if mMessage <> '' then
                begin
                     writeln('Error: Failed to convert '+pFileNameFrom);
                end;

           end;
        finally
           engMP3Converter1.Free;
        end;
   end;  // FileConvertCreate
}



interface

uses
  //Windows, Messages, SysUtils, Classes, mmsystem, Math, CalcWorkUnit;
  Windows, Messages, SysUtils, Classes,
  Dialogs,
  directshow9, uDirectShowPlayer,                     // These are for MP3 conversion
  deAudioIO, deACM, deAudioStreams, deAudioControls,  // These are for WAV conversion
  //ApplicationWorkUnit, CalcWorkUnit, FileWorkUnit,    // enGenic only
  MMSystem;

type
  TengMP3andWAVConverter = class(TComponent)

  private
    { Private declarations }

    // MP3 and WAV components
    mp3ToWavConverter:TMP3ToWAVConverter;
    WavToMP3Converter:TWAVToMP3Converter;
    deAudioConvertorWav: TdeAudioConvertor;
    deAudioControlSourceWav: TdeAudioControlSource;
    FBytesSaved: Cardinal;
    FAudioStream: TdeRIFFAudioWriter;
    FIsMp3: Boolean;
    FConverting: Boolean;
    FInputFile: TFileStream;
    FOutputFile: TFileStream;
    FRIFFIn: TdeRIFFAudioReader;
    FRIFFOut: TdeRIFFAudioWriter;
    FCurrentChunk: TStream;
    procedure WavToMP3(const srcfile,dstfile:string);
    procedure MP3ToWav(const srcfile,dstfile:string);
    procedure WM_MMNotify(var msg: TMessage);message WM_MMNotify;
    procedure MP3Configure;
    function DoFullConversion(pInFile, pTeleFlowWav: String): String;
    procedure deAudioControlSourceWavDataChanged(Sender: TObject);
    procedure deAudioConvertorWavAudioConverted(Sender: TObject;
      AudioData: Pointer; AudioDataSize: Integer; var Abort: Boolean);
    procedure deAudioConvertorWavAudioStreamConverted(Sender: TObject);
    function GenerateAUniqueFileName: String;

  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor destroy;override;
  end;

var

   // MP3 and WAV varaibles
   GlobMP3Processing  : Boolean = False;
   GlobConverterMode  : Boolean;
   GlobSourceFormat   : String;
   GlobPercent        : Cardinal;


procedure Register;

implementation

constructor TengMP3andWAVConverter.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);

     mp3ToWavconverter        := TMP3ToWavConverter.Create;
     mp3ToWavConverter.Handle := HWND;     // !!!!  We cannot do this... .Shucks

     WavToMp3converter        := TWavToMP3Converter.Create;
     WavToMp3Converter.Handle := AOwner;

     deAudioConvertorWav      := TdeAudioConvertor.Create(self);
     with deAudioConvertorWav do
     begin
          RequestRealTime        := False;
          Set8087FPUFlag         := True;

          OnAudioConverted       := deAudioConvertorWavAudioConverted;
          OnAudioStreamConverted := deAudioConvertorWavAudioStreamConverted;

          // Don't have to worry about FormatIn, because it is read
          with FormatOut do
          begin
               BitsPerSample   := 16;
               Channels        := 1;
               SamplesPerSec   := 8000;
               AvgBytesPerSec  := 16000;
               RequestRealTime := False;
          end;

     end;

     // If we get anything other than ''... we have things configured
     GlobSourceFormat := deAudioConvertorWav.FormatOut.Description;

     deAudioControlSourceWav  := TdeAudioControlSource.Create(self);
     with deAudioControlSourceWav do
     begin
          OnDataChanged          := deAudioControlSourceWavDataChanged;
          AudioSource            := deAudioConvertorWav;
     end;
end; // Constructor


destructor TengMP3andWAVConverter.destroy;
begin
     mp3ToWAVConverter.Free;
     WavToMp3Converter.Free;
     deAudioConvertorWav.Free;
     deAudioControlSourceWav.Free;
     inherited;
end; // Destructor


procedure Register;
begin
  RegisterComponents('enGenic', [TengMP3andWAVConverter]);
end;

end.

 